/*----------------------------------------------------------------------*/
/*  Softwaretechnik:        (Folgen)                                    */
/*                                                                      */
/*                                                 FOLGEN               */
/*                                                                      */
/*  flglib.h:   Datentypdefinition/Funktionsdeklaration                 */
/*                                                             10/95 di */
/*                                                          MF/ST 11.95 */
/*----------------------------------------------------------------------*/
#include <stdio.h> 
#include <stdlib.h> 
#include <errno.h> 

#ifndef _H_FLGLIB
#define _H_FLGLIB
#define  Nach  0
#define  Vor   1

/*  Fehlermakros fuer die errno Variable  */

#define  FLGBEREICH  1000

#define Anfang  0
#define Ende    1

/*- Iteratoren ---------------------------------------------------------*/

#define  KeAnfang(W)                 W
#define  KeEnde(W)                   W
#define  KeErstesGlied(W)            W->nach
#define  KeLetztesGlied(W)           W->vor
#define  KeNachfolgerGlied(p)        p->nach
#define  KeVorgaengerGlied(p)        p->vor)
#define  KeDurchlaufVorwaerts(p,W)   for (p=W->nach; p!=W; p=p->nach)
#define  KeDurchlaufRueckwaerts(p,W) for (p=W->vor ; p!=W; p=p->vor )


/*- Definition des Datentyps Bool und Rel ------------------------------*/

typedef enum { FlgFalse, FlgTrue} FlgBool;   

typedef enum { Less , Equal , Greater , FlgNone } Rel;   


typedef struct glied
{
  struct glied *vor  ;          /*  Zeiger auf den Vorgaenger   */
  struct glied *nach ;          /*  Zeiger auf den Nachfolger   */
  void   *x    ;                /*  Elementbezeichnung          */
} KeGlied;                      /*  Datentyp Glied              */


extern KeGlied* KeKetteDefinieren(void);
extern void     KeKetteLoeschen(KeGlied *W);
extern void     KeElementEintragen (void  *x, int rel, KeGlied *q);
extern void     KeGliedEintragen   (KeGlied *p, int rel, KeGlied *q);
extern void*    KeElementAustragen (KeGlied *p);
extern void     KeGliedAustragen   (KeGlied *p);


/* Sortieren */
extern void     KeSchnellSortieren (KeGlied *K, Rel (*Vergleich) (void*,void*));
extern void     KeMSort (KeGlied *pa,KeGlied *pe, Rel (*Vergleich) (void*,void*));

/* Suchen */
extern int KeElementSuchen(void *x, KeGlied *q);

#endif 



