#include <stdio.h>
#include <malloc.h>

/*----------------------------------------------------------------------*/
/*   PROFILE MATRIX : Declaration File                                  */
/*----------------------------------------------------------------------*/

/*...Return Codes.......................................................*/

#define  CPmOK        ( 0L)            /* function executed             */
#define  CPmError     (-3L)            /* error in execution            */
#define  CPmPivot     (-2L)            /* pivot element Zero            */

/*...Status Code for Element Variables..................................*/

#define  CPmAbsent    (-1L)            /* state variable does not exist */
/* A present state variable within an element has to be specified by    */
/* its system variable number.                                          */

/*...Status Code for System Variables...................................*/

#define  CPmPrimal    (-1L)            /* primal  variable is given     */
#define  CPmDual      (-2L)            /* dual    variable is given     */
#define  CPmNegative  (-3L)            /* negative diagonal element     */
#define  CPmInactive  (-4L)            /* inactive system variable      */

/*...Function Names.....................................................*/

#define  PmInitSystemMatrix        PmInitSysMat
#define  PmInitProfileVector       PmInitProf
#define  PmAddElementMatrix        PmAddEleMat
#define  PmDecomposeSystemMatrix   PmDecompose
#define  PmGetDeterminant          PmDetermin
#define  PmSetPointerVector        PmSetPointer
#define  PmSetProfileVector        PmSetProfile
#define  PmGetMatrixSize           PmGetMatSize
#define  PmSolveEquations          PmSolveEqn

/*...Functions for profile matrices.....................................*/


long PmDecompose(long PmDimSystem, long PmStatus[], long PmProfile[],
		 double *PmAa[], long *PmError);
void PmSolveEqn(long PmDimSystem, long PmStatus[], long PmProfile[],
		double *PmAa[], double *PmXx, double *PmBb);         


/*
  Alloc.c
*/ 
double** AllocMatrix(long zdim,long sdim);
double** AllocPMatrix(long dim, long pv[]);




