#ifndef _XSTABDEK_H
#define _XSTABDEK_H

/*
  Datei     : XStabDek.h
  erstellt  : 25.06.96
  gendert  : 04.04.97
              07.02.98 von as
  Autor     : jh
*/

#ifdef XS_MAIN
 #define EXT
#else
 #define EXT extern
#endif

#define COL_RAND fl_get_pixel(FL_INACTIVE_COL)

#include "XStabTyp.h"
#include "XStab_globalVars.h"

#include "XStabDek_export.h"


/* main_buttons_cb.c */
void showLoadform(void);


/* ...  mainform_cb.c  ... */

EXT void popup_cb(int);
EXT void popup2_cb(int);


/* ...  cb.c  ... */

EXT void WahlButton3( KeGlied *staebe );


/* ...  wincb.c  ... */

EXT int win_cb(XEvent *,void *);
EXT int win2_cb(XEvent *,void *);
EXT int win3_cb(XEvent *,void *);
EXT int win_fg_cb(XEvent *ev,void *tt);


/* ...  hilfe.c  ... */

EXT void net_hilfe(void);


/* ...  Suchen.c  ... */

EXT TypPunkt* suchePunkt_Nr(long nummer, KeGlied*);


EXT long                suche_Lastfall_ID(long nummer);
EXT long                suche_Lastfall_Nummer(long id);

EXT long                Suche_freiePunktnummer(KeGlied*);
EXT long                Suche_freieLastnummer(void);
EXT int                 Suche_FG_nummer(long nummer);
EXT TypFreiGrad *       Suche_FreiGrad(long nummer, KeGlied*);
EXT TypMaterial*        Suche_Material(long);
EXT TypQuerschnitt*     Suche_Querschnitt(long);



/* ...  Lese.c  ... */

EXT void Lese(char *);
EXT void Lese_Querschnitte(void);
EXT void Lese_Material(void);

EXT long Lese_Color(char *datei_name);


/* ...  Schreibe.c  ... */

EXT void save(void);
EXT void save_as(void);

EXT void Schreibe(char* );
EXT void Schreibe_Material(void);
EXT void Schreibe_Querschnitte(void);

EXT void Schreibe_Color(char *datei_name);


/* ...  Berechne.c  ... */

EXT void Berechne(void);


/* ... BerechneThIIOrdnung.c ... */

EXT void BerechneThIIOrdnung(void);


/* ...   Ausgabe.c  ... */

EXT void Drucke_Stab_Nm(TypStab_Nm *);
EXT void DruckeStaebe_Nm(void);
EXT void Drucke_Stab_Km(TypStab_Km *);
EXT void DruckeStaebe_Km(void);

EXT void Drucke_Punkt(TypPunkt* tmp_punkt);
EXT void DruckePunkte_Nm(void);
EXT void DruckePunkte_Km(void);

EXT void DruckeFreiGrad(KeGlied*);
EXT void DruckeSysSteif(double **SysSteif,long *SysProfil,long SysDim);
EXT void DruckeErgebnisse(char *out);
EXT void DruckeAktiveLastfaelle(Menge *M);
EXT void DruckeKnotenlast(void);
EXT void DruckeStreckenlast(void);
EXT void Drucke_FG_Relation(void);
EXT void DruckeProfil(long *p,long dim);
EXT void DruckeMatrix(double **m,long dim);


/* ...   Zeichne.c  ... */

EXT void Zeichne(void);
EXT void setze_m(TypMaszstab mass, Typ_DsScale *m);
EXT TypMaszstab Zeichne_HoleMaszstab(void);
EXT void ZeichnePfeil(double, double, double, double ,Window);
EXT void Zeichne_Verschiebung_Stab(Window,TypIntervall*,TypMaszstab);
EXT void Zeichne_Beschriftung_Verschiebung(Window win,
				       TypStab_Nm* tmp_stab,
				       TypMaszstab mass);

/* ... zeichne_schnittkraft.c ... */

void Zeichne_Schnittkraft(Window, TypIntervall* inter,long sk, TypMaszstab mass);
void Zeichne_Beschriftung(Window, TypStab_Nm*,long sk, TypMaszstab mass);


/* ...  Pruefe.c  ... */

EXT void Pruefe_Gelenke(long *von, long *bis, TypStab_Nm* tmp_stab);
EXT void pruefeGelenke(long *von, long *bis, TypStab_Nm* tmp_stab);
EXT void PruefeSelektion(long,long);
EXT void PruefeSelektionBox(long x1, long y1, long x2, long y2);
EXT void Edit(TypStab_Nm*);


EXT void SetzeWerte_Eig_Querschnitt(void);
EXT void SetzeWerte_Eig_Material(void);
EXT long Hole_Eig_MaterialID(void);
EXT long Hole_Eig_QuerschnittID(void);


/* ...  zeichne_dienst.c  ... */

EXT void resize_window(void);
EXT double X_win_welt(Window,long);
EXT double Y_win_welt(Window,long);
EXT long X_welt_win(Window,double);
EXT long Y_welt_win(Window,double);

EXT double X_win_welt_m(Window,long, TypMaszstab);
EXT double Y_win_welt_m(Window,long, TypMaszstab);
EXT long X_welt_win_m(Window,double, TypMaszstab);
EXT long Y_welt_win_m(Window,double, TypMaszstab);
EXT void Zeichne_Lager_Z(Window, TypMaszstab, double x, double y);
EXT void Zeichne_Lager_XY(Window,TypMaszstab, 
			 double x, double y, double alpha,long );
EXT void Zeichne_Feder_Z(Window, TypMaszstab, double x, double y);
EXT void Zeichne_Feder_XY(Window win,TypMaszstab mass, 
		      double x, double y, double alpha,long xy);
EXT void Zeichne_KoordSys(Window win,
			  TypStab_Nm *tmp_stab);


/* ...  Last.c  ... */

EXT void aktualisiereAuswahlLF(void);
EXT void Lastfall(void);
/* EXT long LF_select(void); */
EXT void LastfallGewichten(void);
EXT void LastfallSetzeGewicht(long ,double);
EXT void BerechneMass(double *mass,double *off_x, double *off_y,
		      long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void HoleAktiveLastfaelle_Lastwahl(Menge *M);
EXT double HoleGewicht(long nummer);
EXT void Lastfall_Name(long nummer,char *name);
EXT void Lastfall_Name_aendern(void);
EXT void Lastfall_kopieren(long id);

EXT void Zeichne_Lastedit(void);
EXT void Zeichne_Lastedit_Stab(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Lastedit_FreiGrad(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Lastedit_Knotenlast(long win_w,long win_h,
				     TypStab_Nm *tmp_stab, TypKnotenlast_Nm *);
EXT void Zeichne_Lastedit_Streckenlast(long win_w, long win_h, 
				       TypStab_Nm *tmp_stab, TypStreckenlast_Nm *tmp_sl);
EXT void showCopyLoadDlg(TypStab_Nm* stab);


/* ...  info.c  ... */

EXT void info(void);


/* ...  nachlauf.c  ... */

EXT void Nachlauf(void);


/* ...  schnitt.c  ... */

EXT void Schnitt(TypStab_Nm*);
EXT void Zeichne_Schnitt(TypStab_Nm*);
EXT void Zeichne_Schnitt_Stab(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Schnitt_Moment(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Schnitt_Quer(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Schnitt_Normal(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_Schnitt_Verschiebung(long win_w, long win_h,TypStab_Nm* tmp_stab);
EXT void SetzeWerte(TypStab_Nm *tmp_stab);
EXT void SetzeWerte_SK(TypStab_Nm *tmp_stab);

EXT void SetzeWerte_UW(TypStab_Nm *tmp_stab);
EXT void SetzeWerte_SS(TypStab_Nm *tmp_stab);
EXT void SetzeWerte_NS(TypStab_Nm *tmp_stab);


/* ...  Loesche.c  ... */

EXT void Loesche_Relationen(TypFreiGrad *tmp_freigrad, Menge*);
EXT void Loesche_Lastfall(long nummer);


/* ...  Erzeuge.c  ... */

EXT TypModell* erzeugeModell(void);
EXT void         Erzeuge_Projekt(void);
EXT TypLastfall* Erzeuge_Lastfall(long nummer, char* name, long);



/* ...  MaterialQuer.c  ... */

EXT void SetzeWerte_Material(void);
EXT void SetzeWerte_Querschnitt(void);
EXT long Hole_MaterialID(void);
EXT long Hole_QuerschnittID(void);
EXT void Material_Eintragen_Nm(TypStab_Nm* tmp_stab, long _id);
EXT void Querschnitt_Eintragen_Nm(TypStab_Nm* tmp_stab, long _id);
EXT void Material_Querschnitt_zuweisen(KeGlied*);


/* ...  FreiGrad.c  ... */

EXT void Verbinde_FG(TypFreiGrad *, TypFreiGrad *, Menge*);
EXT void LoeseVerbindung_FG(TypFreiGrad *fg1, TypFreiGrad *fg2, 
			Menge* relation);


/* ... tabelle.c  ... */

EXT void tabelle_staebe(void);    
EXT void tabelle_staebe_browserzeichnen(void);

EXT void tabelle_punkte(void);     
EXT void tabelle_fg(void);


/* ...  zoom.c  ... */

EXT void Zoom_in(long,long);
EXT void Zoom_out(long,long);
EXT void Zoom_all(void);
EXT void Zoom_rect(long x1, long y1, long x2, long y2);


/* ...  dienst_environment.c  ... */

/* EXT void toggle_raster(void); */
EXT void modifyKoord(double *X, double *Y, TypPunkt**);
EXT void setFang( int mode );

/* ...  dienst.c  ... */

EXT void not_implemented(void);
EXT long Vergebe_ID(void);
EXT void ScanString(char *s);
EXT void UnScanString(char *s);
EXT void setEnv(void);
EXT char* getText(char* format, char* text);


EXT void addToSystemChoice( TypModell* modell );
EXT void removeFromSystemChoice( TypModell* modell );
EXT void changeSystemChoice( TypModell* modell );

EXT void    dienst_Prg_Status(long s);
EXT void    Meldung(char text[]);
EXT void    Progress(double value);
EXT void    quit(void);
EXT double* dienst_minmaxkoord_Nm(KeGlied*);
EXT void    initmat(double **a,double,double,double,double);
EXT long    PruefePicked(double x1, double y1,
			 double x2, double y2,
			 double x, double y);
EXT void    InvMatrix(double **a,double **inv);
EXT int     Element_suchen(long nummer, Menge *M);

EXT double getM(TypStab_Nm* tmp_stab, double pos);
EXT double getQ(TypStab_Nm* tmp_stab, double pos);
EXT double getN(TypStab_Nm* tmp_stab, double pos);
EXT double maxM(TypStab_Nm* tmp_stab, double* pos);
EXT double maxN(TypStab_Nm* tmp_stab, double* pos);
EXT double maxQ(TypStab_Nm* tmp_stab, double* pos);
EXT double minM(TypStab_Nm* tmp_stab, double* pos);
EXT double minN(TypStab_Nm* tmp_stab, double* pos);
EXT double minQ(TypStab_Nm* tmp_stab, double* pos);

EXT double get_w(TypStab_Nm* tmp_stab, double pos);
EXT double max_w(TypStab_Nm* tmp_stab, double* pos);
EXT double min_w(TypStab_Nm* tmp_stab, double* pos);

EXT double get_u(TypStab_Nm* tmp_stab, double pos);
EXT double max_u(TypStab_Nm* tmp_stab, double* pos);
EXT double min_u(TypStab_Nm* tmp_stab, double* pos);

EXT double maxMKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);
EXT double maxQKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);
EXT double maxNKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);
EXT double minMKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);
EXT double minQKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);
EXT double minNKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos);


/* ...  locale.c  ... */

EXT char* locale(char*);


/* ...  hermite.c  ... */

EXT double  Hermite_dis(double wa, double wsa, double we, double wse, double l, double z);
EXT double* Hermite(double wa, double wsa, double we, double wse, double l, long anz);
EXT double* Hermite_extrema(double wa, double wsa, double we, double wse,double );


/* ...  liste_bildschirm  ... */

EXT void set_res_erg(FD_ergebnisse *);
EXT void liste_bildschirm(KeGlied*);


/* ...  transform.c  ... */

EXT void Nm_Trans_Km(void);
EXT void Km_Trans_Nm(void);


/* ...  lastedit.c  ... */

EXT void Lastedit(TypStab_Nm*);
EXT void Setze_Lasten(TypStab_Nm* tmp_stab);
EXT void Markiere_Last(long id);
EXT void Schreibe_Brow1(void);
EXT void Schreibe_Brow2(void);

EXT void Streckenlast_eintragen(void);
EXT void Streckenlast_aendern(void);

EXT void Punktlast_eintragen(void);
EXT void Punktlast_aendern(void);

EXT long HoleLast_ID_Lastedit(void);

EXT long HoleLastfall_ID_Lastedit(Menge *M);
EXT long HoleLastfall_Nummer_Lastedit(Menge *M);

EXT void Setze_akt_Last(void);

EXT void Last_kopieren(void);
EXT void Last_verschieben(void);


/* ...  pfade.c  ... */

EXT void set_path_form(void);
EXT void zeige_pfade(void);
EXT void set_path(void);
EXT void save_path(void);
EXT void pfade_uebernehmen(void);
EXT void createDirectory(char* newDir);  /* von as hinzugefgt am 6.2.98 */ 

/* ...  init.c  ... */

EXT void init_fg_grafik(void);
EXT void init_schnittgrafik(void);
EXT void init_lastgrafik(void);


/* ...  relation.c  ... */

EXT Rel Rel_Punkt(TypPunkt* a, TypPunkt* b);
EXT Rel Rel_Stab_Nm(TypStab_Nm* a, TypStab_Nm* b);

/* ...  color.c  ... */

void setze_farben(void);


/***********************************************************/
/*   Nutzermodell                                          */
/***********************************************************/

/* ...  lastfall.c  ... */

EXT void schreibeBrowserLastfall(void);
EXT void schreibeBrowserLastfallKombinationen(void);


/*  ...  lfkombination.c  ...  */

EXT void LFKomb_addLF(TypLastfallkombination*,long id, double gewicht);
EXT void LFKomb_activate(long id);
EXT void LFKomb_setName(long id, char *name);
EXT void LFKomb_getName(long id, char *name);
EXT void LFKomb_NameAendern(void);


/* ...  verschieben.c  ... */

EXT void verschieben(double x, double y);


/* ...  Loesche_Nm.c  ... */

EXT void loescheLFKombination(long id);
EXT void loescheModell(TypModell*);
EXT void Loesche_FG_Nm(long fgnummer);
EXT long Loesche_FreiGrad_Nm(TypFreiGrad *tmp_freigrad);
EXT void Loesche_Stab_Nm(Menge*);
EXT void Loesche_Punkt_Nm(TypPunkt* tmp_punkt);

EXT void Loesche_Punktlast_Nm(long nummer);

EXT void Loesche_Punktlast_ID__Nm(long id);
EXT void Loesche_Punktlast_Stabnummer_Nm(long stabnummer);
EXT void Loesche_Streckenlast_Nm(long nummer);
EXT void Loesche_Streckenlast_Stabnummer_Nm(long stabnumer);
EXT void Loesche_Streckenlast_ID__Nm(long id);


/* ...  suche_Nm.c  ... */

EXT TypPunkt* suchePunkt_Koord(double x, double y, double eps);

EXT long                suchefreieLFKombNummer(void);
EXT TypLastfall*        Suche_Lastfall_nr(long nummer);
EXT TypLastfall*        Suche_Lastfall_id(long id);

EXT TypStab_Nm*         Suche_Stab_select_Nm(long *nummer);
EXT KeGlied*            getSelectedK(void);
EXT Menge*              getSelectedM(void);
EXT TypStab_Nm*         Suche_Stab_Nm(long nummer);

EXT long                Suche_freieStabnummer_Nm(void);
EXT TypStreckenlast_Nm* Suche_Streckenlast_Nm(long stabnummer);
EXT TypStreckenlast_Nm* Suche_Last_SL_Nm(long id);
EXT TypKnotenlast_Nm*   Suche_Last_PL_Nm(long id);
EXT TypFreiGrad*        suche_FG_Nm(long fg_nummer);


/* ...  staberzeugen_Nm.c  ... */

EXT void Punkt_1_festlegen(double,double,TypPunkt*);
EXT void Punkt_2_festlegen(double,double,TypPunkt*);

EXT void Zeige_Standardwerte(void);
EXT long Hole_Standard_MaterialID(void);
EXT long Hole_Standard_QuerschnittID(void);
EXT void staberzeugen_cb(FL_OBJECT *obj, long arg);
EXT void staberzeugen_Zeichne_Punkt(Window win, long x, long y);


/* ...  stabteilen_Nm.c  ... */

EXT void Stabteilen_Nm(Menge *M, long anz);


/* ... Erzeuge_Nm.c  ... */

EXT TypLastfallkombination* erzeugeLFKombination(long id);
EXT TypKnotenlast_Nm*   Erzeuge_Punktlast_Nm(long lastfallid, long id);
EXT TypStreckenlast_Nm* Erzeuge_Streckenlast_Nm(long lastfallid, long id);
EXT TypPunkt*           Erzeuge_Punkt_Nm(double x, double y, long id);
EXT TypStab_Nm*         Erzeuge_Stab_Nm(void);
EXT TypStab_Nm*         Erzeuge_Stab_Nm_Lese(void);
EXT TypFreiGrad*        Erzeuge_FG_Nm(TypStab_Nm *tmp_stab, long fg_art);
EXT void                SetzeGeometrie_Nm(TypStab_Nm* tmp_stab);
EXT TypIntervall*       Erzeuge_Intervall(TypStab_Nm *tmp_stab);


/* ...  FreiGrad_Nm.c  ... */

EXT void Freigradedit(void);
EXT void Uebernehme_FGamPunkt_Nm(TypStab_Nm *tmp_stab, TypPunkt *tmp_punkt, long pos);
EXT void Drehe_FG_Nm(long fg_nummer,double alpha);
EXT void fg_setze_form(long flag);


/* ...  FreiGrad_zeichne_Nm.c  ... */

EXT void Zeichne_FG(void);
EXT void Zeichne_FG_Stab(long win_w,long win_h,TypStab_Nm *tmp_stab);
EXT void Zeichne_FG_FgNummer(long win_w, long win_h, TypStab_Nm *tmp_stab);
EXT void Zeichne_FG_Lager(long win_w, long win_h, TypStab_Nm *tmp_stab);
EXT void Zeichne_FG_Lager_XY(TypMaszstab, double x, double y, double alpha,long );



/***********************************************************/
/*   Kernmodell                                            */
/***********************************************************/


/* ...  staberzeugen_Km.c  ... */

EXT void Stabteilen_Km(long anz, TypStab_Km*);
EXT void SetzeGeometrie_Km(TypStab_Km* tmp_stab);


/* ...  Erzeuge_Km.c  ... */

EXT TypStab_Km*  Erzeuge_Stab_Km(long);
EXT TypFreiGrad* Erzeuge_FG_Km(long fg_art,long);
EXT TypPunkt*    Erzeuge_Punkt_Km(double x, double y);


/* ...  suche_Km.c  ... */

EXT TypStab_Km* Suche_Stab_Km(long nummer);
EXT long        Suche_freieStabnummer_Km(void);


/* ...  Loesche_Km.c  ... */

EXT void Loesche_Km(void);



/***********************************************************/
/*   Material                                              */
/***********************************************************/

/* ...  erzeuge_mat.c  ... */

EXT TypMaterial* Erzeuge_Material(void);




/***********************************************************/
/*   Querschnitt                                           */
/***********************************************************/

/* ...  erzeuge_quer.c  ... */

EXT TypQuerschnitt* Erzeuge_Querschnitt(void);


#endif
