#ifndef XSTABTYP_NM_H
#define XSTABTYP_NM_H

/*
  Datei     : XStabTyp_Nm.h
  erstellt  : 07.04.97
  gendert  : 
  Autor     : jh
*/


typedef struct
{
  double d_posA,d_posB;         /* Position im Stab des Nm */
  double d_xa,d_xe;
  double d_ya,d_ye;
  double d_lastp_a,d_lastp_b;
  double d_lastn_a,d_lastn_b;
  double d_Na,d_Qa,d_Ma;
  double d_Nb,d_Qb,d_Mb;
  double d_vs[6]; 
  double d_laenge; 
  double d_alpha1,d_alpha2;
  double d_alpha_stab;
}TypIntervall;


typedef struct
{
  long    l_id;                  /* persistent */
  long    l_lastfallid;          /* persistenter Lastfall ID */
  long    l_stabnummer;          /* zugehoeriger Stab */ 
  char    c_name[100]; 
  double  d_lasta, d_lastb;      /* Gre der Last Punkt A,B */
  double  d_alpha;               /* Drehung bzgl. globalen/lokalen Koordsys */
  long    l_koordsys;            /* global / lokal */
  double  d_anf, d_end;          /* Anfang/Ende zwischen 0 und 1 */
} TypStreckenlast_Nm;


typedef struct
{
  long    l_id;              /* persistent */
  long    l_lastfallid;      /* Lastfall ID */
  char    c_name[100];  
  double  d_last;            /* Groesse der Einwirkung */
  long    l_stabnummer;      /* zugehoeriger Stab */ 
  double  d_alpha;           /* Drehung der Kraft */
  long    l_koordsys_winkel; /* global = 2 / lokal = 1 */
  long    l_koordsys_pos;    
  double  d_pos;             /* Position im Stab 0-1 */
  long    l_art;             /* 1->x,y ;  2->z */
} TypKnotenlast_Nm;


typedef struct
{ 
  long l_nummer;

  /* selektiert = +1 -- nicht selektiert = -1 */ 
  long l_selektiert;           

  /* zugehoerige Freiheitsgrade */
  TypFreiGrad *pe_frei[6];  
  
  /* Topologie */
  TypPunkt *pe_punkta,*pe_punktb; 

  /* Material */
  long l_matid;

  /* Querschnitt */
  long l_querid;

  /* Geometrie - abgeleitet */
  double d_alpha;
  double d_laenge;
  double d_cos,d_sin;

  /* Ergebnisse */
  KeGlied *intervalle;
  
} TypStab_Nm;


#endif
