/*
  Datei     : Alloc.c
  erstellt  : 24.05.95
  geaendert : 09.07.96
  Autor     : jh
*/

#include "PmUsr.h"


/*********************************************************************/
/* double** AllocPMatrix(long dim, long pv[])                        */
/*********************************************************************/ 
/*                                              
   symm. Profilmatrix allokieren
   jh, 24.05.95
*/
/*********************************************************************/

double** AllocPMatrix(long dim, long pv[])
{ 
  double **m;
  long i,summe=0;
  for (i=0;i<dim;i++)
    summe += (i-pv[i]+1);
  
  m = (double**) calloc (dim,sizeof(double*));
  if(!m) {
    fprintf(stderr,"# AllocPMatrix() Mem-Fault \n");
    return NULL;
  }

  m[0] = (double*) calloc (summe,sizeof(double));
  
  if(!m[0]) {
    fprintf(stderr,"# AllocPMatrix() Mem-Fault \n");
    return NULL;
  }
  
  for (i=1;i<dim;i++)
    m[i]= m[i-1]+i-pv[i];
  return m;
}

    
/* vollbesetzte Matrix allokieren */
double** AllocMatrix(long zdim,long sdim)
{
  double** m;
  long i;
  m = (double**) calloc (zdim,sizeof(double*));
  if (!m)  { 
    printf("Fehler beim allokieren !");
    return 0;
  }
  m[0] = (double*) calloc (sdim*zdim,sizeof(double));
  if (!m[0]) { 
    printf("Fehler beim allokieren !");
    return 0;
  }
  for (i=1;i<zdim;i++)  {
    m[i]=m[i-1]+sdim;   
  } 
  return m;
}


