/************************************************************************
  						INCLUDES 
************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "MngUsr.h"

/*..Paar definieren.................................................*/
Paar* Mng_PaarDefinieren (void *a, void *b)
{
  Paar *p ;
  p = (Paar*) calloc (1,sizeof(Paar)) ;
  p->a = a ;  p->b = b ;
  return p ;
}

/*..Paar loeschen...................................................*/
void Mng_PaarLoeschen (void *p)
{
  free (p);  
}

/*..Paar Suchen.....................................................*/
int Mng_PaarSuchen (void *a, void *b, Menge *R)
{  
  int i ; 
  Paar **feld, p ;
  feld = (Paar**) R->feld ;
  i = R->n ;
  feld[0] = &p ;
  feld[0]->a = a ;
  feld[0]->b = b ;
  while (feld[i]->a != a || feld[i]->b != b) i-- ;
  return i ;
}

/*..Paar Zufuegen...................................................*/
void Mng_PaarZufuegen (void *a, void *b, Menge *R)
{
  if (!Mng_PaarSuchen (a,b,R))
    Mng_ElementEintragen (Mng_PaarDefinieren (a,b), R) ;
}

/*..Paar Entfernen..................................................*/
void Mng_PaarEntfernen (void *a, void *b, Menge *R)
{
  int i ;
  if (i = Mng_PaarSuchen (a,b,R))
    {
      R->feld [i] = R->feld [R->n]  ;
      Mng_PaarLoeschen (R->feld [R->n]) ;
      Mng_ElementAustragen (R)          ;
    }   
}

/*..Bilden der einstelligen Relation................................*/
Menge* Mng_UnaereRelation (Menge *A, Mng_Bool (*Relation)(), void *p)
{
  Menge *R ;  int i ;  void *a ;
  R = Mng_MengeDefinieren () ;
  for (i=1; i<=A->n; i++)
    {
      a = A->feld [i] ;
      if (Relation (a,p)) Mng_ElementEintragen (a,R) ;
    }   
  return R ;
}

/*..Bilden der zweistelligen Relation...............................*/
Menge* Mng_BinaereRelation (Menge *A, Menge *B, Mng_Bool (*Relation)(), void *p)
{   Menge *R ;  int i, j  ;  void *a, *b ;
    R = Mng_MengeDefinieren () ;
    for (i=1; i<=A->n; i++)
    {   a = A->feld [i] ;
	for (j=1; j<=B->n; j++)
	{   b = B->feld [j] ;
	    if (Relation (a,b,p))
		Mng_ElementEintragen (Mng_PaarDefinieren (a,b), R) ;
    }   }   return R ;
}

/*..Reflexive Huelle der zweistelligen Relation.....................*/
void Mng_ReflexiveHuelle (Menge *R)
{   int i ;  Paar *p ;
    for (i=R->n; i>0; i--)
    {   p = (Paar*) R->feld [i]   ;
	Mng_PaarZufuegen (p->a,p->a,R) ;
	Mng_PaarZufuegen (p->b,p->b,R) ;
}   }

/*..Symmetrische Huelle der zweistelligen Relation..................*/
void Mng_SymmetrischeHuelle (Menge *R)
{   int i ;  Paar *p ;
    for (i=R->n; i>0; i--)
    {   p = (Paar*) R->feld [i]   ;
	Mng_PaarZufuegen (p->b,p->a,R) ;
}   }

/*..Transitive Huelle der zweistelligen Relation.  .................*/
void Mng_TransitiveHuelle (Menge *R)
{   int i, j, n ;  Paar *p, *q ;
    n = R->n ;
    for (i=1; i<=R->n; i++)
    {   p = (Paar*) R->feld [i] ;
	for (j=1; j<=n; j++)
	{   q = (Paar*) R->feld [j] ;
	    if (p->b == q->a) Mng_PaarZufuegen (p->a,q->b,R) ;
}   }   }
