/*
  Datei     : Erzeuge.c
  erstellt  : 22.07.96
  geaendert : 28.01.98
  Autor     : jh
*/


#include "XStabDek.h"

extern char* version;


long anzSys = 0;

void initModell(TypModell* modell);



/*********************************************************************/
/* TypModell* erzeugeModell(void)                                    */
/*********************************************************************/ 
/*                                              
   Fkt erzeugt ein Modell und trgt dies in KeModell ein
   jh, 07.12.97
*/
/*********************************************************************/

TypModell* erzeugeModell(void)
{
  TypModell *this;  

  this = (TypModell*) calloc (1,sizeof(TypModell));

  this->FG_Relation_Nm = Mng_MengeDefinieren(); 
  this->System.l_id = time(NULL);

  sprintf(this->System.c_datei,"%s","noname");

  if(KeModell) {
    KeElementEintragen(this, Nach, KeModell);
  }
  else {
    KeModell = KeKetteDefinieren();
    KeElementEintragen(this, Nach, KeModell);
  } 
  
  this->nummer = ++anzSys;

  initModell( this );

  Meldung("System erzeugt.");
  
  return this;

}


/*********************************************************************/
/*  initmodell(TypModell* modell)                                    */
/*********************************************************************/ 
/*                                              
   Fkt initialisiert ein Modell
   jh, 28.01.98
*/
/*********************************************************************/

void initModell(TypModell* modell)
{

  modell->Environment.raster = 1;
  modell->Environment.raster_x = 1;
  modell->Environment.raster_y = 1;

  modell->Environment.fang = 3;
  modell->Environment.fang_x = 0.5;
  modell->Environment.fang_y = 0.5;

  modell->prozessor_anz = 2;

}


/*********************************************************************/
/* void Erzeuge_Projekt(void)                                        */
/*********************************************************************/ 
/*                                              
   Fkt erstellt ein neues Verzeichnis fr ein Projekt
   jh, 07.12.97
*/
/*********************************************************************/

void Erzeuge_Projekt(void)
{
  char *c_tmp;   
  char pfad[256];
  char c_projekt[100];
  char c_text[250];

  /* Namen aus input-form holen */
  c_tmp = (char*) fl_get_input(inputform->input); 

  if(strlen(c_tmp))
    sprintf(c_projekt,"%s",c_tmp);
  else    
    return;
    
  /* neues directory anlegen */
  sprintf(pfad,"%s/%s",c_projekte_pfad,c_projekt);
  mkdir(pfad,0040777);     

  fl_hide_form(inputform->inputform);       

  sprintf(c_text,"Projekt %s erzeugt. ",pfad);
  Meldung(c_text);

}



/***********************************************************/ 
/* TypLastfall* Erzeuge_Lastfall(long nummer, char* name)  */
/***********************************************************/ 
/*                                              
   Konstruktor fr Lastfall
   wenn id == -1 wird neuer id vergeben
   jh, 18.03.97
*/
/***********************************************************/

TypLastfall* Erzeuge_Lastfall(long nummer,  /* Lastfallnummer */ 
			      char* name,   /* Lastfallname */
			      long id)      /* Lastfall ID */
{
  TypLastfall *this,*tmp_lastfall2;
  KeGlied *p;

  /* Speicher holen */
  if(!(this = (TypLastfall*) calloc (1,sizeof(TypLastfall)))) {
    fprintf(stderr,"XStab : MemFault\n");
    exit(1);
  }
  
  /* ID bestimmen */
  if(id == -1)
    (*this).l_id = Vergebe_ID();
  else
    (*this).l_id = id;

  /* berpruefen ob Nummer schon vorhanden ist */
  if(Modell->KeLast) {
    KeDurchlaufVorwaerts(p,Modell->KeLast) {

      tmp_lastfall2 = p->x;
      
      if((*tmp_lastfall2).l_nummer == nummer) {
	nummer = Suche_freieLastnummer();
	break;
      }
    }  
  }
  
  /* Nummer zuweisen */
  (*this).l_nummer = nummer;
   
  
  if(strlen(name)==0)
    sprintf((*this).c_name ,"unbenannt");
  else
    sprintf((*this).c_name ,"%s", name);
  
  /* Lastfall eintragen */  
  if(Modell->KeLast)
    KeElementEintragen(this,Nach,Modell->KeLast);   
  else {
    Modell->KeLast = KeKetteDefinieren();
    KeElementEintragen(this,Nach,Modell->KeLast);   
  }

  Modell->unsaved_changes++;

  return this;

}
