/*
  Datei     : Erzeuge_Nm.c
  erstellt  : 22.03.97
  geaendert : 11.04.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"



/*********************************************************************/
/* void Erzeuge_FG_Nm(TypStab_Nm *tmp_stab, long fg_art)             */
/*********************************************************************/ 
/*                                              
   Konstruktor fr Freiheitsgrad im Nutzermodell
   fr tmp_stab (Nutzermodell)  fg_art -> 0 - 5    
   jh, 18.03.97
*/
/*********************************************************************/

TypFreiGrad* Erzeuge_FG_Nm(TypStab_Nm *tmp_stab, long fg_art)
{
  long nummer=0;
  TypFreiGrad *tmp_freigrad;
  
  if(!(tmp_freigrad = (TypFreiGrad*) calloc (1,sizeof(TypFreiGrad))))
    {
      fprintf(stderr,"XStab : MemFault\n");
      exit(1);
    }
  
  (*tmp_freigrad).l_sysid = Modell->System.l_id;
  
  if(fg_art > 2)
    (*tmp_freigrad).l_art = fg_art-3;
  else
    (*tmp_freigrad).l_art = fg_art;
  
  if(Suche_FreiGrad(nummer, Modell->KeFreiGrad_Nm))
    {
      while(Suche_FreiGrad(nummer++, Modell->KeFreiGrad_Nm));
      nummer--;
    }  
 
  (*tmp_freigrad).l_nummer = nummer;
  (*tmp_freigrad).d_verschiebung = 0;
  (*tmp_freigrad).d_einwirkung  = 0;     
  (*tmp_freigrad).l_status = CPmDual;
  (*tmp_freigrad).d_alpha = 0;         

  (*tmp_stab).pe_frei[fg_art] = tmp_freigrad;

  if(Modell->KeFreiGrad_Nm)
    {
      KeElementEintragen(tmp_freigrad, Nach, Modell->KeFreiGrad_Nm);
    }
  else
    {
      Modell->KeFreiGrad_Nm = KeKetteDefinieren();
      KeElementEintragen(tmp_freigrad, Nach, Modell->KeFreiGrad_Nm);
    }

  return tmp_freigrad;

}



/***********************************************************/ 
/* TypPunkt* Erzeuge_Punkt_Nm(double x, double y, long id) */
/***********************************************************/ 
/*                                              
   Konstruktor fr einen Punkt im Nutzermodell
   wenn id == -1 , dann wird ein ID vergeben
   wenn id != -1 wird der id in (*tmp_punkt).l_nummer
   eingetragen
   jh, 17.03.97
*/
/***********************************************************/

TypPunkt* Erzeuge_Punkt_Nm(double x, double y, long id)
{
  TypPunkt* tmp_punkt;

  /* ... Punkt im Nm erzeugen  ... */
  if(!(tmp_punkt = (TypPunkt*) calloc (1,sizeof(TypPunkt))))
    {
      fprintf(stderr,"XStab : MemFault\n");
      exit(1);
    }
  
  (*tmp_punkt).l_sysid = Modell->System.l_id;
  (*tmp_punkt).d_x = x;
  (*tmp_punkt).d_y = y;

  /* Bestimme ID */
  if(id == -1)
    (*tmp_punkt).l_nummer = Suche_freiePunktnummer(Modell->KePunkt_Nm);
  else
    (*tmp_punkt).l_nummer = id;

  /* Punkt in Kette eintragen */
  if(Modell->KePunkt_Nm) 
    KeElementEintragen(tmp_punkt, Nach, Modell->KePunkt_Nm);
  else
    {
      Modell->KePunkt_Nm = KeKetteDefinieren();
      KeElementEintragen(tmp_punkt, Nach, Modell->KePunkt_Nm);
    }

  return tmp_punkt;
}



/***********************************************************/ 
/* TypKnotenlast_Nm* Erzeuge_Punktlast_Nm(long id)         */
/***********************************************************/ 
/*                                              
   Konstruktor fr Punklast im Nutzermodell
   wenn id == -1 , dann wird ein ID vergeben
   wenn id != -1 wird der id in (*tmp_punkt).l_id 
   eingetragen
   jh, 18.03.97
*/
/***********************************************************/

TypKnotenlast_Nm* Erzeuge_Punktlast_Nm(long lastfallid, long id)
{
  TypKnotenlast_Nm* tmp_last;

  if(!(tmp_last = (TypKnotenlast_Nm*) calloc (1,sizeof(TypKnotenlast_Nm))))
    {
      fprintf(stderr,"XStab : MemFault\n");
      exit(1);
    }

  /* ID des Lastfalls eintragen */
  (*tmp_last).l_lastfallid = lastfallid;

  /* ID bestimmen */
  if(id == -1)
    (*tmp_last).l_id = Vergebe_ID();
  else
    (*tmp_last).l_id = id;

  if(Modell->KePunktlast_Nm)
    {
      KeElementEintragen(tmp_last, Nach, Modell->KePunktlast_Nm);
    }
  else
    {
      Modell->KePunktlast_Nm = KeKetteDefinieren();
      KeElementEintragen(tmp_last, Nach, Modell->KePunktlast_Nm);
    }

  Modell->unsaved_changes++;

  return tmp_last;
}



/***********************************************************/ 
/* TypStreckenlast_Nm* Erzeuge_Streckenlast_Nm(long id)    */
/***********************************************************/ 
/*                                              
   Konstruktor fr Streckenlast im Nutzermodell   
   wenn id == -1 , dann wird ein ID vergeben
   wenn id != -1 wird der id in (*tmp_punkt).l_id 
   eingetragen
   jh, 18.03.97
*/
/***********************************************************/

TypStreckenlast_Nm* Erzeuge_Streckenlast_Nm(long lastfallid, 
					    long id)
{
  TypStreckenlast_Nm* tmp_last;

  if(!(tmp_last = (TypStreckenlast_Nm*) calloc (1,sizeof(TypStreckenlast_Nm))))
    {
      fprintf(stderr,"XStab : MemFault\n");
      exit(1);
    }
  
  (*tmp_last).l_lastfallid = lastfallid;

  /* ID bestimmen */
  if(id == -1)
    (*tmp_last).l_id = Vergebe_ID();
  else
    (*tmp_last).l_id = id;

  if(Modell->KeStreckenlast_Nm) {
    KeElementEintragen(tmp_last,Nach,Modell->KeStreckenlast_Nm);
  }
  else {
    Modell->KeStreckenlast_Nm = KeKetteDefinieren();
    KeElementEintragen(tmp_last,Nach,Modell->KeStreckenlast_Nm);
  }

  Modell->unsaved_changes++;

  return tmp_last;
}    	



/***********************************************************/ 
/* TypStab_Nm* Erzeuge_Stab_Nm(void)                       */
/***********************************************************/ 
/*                                              
   Konstruktor fr einen Stab im Nutzermodell  
   wird nicht in Lese() aufgerufen !
   jh, 17.03.97
*/
/***********************************************************/

TypStab_Nm* Erzeuge_Stab_Nm(void)
{
  TypStab_Nm *tmp_stab; 
  long i;
  KeGlied* staebe;

  if(!(tmp_stab = (TypStab_Nm*) calloc (1,sizeof(TypStab_Nm)))) {
    fprintf(stderr,"XStab : MemFault\n");
    exit(1);
  }
  
  (*tmp_stab).l_nummer     = Suche_freieStabnummer_Nm();
  (*tmp_stab).l_selektiert = -1;
  (*tmp_stab).pe_punkta    = NULL;
  (*tmp_stab).pe_punktb    = NULL; 
  (*tmp_stab).intervalle   = NULL;  

  /* FG initialisieren */  
  for(i=0;i<6;i++)    
    (*tmp_stab).pe_frei[i] = NULL;    

  /* Stab in Kette eintragen */
  if(Modell->KeStab_Nm)
    KeElementEintragen(tmp_stab,Nach,Modell->KeStab_Nm);
  else {
    Modell->KeStab_Nm = KeKetteDefinieren();
    KeElementEintragen(tmp_stab,Nach, Modell->KeStab_Nm);
  } 

  /* Standardwerte fr Material und Querschnitte bernehmen */
  if(fl_get_button(staberzeugenform->standardbutton))  { 
    if((Suche_Material(standard_mat) == NULL) || 
       (Suche_Querschnitt(standard_quer) == NULL) ) {
      (*tmp_stab).l_selektiert = 1;

      /* temp. Kette erzeugen */
      staebe = KeKetteDefinieren();
      KeElementEintragen(tmp_stab,Nach, staebe);

      Material_Querschnitt_zuweisen( staebe );

    }
    else {
      Material_Eintragen_Nm(tmp_stab, standard_mat);      
      Querschnitt_Eintragen_Nm(tmp_stab, standard_quer);
    }
  }
  else {
    (*tmp_stab).l_selektiert = 1;

    /* temp. Kette erzeugen */
    staebe = KeKetteDefinieren();
    KeElementEintragen(tmp_stab,Nach, staebe);

    Material_Querschnitt_zuweisen( staebe );

  }   
  
  Modell->unsaved_changes++;

  return tmp_stab;
}



/***********************************************************/ 
/* TypStab_Nm* Erzeuge_Stab_Nm_Lese(void)                  */
/***********************************************************/ 
/*                                              
   Konstruktor fr einen Stab im Nutzermodell  
   fr die Funktion Lese() 
   jh, 17.03.97
*/
/***********************************************************/

TypStab_Nm* Erzeuge_Stab_Nm_Lese(void)
{
  TypStab_Nm *tmp_stab; 
  long i;

  if(!(tmp_stab = (TypStab_Nm*) calloc (1,sizeof(TypStab_Nm)))) {
    fprintf(stderr,"XStab : MemFault\n");
    exit(1);
  }
  
  (*tmp_stab).l_nummer     = Suche_freieStabnummer_Nm();
  (*tmp_stab).l_selektiert = -1;
  (*tmp_stab).pe_punkta    = NULL;
  (*tmp_stab).pe_punktb    = NULL; 
  (*tmp_stab).intervalle   = NULL;  

  /* FG initialisieren */  
  for(i=0;i<6;i++)    
    (*tmp_stab).pe_frei[i] = NULL;    

  /* Stab in Kette eintragen */
  if(Modell->KeStab_Nm)
    KeElementEintragen(tmp_stab,Nach,Modell->KeStab_Nm);
  else {
    Modell->KeStab_Nm = KeKetteDefinieren();
    KeElementEintragen(tmp_stab,Nach, Modell->KeStab_Nm);
  } 

  /* Werte fr Material und Querschnitte werden eingelesen ! */ 
  
  return tmp_stab;
}



/*********************************************************************/
/* void Erzeuge_Intervall(TypStab_Nm *tmp_stab)                      */
/*********************************************************************/ 
/*                                              
   Funktion erzeugt ein Intervall im Stab im Nutzermodell
   jh, 17.04.97 
*/
/*********************************************************************/

TypIntervall *Erzeuge_Intervall(TypStab_Nm *tmp_stab)
{
  TypIntervall *tmp_intervall;

  tmp_intervall = (TypIntervall*) calloc (1,sizeof(TypIntervall));

  /* Intervall in Stab eintragen */
  if( (*tmp_stab).intervalle)
    KeElementEintragen(tmp_intervall,Nach,(*tmp_stab).intervalle);
  else {
    (*tmp_stab).intervalle = KeKetteDefinieren();
    KeElementEintragen(tmp_intervall, Nach, (*tmp_stab).intervalle);
  } 

  return tmp_intervall;

}



void SetzeGeometrie_Nm(TypStab_Nm* tmp_stab)
{
  double x1,y1,x2,y2;
  TypPunkt *p1,*p2;

  p1 = (*tmp_stab).pe_punkta;
  p2 = (*tmp_stab).pe_punktb;

  x1 = (*p1).d_x;
  y1 = (*p1).d_y;

  x2 = (*p2).d_x;
  y2 = (*p2).d_y;

  if(x2-x1) 
    {
      (*tmp_stab).d_alpha = atan((y2-y1)/(x2-x1)); 
      if( (y2-y1)==0 && (x2<x1))
	(*tmp_stab).d_alpha = -PI; 
    } 
  else
    {
      if(y1<y2)
	(*tmp_stab).d_alpha = PI/2;
      if(y1>y2)
	(*tmp_stab).d_alpha = -PI/2;
    }
  
  if( (x2-x1)<0 && (y2-y1)>0 )
    (*tmp_stab).d_alpha += PI ;
  
  if( (x2-x1)<0 && (y2-y1)<0 )
    (*tmp_stab).d_alpha += PI ;

  (*tmp_stab).d_laenge = sqrt( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
  (*tmp_stab).d_cos =  cos((*tmp_stab).d_alpha);
  (*tmp_stab).d_sin =  sin((*tmp_stab).d_alpha);      

}



/*********************************************************************/
/* TypLastfallkombination* erzeugeLFKombination(long id)             */
/*********************************************************************/ 
/*                                              
   Konstruktor fr eine Lastfall-Kombination
   jh, 22.08.97
*/
/*********************************************************************/

TypLastfallkombination* erzeugeLFKombination(long id)
{
  TypLastfallkombination* tmp_lfkomb;

  tmp_lfkomb = (TypLastfallkombination*) calloc (1,sizeof(TypLastfallkombination));

  if(id == -1)
    tmp_lfkomb->l_id = suchefreieLFKombNummer();
  else 
    tmp_lfkomb->l_id = id; 
    

  sprintf(tmp_lfkomb->c_name,"Kombination");
  tmp_lfkomb->l_aktiv = 0;

  tmp_lfkomb->LFKomb = Mng_MengeDefinieren();

  if(Modell->KeLfKombination)
    {
      KeElementEintragen(tmp_lfkomb, Nach, Modell->KeLfKombination);
    }
  else
    {
      Modell->KeLfKombination = KeKetteDefinieren();
      KeElementEintragen(tmp_lfkomb, Nach, Modell->KeLfKombination);
    }
  
  return tmp_lfkomb;

}
