/*
  Datei     : Last.c
  erstellt  : 24.07.96
  geaendert : 16.03.97
  Autor     : jh
*/


#include "XStabDek.h"



void Punktlasten_kopieren(long von_id, long nach_id);
void Streckenlasten_kopieren(long von_id, long nach_id);



/***********************************************************/ 
/* void Lastfall(void)                                     */
/***********************************************************/ 
/*                                              
   Fkt. zeigt die form 'Lastfall erzeugen'
   jh, 18.03.97
*/
/***********************************************************/

void Lastfall(void)
{
  fl_set_focus_object(lastfallform->lastfall,lastfallform->lastfallname);
  fl_show_form(lastfallform->lastfall,FL_PLACE_CENTER,
	       FL_TRANSIENT,"Lastfall erzeugen"); 
}



/*********************************************************************/
/* double HoleGewicht(long nummer)                                   */
/*********************************************************************/ 
/*                                              
   Fkt gibt das Gewicht des Lastfalls mit dem
   Lastfall ID 'nummer' zurck
   jh, 18.03.97
*/
/*********************************************************************/

double HoleGewicht(long nummer)
{
  TypLastfall *tmp_last;
  KeGlied *p;

  if(Modell->KeLast) {
    KeDurchlaufVorwaerts(p,Modell->KeLast) {
      tmp_last = p->x;
      if((*tmp_last).l_id == nummer)
	return (*tmp_last).d_gewicht;
    }
  }
  return 0.;
}



/*********************************************************************/
/* void HoleAktiveLastfaelle_Lastwahl(Menge *M)                      */
/*********************************************************************/ 
/*                                              
   Fkt liest aus der Kette KeLast die
   aktiven Lastflle und schreibt den _ID_
   des Lastfalls in die Menge M
   jh, 18.03.97
*/
/*********************************************************************/

void HoleAktiveLastfaelle_Lastwahl(Menge *M)
{ 
  TypLastfall *tmp_lastfall;
  long *id;
  KeGlied *p;
  
  if(Modell->KeLast)
    KeDurchlaufVorwaerts(p,Modell->KeLast) { 

    tmp_lastfall = p->x;   
    
    if(tmp_lastfall->l_aktiv == 1) {
	
      if(!(id = (long*) calloc (1,sizeof(long)))) {
	fprintf(stderr,"Fehler beim allokieren\n");
	exit(1);
      } 
	
      *id = tmp_lastfall->l_id;
      
      /* Lastfall-ID in M eintragen */
      Mng_ElementEintragen(id,M);
	
    }
  }  
}



/*********************************************************************/
/* void aktualisiereAuswahlLF(void)                                  */
/*********************************************************************/ 
/*                                              
   Fkt. ubertrgt sie aktuelle Auswahl im 
   Browser auf die Lastflle
   jh, 23.08.97
*/
/*********************************************************************/

void aktualisiereAuswahlLF(void)
{
  long nummer,i,j;
  TypLastfall *tmp_lastfall;
  char *c_tmp;
  char lastnummer[3];

  for(i=1;i<=fl_get_browser_maxline(lastfallbrowserform->lastfallbrowser);i++) {   
               
    /* Hole Nummer des Lastfalls aus der Zeile im Browser */
    c_tmp = (char*) fl_get_browser_line(lastfallbrowserform->lastfallbrowser,i);
      
    for(j=0;j<3;j++)
      lastnummer[j] = c_tmp[j];     
    nummer = (long) atol(lastnummer);           
      
    tmp_lastfall = Suche_Lastfall_nr(nummer);
    
    if(fl_isselected_browser_line(lastfallbrowserform->lastfallbrowser,i)) 
      tmp_lastfall->l_aktiv = 1;
    else
      tmp_lastfall->l_aktiv = -1;
    
  }
}





void BerechneMass(double *mass,double *off_x, double *off_y,
		  long win_w,long win_h,TypStab_Nm *tmp_stab)
{
  double xa,ya,xb,yb;

  TypPunkt *tmp_punkt1,*tmp_punkt2;

  tmp_punkt1 = (*tmp_stab).pe_punkta;
  tmp_punkt2 = (*tmp_stab).pe_punktb;
  
  xa = (*tmp_punkt1).d_x;
  ya = (*tmp_punkt1).d_y;
  xb = (*tmp_punkt2).d_x;
  yb = (*tmp_punkt2).d_y;
  
  if(fabs(xa-xb))
    *mass = win_w/(2*fabs(xa-xb));
  else
    *mass = win_h/(2*fabs(ya-yb));
  
  if(fabs(ya-yb))
    if( win_h/(2*fabs(ya-yb)) < *mass)
      *mass = win_h/(2*fabs(ya-yb));  
  
  *off_x =  0.5*(win_w - (xa+xb)*(*mass));	  	  
  *off_y = -0.5*(win_h - (ya+yb)*(*mass));
}

  

void LastfallGewichten(void)
{
  long i,j;
  long nummer;
  char *c_tmp;
  char lastnummer[3];   
  double gewicht;
    
  c_tmp = (char*) fl_get_input(inputform->input); 
  gewicht = atof(c_tmp);
  
  for(i=1;i<=fl_get_browser_maxline(lastfallbrowserform->lastfallbrowser);i++)
    {
      if(fl_isselected_browser_line(lastfallbrowserform->lastfallbrowser,i))
	{
	  c_tmp = (char*) fl_get_browser_line(lastfallbrowserform->lastfallbrowser,i);
	  for(j=0;j<3;j++)
	    lastnummer[j] = c_tmp[j];     
	  nummer = atol(lastnummer);	  
	  
	  LastfallSetzeGewicht(nummer,gewicht);
	  
	}
    }
 
  schreibeBrowserLastfall();
  
  fl_hide_form(inputform->inputform);      
}



void LastfallSetzeGewicht(long nummer,double gewicht)
{
  KeGlied *p;
  TypLastfall *tmp_last;

  if(Modell->KeLast)
    KeDurchlaufVorwaerts(p,Modell->KeLast)
    { 
      tmp_last = p->x;   
      if((*tmp_last).l_nummer == nummer)
	(*tmp_last).d_gewicht = gewicht;
    }  
}
 

void Lastfall_Name_aendern(void)
{
  long i,j;
  long nummer;
  char *name,*c_tmp;
  char lastnummer[3]; 
  
  name = (char*) fl_get_input(inputform->input); 
  
  for(i=1;i<=fl_get_browser_maxline(lastfallbrowserform->lastfallbrowser);i++)
    {
      if(fl_isselected_browser_line(lastfallbrowserform->lastfallbrowser,i))
	{
	  c_tmp = (char*) fl_get_browser_line(lastfallbrowserform->lastfallbrowser,i);
	  for(j=0;j<3;j++)
	    lastnummer[j] = c_tmp[j];     
	  nummer = atol(lastnummer);	  
	  
	  Lastfall_Name(nummer,name);
	  
	}
    }

  schreibeBrowserLastfall();
  
  fl_hide_form(inputform->inputform);        
}


void Lastfall_Name(long nummer,char *name)
{
  KeGlied *p;
  TypLastfall *tmp_last;

  if(Modell->KeLast)
    KeDurchlaufVorwaerts(p,Modell->KeLast)
    { 
      tmp_last = p->x;   
      if((*tmp_last).l_nummer == nummer)
	sprintf( (*tmp_last).c_name,"%s",name);
    }  
}



/*********************************************************************/
/* void Lastfall_kopieren(long id)                                   */
/*********************************************************************/ 
/*                                              
   Lastfall kopieren
   jh, 04.05.97
*/
/*********************************************************************/

void Lastfall_kopieren(long id)
{
  TypLastfall *tmp_lastfall;
  TypLastfall *tmp_lastfallneu;
  char name[200];
  char c_text[200];

  tmp_lastfall = Suche_Lastfall_id(id);
  sprintf(name,"%s(neu)",(*tmp_lastfall).c_name);

  /* neuen LF erzeugen */
  tmp_lastfallneu = Erzeuge_Lastfall(0,name,-1);
  (*tmp_lastfallneu).d_gewicht =  (*tmp_lastfall).d_gewicht;

  /* Lastfall in Browser schreiben */      
  sprintf(c_text,"%3ld %5.2f %s", 
	  (*tmp_lastfallneu).l_nummer, (*tmp_lastfallneu).d_gewicht, (*tmp_lastfallneu).c_name);
  fl_addto_browser(lastfallbrowserform->lastfallbrowser,c_text);

  Punktlasten_kopieren( (*tmp_lastfall).l_id,  (*tmp_lastfallneu).l_id);
  Streckenlasten_kopieren( (*tmp_lastfall).l_id,  (*tmp_lastfallneu).l_id );

}



/*********************************************************************/
/* void Punktlasten_kopieren(long von_id, long nach_id)              */
/*********************************************************************/ 
/*                                              
   Fkt kopiert alle Punktlasten des einen Lastfalls in einen 
   anderen
   jh, 04.05.97
*/
/*********************************************************************/

void Punktlasten_kopieren(long von_id, long nach_id)
{
  KeGlied *p;
  TypKnotenlast_Nm *tmp_punktlast, *tmp_pl;

  if(!Modell->KePunktlast_Nm)
    return;

  /* Schleife ueber alle Punktlasten */
  KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm) {
    tmp_punktlast = p->x;

    /* gehrt aktuelle PL zum Lastfall von_id ? */
    if( (*tmp_punktlast).l_lastfallid == von_id ) {

      /* neue PL erzeugen */
      tmp_pl = Erzeuge_Punktlast_Nm(nach_id, -1);

      /* Werte bernehmen */
      sprintf((*tmp_pl).c_name,"%s",(*tmp_punktlast).c_name);
      (*tmp_pl).d_last            = (*tmp_punktlast).d_last;
      (*tmp_pl).l_stabnummer      = (*tmp_punktlast).l_stabnummer;
      (*tmp_pl).d_alpha           = (*tmp_punktlast).d_alpha;
      (*tmp_pl).l_koordsys_winkel = (*tmp_punktlast).l_koordsys_winkel;
      (*tmp_pl).l_koordsys_pos    = (*tmp_punktlast).l_koordsys_pos;
      (*tmp_pl).d_pos             = (*tmp_punktlast).d_pos;
      (*tmp_pl).l_art             = (*tmp_punktlast).l_art;

    }
  }

}



/*********************************************************************/
/* void Streckenlasten_kopieren(long von_id, long nach_id)           */
/*********************************************************************/ 
/*                                              
   Fkt kopiert alle Streckenlastenlasten des einen 
   Lastfalls in einen anderen
   jh, 04.05.97
*/
/*********************************************************************/

void Streckenlasten_kopieren(long von_id, long nach_id)
{
  KeGlied *p;
  TypStreckenlast_Nm *tmp_streckenlast, *tmp_sl;

  if(!Modell->KeStreckenlast_Nm)
    return;

  /* Schleife ueber alle Streckenlasten */
  KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm) {
    tmp_streckenlast = p->x;

    /* gehrt aktuelle SL zum Lastfall von_id ? */
    if( (*tmp_streckenlast).l_lastfallid == von_id ) {

      /* neue SL erzeugen */
      tmp_sl = Erzeuge_Streckenlast_Nm(nach_id, -1);

      /* Werte bernehmen */
      sprintf((*tmp_sl).c_name,"%s",(*tmp_streckenlast).c_name);
      (*tmp_sl).d_lasta       = (*tmp_streckenlast).d_lasta;
      (*tmp_sl).d_lastb       = (*tmp_streckenlast).d_lastb;    
      (*tmp_sl).d_alpha       = (*tmp_streckenlast).d_alpha;
      (*tmp_sl).l_koordsys    = (*tmp_streckenlast).l_koordsys;
      (*tmp_sl).l_stabnummer  = (*tmp_streckenlast).l_stabnummer;
      (*tmp_sl).d_anf         = (*tmp_streckenlast).d_anf;
      (*tmp_sl).d_end         = (*tmp_streckenlast).d_end;            

    }
  }

}



/*********************************************************************/
/* void copyLoad(TypStab_Nm* stab)                                   */
/*********************************************************************/
/*                                              
   Fkt zeigt den Dialog 'Last kopieren' 
   Quelle ist stab
   jh, 14.02.98
*/
/*********************************************************************/

void showCopyLoadDlg(TypStab_Nm* stab)
{
  
  fl_show_form(lastkopierenform->copyLoad,
	       FL_PLACE_CENTER,FL_TRANSIENT,locale("Last kopieren"));

}
