/*
  Datei     : Loesche_Nm.c
  erstellt  : 16.03.97
  geaendert : 13.04.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"



/*********************************************************************/
/*  void loescheModell()                                             */
/*********************************************************************/
/*                                              
   System und Belastung im Nutzermodell lschen
   jh, 15.03.97

*/
/*********************************************************************/

void loescheModell(TypModell* model)
{
  KeGlied *l,*l2;
  KeGlied *tmp_inter;
  TypStab_Nm *tmp_stab;
  TypLastfallkombination* tmp_lfkomb; 
  TypModell *tmp_model;


  /* ...  lsche Stbe  ... */
  if(model->KeStab_Nm) {
    while(model->KeStab_Nm->nach != model->KeStab_Nm)
      {	  
	l = model->KeStab_Nm->nach;
	KeGliedAustragen(l);       
	tmp_stab = l->x;
	
	/* Intervalle lschen */
	tmp_inter = tmp_stab->intervalle;

	if(tmp_inter) {
	  while(tmp_inter->nach != tmp_inter) {	  
	    l2 = tmp_inter->nach;
	    KeGliedAustragen(l2);     
	    free(l2->x);
	  }
	}
	
	free(l->x);

      }
  }
  
  /* ...  Punkte  ... */
  if(model->KePunkt_Nm) {
    while(model->KePunkt_Nm->nach != model->KePunkt_Nm)
      {
	l = model->KePunkt_Nm->nach;	 
	KeGliedAustragen(l); 		  	             
	free(l->x);	 
      }
  } 
  
  /* ...  Freiheitsgrade  ... */
  if(model->KeFreiGrad_Nm)
    {
      while(model->KeFreiGrad_Nm->nach != model->KeFreiGrad_Nm)
	{
	  l = model->KeFreiGrad_Nm->nach;	 
	  KeGliedAustragen(l); 		  	             
	  free(l->x);	 
	}
    }	  

  /* ...  Punktlasten  ... */   
  if(model->KePunktlast_Nm)
    {
      while(model->KePunktlast_Nm->nach != model->KePunktlast_Nm)
	{
	  l = model->KePunktlast_Nm->nach;
	  KeGliedAustragen(l); 		  	             
	  free(l->x);	 
	}
    }	
 
  /* ...  Streckenlasten  ... */
  if(model->KeStreckenlast_Nm)
    {
      while(model->KeStreckenlast_Nm->nach != model->KeStreckenlast_Nm)
	{
	  l = model->KeStreckenlast_Nm->nach;
	  KeGliedAustragen(l); 		  	             
	  free(l->x);	 
	}
    }	
 
  /* Lastflle */
  if(model->KeLast) {
    while(model->KeLast->nach != model->KeLast) {
      l = model->KeLast->nach;	 
      KeGliedAustragen(l); 		  	             
      free(l->x);	 
    }
  }	
  
  /* FG - Relationen */
  if(model->FG_Relation_Nm)    
    Mng_MengeLoeschen(model->FG_Relation_Nm); 
   

  /* LF - Kombinationen */
  if(model->KeLfKombination) {
    while(model->KeLfKombination->nach != model->KeLfKombination) {
      l = model->KeLfKombination->nach;
      tmp_lfkomb = l->x;
      KeGliedAustragen(l); 		  	             
      Mng_MengeUndElementeLoeschen (tmp_lfkomb->LFKomb);
      free(l->x);	 
    }
  }	

  fl_clear_browser(lastfallbrowserform->lastfallbrowser);  
  fl_clear_browser(lastfallbrowserform->lastfall_komb_browser);


  /* Modell aus der kette austragen */
  if(KeModell) {
    KeDurchlaufVorwaerts(l,KeModell)  {
      tmp_model = l->x;
      if(tmp_model == model)
	KeGliedAustragen(l);
    }
  }

  free(model);

  Meldung("System und Belastung gelscht ");

}



/***********************************************************/
/*  void Loesche_FreiGrad_Nm(TypFreiGrad *tmp_freigrad)    */
/***********************************************************/ 
/*                                              
   Fkt loescht FG wenn nur noch von einem Stab bentigt.
   Der dazugehrige Stab wird _nach_ Aufruf der Funktion 
   gelscht
   return 0 : FG wurde nicht gelscht
   return 1 : FG wurde gelscht
   jh, 15.03.97

*/
/***********************************************************/

long Loesche_FreiGrad_Nm(TypFreiGrad *tmp_freigrad)
{
  long anz = -1;
  TypStab_Nm *tmp_stab;
  KeGlied *p;
  long j;

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
      {
	tmp_stab = p->x;     
	for(j=0;j<6;j++)
	  if((*tmp_stab).pe_frei[j] ==  tmp_freigrad )
	    {
	      anz++;
	      break; /* ein FG kann zwar mehrmals von einem 
			Stab benutzt werden, dies darf aber nur
			einmal in die Zhlung eingehen */
	    }
      }
  
  if(!anz) /* wird nur 1x benutzt -> FG lschen */
    {
      Loesche_FG_Nm((*tmp_freigrad).l_nummer);
      return 1;
    }
  else
    return 0;
  

}


void Loesche_FG_Nm(long fgnummer)
{
  KeGlied *p;
  TypFreiGrad *tmp_freigrad;
  
  if(Modell->KeFreiGrad_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeFreiGrad_Nm)
    {
      tmp_freigrad = p->x;
      
      if((*tmp_freigrad).l_nummer == fgnummer)
	{	 
	  Loesche_Relationen(tmp_freigrad, Modell->FG_Relation_Nm);
	  KeGliedAustragen(p); 
	  free(tmp_freigrad);
	  break;
	}
    }
}



/*********************************************************************/
/* void Loesche_Stab_Nm(Menge *M)                                    */
/*********************************************************************/ 
/*
  Fkt lscht die Stbe in der Menge M	
  jh, 04.05.97    
*/
/*********************************************************************/

void Loesche_Stab_Nm(Menge *M)
{  
  long i,k;
  KeGlied *p;
  KeGlied *tmp_intervalle;
  TypFreiGrad *tmp_freigrad;
  long stabnummer;

  TypStab_Nm *tmp_stab;

  /* Schleife ber Menge mit Stben */
  for(k=1; k<= M->n; k++) {

    tmp_stab = M->feld[k];
    
    if(!tmp_stab)
      return;
    
    stabnummer = (*tmp_stab).l_nummer;
    
    /* Lasten loeschen */  
    Loesche_Streckenlast_Stabnummer_Nm(stabnummer);
    Loesche_Punktlast_Stabnummer_Nm(stabnummer);
    
    /* Pruefen, ob Punkte des Stabes noch benutzt werden */        
    Loesche_Punkt_Nm( (*tmp_stab).pe_punkta );
    Loesche_Punkt_Nm( (*tmp_stab).pe_punktb );
    
    /* Pruefen, ob die Freiheitsgrade des Stabes noch benutzt werden */            
    for(i=0;i<6;i++)  {
      tmp_freigrad =  (*tmp_stab).pe_frei[i];	 	  
      Loesche_FreiGrad_Nm(tmp_freigrad);
    }	      
    
    /* Intervalle lschen */     
    tmp_intervalle = (*tmp_stab).intervalle;
    
    if(tmp_intervalle)
      while(tmp_intervalle->nach != tmp_intervalle)  {	  
	p = tmp_intervalle->nach;
	KeGliedAustragen(p); 
	free(p->x);
      }
  
    /* Stab aus Kette austragen */
    if(!Modell->KeStab_Nm)
      return;

    KeDurchlaufVorwaerts(p, Modell->KeStab_Nm)  {
      if(p->x == tmp_stab) {
	KeGliedAustragen(p); 
	free(tmp_stab);
	break;
      }
    }
  }

  Modell->unsaved_changes++;

}
 


/***********************************************************/
/*  void Loesche_Punkt_Nm(TypPunkt* tmp_punkt)             */
/***********************************************************/ 
/*                                              
   Lscht einen Punkt, wenn dieser nur einmal benutzt wird.
   Der dazugehrige Stab wird _nach_ Aufruf der Funktion 
   gelscht
   jh, 15.03.97

*/
/***********************************************************/

void Loesche_Punkt_Nm(TypPunkt* tmp_punkt)
{
  long anz=-1;
  TypPunkt *tmp_punkt2;
  TypStab_Nm *tmp_stab;
  KeGlied* p;
  
  if(!tmp_punkt)
    return;
  
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {
      tmp_stab = p->x;     
      
      if( (*tmp_stab).pe_punkta == tmp_punkt )
	anz++;
      
      if( (*tmp_stab).pe_punktb == tmp_punkt )
	anz++;
    }
  
  if(anz<1)  {
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)  {
      tmp_punkt2 = p->x;
      if(tmp_punkt == tmp_punkt2)  {
	KeGliedAustragen(p); 		  	             
	free(tmp_punkt);
	break;
      }      
    }   
  }
}


/* Lscht alle Punktlasten eines Lastfalls */

void Loesche_Punktlast_Nm(long lastnummer)
{
  long flag = 1;
  KeGlied *p,*l=NULL;
  TypKnotenlast_Nm *tmp_knotenlast;

  while(flag)  {
    flag = 0;
    if(Modell->KePunktlast_Nm)  {
      KeDurchlaufVorwaerts(p, Modell->KePunktlast_Nm) {
	tmp_knotenlast = p->x;     
	if( (*tmp_knotenlast).l_lastfallid == lastnummer)	    
	  {
	    flag = 1;
	    l = p ;	  
	  }
      }    
      if(flag)
	{
	  KeGliedAustragen(l); 
	  free(l->x); 
	}
    }
  }   

  Modell->unsaved_changes++;
  
}


void Loesche_Punktlast_ID__Nm(long id)
{
  KeGlied *p;
  TypKnotenlast_Nm *tmp_knotenlast;
  
  if(!Modell->KePunktlast_Nm)   
    return;

  KeDurchlaufVorwaerts(p, Modell->KePunktlast_Nm) {
    tmp_knotenlast = p->x;     
    if( (*tmp_knotenlast).l_id == id)	    
      {	     	  
	KeGliedAustragen(p); 
	free(p->x);
	break;
      }
  }
  
  Modell->unsaved_changes++;

}   



/*********************************************************************/
/* void Loesche_Streckenlast_ID__Nm(long id)                         */
/*********************************************************************/
/*                                              
   Funktion lscht die Streckenlast mit der Id 'id'
   im Nutzermodell
   jh, 05.05.97
*/
/*********************************************************************/

void Loesche_Streckenlast_ID__Nm(long id)
{
  KeGlied *p;
  TypStreckenlast_Nm *tmp_streckenlast;
  
  if(Modell->KeStreckenlast_Nm)   
    KeDurchlaufVorwaerts(p, Modell->KeStreckenlast_Nm) {
      tmp_streckenlast = p->x;
      if( (*tmp_streckenlast).l_id == id)  {	     	  
	KeGliedAustragen(p); 
	free(p->x);
	break;
      }
    }
}   


/* Lscht alle Streckenlasten eines Lastfalls */

void Loesche_Streckenlast_Nm(long lastfallid)
{
 long flag = 1;
 KeGlied *p=NULL,*l=NULL;
 TypStreckenlast_Nm *tmp_streckenlast;

 while(flag) {
   flag = 0;
   if(Modell->KeStreckenlast_Nm) {
     KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm) {
       tmp_streckenlast = p->x;     
       if( (*tmp_streckenlast).l_lastfallid == lastfallid) {
	 flag = 1;
	 l = p ;	  
       }
     }    
     if(flag) {
       KeGliedAustragen(l); 
       free(l->x); 
     }
   }
 }

 Modell->unsaved_changes++;

}


void Loesche_Streckenlast_Stabnummer_Nm(long stabnummer)
{
  long flag = 1;
  KeGlied *p,*l=NULL;
  TypStreckenlast_Nm *tmp_streckenlast;
  
  while(flag)
    {
      flag = 0;
      if(Modell->KeStreckenlast_Nm)
	{
	  KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm)
	    {
	      tmp_streckenlast = p->x;     
	      if( (*tmp_streckenlast).l_stabnummer == stabnummer)	    
		{
		  flag = 1;
		  l = p ;	  
		}
	    }    
	  if(flag)
	    {
	      KeGliedAustragen(l); 
	      free(l->x); 
	    }
	}
    }

  Modell->unsaved_changes++;

}


void Loesche_Punktlast_Stabnummer_Nm(long stabnummer)
{
  long flag = 1;
  KeGlied *p,*l=NULL;
  TypKnotenlast_Nm *tmp_punktlast;
  
  while(flag) {
    flag = 0;
    if(Modell->KePunktlast_Nm) {
      KeDurchlaufVorwaerts(p, Modell->KePunktlast_Nm) {
	tmp_punktlast = p->x;
	if( (*tmp_punktlast).l_stabnummer == stabnummer) {
	  flag = 1;
	  l = p ;	  
	}
      }    
      if(flag) {
	KeGliedAustragen(l); 
	free(l->x); 
      }
      }
  }
  
  Modell->unsaved_changes++;
  
}



/*********************************************************************/
/* void loescheLFKombination(long id)                                */
/*********************************************************************/
/*                                              
   Funktion lscht die Lastfallkombination mit der Id 'id'  
   jh, 23.08.97
*/
/*********************************************************************/

void loescheLFKombination(long id)
{
  TypLastfallkombination* tmp_lfkomb; 
  KeGlied* p;

  if(Modell->KeLfKombination) {
    KeDurchlaufRueckwaerts(p, Modell->KeLfKombination) { 
      
      tmp_lfkomb = p->x;
      
      if( tmp_lfkomb->l_id == id ) {

	Mng_MengeUndElementeLoeschen (tmp_lfkomb->LFKomb);

	KeGliedAustragen(p); 
	free(tmp_lfkomb);
	break;

      }
    }
  } 

}
