/*
  Datei     : freigrad_cb.c
  erstellt  : 17.07.96
  gendert  : 08.04.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"



/********************************************************************/
/* void freigrad_ok_cb(FL_OBJECT *obj, long arg)                    */
/********************************************************************/ 
/*                                              
   cb-Fkt schliet die form freigradform
   jh, 08.04.97                                 
*/
/********************************************************************/

void freigrad_ok_cb(FL_OBJECT *obj, long arg)
{
  fl_hide_form(freigradform->freigrad);
  fl_set_event_callback(win_cb,0); 
  Zeichne();   
}



/********************************************************************/
/* void drehung_lokal_input_cb(FL_OBJECT *obj, long arg)            */
/********************************************************************/ 
/*                                              
   cb-Fkt 
   Eingabe einer Drehung des FG bzgl. des lokalen 
   Koordinatensystems
   jh, 11.04.97                                 
*/
/********************************************************************/

void drehung_lokal_input_cb(FL_OBJECT *obj, long arg)
{  
  long fg_nummer;
  double alpha;
  char *c_tmp; 
  char c_text[10];
  TypStab_Nm *tmp_stab;
  
  tmp_stab = Suche_Stab_select_Nm(&fg_nummer);  

  c_tmp = (char*) fl_get_input(freigradform->nummer_0_input);
  fg_nummer = atol(c_tmp);       

  c_tmp = (char*) fl_get_input(obj); 
  alpha = atof(c_tmp);

  Drehe_FG_Nm(fg_nummer, alpha + (*tmp_stab).d_alpha);

  sprintf(c_text,"%.2f", alpha + (*tmp_stab).d_alpha);
  fl_set_input(freigradform->drehung_global_input, c_text);

  Zeichne_FG();

}


/********************************************************************/
/* void drehung_global_input_cb(FL_OBJECT *obj, long arg)           */
/********************************************************************/ 
/*                                              
   cb-Fkt 
   Eingabe einer Drehung des FG bzgl. des globalen
   Koordinatensystems
   jh, 11.04.97                                 
*/
/********************************************************************/

void drehung_global_input_cb(FL_OBJECT *obj, long arg)
{ 
  long fg_nummer;
  double alpha;
  char *c_tmp; 
  char c_text[10];
  TypStab_Nm *tmp_stab;
  
  tmp_stab = Suche_Stab_select_Nm(&fg_nummer); 

  c_tmp = (char*) fl_get_input(freigradform->nummer_0_input);
  fg_nummer = atol(c_tmp);    
 
  c_tmp = (char*) fl_get_input(obj); 
  alpha = atof(c_tmp);
  
  Drehe_FG_Nm(fg_nummer,alpha);
  
  sprintf(c_text,"%.2f",alpha - (*tmp_stab).d_alpha);
  fl_set_input(freigradform->drehung_lokal_input,c_text); 

  Zeichne_FG();

}


/********************************************************************/
/* void von_button_cb(FL_OBJECT *obj, long arg)                     */
/********************************************************************/ 
/*                                              
   cb-Fkt 
   Setzen der Werte der Freiheitsgrade am Punkt A in 
   die form freigradform
   jh, 11.04.97                                 
*/
/********************************************************************/

void von_button_cb(FL_OBJECT *obj, long arg)
{  
  fg_setze_form(0);
}



/********************************************************************/
/* void nach_button_cb(FL_OBJECT *obj, long arg)                    */
/********************************************************************/ 
/*                                              
   cb-Fkt 
   Setzen der Werte der Freiheitsgrade am Punkt B in 
   die form freigradform
   jh, 11.04.97                                 
*/
/********************************************************************/

void nach_button_cb(FL_OBJECT *obj, long arg)
{ 
  fg_setze_form(1);
}



/*********************************************************************/
/* void fg_primal_cb(FL_OBJECT *obj, long arg)                       */
/*********************************************************************/ 
/*                                              
   cb-Fkt setzt den entsprechenden FG auf primal
   jh, 08.04.97                                 
*/
/*********************************************************************/

void fg_primal_cb(FL_OBJECT *obj, long arg)
{ 
  TypFreiGrad *tmp_fg;
  long nummer=0;
  char *c_tmp=NULL,*c_tmp2=NULL;
  double u;

  switch(arg)
    {
    case 0 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_0_input);      
      nummer = atol(c_tmp);
      c_tmp2 = (char*) fl_get_input(freigradform->verschiebung_0_input); 
      fl_set_object_label(freigradform->einw_0_text,"Auflager");
     break;
      
    case 1 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_1_input);      
      nummer = atol(c_tmp);
      c_tmp2 = (char*) fl_get_input(freigradform->verschiebung_1_input); 
      fl_set_object_label(freigradform->einw_1_text,"Auflager"); 
      break;
      
    case 2 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_2_input);
      nummer = atol(c_tmp);
      c_tmp2 = (char*) fl_get_input(freigradform->verschiebung_2_input); 
      fl_set_object_label(freigradform->einw_2_text,"Auflager"); 
      break;
    } 

  tmp_fg = suche_FG_Nm(nummer);
  (*tmp_fg).l_status = CPmPrimal;

  u = atof(c_tmp2);
  (*tmp_fg).d_verschiebung = u;

  Zeichne_FG();

}



/*********************************************************************/
/* void fg_dual_cb(FL_OBJECT *obj, long arg)                         */
/*********************************************************************/ 
/*                                              
   cb-Fkt setzt den entsprechenden FG auf dual
   jh, 08.04.97                                 
*/
/*********************************************************************/

void fg_dual_cb(FL_OBJECT *obj, long arg)
{ 
  TypFreiGrad *tmp_fg;
  long nummer=0;
  char *c_tmp=NULL,*c_tmp2=NULL;
  double feder;

  switch(arg)
    {
    case 0 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_0_input);      
      nummer = atol(c_tmp);
      c_tmp2 = (char*) fl_get_input(freigradform->feder_0_input);
      fl_set_object_label(freigradform->einw_0_text,"Einwirkung"); 
      break;
      
    case 1 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_1_input);   
      nummer = atol(c_tmp);
      c_tmp2 = (char*) fl_get_input(freigradform->feder_1_input); 
      fl_set_object_label(freigradform->einw_1_text,"Einwirkung"); 
      break;
      
    case 2 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_2_input); 
      nummer = atol(c_tmp); 
      c_tmp2 = (char*) fl_get_input(freigradform->feder_2_input);  
      fl_set_object_label(freigradform->einw_2_text,"Einwirkung"); 
      break;
    } 

  tmp_fg = suche_FG_Nm(nummer);
 
  (*tmp_fg).l_status = CPmDual;

  feder = atof(c_tmp2);
  (*tmp_fg).d_feder = feder;

  Zeichne_FG();

}


void fg_verschiebung_cb(FL_OBJECT *obj, long arg)
{ 
  long fg_nummer=0;
  double u;
  char *c_tmp; 
  TypFreiGrad *tmp_fg;

  /* Hole Nummer */
  switch(arg)
    {
    case 0 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_0_input); 
      fg_nummer = atol(c_tmp); 
      break;

    case 1 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_1_input); 
      fg_nummer = atol(c_tmp); 
      break;

    case 2 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_2_input); 
      fg_nummer = atol(c_tmp); 
      break;
    }

  c_tmp = (char*) fl_get_input(obj); 
  u = atof(c_tmp);
  
  /* suche Freiheitsgrad */
  tmp_fg = suche_FG_Nm(fg_nummer);
  
  if(tmp_fg)
    (*tmp_fg).d_verschiebung = u;

}



/***********************************************************/ 
/* void fg_nummer_cb(FL_OBJECT *obj, long arg)             */
/***********************************************************/ 
/*                                              
   cb-Funktion 
   Eingabe einer Freiheitsgradnummer
   wenn die Nummer schon vorhanden ist, wird das Gelenk 
   geschlossen
   jh, 09.04.97
*/
/***********************************************************/

void fg_nummer_input_cb(FL_OBJECT *obj, long arg)
{ 

  TypFreiGrad *tmp_fg;
  long nummer,flag;
  char *c_tmp;
  TypStab_Nm *tmp_stab;
  
  /* Hole selektierten Stab */
  tmp_stab = Suche_Stab_select_Nm(&nummer); 

  /* Punkt A oder B ? */
  if(fl_get_button(freigradform->von_button))
    flag = 0;
  else
    flag = 1;

  /* Hole FG-Nummer */
  c_tmp = (char*) fl_get_input(obj);
  nummer = atol(c_tmp);

  /* hat sich die Nummer gendert ? */
  tmp_fg = (*tmp_stab).pe_frei[(flag*3)+arg];
  if( (*tmp_fg).l_nummer == nummer )    
    return; 

  /* suche Freiheitsgrad */
  tmp_fg = suche_FG_Nm(nummer);

  if(tmp_fg)
    {     

      if((*tmp_fg).l_art != arg ) /* der schon vorhandene FG ist nicht vom gleichen Typ */
	{	
	  fg_setze_form(flag);
	  return;
	}

      /* alten FG lschen, wenn nur noch vom akt. Stab bentigt */
      Loesche_FreiGrad_Nm( (*tmp_stab).pe_frei[(flag*3)+arg] );
      
      /* gefundenen FG in Stab eintragen */
      (*tmp_stab).pe_frei[(flag*3)+arg] = tmp_fg;
      Zeichne_FG();
      fg_setze_form(arg);
    }
  else  /* noch nicht vorhanden */
    {
      printf("FG noch nicht vorhanden \n");

      /* neuen Fg erzeugen, neue Nummer vergeben und eintragen */
      fg_erzeugen_cb(NULL, arg);  
    }
}



/***********************************************************/ 
/* void fg_menu_cb(FL_OBJECT *obj, long arg)               */
/***********************************************************/ 
/*                                              
   cb-Funktion Zeichenmenu in der form freigradform
   Auswahl der zu zeichenden Elemente - Lager, Fg-Nr
   jh, 09.04.97
*/
/***********************************************************/

void fg_menu_cb(FL_OBJECT *obj, long arg)
{ 
  Zeichne_FG();
}


void fg_feder_cb(FL_OBJECT *obj, long arg)
{ 
  long fg_nummer=0;
  double feder;
  char *c_tmp; 
  TypFreiGrad *tmp_fg;

  /* Hole Nummer */
  switch(arg)
    {
    case 0 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_0_input); 
      fg_nummer = atol(c_tmp); 
      break;

    case 1 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_1_input);     
      fg_nummer = atol(c_tmp); 
      break;
      
    case 2 :
      c_tmp = (char*) fl_get_input(freigradform->nummer_2_input); 
      fg_nummer = atol(c_tmp); 
      break;
    }

  c_tmp = (char*) fl_get_input(obj); 
  feder = atof(c_tmp);

  /* suche Freiheitsgrad */
  tmp_fg = suche_FG_Nm(fg_nummer);

  if(tmp_fg)
    (*tmp_fg).d_feder = feder; 
}



/***********************************************************/
/* void fg_erzeugen_cb(FL_OBJECT *obj, long arg)            */
/***********************************************************/ 
/*                                              
   cb-Fkt 
   neuen FG erzeugen -> Erzeugen eines Gelenks an
   dieser Stelle
   jh, 09.04.97                                 
*/
/***********************************************************/

void fg_erzeugen_cb(FL_OBJECT *obj, long arg)
{ 
  long dummy;  
  TypFreiGrad *tmp_freigrad;
  TypStab_Nm *tmp_stab;
  double drehung_global;
  char *c_tmp;
  char c_t[10];
  long flag;

  /* Punkt A oder B ? */
  if(fl_get_button(freigradform->von_button))
    flag = 0;
  else
    flag = 1;

  c_tmp = (char*) fl_get_input(freigradform->drehung_global_input); 
  drehung_global = atof(c_tmp); 
  
  tmp_stab = Suche_Stab_select_Nm(&dummy); 

  /* Lsche FG wenn nicht mehr bentigt */
  if ( !Loesche_FreiGrad_Nm( (*tmp_stab).pe_frei[(flag*3) + arg] ) )
    {
      /* FG konnte nicht gelscht werden, da noch von anderen 
	 Stben benutzt, 
	 ->alte Relationen lschen, wenn x- oder y-FG  und nur
	 an einem Stab vorhanden */
      if( arg!=2 && arg!=5 )
	{
	  long anz = 0;
	  TypStab_Nm *tmp_stab2;
	  KeGlied *p;

	  /* Stbe zhlen */	 
	  if(Modell->KeStab_Nm)
	    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
	      {
		tmp_stab2 = p->x;     

		if( (*tmp_stab2).pe_frei[0] == (*tmp_stab).pe_frei[(flag*3)] )
		  if( (*tmp_stab2).pe_frei[1] == (*tmp_stab).pe_frei[(flag*3)+1] )
		    anz++;

		if( (*tmp_stab2).pe_frei[3] == (*tmp_stab).pe_frei[(flag*3)] )
		  if( (*tmp_stab2).pe_frei[4] == (*tmp_stab).pe_frei[(flag*3)+1] )
		    anz++;
	      }
	  
	  if(anz<2)  /* anz == 1 -> FG-Verbindung nur beim selektierten Stab */
	    LoeseVerbindung_FG((*tmp_stab).pe_frei[ (flag*3) ],
			       (*tmp_stab).pe_frei[ (flag*3)+1],
			       Modell->FG_Relation_Nm);
	}
    }
    
  
  switch(arg)
    {
    case 0 :                 

      tmp_freigrad = Erzeuge_FG_Nm( tmp_stab, (flag*3) );           

      /* primal - dual in Fg eintragen  */
      if( fl_get_button(freigradform->primal_0_check) )
	(*tmp_freigrad).l_status = CPmPrimal;
      else
	(*tmp_freigrad).l_status = CPmDual;

      /* Drehung eintragen */
      (*tmp_freigrad).d_alpha = drehung_global;
      
      fl_set_input(freigradform->verschiebung_0_input,"0");
      fl_set_object_label(freigradform->einwirkung_0_text,"0");

      /* Nummer in form setzen */
      sprintf(c_t,"%ld",(*tmp_freigrad).l_nummer);
      fl_set_input(freigradform->nummer_0_input,c_t);      

      /* Fg verbinden */    
      Verbinde_FG(tmp_freigrad, 
		  (*tmp_stab).pe_frei[(flag*3)+1], 
		  Modell->FG_Relation_Nm);

      break;


    case 1 :           
      
      tmp_freigrad = Erzeuge_FG_Nm(tmp_stab,(flag*3)+1);

      /* primal - dual in Fg eintragen  */
      if( fl_get_button(freigradform->primal_1_check) )	
	(*tmp_freigrad).l_status = CPmPrimal;
      else
	(*tmp_freigrad).l_status = CPmDual;

      /* Drehung eintragen */	
      (*tmp_freigrad).d_alpha = drehung_global;
      
      fl_set_input(freigradform->verschiebung_1_input,"0");
      fl_set_object_label(freigradform->einwirkung_1_text,"0");

      sprintf(c_t,"%ld", (*tmp_freigrad).l_nummer );
      fl_set_input(freigradform->nummer_1_input,c_t);

      /* FG verbinden */
      Verbinde_FG(tmp_freigrad, 
		  (*tmp_stab).pe_frei[(flag*3)], 
		  Modell->FG_Relation_Nm); 

      break;


    case 2 :           

      tmp_freigrad = Erzeuge_FG_Nm(tmp_stab,(flag*3)+2);
            
      /* primal - dual in Fg eintragen  */
      if( fl_get_button(freigradform->primal_2_check) )	
	(*tmp_freigrad).l_status = CPmPrimal;
      else
	(*tmp_freigrad).l_status = CPmDual;

      /* Drehung eintragen */	
      (*tmp_freigrad).d_alpha = drehung_global;
      
      fl_set_input(freigradform->verschiebung_2_input,"0");
      fl_set_object_label(freigradform->einwirkung_2_text,"0");

      sprintf(c_t,"%ld", (*tmp_freigrad).l_nummer );
      fl_set_input(freigradform->nummer_2_input,c_t);

      break;

    }  

  /* Bild aktualisieren */
  Zeichne_FG();

}


