/*
  Datei     : geotopologie_cb.c
  erstellt  : 11.07.96
  geaendert : 17.04.97
  Autor     : jh
*/


#include "XStabDek.h"


/*********************************************************************/
/* void okbutton_cb(FL_OBJECT *obj, long arg)                        */
/*********************************************************************/ 
/*                                              
   cb-Funktion 
   schliet das Fenster Geometrie/Topologie und bernimmt die 
   Werte
   jh, 17.04.97
*/
/*********************************************************************/

void okbutton_cb(FL_OBJECT *obj, long arg)
{
  KeGlied *p,*tmp;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt;
  long nummer,dummy;
  double wert;
  char *c_tmp;

  tmp_stab = Suche_Stab_select_Nm(&dummy);

  if(tmp_stab)
    {              	 	 
      c_tmp = (char*) fl_get_input(stabeditform->punktainput); 
      nummer = atol(c_tmp);
      
      KeDurchlaufVorwaerts(tmp,Modell->KePunkt_Nm)
	{
	  tmp_punkt = tmp->x;
	  if( (*tmp_punkt).l_nummer == nummer)
	    {
	      c_tmp = (char*) fl_get_input(stabeditform->xa); 
	      wert = atof(c_tmp);
	      (*tmp_punkt).d_x = wert;
	      
	      c_tmp = (char*) fl_get_input(stabeditform->ya); 
	      wert = atof(c_tmp);
	      (*tmp_punkt).d_y = wert;
	      (*tmp_stab).pe_punkta = tmp_punkt;	
	    }
	}
      
      c_tmp = (char*) fl_get_input(stabeditform->punktbinput); 
      nummer = atol(c_tmp);

      KeDurchlaufVorwaerts(tmp,Modell->KePunkt_Nm)
	{
	  tmp_punkt = tmp->x;
	  if( (*tmp_punkt).l_nummer == nummer)
	    {
	      c_tmp = (char*) fl_get_input(stabeditform->xb); 
	      wert = atof(c_tmp);
	      (*tmp_punkt).d_x = wert;
	      
	      c_tmp = (char*) fl_get_input(stabeditform->yb); 
	      wert = atof(c_tmp);
	      (*tmp_punkt).d_y = wert;
	      (*tmp_stab).pe_punktb = tmp_punkt; 		    		   		    		   
	    }
	}	    
    }	

  /* fuer alle Staebe die Geometrie neu berechnen */
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;                      
      SetzeGeometrie_Nm(tmp_stab);
    }
    
  fl_hide_form(stabeditform->stab_edit);
  XFlush(display);
  Zeichne();
}


void abbruch_cb(FL_OBJECT *obj, long arg)
{
  KeGlied *p;
  TypStab_Nm *tmp_stab; 

  /* fuer alle Staebe die Geometrie neu berechnen */

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;                     
      SetzeGeometrie_Nm(tmp_stab);
    } 
  
  fl_hide_form(stabeditform->stab_edit);
  Zeichne();
}


void punktainput_cb(FL_OBJECT *obj, long arg)
{
  TypPunkt *tmp_punkt;
  TypStab_Nm *tmp_stab;
  KeGlied *p;
  long nummer,anz;
  char *c_tmp;
  char c_nummer[20];
  double x,y;
  long i;

  tmp_stab = Suche_Stab_select_Nm(&nummer);

  tmp_punkt = (*tmp_stab).pe_punkta;

  /* wird der alte Punkt noch gebraucht ? */
  anz = -1;
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab = p->x;      
      if( (*tmp_stab).pe_punkta == tmp_punkt)
	anz++;
      if( (*tmp_stab).pe_punktb == tmp_punkt)
	anz++;
    }
  
  /* anz = 0 -> Punkt loeschen */
  if(!anz) {    
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm) {	  
      if( p->x == tmp_punkt) {
	KeGliedAustragen(p); 		  	             
	free(tmp_punkt);
	break;
      }
    }
  }

  
  /* neue Nummer einlesen */
  c_tmp = (char*) fl_get_input(stabeditform->punktainput); 
  nummer = (long) atol(c_tmp);


  /* gibt es den Punkt schon ? */
  tmp_punkt = suchePunkt_Nr(nummer, Modell->KePunkt_Nm);
  
  /* ja */
  if(tmp_punkt) {   
    sprintf(c_nummer,"%.3f", (*tmp_punkt).d_x);
    fl_set_input(stabeditform->xa,c_nummer);
    
    sprintf(c_nummer,"%.3f", (*tmp_punkt).d_y);
    fl_set_input(stabeditform->ya,c_nummer);
    
    tmp_stab = Suche_Stab_select_Nm(&nummer);
    
    (*tmp_stab).pe_punkta = tmp_punkt;
    
    for(i=0;i<3;i++)
      Loesche_FreiGrad_Nm((*tmp_stab).pe_frei[i]);
    
    /* FG vom vorh. Punkt uebernehmen */
    Uebernehme_FGamPunkt_Nm(tmp_stab, tmp_punkt, 1);
    
  }
  /* nein */
  else { 
    c_tmp = (char*) fl_get_input(stabeditform->xa); 
    x = atof(c_tmp);     
    
    c_tmp = (char*) fl_get_input(stabeditform->ya); 
    y = atof(c_tmp);
    
    tmp_punkt = Erzeuge_Punkt_Nm(x,y,nummer);           
    
    tmp_stab = Suche_Stab_select_Nm(&nummer);
    
    (*tmp_stab).pe_punkta = tmp_punkt;
    
  }
  
  sprintf(c_nummer,"%.3f",(*tmp_punkt).d_x);
  fl_set_input(stabeditform->xa,c_nummer);
  sprintf(c_nummer,"%.3f",(*tmp_punkt).d_y);
  fl_set_input(stabeditform->ya,c_nummer);  
      
}


void punktbinput_cb(FL_OBJECT *obj, long arg)
{
  TypPunkt *tmp_punkt;
  TypStab_Nm *tmp_stab;
  KeGlied *p;
  long nummer,anz;
  char *c_tmp;
  char c_nummer[20];
  double x,y;
  long i;

  tmp_stab = Suche_Stab_select_Nm(&nummer);

  tmp_punkt = (*tmp_stab).pe_punktb;

  /* wird der alte Punkt noch gebraucht ? */
  anz = -1;
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;      
      if( (*tmp_stab).pe_punkta == tmp_punkt)
	anz++;
      if( (*tmp_stab).pe_punktb == tmp_punkt)
	anz++;
    }
  
  /* anz = 0 -> Punkt loeschen */
  if(!anz)
    { 
      KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)
	{	  
	  if( p->x == tmp_punkt)
	    {
	      KeGliedAustragen(p); 		  	             
	      free(tmp_punkt);
	      break;
	    }
	}
    }
  
  /* neue Nummer einlesen */
  c_tmp = (char*) fl_get_input(stabeditform->punktbinput); 
  nummer = (long) atol(c_tmp);

  /* gibt es den Punkt schon ? */
  tmp_punkt = suchePunkt_Nr(nummer, Modell->KePunkt_Nm);
  
  /* ja */
  if(tmp_punkt)
    {   
      sprintf(c_nummer,"%.3f", (*tmp_punkt).d_x);
      fl_set_input(stabeditform->xb,c_nummer);
      
      sprintf(c_nummer,"%.3f", (*tmp_punkt).d_y);
      fl_set_input(stabeditform->yb,c_nummer);

      tmp_stab = Suche_Stab_select_Nm(&nummer);
      
      (*tmp_stab).pe_punktb = tmp_punkt;
      
      for(i=3;i<6;i++)
	Loesche_FreiGrad_Nm((*tmp_stab).pe_frei[i]);

      /* FG vom vorh. Punkt uebernehmen */
      Uebernehme_FGamPunkt_Nm(tmp_stab,tmp_punkt,2);

    }
  /* nein */
  else
    {            
      c_tmp = (char*) fl_get_input(stabeditform->xb);
      x = atof(c_tmp);
          
      c_tmp = (char*) fl_get_input(stabeditform->yb); 
      y = atof(c_tmp);
      
      tmp_punkt = Erzeuge_Punkt_Nm(x,y,nummer);    

      tmp_stab = Suche_Stab_select_Nm(&nummer);

      (*tmp_stab).pe_punktb = tmp_punkt;
            
    }

  sprintf(c_nummer,"%.3f",(*tmp_punkt).d_x);
  fl_set_input(stabeditform->xb,c_nummer);
  sprintf(c_nummer,"%.3f",(*tmp_punkt).d_y);
  fl_set_input(stabeditform->yb,c_nummer);        

}


/*
  neuen Punkt erzeugen 
*/
void stabeditneuerpunkt_cb(FL_OBJECT *obj, long arg)
{
  TypPunkt *tmp_punkt;
  TypStab_Nm *tmp_stab,*tmp_stab2;
  KeGlied *p;
  long anz,dummy;
  char c_tmp[50];
  double x,y;
  long i;

  tmp_stab = Suche_Stab_select_Nm(&dummy);

  if(arg == 1)
    tmp_punkt = (*tmp_stab).pe_punkta;
  else
    tmp_punkt = (*tmp_stab).pe_punktb;


  x = (*tmp_punkt).d_x;
  y = (*tmp_punkt).d_y;


  /* Ueberpruefen ob alter Punkt noch gebraucht wird */
  
  anz = -1;
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab2 = p->x;      
      if( (*tmp_stab2).pe_punkta == tmp_punkt)
	anz++;
      if( (*tmp_stab2).pe_punktb == tmp_punkt)
	anz++;
    }
  
  if(!anz)  {
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)  {	  
      if( p->x == tmp_punkt)  {
	KeGliedAustragen(p); 		  	             
	free(tmp_punkt);
	break;
      }
    }
  }
  
  tmp_punkt = Erzeuge_Punkt_Nm(x+0.5, y+0.5,-1);
  
  
  /* Punkt in Stab eintragen, neue FG erzeugen  */

  if(arg == 1)  {    
    (*tmp_stab).pe_punkta = tmp_punkt;
    
    for(i=0;i<3;i++) {
      Loesche_FreiGrad_Nm((*tmp_stab).pe_frei[i]);
      Erzeuge_FG_Nm(tmp_stab,i);
    }
  }
  else  {
    (*tmp_stab).pe_punktb = tmp_punkt;
    for(i=3;i<6;i++)	{
      Loesche_FreiGrad_Nm((*tmp_stab).pe_frei[i]);
      Erzeuge_FG_Nm(tmp_stab,i);
    }
  }
  
 
  /* neue Koordinaten in stabeditform eintragen  */

  if(arg == 1)  {
    sprintf(c_tmp,"%ld",(*tmp_punkt).l_nummer);
    fl_set_input(stabeditform->punktainput,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt).d_x);
    fl_set_input(stabeditform->xa,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt).d_y);
    fl_set_input(stabeditform->ya,c_tmp);  
  }
  else   {
    sprintf(c_tmp,"%ld",(*tmp_punkt).l_nummer);
    fl_set_input(stabeditform->punktbinput,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt).d_x);
    fl_set_input(stabeditform->xb,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt).d_y);
    fl_set_input(stabeditform->yb,c_tmp);  
  }
}

