/*
  Datei     : lastedit.c
  erstellt  : 13.01.97
  geaendert : 16.03.97
  Autor     : jh
*/


#include "XStabDek.h"



/*********************************************************************/
/*  void Lastedit(TypStab_Nm* tmp_stab                               */
/*********************************************************************/
/*                                              
   Funktion editiert die Lasten eines Stabes
   jh, 16.03.97
*/
/*********************************************************************/

void Lastedit(TypStab_Nm* tmp_stab)
{
  KeGlied *p; 
  TypStab_Nm* tmp_stab2;
  char c_text[100];

  /* sichergehen, da nur der aktuelle Stab markiert ist -> fr cb-Fkt ! */  
  if(Modell->KeStab_Nm)    
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab2 = p->x;
      (*tmp_stab2).l_selektiert = -1;
    }
  (*tmp_stab).l_selektiert = 1;
  
  /* 
     Lasttyp setzen und initialisieren 
     z.Zt. : Punktlast, Streckenlast
  */
  lasttyp_choice_cb(lastfalleditform->lasttyp_choice,0);
 
  /* Lastflle eintragen */
  Schreibe_Brow1();
  fl_select_browser_line(lastfalleditform->lastfalleditbrow1,1);

  /* Lasten des aktuellen Lastfalls eintragen */
  Setze_Lasten(tmp_stab);
  
  /* Stablnge, Nr, Projektion  */  
  sprintf(c_text,"Nr.  :  %ld",(*tmp_stab).l_nummer);
  fl_set_object_label(lastfalleditform->lastedit_stabnummer, c_text);

  sprintf(c_text,"%s  :  %.3f", locale("Lnge"), (*tmp_stab).d_laenge);  
  fl_set_object_label(lastfalleditform->lastedit_stablaenge, c_text);  

  sprintf(c_text,"Projektion  :  %.3f",(*tmp_stab).d_laenge * (*tmp_stab).d_cos);
  fl_set_object_label(lastfalleditform->lastedit_stablaenge_projektion, c_text);  

  /* Form zeigen */
  fl_show_form(lastfalleditform->lastedit,FL_PLACE_CENTER,FL_TRANSIENT,"Belastung editieren"); 
  init_lastgrafik(); 

  /* Bild zeichnen */
  Zeichne_Lastedit();

}



/***********************************************************/ 
/* void Setze_Lasten(TypStab_Nm* tmp_stab)                 */
/***********************************************************/
/*                                              
   Fkt schreibt Brow2 und setzt das Eingabeformular
   jh, 16.03.97
*/
/***********************************************************/

void Setze_Lasten(TypStab_Nm* tmp_stab)
{   
  Schreibe_Brow2();
  Setze_akt_Last();
}



/***********************************************************/ 
/* void Setze_Lasten(TypStab_Nm* tmp_stab)                 */
/***********************************************************/
/*                                              
   Fkt schreibt Brow1 in dem die Lastflle stehen
   jh, 20.03.97
*/
/***********************************************************/

void Schreibe_Brow1(void)
{
  TypLastfall *tmp_lastfall;
  KeGlied *p;
  char c_text[50];

  fl_clear_browser(lastfalleditform->lastfalleditbrow1);
  
  if(Modell->KeLast)
    KeDurchlaufRueckwaerts(p,Modell->KeLast) { 
      tmp_lastfall = p->x;
      sprintf(c_text,"%3ld %5.2f %s", 
	      (*tmp_lastfall).l_nummer, (*tmp_lastfall).d_gewicht, (*tmp_lastfall).c_name);
      fl_addto_browser(lastfalleditform->lastfalleditbrow1, c_text);
    } 
}



/***********************************************************/ 
/* void Setze_Lasten(TypStab_Nm* tmp_stab)                 */
/***********************************************************/
/*                                              
   Fkt schreibt Brow2 in dem die Lasten eines Lastfalls
   stehen
   jh, 20.03.97
*/
/***********************************************************/

void Schreibe_Brow2(void)
{
  KeGlied *p;
  long dummy;
  TypStreckenlast_Nm *tmp_strecke;
  TypKnotenlast_Nm *tmp_punkt;
  char c_tmp[150];
  TypStab_Nm *tmp_stab;
  Menge *M;

  M = Mng_MengeDefinieren();

  if(!HoleLastfall_ID_Lastedit(M))
    return; 

  tmp_stab = Suche_Stab_select_Nm(&dummy);

 
  fl_clear_browser(lastfalleditform->lastfalleditbrow2); 
  
  /* Streckenlasten durchsuchen */ 
  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm) {
      tmp_strecke = p->x;
      
      /* aktuelle Streckenlast aktiv ? */
      if(Element_suchen( (*tmp_strecke).l_lastfallid ,M)) 
	if( (*tmp_strecke).l_stabnummer == (*tmp_stab).l_nummer ) {
	  sprintf(c_tmp,"%ld [SL] LF %ld  %s", 
		  (*tmp_strecke).l_id, 
		  suche_Lastfall_Nummer((*tmp_strecke).l_lastfallid),
		  (*tmp_strecke).c_name);
	  fl_addto_browser(lastfalleditform->lastfalleditbrow2, c_tmp); 
	}
    }  
  
  /* Punktlasten durchsuchen */
  
  if(Modell->KePunktlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm) {
      tmp_punkt = p->x;
	
      /* aktuelle Punktlast aktiv ? */
      if( Element_suchen((*tmp_punkt).l_lastfallid,M))
	if( (*tmp_punkt).l_stabnummer == (*tmp_stab).l_nummer ) {
	  sprintf(c_tmp,"%ld [PL] LF %ld  %s", 
		  (*tmp_punkt).l_id, 
		  suche_Lastfall_Nummer((*tmp_punkt).l_lastfallid), 
		  (*tmp_punkt).c_name);	       
	  fl_addto_browser(lastfalleditform->lastfalleditbrow2, c_tmp);  
	}
    }

  /* temp. Menge lschen */
  Mng_MengeUndElementeLoeschen(M);

}


void Streckenlast_eintragen(void)
{ 
  TypStreckenlast_Nm *tmp_strecke; 
  long *id;
  long dummy;
  char *c_tmp;  
  TypStab_Nm *tmp_stab; 
  /* char c_text[50]; */
  double pos_anf,pos_ende;
  double laenge;
  Menge *M;
  long i;

  M = Mng_MengeDefinieren();

  /* hole selektierten Stab */
  tmp_stab = Suche_Stab_select_Nm(&dummy);

  /* berprfen, ob pos im zul. Bereich */   
  laenge = (*tmp_stab).d_laenge;

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_anf);
  pos_anf =  atof(c_tmp);
  
  if((pos_anf/laenge > 1) || (pos_anf/laenge < 0)) { /* pos auerhalb des Stabes !! */
    fl_set_input(lastfalleditform->lastedit_sl_anf,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition Anfang.\n Last auerhalb des Stabes !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  } 

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_end);
  pos_ende = atof(c_tmp);
  
  if((pos_ende/laenge > 1) || (pos_ende/laenge < 0)) { /* pos auerhalb des Stabes !! */    
    fl_set_input(lastfalleditform->lastedit_sl_end,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition Ende.\n Last auerhalb des Stabes !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  }
  
  if( pos_anf > pos_ende ) {
    fl_set_input(lastfalleditform->lastedit_sl_end,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition\n Pos_Anfang grer als Pos_Ende !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  }
  
  /* ID des Lastfalls holen */
  HoleLastfall_ID_Lastedit(M);
  
  for(i=1;i<=M->n;i++) {
    id = M->feld[i];

    tmp_strecke = Erzeuge_Streckenlast_Nm(*id,-1);

    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_name);
    if(strlen(c_tmp)>0)
      sprintf((*tmp_strecke).c_name,"%s",c_tmp);
    else
      sprintf((*tmp_strecke).c_name,"-");
  
    (*tmp_strecke).l_lastfallid = *id;

    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_groessea);
    (*tmp_strecke).d_lasta = atof(c_tmp);

    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_groesseb);
    (*tmp_strecke).d_lastb = atof(c_tmp);

    (*tmp_strecke).l_stabnummer = (*tmp_stab).l_nummer;
    
    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_winkel); 
    (*tmp_strecke).d_alpha = (atof(c_tmp) * PI /180);
    
    (*tmp_strecke).l_koordsys = fl_get_choice((lastfalleditform->lastedit_sl_koordsys));
    
    (*tmp_strecke).d_anf = pos_anf/laenge; 
    (*tmp_strecke).d_end = pos_ende/laenge;             
    
  }

  Schreibe_Brow2();
  Zeichne_Lastedit(); 

  /* temp. Menge lschen */
  Mng_MengeUndElementeLoeschen(M);
}



/*********************************************************************/
/* void Streckenlast_aendern(void)                                   */
/*********************************************************************/
/*                                              
   Funktion ndert die Werte einer Streckenlast
   jh, 03.05.97 
*/
/*********************************************************************/

void Streckenlast_aendern(void)
{ 
  long id;
  long dummy;
  char *c_tmp;  
  TypStab_Nm *tmp_stab; 
  TypStreckenlast_Nm *tmp_sl; 
  double pos_anf,pos_ende;
  double laenge;


  tmp_stab = Suche_Stab_select_Nm(&dummy);
  id = HoleLast_ID_Lastedit();
  if(id == -1)  {
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"keine Last ausgewhlt");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
    return;
  }
  
  tmp_sl = Suche_Last_SL_Nm(id); 
  
  /* berprfen, ob pos im zul. Bereich */   
  laenge = (*tmp_stab).d_laenge;

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_anf);
  pos_anf =  atof(c_tmp);
  
  if((pos_anf/laenge > 1) || (pos_anf/laenge < 0)) { /* pos auerhalb des Stabes !! */
    fl_set_input(lastfalleditform->lastedit_sl_anf,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition Anfang.\n Last auerhalb des Stabes !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  } 

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_end);
  pos_ende = atof(c_tmp);
  
  if((pos_ende/laenge > 1) || (pos_ende/laenge < 0))  { /* pos auerhalb des Stabes !! */    
    fl_set_input(lastfalleditform->lastedit_sl_end,"err");
      
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition Ende.\n Last auerhalb des Stabes !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  }
  
  if( pos_anf > pos_ende ) {
    fl_set_input(lastfalleditform->lastedit_sl_end,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition\n Pos_Anfang grer als Pos_Ende !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    return;
  }
  
 
  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_name);
  if(strlen(c_tmp)>0)
    sprintf((*tmp_sl).c_name,"%s",c_tmp);
  else
    sprintf((*tmp_sl).c_name,"-");  

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_groessea);
  (*tmp_sl).d_lasta = atof(c_tmp);

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_groesseb);
  (*tmp_sl).d_lastb = atof(c_tmp);

  (*tmp_sl).l_stabnummer = (*tmp_stab).l_nummer;

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_sl_winkel); 
  (*tmp_sl).d_alpha = (atof(c_tmp) * PI /180);

  (*tmp_sl).l_koordsys = fl_get_choice((lastfalleditform->lastedit_sl_koordsys));
 
  (*tmp_sl).d_anf = pos_anf/laenge; 
  (*tmp_sl).d_end = pos_ende/laenge;
  
 
  /* Last in Browser2 eintragen */  
  Schreibe_Brow2();  
  Markiere_Last(id);
  Zeichne_Lastedit(); 
    
}



/*********************************************************************/
/* void Punktlast_eintragen(void)                                    */
/*********************************************************************/
/*                                              
   neue Punktlast erzeugen und Werte eintragen 
   jh, 03.05.97 
*/
/*********************************************************************/

void Punktlast_eintragen(void)
{
  long *id;
  long dummy;
  char *c_tmp; 
  TypKnotenlast_Nm *tmp_pl;
  TypStab_Nm *tmp_stab; 
  /* char c_text[50]; */
  double pos, laenge;
  long koord_pos;
  Menge *M;
  long i;


  /* M definieren  */
  M = Mng_MengeDefinieren();
 
  tmp_stab = Suche_Stab_select_Nm(&dummy);

  /* berprfen, ob pos im zul. Bereich */
  koord_pos = fl_get_choice((lastfalleditform->lastedit_pl_koordsys_pos));

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_pos); 
  pos = atof(c_tmp);

  if( koord_pos == 2 )   /* globales Koordsys */
    laenge = (*tmp_stab).d_laenge * (*tmp_stab).d_cos;
  else                   /* lokales Stab-Koordsys */ 
    laenge = (*tmp_stab).d_laenge;
  
  if((pos/laenge > 1) || (pos/laenge < 0)) {  /* pos auerhalb des Stabes !! */    
    fl_set_input(lastfalleditform->lastedit_pl_pos,"err");
    
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Fehler bei der Lastposition\n Last auerhalb des Stabes !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");
    
    return;
  } 
 
  /* ID des Lastfalls holen */
  HoleLastfall_ID_Lastedit(M);
  
  for(i=1;i<=M->n;i++) {
    id = M->feld[i];
    tmp_pl = Erzeuge_Punktlast_Nm(*id,-1); 

    (*tmp_pl).l_lastfallid = *id;

    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_name);
    if(strlen(c_tmp)>0)
      sprintf((*tmp_pl).c_name,"%s",c_tmp); 
    else
      sprintf((*tmp_pl).c_name,"-");

    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_groesse);
    (*tmp_pl).d_last = atof(c_tmp);

    (*tmp_pl).l_stabnummer = (*tmp_stab).l_nummer;
    
    c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_winkel); 
    (*tmp_pl).d_alpha = (atof(c_tmp) * PI /180);
    
    (*tmp_pl).l_koordsys_winkel = fl_get_choice((lastfalleditform->lastedit_pl_koordsys_winkel));
    
    (*tmp_pl).d_pos = pos/laenge;
    (*tmp_pl).l_koordsys_pos = koord_pos;

    (*tmp_pl).l_art = fl_get_choice((lastfalleditform->lastedit_pl_art));
   
  }

  Schreibe_Brow2();
  Zeichne_Lastedit(); 
  
  /* temp. Menge lschen */
  Mng_MengeUndElementeLoeschen(M);
 
}


/* Punktlast aendern */

void Punktlast_aendern(void)
{
  long id;
  long dummy;
  char *c_tmp; 
  TypKnotenlast_Nm *tmp_pl;
  TypStab_Nm *tmp_stab;  
  double pos, laenge;
  long koord_pos;

  tmp_stab = Suche_Stab_select_Nm(&dummy);
  id = HoleLast_ID_Lastedit();
  if(id == -1)
    {
      warnung_status = 2;
      fl_set_object_label(warnungform->warnungtext,
			  "keine Last ausgewhlt");
      fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
      return;
    }

  tmp_pl = Suche_Last_PL_Nm(id);


  /* berprfen, ob pos im zul. Bereich */
  koord_pos = fl_get_choice((lastfalleditform->lastedit_pl_koordsys_pos));

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_pos); 
  pos = atof(c_tmp);

  if( koord_pos == 2 )   /* globales Koordsys */
    laenge = (*tmp_stab).d_laenge * (*tmp_stab).d_cos;

  else                                  /* lokales Stab-Koordsys */ 
    laenge = (*tmp_stab).d_laenge;
  
  if((pos/laenge > 1) || (pos/laenge < 0))  /* pos auerhalb des Stabes !! */
    {
      fl_set_input(lastfalleditform->lastedit_pl_pos,"err");

      warnung_status = 2;
      fl_set_object_label(warnungform->warnungtext,
			  "Fehler bei der Lastposition\n Last auerhalb des Stabes !");
      fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");

      return;
    }      
  
  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_name);
  sprintf((*tmp_pl).c_name,"%s",c_tmp); 

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_groesse);
  (*tmp_pl).d_last = atof(c_tmp);

  (*tmp_pl).l_stabnummer = (*tmp_stab).l_nummer;

  c_tmp = (char*) fl_get_input(lastfalleditform->lastedit_pl_winkel); 
  (*tmp_pl).d_alpha = (atof(c_tmp) * PI /180);

  (*tmp_pl).l_koordsys_winkel = fl_get_choice((lastfalleditform->lastedit_pl_koordsys_winkel));

  (*tmp_pl).d_pos = pos/laenge;
  (*tmp_pl).l_koordsys_pos = koord_pos;

  (*tmp_pl).l_art = fl_get_choice((lastfalleditform->lastedit_pl_art));
   

  /* Last in Browser2 eintragen */  
  Schreibe_Brow2();
  Markiere_Last(id);
  Zeichne_Lastedit(); 
  
}



/*********************************************************************/
/* void HoleLastfall_Nummer_Lastedit(Menge *M)                       */
/*********************************************************************/ 
/*                                              
   Fkt holt die Nummern der im Browser 1 aktiven Lastflle 
   jh, 18.05.97
*/
/*********************************************************************/

long HoleLastfall_Nummer_Lastedit(Menge *M)
{
  char lastnummer[4]; 
  char *c_tmp;
  long i,j;
  long *nummer;

  /* Durchlauf des Browsers */
  for(i=1;i<=fl_get_browser_maxline(lastfalleditform->lastfalleditbrow1);i++) {
    if(fl_isselected_browser_line(lastfalleditform->lastfalleditbrow1,i)) {	 	  
      c_tmp = (char*) fl_get_browser_line(lastfalleditform->lastfalleditbrow1,i);
      for(j=0;j<3;j++)
	lastnummer[j] = c_tmp[j];     
      lastnummer[3] = '\0';

      if(!(nummer = (long*) calloc (1,sizeof(long)))) {
	fprintf(stderr,"Mem - Fault\n");
	return 0;
      } 

      *nummer = atol(lastnummer);

      /* Lastfall-Nummer in M eintragen */
      Mng_ElementEintragen(nummer,M);
      
    }
  }     
  return 1;
}



/*********************************************************************/
/* void HoleLastfall_ID_Lastedit(Menge *M)                           */
/*********************************************************************/ 
/*                                              
   Fkt holt die IDs der aktiven Lastflle im Browser 1
   jh, 18.05.97
*/
/*********************************************************************/

long HoleLastfall_ID_Lastedit(Menge *M)
{  
  Menge *Mtmp=NULL;
  long *nr, *id;
  long i;

  Mtmp = Mng_MengeDefinieren();

  /* Nummern der Lastflle holen */
  if(!HoleLastfall_Nummer_Lastedit(Mtmp))
    return 0;

  /* Ids ermitteln und eintragen */ 
  for(i=1;i<=Mtmp->n;i++)  {
    nr = Mtmp->feld[i];

    if(!(id = (long*) calloc (1,sizeof(long)))) {
      fprintf(stderr,"Mem - Fault\n");
      return 0;
    }

    *id = suche_Lastfall_ID(*nr);

    /* Lastfall-ID in M eintragen */
    Mng_ElementEintragen(id,M);
  }    
  
  /* temp. menge lschen */
  Mng_MengeUndElementeLoeschen(Mtmp); 

  return 1;

}



/***********************************************************/ 
/*  long HoleLast_ID_Lastedit(void)                        */
/***********************************************************/ 
/*                                              
   Fkt holt den ID der Last, die im Browser 2
   angewhlt ist
   jh, 16.03.97
*/
/***********************************************************/

long HoleLast_ID_Lastedit(void)
{
  char id[9];
  char *c_tmp;
  long i,j;

  for(i=1;i<=fl_get_browser_maxline(lastfalleditform->lastfalleditbrow2);i++) {
    if(fl_isselected_browser_line(lastfalleditform->lastfalleditbrow2,i)) {	 	  
      c_tmp = (char*) fl_get_browser_line(lastfalleditform->lastfalleditbrow2,i);
      for(j=0;j<8;j++)
	id[j] = c_tmp[j];
      id[8] = '\0';
      return (long) atol(id);
    }
  }
  return -1;
}



/*********************************************************/ 
/*  void Setze_akt_Lasten(void)                          */
/*********************************************************/ 
/*                                              
   Fkt setzt aktuelle Werte in dem Eingabeformular 
   jh, 16.03.97
*/
/*********************************************************/    

void Setze_akt_Last(void)
{
  long id;
  TypStreckenlast_Nm *tmp_sl;
  TypKnotenlast_Nm *tmp_pl; 
  char c_text[50];
  double alpha;
  TypStab_Nm *tmp_stab;
  long dummy;

  tmp_stab = Suche_Stab_select_Nm(&dummy);
  id = HoleLast_ID_Lastedit(); 

  if(id == -1) {
    fl_set_input(lastfalleditform->lastedit_pl_groesse,"");
    fl_set_input(lastfalleditform->lastedit_pl_pos,"");
    fl_set_input(lastfalleditform->lastedit_pl_winkel,"");
    fl_set_input(lastfalleditform->lastedit_pl_name,"");
    
    fl_set_input(lastfalleditform->lastedit_sl_groessea,"");
    fl_set_input(lastfalleditform->lastedit_sl_groesseb,"");
    fl_set_input(lastfalleditform->lastedit_sl_winkel,"");
  
    fl_set_input(lastfalleditform->lastedit_sl_anf,"0.00");

    sprintf(c_text,"%.3f",(*tmp_stab).d_laenge);
    fl_set_input(lastfalleditform->lastedit_sl_end,c_text);

    fl_set_input(lastfalleditform->lastedit_sl_name,"");
  }
  else {

    /* Streckenlast */
      
    if((tmp_sl = Suche_Last_SL_Nm(id))) {
      fl_freeze_form(lastfalleditform->lastedit);
      {    
	/* Lastfalltyp auf SL setzen */	
	fl_set_choice(lastfalleditform->lasttyp_choice,2);
		
	/* Formular fr SL zeigen */	    	
	fl_hide_object(lastfalleditform->punktlast);   
	fl_show_object(lastfalleditform->streckenlast);        


	/* Werte der akt. Last eintragen */	  
	sprintf(c_text,"%.3f",(*tmp_sl).d_lasta);
	fl_set_input(lastfalleditform->lastedit_sl_groessea,c_text);

	sprintf(c_text,"%.3f",(*tmp_sl).d_lastb);
	fl_set_input(lastfalleditform->lastedit_sl_groesseb,c_text);

	alpha = 180 * (*tmp_sl).d_alpha /PI;
	sprintf(c_text,"%.3f", alpha);
	fl_set_input(lastfalleditform->lastedit_sl_winkel,c_text);

	sprintf(c_text,"%.3f",(*tmp_sl).d_anf * (*tmp_stab).d_laenge);
	fl_set_input(lastfalleditform->lastedit_sl_anf,c_text);

	sprintf(c_text,"%.3f",(*tmp_sl).d_end * (*tmp_stab).d_laenge);
	fl_set_input(lastfalleditform->lastedit_sl_end,c_text);

	fl_set_input(lastfalleditform->lastedit_sl_name,(*tmp_sl).c_name);	    
	fl_set_choice(lastfalleditform->lastedit_sl_koordsys, (*tmp_sl).l_koordsys);
      }
      fl_unfreeze_form(lastfalleditform->lastedit);	
      
      Zeichne_Lastedit();
      
      return;
    }
	
    /* Punktlast */

    if((tmp_pl = Suche_Last_PL_Nm(id))) {
      fl_freeze_form(lastfalleditform->lastedit);
      {

	/* Lastfalltyp auf PL setzen */	
	fl_set_choice(lastfalleditform->lasttyp_choice,1);
		    
	/* Formular fr PL zeigen */
	fl_hide_object(lastfalleditform->streckenlast);    
	fl_show_object(lastfalleditform->punktlast);
	
	/* Werte der akt. Last eintragen */	    
	sprintf(c_text,"%.3f",(*tmp_pl).d_last);
	fl_set_input(lastfalleditform->lastedit_pl_groesse,c_text);

	/* Position der Last */
	fl_set_choice(lastfalleditform->lastedit_pl_koordsys_pos, (*tmp_pl).l_koordsys_pos);

	if( (*tmp_pl).l_koordsys_pos == 1 ) {  /*lokal */
	  sprintf(c_text,"%.3f",(*tmp_pl).d_pos * (*tmp_stab).d_laenge);
	  fl_set_input(lastfalleditform->lastedit_pl_pos,c_text);	 
	}
	else {  /* global */
	  sprintf(c_text,"%.3f",(*tmp_pl).d_pos * (*tmp_stab).d_laenge * (*tmp_stab).d_cos);
	  fl_set_input(lastfalleditform->lastedit_pl_pos,c_text);
	  fl_set_choice(lastfalleditform->lastedit_pl_koordsys_pos, (*tmp_pl).l_koordsys_pos);
	}
	
	alpha = 180 * (*tmp_pl).d_alpha /PI;
	sprintf(c_text,"%.3f",alpha);
	fl_set_input(lastfalleditform->lastedit_pl_winkel,c_text);
	fl_set_choice(lastfalleditform->lastedit_pl_koordsys_winkel, (*tmp_pl).l_koordsys_winkel);
	
	fl_set_input(lastfalleditform->lastedit_pl_name,(*tmp_pl).c_name);	    	   
	fl_set_choice(lastfalleditform->lastedit_pl_art, (*tmp_pl).l_art);
	
	/* wenn Knotenmoment, dann Last-Winkel deaktivieren */
	lastedit_pl_art_cb(lastfalleditform->lastedit_pl_art, 0);
	
      }
      fl_unfreeze_form(lastfalleditform->lastedit);	
      
      Zeichne_Lastedit(); 
      
      return;
    }
  }
}



void Markiere_Last(long id)
{
  char c_id[8];
  char *c_tmp;
  long i,j;
 
  for(i=1;i<=fl_get_browser_maxline(lastfalleditform->lastfalleditbrow2);i++) {     	 	  
    c_tmp = (char*) fl_get_browser_line(lastfalleditform->lastfalleditbrow2,i);
    
    for(j=0;j<8;j++)
      c_id[j] = c_tmp[j];     
    
    if( atol(c_id) == id) {
      fl_select_browser_line(lastfalleditform->lastfalleditbrow2,i);
      return;
    }      
  }
}



/*********************************************************************/
/* void Last_verschieben(void)                                       */
/*********************************************************************/ 
/*                                              
   Fkt. verschiebt eine Punktlast in einen
   anderen Lastfall
   jh, 18.03.97
*/
/*********************************************************************/

void Last_verschieben(void)
{
  long lastfall_nummer;
  long last_id;
  char *c_tmp;
  TypKnotenlast_Nm *tmp_pl;
  TypStreckenlast_Nm *tmp_sl;
  TypLastfall *tmp_lf;


  last_id = HoleLast_ID_Lastedit();
  if(last_id == -1) {
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"keine Last ausgewhlt");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
    return;
  }   
 
  c_tmp = (char*) fl_show_simple_input("In welchen Lastfall verschieben ?","");
  lastfall_nummer =  atol(c_tmp);

  if(!(tmp_lf = Suche_Lastfall_nr(lastfall_nummer))) {
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Lastfall existiert nicht !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
    return;
   }

  tmp_pl = Suche_Last_PL_Nm(last_id);
  if(tmp_pl) {   
    (*tmp_pl).l_lastfallid = (*tmp_lf).l_id;
    return;
  }

  tmp_sl = Suche_Last_SL_Nm(last_id);
  if(tmp_sl) {   
    (*tmp_sl).l_lastfallid =  (*tmp_lf).l_id;
    return;
  }

}



/*********************************************************************/
/* void Last_kopieren(void)                                       */
/*********************************************************************/ 
/*                                              
   Fkt. verschiebt eine Punktlast in einen
   anderen Lastfall
   jh, 18.03.97
*/
/*********************************************************************/

void Last_kopieren(void)
{
  long lastfall_nummer;
  long last_id;
  char *c_tmp;
  TypKnotenlast_Nm *tmp_pl,*tmp_pl2;
  TypStreckenlast_Nm *tmp_sl,*tmp_sl2;
  TypLastfall *tmp_lf;


  /* Id der Last holen */
  last_id = HoleLast_ID_Lastedit();
  if(last_id == -1) {
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"keine Last ausgewhlt");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
    return;
  }   
 
  c_tmp = (char*) fl_show_simple_input("In welchen Lastfall kopieren ?","");
  lastfall_nummer =  atol(c_tmp);

  /* Lastfall holen */
  if(!(tmp_lf = Suche_Lastfall_nr(lastfall_nummer))) {
    warnung_status = 2;
    fl_set_object_label(warnungform->warnungtext,
			"Lastfall existiert nicht !");
    fl_show_form(warnungform->warnung,FL_PLACE_CENTER,FL_FULLBORDER,"Fehler");           
    return;
   }

  /* Punktlast */
  tmp_pl = Suche_Last_PL_Nm(last_id);
  if(tmp_pl) {   
    tmp_pl2 = Erzeuge_Punktlast_Nm((*tmp_lf).l_id,-1);

    /* Werte bernehmen */
    sprintf((*tmp_pl2).c_name,"%s",(*tmp_pl).c_name);
    (*tmp_pl2).d_last            = (*tmp_pl).d_last;
    (*tmp_pl2).l_stabnummer      = (*tmp_pl).l_stabnummer;
    (*tmp_pl2).d_alpha           = (*tmp_pl).d_alpha;
    (*tmp_pl2).l_koordsys_winkel = (*tmp_pl).l_koordsys_winkel;
    (*tmp_pl2).l_koordsys_pos    = (*tmp_pl).l_koordsys_pos;
    (*tmp_pl2).d_pos             = (*tmp_pl).d_pos;
    (*tmp_pl2).l_art             = (*tmp_pl).l_art;

    return;
  }

  /* Streckenlast */
  tmp_sl = Suche_Last_SL_Nm(last_id);
  if(tmp_sl) {   
    tmp_sl2 = Erzeuge_Streckenlast_Nm((*tmp_lf).l_id,-1);
    
    /* Werte bernehmen */
    sprintf((*tmp_sl2).c_name,"%s",(*tmp_sl).c_name);
    (*tmp_sl2).d_lasta       = (*tmp_sl).d_lasta;
    (*tmp_sl2).d_lastb       = (*tmp_sl).d_lastb;
    (*tmp_sl2).l_stabnummer  = (*tmp_sl).l_stabnummer;
    (*tmp_sl2).d_alpha       = (*tmp_sl).d_alpha;
    (*tmp_sl2).l_koordsys    = (*tmp_sl).l_koordsys;
    (*tmp_sl2).d_anf         = (*tmp_sl).d_anf;
    (*tmp_sl2).d_end         = (*tmp_sl).d_end;

    return;
  }

}



