/*
  Datei     : lfkombination.c
  erstellt  : 23.08.97
  gendert  : 
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"




/*********************************************************************/
/* void LFKomb_addLF(TypLastfallkombination* , long , double )       */
/*********************************************************************/
/*                                              
   Fkt fgt einer LF-Kombination den LF mit der Nummer 'id'
   und dem Gewicht 'gewicht' hinzu
   jh, 23.08.97
*/
/*********************************************************************/

void LFKomb_addLF(TypLastfallkombination* tmp_lfkomb, 
		  long id, double gewicht)
{
  TypLFKomb *tmp_komb;

  tmp_komb = (TypLFKomb*) calloc (1, sizeof(TypLFKomb));

  tmp_komb->l_id = id;
  tmp_komb->d_gewicht = gewicht;

  Mng_ElementEintragen(tmp_komb,tmp_lfkomb->LFKomb);

}



/*********************************************************************/
/* void LFKomb_activate(long id)                                     */
/*********************************************************************/
/*                                              
   Fkt aktiviert die LF-Kombiantion mit der Nummer 'id'
   jh, 23.08.97
*/
/*********************************************************************/

void LFKomb_activate(long id)
{
  long j;
  TypLastfall* tmp_lastfall; 
  TypLastfallkombination* tmp_lfkomb;
  TypLFKomb *tmp_komb;
  KeGlied* p;

  Menge *M=NULL;

  /* alle LF deaktivieren */
  if(Modell->KeLast) {
    KeDurchlaufRueckwaerts(p,Modell->KeLast) { 
      tmp_lastfall = p->x;   
      tmp_lastfall->l_aktiv = -1;
    }
  }


  if(Modell->KeLfKombination) {
    KeDurchlaufRueckwaerts(p, Modell->KeLfKombination) { 

      tmp_lfkomb = p->x;
      
      if( tmp_lfkomb->l_id == id ) {

	tmp_lfkomb->l_aktiv = 1;

	M = tmp_lfkomb->LFKomb;
	
	/* LF aktivieren */
	for(j=1;j<=M->n;j++) {

	  tmp_komb = M->feld[j];

	  tmp_lastfall = Suche_Lastfall_id(tmp_komb->l_id);
	  tmp_lastfall->l_aktiv = 1;
	  tmp_lastfall->d_gewicht = tmp_komb->d_gewicht;

	}
      }
      else {
	tmp_lfkomb->l_aktiv = 0;
      }

    }      
  }

  schreibeBrowserLastfall(); 

}



/*********************************************************************/
/* void LFKomb_setName(long id, char *name)                          */
/*********************************************************************/
/*                                              
   Fkt ndert den Name der LF-Komb
   jh, 26.08.97
*/
/*********************************************************************/

void LFKomb_setName(long id, char *name)
{
  TypLastfallkombination* tmp_lfkomb; 
  KeGlied* p;
 
  if(Modell->KeLfKombination) {
    KeDurchlaufRueckwaerts(p, Modell->KeLfKombination) { 
      
      tmp_lfkomb = p->x;
      
      if( tmp_lfkomb->l_id == id ) {	
	sprintf(tmp_lfkomb->c_name,"%s",name);
	break;
      }
    }
  }
}



/*********************************************************************/
/* void LFKomb_getName(long id, char *name)                          */
/*********************************************************************/
/*                                              
   Fkt bestimmt den Namen der LF-Komb
   jh, 26.08.97
*/
/*********************************************************************/

void LFKomb_getName(long id, char *name)
{
  TypLastfallkombination* tmp_lfkomb; 
  KeGlied* p;
 
  if(Modell->KeLfKombination) {
    KeDurchlaufRueckwaerts(p, Modell->KeLfKombination) { 
      
      tmp_lfkomb = p->x;
      
      if( tmp_lfkomb->l_id == id ) {	
	sprintf(name,"%s",tmp_lfkomb->c_name);
	break;
      }
    }
  }
}



/*********************************************************************/
/* void LFKomb_NameAendern(void)                                     */
/*********************************************************************/
/*                                              
   Fkt wird von input-form aufgerufen
   jh, 26.08.97
*/
/*********************************************************************/

void LFKomb_NameAendern(void)
{ 
  long i,j;
  long nummer;
  char *name,*c_tmp;
  char lastnummer[3]; 
  
  name = (char*) fl_get_input(inputform->input); 
  fl_hide_form(inputform->inputform);

  if(!name)
    return;

  for(i=1;i<=fl_get_browser_maxline(lastfallbrowserform->lastfall_komb_browser);i++) {   
    
    if(fl_isselected_browser_line(lastfallbrowserform->lastfall_komb_browser,i)) {
      
      /* Hole Nummer des Lastfalls aus der Zeile im Browser */
      c_tmp = (char*) fl_get_browser_line(lastfallbrowserform->lastfall_komb_browser,i);
      
      for(j=0;j<3;j++)
	lastnummer[j] = c_tmp[j];     
      nummer = (long) atol(lastnummer); 
      
      LFKomb_setName(nummer, name);     

      schreibeBrowserLastfallKombinationen(); 

      Modell->unsaved_changes++;
      break;
      
    }
  }

}
