/*
  Datei     : materialquerschnitt_cb.c
  erstellt  : 17.04.97
  gendert  : 10.08.97
  Autor     : jh
*/


#include "XStabDek.h"


extern KeGlied *KetteStaebe;


/*********************************************************************/
/* void materialedit_okbutton_cb(FL_OBJECT *obj, long arg)           */
/*********************************************************************/ 
/*                                              
   Fenster schlieen und Werte fr alle 
   ausgewhlten Stbe bernehmen
   jh, 10.08.97
*/
/*********************************************************************/

void materialedit_okbutton_cb(FL_OBJECT *obj, long arg)
{ 
  long mat_nummer,quer_nummer;  
  TypStab_Nm *tmp_stab;
  KeGlied* p;
  TypMaterial *tmp_mat;
  TypQuerschnitt *tmp_quer;

  /* Material */
  mat_nummer = Hole_Eig_MaterialID();
  tmp_mat = Suche_Material(mat_nummer); 

  /* Querschnitt */
  quer_nummer = Hole_Eig_QuerschnittID();
  tmp_quer = Suche_Querschnitt(quer_nummer); 

  if(tmp_mat)
    Modell->unsaved_changes++;
  if(tmp_quer) 
    Modell->unsaved_changes++;

  if(KetteStaebe)
    KeDurchlaufVorwaerts(p,KetteStaebe) {

      tmp_stab = p->x;
        
      if(tmp_mat)
	(*tmp_stab).l_matid  = mat_nummer;
      
      if(tmp_quer) 
	(*tmp_stab).l_querid = quer_nummer;
      
    }  
  
  fl_hide_form(materialeditform->materialeditform);

  /* Kette lschen */
  while(KetteStaebe->nach != KetteStaebe) {	  
    p = KetteStaebe->nach;
    KeGliedAustragen(p);
  }

  Zeichne();
      
}



/*********************************************************************/
/* void global1_cb(FL_OBJECT *obj, long arg)                         */
/*********************************************************************/ 
/*                                              
   Material global aendern
   jh, 22.03.97
*/
/*********************************************************************/

void global1_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypMaterial *tmp_mat;
  TypStab_Nm *tmp_stab;
  KeGlied *p;

  nummer = Hole_Eig_MaterialID();  
  tmp_mat = Suche_Material(nummer); 

  if(tmp_mat)  {    
    if(Modell->KeStab_Nm)
      KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
	tmp_stab = p->x;     	
	(*tmp_stab).l_matid = nummer;
      }
  }  
  else {
    fl_set_object_label(materialeditform->eigenschaften_material_text,
			"Material auswaehlen !");
  }
}

/*********************************************************************/
/* void global2_cb(FL_OBJECT *obj, long arg)                         */
/*********************************************************************/ 
/*                                              
   Querschnitte global aendern 
   jh, 22.03.97
*/
/*********************************************************************/

void global2_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypQuerschnitt *tmp_quer;
  TypStab_Nm *tmp_stab; 
  KeGlied *p;

  nummer = Hole_Eig_QuerschnittID();
  
  tmp_quer = Suche_Querschnitt(nummer); 

  if(tmp_quer) {    
    if(Modell->KeStab_Nm)
      KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
	{
	  tmp_stab = p->x;     	
	  (*tmp_stab).l_querid = nummer;
	}
  }  
  else {
    fl_set_object_label(materialeditform->eigenschaften_quer_text,
			"Querschnitt auswaehlen !");
  }
}



/*********************************************************************/
/* void eigenschaften_matbrowser_cb(FL_OBJECT *obj, long arg)        */
/*********************************************************************/ 
/*                                              
   cb-Funktion des Materialbrowsers 
   das Material wird fr alle angewhlten Stbe bernommen
   jh, 22.03.97
*/
/*********************************************************************/

void eigenschaften_matbrowser_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypMaterial *tmp_mat;
  char c_text[100]; 
    
  nummer = Hole_Eig_MaterialID();
  tmp_mat = Suche_Material(nummer); 

  if(tmp_mat) {   
    fl_set_object_label(materialeditform->eigenschaften_material_text,
			(*tmp_mat).c_name);
    sprintf(c_text,"%.4e", (*tmp_mat).d_E);
    fl_set_object_label(materialeditform->eigenschaften_emodul_text,
			c_text);	 
  }
  else {
    fl_set_object_label(materialeditform->eigenschaften_material_text,"");
    fl_set_object_label(materialeditform->eigenschaften_emodul_text,"");	 
  }
}


void eigenschaften_querbrowser_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypQuerschnitt *tmp_quer;
  char c_text[100]; 

  nummer = Hole_Eig_QuerschnittID();
  tmp_quer = Suche_Querschnitt(nummer); 

  if(tmp_quer)  {  
    fl_set_object_label(materialeditform->eigenschaften_quer_text,
			(*tmp_quer).c_name);
    sprintf(c_text,"%.4e", (*tmp_quer).d_A);
    fl_set_object_label(materialeditform->eigenschaften_flaeche,c_text);
    sprintf(c_text,"%.4e", (*tmp_quer).d_Iz);
    fl_set_object_label(materialeditform->eigenschaften_Iz,c_text);	 
  }
  else  {
    fl_set_object_label(materialeditform->eigenschaften_quer_text,"");    
    fl_set_object_label(materialeditform->eigenschaften_flaeche,"");     
    fl_set_object_label(materialeditform->eigenschaften_Iz,"");	 
  }
}


/*
  Standardwerte setzen 
*/
void materialedit_stwerte_cb(FL_OBJECT *obj, long arg)
{
  long mat_nummer, quer_nummer;
  TypMaterial *tmp_mat;
  TypQuerschnitt *tmp_quer;
  TypStab_Nm *tmp_stab;
  KeGlied* p;
  char c_text[200];
  

  mat_nummer = standard_mat;
  tmp_mat = Suche_Material(mat_nummer); 
  
  if(tmp_mat)  {  
    fl_set_object_label(materialeditform->eigenschaften_material_text,
			(*tmp_mat).c_name);
    sprintf(c_text,"%.4e", (*tmp_mat).d_E);
    fl_set_object_label(materialeditform->eigenschaften_emodul_text,c_text);	 
  }
  else  {
    fl_set_object_label(materialeditform->eigenschaften_material_text,"");
    fl_set_object_label(materialeditform->eigenschaften_emodul_text,"");	 
  } 
  
  quer_nummer = standard_quer;
  tmp_quer = Suche_Querschnitt(quer_nummer); 
  
  if(tmp_quer) {  
    fl_set_object_label(materialeditform->eigenschaften_quer_text,
			(*tmp_quer).c_name);
    sprintf(c_text,"%.4e", (*tmp_quer).d_A);
    fl_set_object_label(materialeditform->eigenschaften_flaeche,c_text);
    sprintf(c_text,"%.4e", (*tmp_quer).d_Iz);
    fl_set_object_label(materialeditform->eigenschaften_Iz,c_text);	 
  }
  else  {
    fl_set_object_label(materialeditform->eigenschaften_quer_text,"");    
    fl_set_object_label(materialeditform->eigenschaften_flaeche,"");     
    fl_set_object_label(materialeditform->eigenschaften_Iz,"");	 
  }

  if(KetteStaebe) {
    KeDurchlaufVorwaerts(p,KetteStaebe) {
      
      tmp_stab = p->x;
      
      if(tmp_mat)
	(*tmp_stab).l_matid = mat_nummer;
      
      if(tmp_quer) 
	(*tmp_stab).l_querid = quer_nummer;
      
    }
  }

  Modell->unsaved_changes++;
    
}

