/*
  Datei     : schnitt.c
  erstellt  : 20.08.96
  geaendert : 07.12.96
  Autor     : jh
*/


#include "XStabDek.h"



/*********************************************************************/
/* void Schnitt( ... )                                               */
/*********************************************************************/
/*                                              
   Funktion zeigt die Form schnittform
   (Schnittlasten-Fenster)
   jh, 03.05.97 
*/
/*********************************************************************/

void Schnitt(TypStab_Nm* tmp_stab)
{
  fl_set_object_label(schnittform->intervalle_1_text,"");
  fl_set_object_label(schnittform->intervalle_2_text,"");
  fl_set_object_label(schnittform->intervalle_3_text,"");

  fl_show_form(schnittform->schnittkraefte,
	       FL_PLACE_CENTER,FL_TRANSIENT,"Schnittgren / Verschiebungen ..."); 
  init_schnittgrafik();
  Zeichne_Schnitt(tmp_stab);
}



/*********************************************************************/
/* void Zeichne_Schnitt( ... )                                       */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Schnittkraft im
   Schnittlasten-Fenster  
   jh, 25.04.97 
*/
/*********************************************************************/

void Zeichne_Schnitt(TypStab_Nm* tmp_stab)
{
  FL_Coord  win_w,win_h; 
  char c_tmp[10];
 
  fl_get_winsize(schnittwin,&win_w,&win_h); 

  sprintf(c_tmp,"%ld",(*tmp_stab).l_nummer);  
  fl_set_object_label(schnittform->schnittnummer,c_tmp);
  
  sprintf(c_tmp,"%.3f",(*tmp_stab).d_laenge);  
  fl_set_object_label(schnittform->schnitt_laenge_text,c_tmp);

  if(tmp_stab) {           
    XClearWindow(display,schnittwin);
      
    Zeichne_Schnitt_Stab((long) win_w, (long) win_h,tmp_stab);    

    if(fl_get_button(schnittform->schnittmomentbutton))
      Zeichne_Schnitt_Moment((long) win_w, (long) win_h,tmp_stab); 
    if(fl_get_button(schnittform->schnittquerbutton))
      Zeichne_Schnitt_Quer((long) win_w, (long) win_h,tmp_stab); 
    if(fl_get_button(schnittform->schnittnormalbutton))
      Zeichne_Schnitt_Normal((long) win_w, (long) win_h,tmp_stab); 
    if(fl_get_button(schnittform->schnitt_verschiebung_button))
      Zeichne_Schnitt_Verschiebung((long) win_w, (long) win_h,tmp_stab); 

    if(fl_get_button(schnittform->schnitt_koordsys_button))
      Zeichne_KoordSys(schnittwin,tmp_stab);
    
    SetzeWerte(tmp_stab);     
    
  }          
}



/*********************************************************************/
/* void SetzeWerte(TypStab_Nm *tmp_stab)                             */
/*********************************************************************/
/*                                              
   Funktion setzt in 10 Intervallen die Werte der Schnittkrfte
   jh, 25.04.97 
*/
/*********************************************************************/

void SetzeWerte(TypStab_Nm *tmp_stab)
{
  double pos[11]; 
  long i;
  long anz_points = 11;
  char *sk_text;
  char c_tmp[20];
  double z,step;
  double max,min;
  double posmax,posmin; 
 

  /* Intervall-Positionen setzen */
  z = 0;
  step = (double) (1./((double) anz_points - 1.));
  
  for(i=0; i<anz_points; i++)  {      
    pos[i] = (*tmp_stab).d_laenge * z;   
    z += step;
  }  

  sk_text = (char*) calloc (250,sizeof(char));
 
  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %8.2f ",pos[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_pos,sk_text);   
  free(sk_text);  

  /* Diskrete Werte lschen */
  fl_set_object_label(schnittform->dis_1_text,"");
  fl_set_object_label(schnittform->dis_2_text,"");
  fl_set_object_label(schnittform->dis_3_text,"");  


  switch(fl_get_choice(schnittform->schnitt_choice)) {
  case 1 :
    SetzeWerte_SK(tmp_stab);
    break;
  case 2 :
    SetzeWerte_UW(tmp_stab);
    break;
  case 3 :
    SetzeWerte_NS(tmp_stab);
    break;
  case 4 :
    SetzeWerte_SS(tmp_stab);
    break;
  }


  /* Extrema setzen */

  /* M */
  max = maxM(tmp_stab,&posmax);
  min = minM(tmp_stab,&posmin);

  sprintf(c_tmp,"%.3f",max);
  fl_set_object_label(schnittform->krafttext_max_moment,c_tmp);
  sprintf(c_tmp,"%.3f",(posmax*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos_mom,c_tmp);
    
  sprintf(c_tmp,"%.3f",min);
  fl_set_object_label(schnittform->krafttext_min_moment,c_tmp);
  sprintf(c_tmp,"%.3f",(posmin*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos2_mom,c_tmp);

  /* Q */
  max = maxQ(tmp_stab,&posmax);
  min = minQ(tmp_stab,&posmin);

  sprintf(c_tmp,"%.3f",max);
  fl_set_object_label(schnittform->krafttext_max_quer,c_tmp);
  sprintf(c_tmp,"%.3f",(posmax*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos_quer,c_tmp);
    
  sprintf(c_tmp,"%.3f",min);
  fl_set_object_label(schnittform->krafttext_min_quer,c_tmp);
  sprintf(c_tmp,"%.3f",(posmin*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos2_quer,c_tmp);
  
  /* N */
  max = maxN(tmp_stab,&posmax);
  min = minN(tmp_stab,&posmin);
  
  sprintf(c_tmp,"%.3f",max);
  fl_set_object_label(schnittform->krafttext_max_normal,c_tmp);
  sprintf(c_tmp,"%.3f",(posmax*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos_normal,c_tmp);
  
  sprintf(c_tmp,"%.3f",min);
  fl_set_object_label(schnittform->krafttext_min_normal,c_tmp);
  sprintf(c_tmp,"%.3f",(posmin*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos2_normal,c_tmp);

  /* w */
  max = max_w(tmp_stab,&posmax);
  min = min_w(tmp_stab,&posmin);
  
  sprintf(c_tmp,"%.4f",max);
  fl_set_object_label(schnittform->krafttext_max_w,c_tmp);
  sprintf(c_tmp,"%.3f",(posmax*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos_w,c_tmp);
  
  sprintf(c_tmp,"%.4f",min);
  fl_set_object_label(schnittform->krafttext_min_w,c_tmp);
  sprintf(c_tmp,"%.3f",(posmin*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos2_w,c_tmp);

  /* u */
  max = max_u(tmp_stab,&posmax);
  min = min_u(tmp_stab,&posmin);
  
  sprintf(c_tmp,"%.6f",max);
  fl_set_object_label(schnittform->krafttext_max_u,c_tmp);
  sprintf(c_tmp,"%.3f",(posmax*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos_u,c_tmp);
  
  sprintf(c_tmp,"%.6f",min);
  fl_set_object_label(schnittform->krafttext_min_u,c_tmp);
  sprintf(c_tmp,"%.3f",(posmin*(*tmp_stab).d_laenge));
  fl_set_object_label(schnittform->krafttext_pos2_u,c_tmp);

}



/*********************************************************************/
/* void SetzeWerte_SK(TypStab_Nm *tmp_stab)                             */
/*********************************************************************/
/*                                              
   Funktion setzt in 10 Intervallen die Werte der Schnittkrfte
   jh, 25.04.97 
*/
/*********************************************************************/

void SetzeWerte_SK(TypStab_Nm *tmp_stab)
{
  double M[11],N[11],Q[11];
  long i;
  long anz_points = 11;
  char *sk_text;
  char c_tmp[20]; 
  double z,step;

  fl_set_object_label(schnittform->schnitt_bezeichnung_1,"M");
  fl_set_object_label(schnittform->schnitt_bezeichnung_2,"Q");
  fl_set_object_label(schnittform->schnitt_bezeichnung_3,"N");

  fl_set_object_label(schnittform->schnitt_einheit_1,"[kNm]");
  fl_set_object_label(schnittform->schnitt_einheit_2,"[kN]");
  fl_set_object_label(schnittform->schnitt_einheit_3,"[kN]");

  z = 0;
  step = (double) (1./((double) anz_points - 1.));

  for(i=0; i<anz_points; i++)  {         
    M[i] = getM(tmp_stab,z);
    Q[i] = getQ(tmp_stab,z);
    N[i] = getN(tmp_stab,z);
    z += step;
  }
 
  /* Moment setzen */
  sk_text = (char*) calloc (250,sizeof(char));

  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %8.2f ",M[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_1_text,sk_text);
  free(sk_text); 

  /* Querkraft setzen */
  sk_text = (char*) calloc (250,sizeof(char));

  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %8.2f ",Q[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_2_text,sk_text);
  free(sk_text); 

  /* Normalkraft setzen */
  sk_text = (char*) calloc (250,sizeof(char));
  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %8.2f ",N[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_3_text,sk_text);
  free(sk_text); 
 
}



/*********************************************************************/
/* void SetzeWerte_UW(TypStab_Nm *tmp_stab)                          */
/*********************************************************************/
/*                                              
   Funktion setzt in 10 Intervallen die Werte der Verschiebungen
   jh, 25.04.97 
*/
/*********************************************************************/

void SetzeWerte_UW(TypStab_Nm *tmp_stab)
{
  double U[11],W[11];
  long i;
  long anz_points = 11;
  char *sk_text;
  char c_tmp[20]; 
  double z,step;


  fl_set_object_label(schnittform->schnitt_bezeichnung_1,"w");
  fl_set_object_label(schnittform->schnitt_bezeichnung_2,"u");
  fl_set_object_label(schnittform->schnitt_bezeichnung_3,"");

  fl_set_object_label(schnittform->schnitt_einheit_1,"[m]");
  fl_set_object_label(schnittform->schnitt_einheit_2,"[m]");
  fl_set_object_label(schnittform->schnitt_einheit_3,"");

  z = 0;
  step = (double) (1./((double) anz_points - 1.));

  for(i=0; i<anz_points; i++)  {         
    U[i] = get_u(tmp_stab,z);
    W[i] = get_w(tmp_stab,z);  
    z += step;
  }
 
  /* w setzen */
  sk_text = (char*) calloc (250,sizeof(char));

  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %9.6f",W[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_1_text,sk_text);
  free(sk_text); 

  /* u setzen */
  sk_text = (char*) calloc (250,sizeof(char));

  for(i=0;i<anz_points; i++)  {   
    sprintf(c_tmp," %9.6f",U[i]);
    strcat(sk_text,c_tmp);
  }

  fl_set_object_label(schnittform->intervalle_2_text,sk_text);
  free(sk_text); 
  
  fl_set_object_label(schnittform->intervalle_3_text,"");
  
}
 


/*********************************************************************/
/* void SetzeWerte_UW(TypStab_Nm *tmp_stab)                          */
/*********************************************************************/
/*                                              
   Funktion setzt in 10 Intervallen die Werte der 
   Normalspannungen
   jh, 25.04.97 
*/
/*********************************************************************/

void SetzeWerte_NS(TypStab_Nm *tmp_stab)
{
  fl_set_object_label(schnittform->intervalle_1_text,"");
  fl_set_object_label(schnittform->intervalle_2_text,"");
  fl_set_object_label(schnittform->intervalle_3_text,"");
}
 


/*********************************************************************/
/* void SetzeWerte_SS(TypStab_Nm *tmp_stab)                          */
/*********************************************************************/
/*                                              
   Funktion setzt in 10 Intervallen die Werte der 
   Schubspannungen
   jh, 02.05.97 
*/
/*********************************************************************/

void SetzeWerte_SS(TypStab_Nm *tmp_stab)
{
  fl_set_object_label(schnittform->intervalle_1_text,"");
  fl_set_object_label(schnittform->intervalle_2_text,"");
  fl_set_object_label(schnittform->intervalle_3_text,"");
}
 


/*********************************************************************/
/* void Zeichne_Schnitt_Stab( ... )                                  */
/*********************************************************************/
/*                                              
   Funktion zeichnet einen Stab im Fenster schnittwin
   jh, 25.04.97 
*/
/*********************************************************************/

void Zeichne_Schnitt_Stab(long win_w,long win_h,TypStab_Nm *tmp_stab)
{
  double xa,ya,xb,yb;  
  TypPunkt *tmp_punkt1,*tmp_punkt2;
  TypMaszstab mass;
  double s,c,abstand = 4;
  Typ_DsScale m;

  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;
 
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);
  XSetForeground(display,gc,xs_color.stab);
  XSetBackground(display,gc,xs_color.bg);

  s =  (*tmp_stab).d_sin;
  c =  (*tmp_stab).d_cos;

  tmp_punkt1 = (*tmp_stab).pe_punkta;
  tmp_punkt2 = (*tmp_stab).pe_punktb;
  
  xa =  (*tmp_punkt1).d_x;
  ya =  (*tmp_punkt1).d_y;
  xb =  (*tmp_punkt2).d_x;
  yb =  (*tmp_punkt2).d_y;

  BerechneMass( &mass.system, &mass.off_x, &mass.off_y,win_w,win_h,tmp_stab);
  
  /* Stab */
  XDrawLine(display,
	    schnittwin,gc,
	    (long) X_welt_win_m(schnittwin,xa,mass), 
	    (long) Y_welt_win_m(schnittwin,ya,mass),
	    (long) X_welt_win_m(schnittwin,xb,mass), 
	    (long) Y_welt_win_m(schnittwin,yb,mass));

  /* Bezugsfaser */
  line_style = LineOnOffDash;
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  XDrawLine (display,
	     schnittwin,gc,
	     (long) X_welt_win_m(schnittwin,xa,mass) + (abstand * s),
	     (long) Y_welt_win_m(schnittwin,ya,mass) + (abstand * c),
	     (long) X_welt_win_m(schnittwin,xb,mass) + (abstand * s),
	     (long) Y_welt_win_m(schnittwin,yb,mass) + (abstand * c));  

  /* Punktbeschriftung */
  XSetForeground(display,gc,xs_color.punkt_nr);

  XDrawImageString(display,
		   schnittwin,gc, 
		   (long) X_welt_win_m(schnittwin,xa,mass) - 10, 
		   (long) Y_welt_win_m(schnittwin,ya,mass) + 10,
		   "A",1);

  XDrawImageString(display,
		   schnittwin,gc, 
		   (long) X_welt_win_m(schnittwin,xb,mass) + 10, 
		   (long) Y_welt_win_m(schnittwin,yb,mass) - 10,
		   "B",1);      

  /* Punkte */
  XSetForeground(display,gc,xs_color.punkt_nr);
 
  setze_m(mass,&m);       
  m.win = schnittwin;

  ds_punkt(xa,ya,m);	
  ds_punkt(xb,yb,m);

}      



/*********************************************************************/
/* void Zeichne_Schnitt_Moment( ... )                                */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Momentenlinie im Fenster schnittwin
   jh, 25.04.97 
*/
/*********************************************************************/

void Zeichne_Schnitt_Moment(long win_w,long win_h,TypStab_Nm *tmp_stab)
{ 
  KeGlied *l;  
  TypIntervall *tmp_intervall;
  TypMaszstab mass;
  char *c_tmp;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(!(*tmp_stab).intervalle)
    return;

  XSetForeground(display,gc, xs_color.moment);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);   

  c_tmp = (char*) fl_get_input(scale_form->input6); 
  mass.schnittkraft = atof(c_tmp);
  mass.schnittkraft /= 100;
  
  /* Mastab berechnen */
  BerechneMass( &mass.system, &mass.off_x, &mass.off_y,win_w,win_h,tmp_stab);
      
  /* Schleife ber alle Intervalle des Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;    
    Zeichne_Schnittkraft(schnittwin,tmp_intervall, 2, mass);
  }   

  /* Beschriftung zeichnen */
  if(fl_get_button(schnittform->schnitt_beschriftung_button)) 
    Zeichne_Beschriftung(schnittwin,tmp_stab, 2, mass); 

}


/*********************************************************************/
/* void Zeichne_Schnitt_Quer( ... )                                  */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Querkraftlinie im Fenster schnittwin
   jh, 25.04.97 
*/
/*********************************************************************/

void Zeichne_Schnitt_Quer(long win_w,long win_h,
			  TypStab_Nm *tmp_stab)
{
  KeGlied *l;  
  TypIntervall *tmp_intervall;
  TypMaszstab mass;
  char *c_tmp;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(!(*tmp_stab).intervalle)
    return;

  XSetForeground(display,gc, xs_color.quer);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);   

  c_tmp = (char*) fl_get_input(scale_form->input6); 
  mass.schnittkraft = atof(c_tmp);
  mass.schnittkraft /= 100;
  
  /* Mastab berechnen */
  BerechneMass( &mass.system, &mass.off_x, &mass.off_y,win_w,win_h,tmp_stab);

      
  /* Schleife ber alle Intervalle des Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;    
    Zeichne_Schnittkraft(schnittwin,tmp_intervall, 1, mass);
  }   

  /* Beschriftung zeichnen */
  if(fl_get_button(schnittform->schnitt_beschriftung_button)) 
    Zeichne_Beschriftung(schnittwin,tmp_stab, 1, mass); 

}



/*********************************************************************/
/* void Zeichne_Schnitt_Normal( ... )                                */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Normalkraftlinie im Fenster schnittwin
   jh, 25.04.97 
*/
/*********************************************************************/

void Zeichne_Schnitt_Normal(long win_w,long win_h,
			    TypStab_Nm *tmp_stab)
{ 
  KeGlied *l;  
  TypIntervall *tmp_intervall;
  TypMaszstab mass;
  char *c_tmp;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(!(*tmp_stab).intervalle)
    return;

  XSetForeground(display,gc, xs_color.normal);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);   

  c_tmp = (char*) fl_get_input(scale_form->input6); 
  mass.schnittkraft = atof(c_tmp);
  mass.schnittkraft /= 100;
  
  /* Mastab berechnen */
  BerechneMass( &mass.system, &mass.off_x, &mass.off_y,win_w,win_h,tmp_stab);
      
  /* Schleife ber alle Intervalle des Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;    
    Zeichne_Schnittkraft(schnittwin,tmp_intervall, 0, mass);
  }  

  /* Beschriftung zeichnen */
  if(fl_get_button(schnittform->schnitt_beschriftung_button)) 
    Zeichne_Beschriftung(schnittwin,tmp_stab, 0, mass); 

}



/*********************************************************************/
/* void Zeichne_Schnitt_Verschiebung( ... )                          */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Verschiebung eines Stabes im 
   Fenster schnittwin
   jh, 02.05.97 
*/
/*********************************************************************/

void Zeichne_Schnitt_Verschiebung(long win_w, long win_h,
				  TypStab_Nm *tmp_stab)
{
  KeGlied *l;  
  TypIntervall *tmp_intervall;
  TypMaszstab mass; 

  int line_style = LineSolid;
  int line_width = 4;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(!(*tmp_stab).intervalle)
    return;

  XSetForeground(display,gc, xs_color.verschiebung);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);   

  mass = Zeichne_HoleMaszstab(); 
  
  /* Mastab berechnen */
  BerechneMass( &mass.system, &mass.off_x, &mass.off_y,win_w,win_h,tmp_stab);
      
  /* Schleife ber alle Intervalle des Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;    
    Zeichne_Verschiebung_Stab(schnittwin,tmp_intervall, mass);
  }  

  /* Beschriftung zeichnen */
  if(fl_get_button(schnittform->schnitt_beschriftung_button)) {
    XSetLineAttributes(display,gc,line_width=0,line_style,cap_style,join_style);
    Zeichne_Beschriftung_Verschiebung(schnittwin, tmp_stab, mass);
  }
  
}
