/*
  Datei     : staberzeugen_Nm.c
  erstellt  : 11.08.96
  gendert  : 22.03.97
              02.02.98, jh
  Autor     : jh
*/


#include "XStabDek.h"



/*********************************************************************/
/* void Punkt_1_festlegen(double x, double y, TypPunkt* P)           */
/*********************************************************************/
/*                                              
   Fkt legt den ersten Punkt eines neuen Stabes fest
   wenn P != NULL wird dieser Punkt eingetragen
   jh, 18.03.97
*/
/*********************************************************************/

void Punkt_1_festlegen(double x, double y, TypPunkt* P)
{
  long x_win, y_win; 
   
  
  /*  wenn ein Punkt bergeben wurde  */

  if( P != NULL ) {

    PUNKT = P;
    x = P->d_x;
    y = P->d_y;

  }
  else {

    /*  berpruefen ob ein Punkt an dieser 
	Stelle schon existiert  */

    PUNKT = suchePunkt_Koord(x, y, 1e-3);

    /*  neuer Punkt  */
    if( PUNKT == NULL )
      PUNKT = Erzeuge_Punkt_Nm(x,y,-1);           
    
  }
 
  x_win = X_welt_win(win, x);
  y_win = Y_welt_win(win, y);

  /* Punktsymbol zeichnen */
  staberzeugen_Zeichne_Punkt(win, (long) x_win, (long) y_win);

  Meldung("Punkt 2 festlegen");
  dienst_Prg_Status(3);  

}



/*********************************************************************/
/* void Punkt_2_festlegen(double x, double y, TypPunkt* P)           */
/*********************************************************************/
/*                                              
   Fkt legt den zweiten Punkt eines neuen Stabes fest
   wenn P != NULL wird dieser Punkt eingetragen
   jh, 02.02.98
*/
/*********************************************************************/

void Punkt_2_festlegen(double x, double y, TypPunkt* P)
{
  long x_win,y_win; 
  TypPunkt *tmp_punkt = NULL;
  TypStab_Nm *tmp_stab; 
  long i; 
 

  /*  wenn ein Punkt bergeben wurde  */

  if( P != NULL ) {

    tmp_punkt = P;
    x = P->d_x;
    y = P->d_y;

  }
  else {

    /*  berprfen ob ein Punkt an dieser 
	Stelle schon existiert  */

    tmp_punkt = suchePunkt_Koord(x, y, 1e-3);

  }


  /*  wenn die Koordinaten des ersten und des zweiten Punktes
      gleich sind, dann mu ein neuer zweiter Punkt
      festgelegt werden   */
  
  if( (*PUNKT).d_x == x && (*PUNKT).d_y == y) {     
    Meldung("Punkt 1 und Punkt 2 haben gleiche Koordinaten !!");
    Meldung("Punkt 2 erneut festlegen");
    return;
  }
  
  /*  wenn Punkt noch nicht vorhanden, neuen 
      Punkt mit neuem ID  erzeugen  */
  
  if( tmp_punkt == NULL )
    tmp_punkt = Erzeuge_Punkt_Nm(x, y, -1);
  

  x_win = X_welt_win(win, x);
  y_win = Y_welt_win(win, y);
 

  /*  Punktsymbol zeichnen  */
  staberzeugen_Zeichne_Punkt(win, (long) x_win, (long) y_win); 


  /* Stab erzeugen */
  tmp_stab = Erzeuge_Stab_Nm();

  if(tmp_stab) {
    (*tmp_stab).pe_punkta = PUNKT;
    (*tmp_stab).pe_punktb = tmp_punkt;
  }
  else {
    Meldung("Fehler bei (staberzeugen)");
    return;
  }
  
  SetzeGeometrie_Nm(tmp_stab);    
 
  /* FG bestimmen */
  Uebernehme_FGamPunkt_Nm(tmp_stab, tmp_punkt, 2);
  Uebernehme_FGamPunkt_Nm(tmp_stab, PUNKT, 1);
    
  for(i=0; i<6; i++)
    if( (*tmp_stab).pe_frei[i] == NULL)     
      Erzeuge_FG_Nm(tmp_stab,i);
    
  Verbinde_FG( (*tmp_stab).pe_frei[0], (*tmp_stab).pe_frei[1], Modell->FG_Relation_Nm);
  Verbinde_FG( (*tmp_stab).pe_frei[3], (*tmp_stab).pe_frei[4], Modell->FG_Relation_Nm);  
 
  dienst_Prg_Status(1);

  Meldung("ok");

  /* Drucke_FG_Relation(); */
  /* DruckePunkte_Nm(); */
  /* DruckeStaebe_Nm(); */
  
  Zeichne();

}


/***********************************************************/ 
/* void staberzeugen_Zeichne_Punkt(...)                    */
/***********************************************************/ 
/*                                              
   Funktion markiert mit einem Symbol den ersten
   ausgewhlten Punkt beim Erzeugen 
   eines Stabes
   jh, 03.04.97
*/
/***********************************************************/

void staberzeugen_Zeichne_Punkt(Window win, long x, long y)
{
  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetForeground(display,gc,fl_get_flcolor(FL_INDIANRED));
  XSetLineAttributes(display,gc,line_width,
		     line_style,cap_style,join_style);

  XDrawRectangle(display, win, gc, x-5, y-5, 10, 10);
}



void Zeige_Standardwerte(void)
{
  KeGlied *p;
  TypMaterial *tmp_mat;
  TypQuerschnitt *tmp_quer;
  char c_text[100];

  /* Material eintragen */

  fl_clear_browser(staberzeugenform->standardmat_browser);
  fl_set_object_label(staberzeugenform->standard_mat_text,"");
  
  if(KeMaterial)
    KeDurchlaufVorwaerts(p,KeMaterial)
    {	  
      tmp_mat = p->x;

      sprintf(c_text,"%10ld  %s", (*tmp_mat).l_id, (*tmp_mat).c_name);

      if((*tmp_mat).l_id == standard_mat)
	fl_set_object_label(staberzeugenform->standard_mat_text,c_text);
     
      fl_add_browser_line(staberzeugenform->standardmat_browser,c_text);
    }      

  /* Querschnitte eintragen */

  fl_clear_browser(staberzeugenform->standardquer_browser);
  fl_set_object_label(staberzeugenform->standard_quer_text,"");

  if(KeQuerschnitt)
    KeDurchlaufVorwaerts(p,KeQuerschnitt)
    {	  
      tmp_quer = p->x;

      sprintf(c_text,"%10ld  %s", (*tmp_quer).l_id, (*tmp_quer).c_name);

      if((*tmp_quer).l_id == standard_quer)
	fl_set_object_label(staberzeugenform->standard_quer_text,c_text);
     
      fl_add_browser_line(staberzeugenform->standardquer_browser,c_text);
    }
      
  fl_show_form(staberzeugenform->staberzeugen,FL_PLACE_CENTER,FL_TRANSIENT,
	       "Standardwerte Stab erzeugen"); 
}


long Hole_Standard_MaterialID(void)
{
  char c_nummer[10];
  char *c_tmp;
  long i,j;

  for(i=1;i<=fl_get_browser_maxline(staberzeugenform->standardmat_browser);i++) {
    if(fl_isselected_browser_line(staberzeugenform->standardmat_browser,i)) {	 	  
      c_tmp = (char*) fl_get_browser_line(staberzeugenform->standardmat_browser,i);
      for(j=0;j<10;j++)
	c_nummer[j] = c_tmp[j];     
      return (long) atol(c_nummer);
    }
  }    
  return -1;
}


long Hole_Standard_QuerschnittID(void)
{
  char c_nummer[10];
  char *c_tmp;
  long i,j;

  for(i=1;i<=fl_get_browser_maxline(staberzeugenform->standardquer_browser);i++) {
    if(fl_isselected_browser_line(staberzeugenform->standardquer_browser,i)) {	 	  
      c_tmp = (char*) fl_get_browser_line(staberzeugenform->standardquer_browser,i);
      for(j=0;j<10;j++)
	c_nummer[j] = c_tmp[j];     
      return (long) atol(c_nummer);
    }
  }    
  return -1;
}


void staberzeugen_cb(FL_OBJECT *obj, long arg)
{
  if(prg_status == 1) {
    Meldung("Punkt 1 festlegen !");        
    dienst_Prg_Status(2);
  }
}

