/*
  Datei     : stabteilen_Nm.c
  erstellt  : 05.05.97
  geaendert : 14.07.97
  Autor     : jh
*/


#include "XStabDek.h"



/***********************************************************/ 
/* void Stabteilen_Nm(long anz)                            */
/***********************************************************/ 
/*                                              
   Funktion teilt einen Stab im NM in anz Teile
   jh, 04.05.97
*/
/***********************************************************/

void Stabteilen_Nm(Menge *M, long anz)
{

  TypStab_Nm *tmp_stab;

  double step,x,y,z;
  long i,j,k;
  KeGlied *p,*tmp_kette;
  TypStab_Nm **stab;
  TypPunkt **punkt; 
  TypKnotenlast_Nm *tmp_pl;
  TypStreckenlast_Nm *tmp_sl, *tmp_sl_neu;
  double XA,YA,XE,YE;
  double A,B;
  double pos,posA,posB;
  long index,index1,index2;
  double n;

  if(anz<2)
    return;
 
  n = (double) M->n;

  Progress(0.);

  /* Schleife ber Menge mit Stben */
  for(k=1; k<= M->n; k++) {

    Progress( (double)  (k / n) );  

    tmp_stab = M->feld[k];

     /* Vektor, in dem die Stbe stehen, stab[0] ist der alte Stab */
    stab = (TypStab_Nm**) calloc (anz,sizeof(TypStab_Nm*));
    stab[0] = tmp_stab;

    /* Vektor, in dem die Punkte stehen */
    punkt = (TypPunkt**) calloc (anz+1,sizeof(TypPunkt*));
     
    /* ersten und letzten Punkt setzen */
    punkt[0]   = (*stab[0]).pe_punkta;
    punkt[anz] = (*stab[0]).pe_punktb;
     
    /* neue Staebe erzeugen */
    for(i=1;i<anz;i++)
      stab[i] = Erzeuge_Stab_Nm();
    
    /* Geometrie sichern */
    XA = (*punkt[0]).d_x;
    YA = (*punkt[0]).d_y;
    XE = (*punkt[anz]).d_x;
    YE = (*punkt[anz]).d_y;
    
    /* neue Punkte erzeugen */
    step = (double) 2./anz;
    z=-1.+step;
    for(i=1;i<anz;i++) {    
      x = 0.5 * (XA * (1.-z) + XE * (1.+z));
      y = 0.5 * (YA * (1.-z) + YE * (1.+z));
      punkt[i] = Erzeuge_Punkt_Nm(x,y,-1);
      z+=step;
    }  
    
    /* Punkte den Staeben zuweisen */
    (*stab[0]).pe_punktb = punkt[1];
    
    for(i=1;i<anz;i++) {
      (*stab[i]).pe_punkta = punkt[i];
      (*stab[i]).pe_punktb = punkt[i+1];  
    } 
    
    /* die FG 3-6 des alten Stabes, dem letzten neuen Stab zuweisen */
    for(i=3;i<6;i++)
      (*stab[anz-1]).pe_frei[i] =  (*stab[0]).pe_frei[i];
    
    /* die FG 3-6 des alten Stabes neu erzeugen */
    for(i=3;i<6;i++) 
      Erzeuge_FG_Nm(stab[0],i);     
    
    for(i=1;i<anz-1;i++) {    
      for(j=0;j<3;j++)
	(*stab[i]).pe_frei[j] = (*stab[i-1]).pe_frei[j+3];
      for(j=3;j<6;j++) 
	Erzeuge_FG_Nm(stab[i],j);     
    }
    
    for(i=0;i<3;i++)
      (*stab[anz-1]).pe_frei[i] = (*stab[anz-2]).pe_frei[i+3];  
    
    /* Geometrie neu berechnen */
    for(i=0;i<anz;i++) 
      SetzeGeometrie_Nm(stab[i]);
    
    /* Material und Querschnitt bernehmen */
    for(i=1;i<anz;i++) {
      (*stab[i]).l_matid  = (*tmp_stab).l_matid;     
      (*stab[i]).l_querid = (*tmp_stab).l_querid;    
    }
    
    /* Lasten verteilen */
    
    /* Schleife ueber alle Punktlasten */
    if(Modell->KePunktlast_Nm) {
      KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm) {
	tmp_pl = p->x;
      
	/* wirkt Pl auf dem Stab tmp_stab ? */
	if( (*tmp_pl).l_stabnummer == (*tmp_stab).l_nummer ) {
	
	  /* Intervall ermitteln, in dem die Lat wirkt */
	  step = (*tmp_pl).d_pos * anz;
	  index = (long) (step/1L);
	  
	  /* Last am Stabende */
	  if( (*tmp_pl).d_pos == 1. )
	    index--;
	  
	  (*tmp_pl).l_stabnummer = (*stab[index]).l_nummer;
	  A = (double) index/anz;
	  B = (double) (index+1.)/anz;
	  (*tmp_pl).d_pos =  ((*tmp_pl).d_pos - A)/(B - A);
	  
	}
      }
    }
    
    /* Streckenlasten des Stabes in temp. Kette eintragen */
    tmp_kette = KeKetteDefinieren();
    
    if(Modell->KeStreckenlast_Nm)
      KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm) {
      tmp_sl = p->x;
      if( (*tmp_sl).l_stabnummer == (*tmp_stab).l_nummer ) 
	KeElementEintragen(tmp_sl,Nach,tmp_kette);
    }
      
      
      
      /* Schleife ueber alle Streckenlasten des Stabes */ 
      KeDurchlaufVorwaerts(p,tmp_kette) {
	tmp_sl = p->x;    
	
	step = (*tmp_sl).d_anf * anz;
	index1 = (long) (step/1L);
	
	step = (*tmp_sl).d_end * anz;
	index2 = (long) (step/1L);
	
	/* Last am Stabende */
	if( (*tmp_sl).d_end == 1. )
	  index2--;
	
	for(i=index1; i<= index2; i++) {
	  
	  /* neu SL erzeugen */
	  tmp_sl_neu = Erzeuge_Streckenlast_Nm( (*tmp_sl).l_lastfallid, -1);			      
	  
	  /* Werte sichern */
	  sprintf((*tmp_sl_neu).c_name,"%s_%ld", (*tmp_sl).c_name, i);
	  (*tmp_sl_neu).d_alpha = (*tmp_sl).d_alpha;
	  (*tmp_sl_neu).l_koordsys = (*tmp_sl).l_koordsys;
	  (*tmp_sl_neu).l_stabnummer = (*stab[i]).l_nummer;

	  /* posA und posB bestimmen */

	  /* Intervallgrenzen */
	  A = (double) i/anz;
	  B = (double) (i+1.)/anz;
	  
	  /* pos bezogen auf das Intervall im Bereich (0,1) */
	  posA =  ((*tmp_sl).d_anf - A)/(B - A);
	  if(posA < 0.)
	    posA = 0.;
	  
	  posB =  ((*tmp_sl).d_end - A)/(B - A);
	  if(posB > 1.)
	    posB = 1.;          

	  (*tmp_sl_neu).d_anf = posA;
	  (*tmp_sl_neu).d_end = posB;	 

	  /* Anfang : Last interpolieren */      
	  pos = (double) A + (double) posA/anz; /* pos bezogen auf Stab */	 

	  /* Sttzstellen im Bereich der Last ermitteln */
	  z = (pos - (*tmp_sl).d_anf) / ((*tmp_sl).d_end - (*tmp_sl).d_anf);
          
	  (*tmp_sl_neu).d_lasta = (*tmp_sl).d_lasta * (1.-z) + (*tmp_sl).d_lastb * z;	


	  /* Ende : Last interpolieren */      
	  pos = (double) A + posB/anz;	 
	  
	  /* Sttzstellen im Bereich der Last ermitteln */
	    z = (pos - (*tmp_sl).d_anf) / ((*tmp_sl).d_end - (*tmp_sl).d_anf);
          
	    (*tmp_sl_neu).d_lastb = (*tmp_sl).d_lasta * (1.-z) + (*tmp_sl).d_lastb * z;        
      	   
	  }

	  /* alte Streckenlast in KeStreckenlasten_Nm lschen */
	  Loesche_Streckenlast_ID__Nm((*tmp_sl).l_id);
	  
      }    
      
      /* temp. Kette lschen */
      while(tmp_kette->nach != tmp_kette) {
	p = tmp_kette->nach;	 
	KeGliedAustragen(p); 		  	               
      }
      
      /* Speicher freigeben */
      free(tmp_kette);
      free(stab);
      free(punkt);
  }

  Modell->unsaved_changes++;
  
}


