/*
  Datei     : suche_Nm.c
  erstellt  : 06.01.97
  gendert  : 01.02.98
  Autor     : jh
*/

#include "XStabDek.h"

 
TypStab_Nm* Suche_Stab_select_Nm(long *nummer)
{  
  KeGlied *p;
  TypStab_Nm *tmp_stab;

  if(Modell->KeStab_Nm) {
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {	  
      tmp_stab = p->x;     
      if((*tmp_stab).l_selektiert == 1) {
	*nummer =  (*tmp_stab).l_nummer;
	return tmp_stab;
      }
    }
  }

  *nummer = -1;
  return NULL;

}



/*********************************************************************/
/* TypPunkt* suchePunkt_Koord(double x, double y)                    */
/*********************************************************************/
/*                                              
   Fkt berprft, ob an der Stelle x/y (+-eps) schon ein
   Punkt existiert und gibt diesen zurck, sonst NULL
   jh, 01.02.98
*/
/*********************************************************************/

TypPunkt* suchePunkt_Koord(double x, double y, double eps)
{
  TypPunkt* tmp_punkt;
  TypPunkt* punkt=NULL;
  KeGlied* p;
  double _x,_y;
  double _r,r;

  _r = eps;  

  if(Modell->KePunkt_Nm) {
    KeDurchlaufVorwaerts(p, Modell->KePunkt_Nm) {

      tmp_punkt = p->x;

      _x = (*tmp_punkt).d_x - x;
      _y = (*tmp_punkt).d_y - y;

      r = sqrt( _x * _x + _y * _y );

      if( r < _r) {

	_r = r;
	punkt = tmp_punkt;
	      	    
      }
    }

    if( punkt )
      return punkt;
  }

  return NULL;

}



/*********************************************************************/
/* KeGlied* getSelectedK(void)                                       */
/*********************************************************************/ 
/*                                              
   Fkt liefert eine Kette der selektierten Stbe
   jh, 07.08.97
*/
/*********************************************************************/

KeGlied* getSelectedK(void)
{
  KeGlied *M;
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  long anz=0;

  /*  Kette definieren */
  M = KeKetteDefinieren();

  if(Modell->KeStab_Nm) {
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {	  
      tmp_stab = p->x;     
      if((*tmp_stab).l_selektiert == 1) {
	anz++;
	KeElementEintragen(tmp_stab,Nach,M);

      }
    }
  }  

  if(anz)
    return M;
  else 
    return NULL;     
}



/*********************************************************************/
/* Menge* getSelectedM(void)                                         */
/*********************************************************************/ 
/*                                              
   Fkt liefert die Menge der selektierten Stbe
   jh, 14.07.97
*/
/*********************************************************************/

Menge* getSelectedM(void)
{
  Menge *M;
  KeGlied *p;
  TypStab_Nm *tmp_stab;

  /* Menge definieren */
  M = Mng_MengeDefinieren();

  if(Modell->KeStab_Nm) {
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {	  
      tmp_stab = p->x;     
      if((*tmp_stab).l_selektiert == 1) {

	Mng_ElementEintragen(tmp_stab,M);

      }
    }
  }   

  return M;

}


TypStreckenlast_Nm* Suche_Streckenlast_Nm(long stabnummer)
{
  KeGlied* p;
  TypStreckenlast_Nm* tmp_streckenlast;

  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm)
    {	  
      tmp_streckenlast = p->x;     
      if((*tmp_streckenlast).l_stabnummer == stabnummer)
	{	 
	  return tmp_streckenlast;
	}
    }
  return NULL;
}



/*********************************************************************/
/* TypFreigrad* suche_FG_Nm(long fg_nummer)                          */
/*********************************************************************/ 
/*                                              
   Fkt sucht den Freiheitsgrad mit der Nummer fg_nummer
   jh, 08.04.97                                 
*/
/*********************************************************************/

TypFreiGrad* suche_FG_Nm(long fg_nummer)
{
  KeGlied* p;
  TypFreiGrad* tmp_fg;

  if(Modell->KeFreiGrad_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeFreiGrad_Nm)
      {	  
	tmp_fg = p->x;     
	if((*tmp_fg).l_nummer == fg_nummer)	 
	  return tmp_fg;	  
      }
  return NULL;
}



TypStab_Nm* Suche_Stab_Nm(long nummer)
{
  KeGlied* p;
  TypStab_Nm* tmp_stab;

  if(!Modell->KeStab_Nm)
    return NULL;

  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {	  
    tmp_stab = p->x;     
    if((*tmp_stab).l_nummer == nummer)      
      return tmp_stab;	
  }

  return NULL;

}


long Suche_freieStabnummer_Nm(void)
{
  KeGlied *p;
  TypStab_Nm *tmp_stab; 

  long nummer=0;
  long gefunden=1; 

  if(Modell->KeStab_Nm)
    {
      nummer = -1;
      while(gefunden)
      {
	nummer++;
	gefunden = 0;
	KeDurchlaufVorwaerts(p, Modell->KeStab_Nm)
	  {
	    tmp_stab = p->x;
	    if((*tmp_stab).l_nummer == nummer)
	      {
		gefunden = 1;
		break;
	      }
	  }	
      }
    } 
  return nummer;    
}


/*********************************************************************/
/* long suchefreieLFKombNummer(void)                                 */
/*********************************************************************/ 
/* 
   Fkt sucht eine freie Nummer in der Kette KeLfKombination
   jh, 22.08.97
*/
/*********************************************************************/

long suchefreieLFKombNummer(void)
{
  KeGlied *p;
  TypLastfallkombination* tmp_lfkomb;

  long nummer=0;
  long gefunden=1; 

  if(Modell->KeLfKombination) {
    nummer = -1;
    while(gefunden) {
      nummer++;
      gefunden = 0;
    
      KeDurchlaufVorwaerts(p, Modell->KeLfKombination) {
	tmp_lfkomb = p->x;
	if( tmp_lfkomb->l_id == nummer) {
	  gefunden = 1;
	  break;
	}
      }
	
    }
  } 

  return nummer;    
  
}



TypKnotenlast_Nm* Suche_Last_PL_Nm(long id)
{
  TypKnotenlast_Nm *tmp_pl; 
  KeGlied *p;
   
  if(Modell->KePunktlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm)
    {	  
      tmp_pl = p->x;
      if( (*tmp_pl).l_id == id)
	return tmp_pl;
    }

  return NULL;
}


TypStreckenlast_Nm* Suche_Last_SL_Nm(long id)
{
  TypStreckenlast_Nm *tmp_sl;
  KeGlied *p;
   
  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm)
    {	  
      tmp_sl = p->x;
      if( (*tmp_sl).l_id == id)
	return tmp_sl;
    }

  return NULL;
}



/*********************************************************************/
/* TypLastfall* Suche_Lastfall(long nummer)                          */
/*********************************************************************/ 
/*                                              
   Fkt. sucht den Lastfall mit der Nummer 'nummer'
   jh, 28.04.97
*/
/*********************************************************************/

TypLastfall* Suche_Lastfall_nr(long nummer)
{
  TypLastfall *tmp_lf;  
  KeGlied *p;
   
  if(Modell->KeLast)
    KeDurchlaufVorwaerts(p,Modell->KeLast) {	  
      tmp_lf = p->x;
      if( (*tmp_lf).l_nummer == nummer)
	return tmp_lf;
    }

  return NULL;
}



/*********************************************************************/
/* TypLastfall* Suche_Lastfall(long nummer)                          */
/*********************************************************************/ 
/*                                              
   Fkt. sucht den Lastfall mit dem ID 'id'
   jh, 28.04.97
*/
/*********************************************************************/

TypLastfall* Suche_Lastfall_id(long id)
{
  TypLastfall *tmp_lf;  
  KeGlied *p;
   
  if(Modell->KeLast)
    KeDurchlaufVorwaerts(p,Modell->KeLast) {	  
      tmp_lf = p->x;
      if( (*tmp_lf).l_id == id)
	return tmp_lf;
    }

  return NULL;
}
