/*
  Datei     : Pruefe.c
  erstellt  : 09.07.96
  geaendert : 09.03.97
  Autor     : jh
*/


#include "XStabDek.h"



/***********************************************************/ 
/* void Pruefe_Gelenke(long *, long *, TypStab_Nm* )       */
/***********************************************************/ 
/*                                              
   Funktion prft, ob an einem Punkt alle Stbe biegesteif 
   angeschlossen sind.
   Wenn ja, dann werden diese Freiheitsgrade, bei gesetzter 
   Option, nicht gezeichnet.  
   von, bis ist der Bereich der zu zeichnenden FG-Nummern
   jh, 22.03.97
*/
/***********************************************************/

void Pruefe_Gelenke(long *von, long *bis, TypStab_Nm* tmp_stab)
{ 
  /* Abfrage des Menubuttons */
  if(fl_get_menu_item_mode(form->Einstellungen,4) == 6) {
    /* Option nicht gesetzt -> alle FG zeichnen */
    *von = 0;
    *bis = 6;
  }
  else {     
    pruefeGelenke(von,bis,tmp_stab);
  }
}



/***********************************************************/ 
/* void pruefeGelenke(long *, long *, TypStab_Nm* )        */
/***********************************************************/ 
/*                                              
   Funktion prft, ob an einem Punkt alle Stbe biegesteif 
   angeschlossen sind.  
   jh, 03.08.97
*/
/***********************************************************/

void pruefeGelenke(long *von, long *bis, TypStab_Nm* tmp_stab)
{
  TypPunkt *tmp_punkt1, *tmp_punkt2;  
  KeGlied *p;
  Menge *M;  /* hier stehen die FGs */
  long anz,i;

  if(!Modell->KeStab_Nm) {
    *von = 0;
    *bis = 0;
    return;
  }

  M = Mng_MengeDefinieren();
    
  tmp_punkt1 = (*tmp_stab).pe_punkta;
  tmp_punkt2 = (*tmp_stab).pe_punktb;     
        
  /* ...  PUNKT 1  ... */
    
  /* FG an Punkt 1 zhlen */ 
  
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;
    
    if( (*tmp_stab).pe_punkta == tmp_punkt1 ) {
      for(i=0;i<3;i++) {
	if( Mng_ElementSuchen( (*tmp_stab).pe_frei[i], M) == 0)
	  Mng_ElementEintragen((*tmp_stab).pe_frei[i], M);	
      }
    }
    
    if( (*tmp_stab).pe_punktb == tmp_punkt1 ) {
      for(i=3;i<6;i++) {
	if( Mng_ElementSuchen((*tmp_stab).pe_frei[i], M) == 0)
	  Mng_ElementEintragen( (*tmp_stab).pe_frei[i], M);	
      }
    }	   	    
  }
    
  anz = M->n;
    
  if(anz > 3)
    *von = 0;
  else
    *von = 3;
    
  Mng_MengeLoeschen(M); 
  M = Mng_MengeDefinieren();
    
  /* ...  PUNKT 2  ... */          
    
  /* FG an Punkt 2 zhlen */
  
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;
    
    if( (*tmp_stab).pe_punkta == tmp_punkt2 ) {
      for(i=0;i<3;i++) {
	if( Mng_ElementSuchen((*tmp_stab).pe_frei[i], M) == 0)
	  Mng_ElementEintragen( (*tmp_stab).pe_frei[i], M);	
      }
    }
    
    if( (*tmp_stab).pe_punktb == tmp_punkt2 ) {
      for(i=3;i<6;i++) {
	if( Mng_ElementSuchen((*tmp_stab).pe_frei[i], M) == 0)
	  Mng_ElementEintragen( (*tmp_stab).pe_frei[i], M);		
      }
    }	   	    
  }
	
  anz = M->n;
  
  if(anz > 3)
    *bis = 6;
  else
    *bis = 3;        
}



/*********************************************************************/
/* void PruefeSelektion(double x, double y)                          */
/*********************************************************************/ 
/*                                              
   Funktion prft, ob ein Stab angeklickt wurde
   jh, 22.03.97
*/
/*********************************************************************/

void PruefeSelektion(long x, long y)
{
  double x_l,y_l;

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1, *tmp_punkt2;

  /* Fensterkoordinaten in Fensterkoordinaten umrechnen */
  x_l = X_win_welt(win,x);
  y_l = Y_win_welt(win,y);

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;     

      tmp_punkt1 = (*tmp_stab).pe_punkta;
      tmp_punkt2 = (*tmp_stab).pe_punktb;

      if(PruefePicked((*tmp_punkt1).d_x , (*tmp_punkt1).d_y , 
		      (*tmp_punkt2).d_x , (*tmp_punkt2).d_y ,
		      x_l,y_l))	
	(*tmp_stab).l_selektiert *= -1;
    }  
}



/*********************************************************************/
/* void PruefeSelektionBox(long x1, long y1, long x2, long y2)       */
/*********************************************************************/ 
/*                                              
   Funktion prft, welche Stbe im ausgewhlten Rechteck liegen
   x1,y1 Ecke links oben,
   x2,y2 Ecke rechts unten

   jh, 08.08.97
*/
/*********************************************************************/

void PruefeSelektionBox(long x1, long y1, long x2, long y2)
{
  double x1_l,y1_l;
  double x2_l,y2_l;

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1, *tmp_punkt2;

  if(!Modell->KeStab_Nm)
    return;

  /* Fensterkoordinaten in Weltkoordinaten umrechnen */
  x1_l = X_win_welt(win,x1);
  y1_l = Y_win_welt(win,y1);
  x2_l = X_win_welt(win,x2);
  y2_l = Y_win_welt(win,y2);  

  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {

    tmp_stab = p->x;     

    tmp_punkt1 = (*tmp_stab).pe_punkta;
    tmp_punkt2 = (*tmp_stab).pe_punktb;          

    if ( (*tmp_punkt1).d_x > x1_l &&  (*tmp_punkt1).d_x < x2_l )          
      if ( (*tmp_punkt1).d_y < y1_l &&  (*tmp_punkt1).d_y > y2_l )	
	if ( (*tmp_punkt2).d_x > x1_l &&  (*tmp_punkt2).d_x < x2_l )
	  if ( (*tmp_punkt2).d_y < y1_l &&  (*tmp_punkt2).d_y > y2_l )      
	    (*tmp_stab).l_selektiert = 1;

  }
}



void Edit(TypStab_Nm* tmp_stab)
{
  TypPunkt *tmp_punkt1, *tmp_punkt2;
  char c_tmp[10];
  
  if(tmp_stab) {
    tmp_punkt1 =  (*tmp_stab).pe_punkta;
    tmp_punkt2 =  (*tmp_stab).pe_punktb;

    sprintf(c_tmp,"%ld",(*tmp_stab).l_nummer);
    fl_set_object_label(stabeditform->stabnummer,c_tmp);
  
    /* Punkte eintragen */
    sprintf(c_tmp,"%ld",(*tmp_punkt1).l_nummer);
    fl_set_input(stabeditform->punktainput,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt1).d_x);
    fl_set_input(stabeditform->xa,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt1).d_y);
    fl_set_input(stabeditform->ya,c_tmp);
    
    sprintf(c_tmp,"%ld",(*tmp_punkt2).l_nummer);
    fl_set_input(stabeditform->punktbinput,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt2).d_x);
    fl_set_input(stabeditform->xb,c_tmp);
    sprintf(c_tmp,"%.3f",(*tmp_punkt2).d_y);
    fl_set_input(stabeditform->yb,c_tmp);
      
      
    sprintf(c_tmp,"%.4f",(*tmp_stab).d_alpha);
    fl_set_object_label(stabeditform->winkel2,c_tmp);
    
    sprintf(c_tmp,"%.4f",(*tmp_stab).d_laenge);
    fl_set_object_label(stabeditform->laenge2,c_tmp);             
    
    fl_show_form(stabeditform->stab_edit,FL_PLACE_CENTER,FL_TRANSIENT,"Stab"); 
  }
} 




void SetzeWerte_Eig_Querschnitt(void)
{
  KeGlied *p;
  TypQuerschnitt *tmp_quer=NULL;
  TypStab_Nm *tmp_stab;
  long dummy;
  char c_text[100];

  fl_clear_browser(materialeditform->eigenschaften_querbrowser);
  
  if(KeQuerschnitt) {
    KeDurchlaufVorwaerts(p,KeQuerschnitt) {	  
      tmp_quer = p->x;	 
      sprintf(c_text,"%10ld  %s", (*tmp_quer).l_id, (*tmp_quer).c_name);
      fl_add_browser_line(materialeditform->eigenschaften_querbrowser,c_text);
    }
    
    tmp_stab = Suche_Stab_select_Nm(&dummy);
    
    if(tmp_stab)      
      tmp_quer = Suche_Querschnitt((*tmp_stab).l_querid);
    
    if(tmp_quer) {
      fl_set_object_label(materialeditform->eigenschaften_quer_text,(*tmp_quer).c_name);
      sprintf(c_text,"%.4e", (*tmp_quer).d_A);
      fl_set_object_label(materialeditform->eigenschaften_flaeche,c_text);
      sprintf(c_text,"%.4e", (*tmp_quer).d_Iz);
      fl_set_object_label(materialeditform->eigenschaften_Iz,c_text);
    }
    else {
      fl_set_object_label(materialeditform->eigenschaften_quer_text,"kein Querschnitt !");
      fl_set_object_label(materialeditform->eigenschaften_flaeche,"");
      fl_set_object_label(materialeditform->eigenschaften_Iz,"");
    }
  }
}


/* ...  Form Material/Querschnitt aufbauen  ... */

void SetzeWerte_Eig_Material(void)
{
  KeGlied *p;
  TypMaterial *tmp_mat=NULL;
  TypStab_Nm *tmp_stab=NULL;
  long dummy;
  char c_text[100];

  fl_clear_browser(materialeditform->eigenschaften_matbrowser);
  
  if(KeMaterial)  {
    KeDurchlaufVorwaerts(p,KeMaterial) {	  
      tmp_mat = p->x;	 
      sprintf(c_text,"%10ld  %s", (*tmp_mat).l_id, (*tmp_mat).c_name);
      fl_add_browser_line(materialeditform->eigenschaften_matbrowser,c_text);
    }
    
    tmp_stab = Suche_Stab_select_Nm(&dummy);
    
    if(tmp_stab)
      tmp_mat = Suche_Material((*tmp_stab).l_matid);
    
    if(tmp_mat) {
      fl_set_object_label(materialeditform->eigenschaften_material_text,(*tmp_mat).c_name);
      sprintf(c_text,"%.4e", (*tmp_mat).d_E);
      fl_set_object_label(materialeditform->eigenschaften_emodul_text,c_text);	 
    }
    else {
      fl_set_object_label(materialeditform->eigenschaften_material_text,"kein Material !");	
      fl_set_object_label(materialeditform->eigenschaften_emodul_text,"");	 
    }
  }
}


long Hole_Eig_MaterialID(void)
{
  char c_nummer[10];
  char *c_tmp;
  long i,j;

  for(i=1;i<=fl_get_browser_maxline(materialeditform->eigenschaften_matbrowser);i++)
    {
      if(fl_isselected_browser_line(materialeditform->eigenschaften_matbrowser,i))
	{	 	  
	  c_tmp = (char*) fl_get_browser_line(materialeditform->eigenschaften_matbrowser,i);
	  for(j=0;j<10;j++)
	    c_nummer[j] = c_tmp[j];     
	  return (long) atol(c_nummer);
	}
    }    
  return -1;
}


long Hole_Eig_QuerschnittID(void)
{
  char c_nummer[10];
  char *c_tmp;
  long i,j;

  for(i=1;i<=fl_get_browser_maxline(materialeditform->eigenschaften_querbrowser);i++)
    {
      if(fl_isselected_browser_line(materialeditform->eigenschaften_querbrowser,i))
	{	 	  
	  c_tmp = (char*) fl_get_browser_line(materialeditform->eigenschaften_querbrowser,i);
	  for(j=0;j<10;j++)
	    c_nummer[j] = c_tmp[j];     
	  return (long) atol(c_nummer);
	}
    }    
  return -1;
}




