/*
  Datei     : Suchen.c
  erstellt  : 13.08.96
  geaendert : 18.03.97
  Autor     : jh
*/


#include "XStabDek.h"



/***********************************************************/
/* long suche_Lastfall_ID(long nummer)                     */
/***********************************************************/ 
/*                                              
   Fkt sucht den ID eines Lastfalls bei gegebener Nummer
   (Nummer wird zur Laufzeit vergeben)
   jh, 18.03.97
*/
/***********************************************************/

long suche_Lastfall_ID(long nummer)
{
  KeGlied *p;
  TypLastfall *tmp_lastfall;

  if(Modell->KeLast)
    KeDurchlaufRueckwaerts(p,Modell->KeLast) { 
      tmp_lastfall = p->x;
      if( (*tmp_lastfall).l_nummer == nummer )
	return (*tmp_lastfall).l_id;
    }
  return -1;
}



/*********************************************************************/
/* long suche_Lastfall_Nummer(long id)                               */
/*********************************************************************/ 
/*                                              
   Fkt sucht die Nummer eines Lastfalls bei gegebenem ID
   (Nummer wird zur Laufzeit vergeben)
   jh, 18.03.97
*/
/*********************************************************************/

long suche_Lastfall_Nummer(long id)
{
  KeGlied *p;
  TypLastfall *tmp_lastfall;

  if(Modell->KeLast)
    KeDurchlaufRueckwaerts(p,Modell->KeLast) { 
      tmp_lastfall = p->x;
      if( (*tmp_lastfall).l_id == id )
	return (*tmp_lastfall).l_nummer;
    }
  return -1;
}






/*********************************************************************/
/* TypPunkt* suchePunkt_Nr(long nummer, KeGlied* kette)              */
/*********************************************************************/ 
/*                                              
   Fkt sucht einen Punkt mit der Nummer 'nummer'
   in der angegebenen Kette
   jh, 18.03.97
*/
/*********************************************************************/

TypPunkt* suchePunkt_Nr(long nummer, KeGlied* kette)
{
  KeGlied* p;
  TypPunkt* tmp_punkt;

  if(kette)
    KeDurchlaufVorwaerts(p, kette)
      {	  
	tmp_punkt = p->x;     
	if((*tmp_punkt).l_nummer == nummer)	
	  return tmp_punkt;	 
      }
  return NULL;
}



/***********************************************************/
/* TypFreiGrad* Suche_FreiGrad(long nummer, KeGlied* kette)*/
/***********************************************************/ 
/*                                              
   Fkt sucht einen Freiheitsgrad mit der Nummer 'nummer'
   in der angegebenen Kette
   jh, 18.03.97
*/
/***********************************************************/

TypFreiGrad* Suche_FreiGrad(long nummer, KeGlied* kette)
{
  KeGlied* p;
  TypFreiGrad* tmp_freigrad;

  if(kette)
    KeDurchlaufVorwaerts(p,kette)
      {	  
	tmp_freigrad = p->x;     
	if((*tmp_freigrad).l_nummer == nummer)      
	  return tmp_freigrad;	
      }
  return NULL;
}


TypMaterial* Suche_Material(long id)
{
  KeGlied *p;
  TypMaterial *tmp_material;
  
  if(KeMaterial)
    KeDurchlaufVorwaerts(p,KeMaterial) {	  
      tmp_material = p->x;
      if( (*tmp_material).l_id == id)
	return tmp_material;
    }

  return NULL;
}


TypQuerschnitt* Suche_Querschnitt(long id)
{
  KeGlied *p;
  TypQuerschnitt *tmp_quer;
  
  if(KeQuerschnitt)
    KeDurchlaufVorwaerts(p,KeQuerschnitt)
    {	  
      tmp_quer = p->x;
      if( (*tmp_quer).l_id == id)
	return tmp_quer;
    }

  return NULL;
}



long Suche_freiePunktnummer(KeGlied* kette)
{
  KeGlied *p;
  TypPunkt *tmp_punkt;
  long nummer=0;
  long gefunden=1;

  if(kette)
    {
      nummer = -1;
      while(gefunden)
	{
	  nummer++;
	  gefunden = 0;
	  KeDurchlaufVorwaerts(p,kette)
	    {
	      tmp_punkt = p->x;
	      if((*tmp_punkt).l_nummer == nummer)
		{
		  gefunden = 1;	       
		  break;
		}
	    }
	}
    }      
  return nummer;
}



long Suche_freieLastnummer()
{
  KeGlied* p;
  TypLastfall* tmp_last;
  long nummer=0;
  long gefunden=0;

  if(Modell->KeLast)    
    while(1)
      {
	KeDurchlaufVorwaerts(p,Modell->KeLast)
	  {
	    tmp_last = p->x;
	    if((*tmp_last).l_nummer == nummer)
	      {
		gefunden = 1;
		break;
	      }
	  }	
	if(!gefunden)
	  return nummer;
	gefunden = 0;
	nummer++; 
      }    
  return 0;
}

