/*
  Datei    : Ausgabe.c
  erstellt : 25.06.96
  gendert : 06.09.96
  Autor    : jh
*/



#include "XStabDek.h"


void Drucke_Stab_Nm(TypStab_Nm *stab)
{
  long i;

  TypPunkt *tmp_punkt1,*tmp_punkt2;
  TypFreiGrad *tmp_freigrad;

  fprintf(stderr,"Nummer : %ld\n",(*stab).l_nummer);

  tmp_punkt1 = (*stab).pe_punkta;
  tmp_punkt2 = (*stab).pe_punktb;

  fprintf(stderr,"Von Punkt : %p   Nach Punkt : %p\n", tmp_punkt1, tmp_punkt2);

  /* fprintf(stderr,"Von Punkt : %ld   Nach Punkt : %ld\n",(*tmp_punkt1).l_nummer,(*tmp_punkt2).l_nummer); */
  fprintf(stderr,"Laenge : %f\n",(*stab).d_laenge);
  fprintf(stderr,"alpha : %f\n",(*stab).d_alpha);

  for(i=0;i<6;i++)  {
    tmp_freigrad = (*stab).pe_frei[i];
    fprintf(stderr,"Zeiger FreiGrad : %p\n",tmp_freigrad);
    
    if(tmp_freigrad)		 
      fprintf(stderr,"Freigrad Nummer %ld : %ld\n",i,(*tmp_freigrad).l_nummer);	
  }

 
}


void Drucke_Stab_Km(TypStab_Km *stab)
{
  long i;

  TypPunkt *tmp_punkt1,*tmp_punkt2;
  TypFreiGrad *tmp_freigrad;

  fprintf(stderr,"------ Nummer : %ld\n",(*stab).l_nummer);

  fprintf(stderr,"Position im Stab_Nm von [%.2f] nach [%.2f]\n",(*stab).d_posA,(*stab).d_posB);

  tmp_punkt1 = (*stab).pe_punkta;
  tmp_punkt2 = (*stab).pe_punktb;

  fprintf(stderr,"Von Punkt : %p\n", tmp_punkt1);
  /* Drucke_Punkt(tmp_punkt1); */
  fprintf(stderr,"Nach Punkt : %p\n", tmp_punkt2);
  /* Drucke_Punkt(tmp_punkt2); */
 
  fprintf(stderr,"Laenge : %f\n",(*stab).d_laenge);
  fprintf(stderr,"alpha : %f\n",(*stab).d_alpha);

  for(i=0;i<6;i++) {
    tmp_freigrad = (*stab).pe_frei[i];
    fprintf(stderr,"Zeiger FreiGrad : %p\n",tmp_freigrad);
    
    if(tmp_freigrad)		 
      fprintf(stderr,"Freigrad Nummer %ld : %ld\n",i,(*tmp_freigrad).l_nummer);	
  }

  fprintf(stderr,"Last :\n");
  fprintf(stderr,"pA : %.2f   pE : %.2f\n",(*stab).d_lastp_a,(*stab).d_lastp_b);
  fprintf(stderr,"nA : %.2f   nE : %.2f\n",(*stab).d_lastn_a,(*stab).d_lastn_b);

  /* Schnittkrfte */
  fprintf(stderr,"Schnittkrfte :\n");
  fprintf(stderr,"Na : %.2f   Qa : %.2f  Ma : %.2f\n",(*stab).d_Na,(*stab).d_Qa,(*stab).d_Ma);
  fprintf(stderr,"Nb : %.2f   Qb : %.2f  Mb : %.2f\n",(*stab).d_Nb,(*stab).d_Qb,(*stab).d_Mb);

}


void DruckeStaebe_Nm(void)
{
  KeGlied *p;

  fprintf(stderr,"\n STAEBE Nutzermodell:\n");

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {       
      Drucke_Stab_Nm(p->x);
    }    
}


void DruckeStaebe_Km(void)
{
  KeGlied *p;

  fprintf(stderr,"\n STAEBE Kernmodell :\n");

  if(Modell->KeStab_Km)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Km) {       
      fprintf(stderr,"\n------\n");
      Drucke_Stab_Km(p->x);
      fprintf(stderr,"------\n");
    }    
}


void DruckePunkte_Nm(void)
{
  KeGlied *p;

  fprintf(stderr,"\n PUNKTE :\n");
  if(Modell->KePunkt_Nm)
    {
      KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)	
	Drucke_Punkt(p->x);     
    }
}


void DruckePunkte_Km(void)
{
  KeGlied *p;

  fprintf(stderr,"\n PUNKTE Kernmodell :\n");
  if(Modell->KePunkt_Km) {
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Km)	
      Drucke_Punkt(p->x);     
  }
}


void Drucke_Punkt(TypPunkt* tmp_punkt)
{
  fprintf(stderr,"Nummer : %ld ID : %ld \n", (*tmp_punkt).l_nummer, (*tmp_punkt).l_sysid);
  fprintf(stderr,"X : %f Y : %f\n", (*tmp_punkt).d_x,(*tmp_punkt).d_y);
}

	  

void DruckeFreiGrad(KeGlied *kette)
{
  KeGlied *p;
  TypFreiGrad *tmp_frei;

  fprintf(stderr," FREIHEITSGRADE :\n");

  if(kette)
    KeDurchlaufVorwaerts(p,kette)  {
      tmp_frei = p->x;

      fprintf(stderr,"----------\n");
      fprintf(stderr,"Freiheitsgrad : %p\n",tmp_frei);
      fprintf(stderr,"Index : %ld Nummer : %ld\n", (*tmp_frei).l_index , (*tmp_frei).l_nummer );
      fprintf(stderr,"Verschiebung  : %f Einwirkung : %f  Auflager : %.2f\n",
	      (*tmp_frei).d_verschiebung , (*tmp_frei).d_einwirkung,  (*tmp_frei).d_auflager);
      fprintf(stderr,"Status : %ld Winkel : %f Art : %ld\n",
	      (*tmp_frei).l_status, (*tmp_frei).d_alpha, (*tmp_frei).l_art);
      fprintf(stderr,"Feder : %.2f\n",(*tmp_frei).d_feder);
      fprintf(stderr,"----------\n");

    }
 
}


void DruckeAktiveLastfaelle(Menge *M)
{
  long i=0;
  long *element;
  
  fprintf(stderr,"\nAktive Lastfaelle :\n");

  for(i=1;i<=M->n;i++)
    {
      element = M->feld[i];
      fprintf(stderr,"Lastfall : %ld\n",*element);        
    }

  fprintf(stderr,"Ende aktive LF\n");
}


void DruckeKnotenlast(void)
{
  KeGlied *p;
  TypKnotenlast_Nm *tmp_knotenlast;

  fprintf(stderr,"KNOTENLASTEN :\n");

  if(Modell->KePunktlast_Nm) 
    KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm)
    {
      tmp_knotenlast = p->x;
      
      fprintf(stderr,"Nummer : %ld Lastfall-ID %ld\n",
	     (*tmp_knotenlast).l_id,  (*tmp_knotenlast).l_lastfallid);
      fprintf(stderr,"Last : %f\n",(*tmp_knotenlast).d_last);     
    }
}


void DruckeStreckenlast(void)
{
  KeGlied *p;
  TypStreckenlast_Nm* tmp_streckenlast;

  fprintf(stderr,"\n+++ Streckenlasten :\n");
  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm)
    {
      tmp_streckenlast = p->x;
      
      fprintf(stderr,"Nummer : %ld\n",(*tmp_streckenlast).l_id);
      fprintf(stderr,"Last A : %f Last B : %f \n",(*tmp_streckenlast).d_lasta,(*tmp_streckenlast).d_lastb);
      fprintf(stderr,"Stab-Nummer : %ld\n",(*tmp_streckenlast).l_stabnummer);

    }
}



void Drucke_FG_Relation(void)
{
  long i;
  Paar *paar;
  TypFreiGrad *fg1, *fg2;

  fprintf(stderr,"FG Relationen : \n");

  for(i=1;i<=Modell->FG_Relation_Nm->n;i++)
    {
      paar = Modell->FG_Relation_Nm->feld[i];
      fg1 = paar->a;
      fg2 = paar->b;

      fprintf(stderr,"(%ld,%ld)\n",(*fg1).l_nummer,(*fg2).l_nummer);
    }

  fprintf(stderr,"\n");
}


/* nur zum debugen */
void DruckeSysSteif(double **SysSteif,long *SysProfil,long SysDim)
{
  long i,j;

  for(i=0;i<SysDim;i++)
    {
      for(j=0;j<=i;j++)
	if(SysProfil[i]>j)
	  fprintf(stderr," %10.5f ",0.);
	else
	  fprintf(stderr," %10.5f ",SysSteif[i][j]);
      fprintf(stderr,"\n");
    }
}


void DruckeMatrix(double **m,long dim)
{
  long i,j;

  for(i=0;i<dim;i++)
    {
      for(j=0;j<dim;j++)       
	fprintf(stderr," %6.2f ",m[i][j]);
      fprintf(stderr,"\n");
    }
  fprintf(stderr,"\n");
}


void DruckeProfil(long *p,long dim)
{
  long i;

  for(i=0;i<dim;i++)
    fprintf(stderr,"p[%ld] %ld\n",i,p[i]);
}

