/*
  Datei     : dienst.c
  erstellt  : 28.11.96
  gendert  : 28.01.98
  Autor     : jh
*/


#define XS_KLICKED_EPS 0.008
 

#include "XStabDek.h"


/*********************************************************************/
/* long Vergebe_ID(void)                                             */
/*********************************************************************/ 
/*                                              
   Fkt berechnet einen persistenten ID 
   (innerhalb eines Jahres, um die Zahlen nicht zu
   gro werden zu lassen ) 
   jh, 18.03.97
*/
/*********************************************************************/

long Vergebe_ID(void)
{ 
  static long id=0;

  if(!id) {
    id = time(NULL) % 90000000;
    id += 10000000; /* 8stellige Ziffern ! */
  }
  else
    id++;
 
  return id;
}



/*********************************************************************/
/*  void Meldung(char text[])                                        */
/*********************************************************************/ 
/*                                              
   Fkt gibt eine Meldung auf dem Browser im
   Hauptfenster aus
   jh, 15.03.97

*/
/*********************************************************************/

void Meldung(char text[])
{	
  char c_text[200];
  sprintf(c_text,"%4d  %s", fl_get_browser_maxline(form->meldungbrow),text);
  fl_addto_browser(form->meldungbrow,c_text);     	 
}



char* getText(char* format, char* text)
{
  char *tmp;
  static char c_tmp[255];

  sprintf(c_tmp, format, text);

  tmp = (char*) calloc (strlen(c_tmp)+1, sizeof(char) );

  sprintf(tmp, format, text); 

  return tmp;

}


/*********************************************************************/
/* void addToSystemChoice( TypModell* modell )                       */
/*********************************************************************/ 
/*                                              
   Fkt fgt ein Modell der systemauswahl hinzu
   jh, 07.12.97

*/
/*********************************************************************/

void addToSystemChoice( TypModell* modell )
{
  char text[256];

  if( strlen(modell->System.c_datei) < 1 )
    sprintf(text, "%3ld noname", modell->nummer);  
  else
    sprintf(text, "%3ld %s", modell->nummer, modell->System.c_datei);  

  fl_addto_choice(form->system_choice, text);

  fl_set_choice(form->system_choice, 
		fl_get_choice_maxitems(form->system_choice));
}



/*********************************************************************/
/* void  removeFromSystemChoice( TypModell* modell )                 */
/*********************************************************************/ 
/*                                              
   Fkt entfernt ein Modell von der Systemauswahl
   jh, 07.12.97
*/
/*********************************************************************/

void removeFromSystemChoice( TypModell* modell )
{
  long nummer;
  char cnummer[3];
  char* c_tmp;
  int i,j;

  for(i=1; i<fl_get_choice_maxitems(form->system_choice)+1; i++) {

    c_tmp = (char*) fl_get_choice_item_text(form->system_choice, i);
  
    for(j=0;j<3;j++)
      cnummer[j] = c_tmp[j];     
    nummer = (long) atol(cnummer);

    if( modell->nummer == nummer ) {
      fl_delete_choice(form->system_choice, i);
      break;
    }    
  }

}



/*********************************************************************/
/* void  changeSystemChoice( TypModell* modell )                     */
/*********************************************************************/ 
/*                                              
   Fkt ndert den Eintrag in der Systemauswahl fr 'model'
   jh, 07.12.97
*/
/*********************************************************************/

void changeSystemChoice( TypModell* modell )
{
  long nummer;
  char cnummer[3];
  char* c_tmp;
  int i,j;
  char text[256];
  
  for(i=1; i<fl_get_choice_maxitems(form->system_choice)+1; i++) {
    
    c_tmp = (char*) fl_get_choice_item_text(form->system_choice, i);
    
    for(j=0;j<3;j++)
      cnummer[j] = c_tmp[j];     
    nummer = (long) atol(cnummer);

    if( modell->nummer == nummer ) {

      sprintf(text, "%3ld %s", modell->nummer, modell->System.c_datei);  
      fl_replace_choice(form->system_choice, i, text);  
      break;

    }    
  }   
}



/*********************************************************************/
/* void setEnv(void)                                                 */
/*********************************************************************/ 
/* 
   Funktion pat die Einstellung der Oberflche an das aktuelle
   Modell an,
   schreibt die Lastfallbrowser neu
   jh, 28.01.98			       
*/
/*********************************************************************/

void setEnv(void)
{
  char ctmp[100];

  sprintf(ctmp, "%ld", Modell->prozessor_anz);  
  fl_set_input(prozessor_form->prozessor_stabteil_input, ctmp);

  schreibeBrowserLastfall();
  schreibeBrowserLastfallKombinationen();


  /* Raster */

  fl_set_button(rasterform->raster_checkbutton,  
		Modell->Environment.raster );
  fl_set_button(drawcontrol_preferences_form->rasterbutton , 
		Modell->Environment.raster );

  sprintf(ctmp, "%.3f", Modell->Environment.raster_x);
  fl_set_input(rasterform->raster_input1, ctmp);

  sprintf(ctmp, "%.3f", Modell->Environment.raster_y);
  fl_set_input(rasterform->raster_input2, ctmp);


  /*  Fang  */
  
  fl_set_choice(rasterform->fang_choice, Modell->Environment.fang + 1 );
  fl_set_choice(drawcontrol_preferences_form->fang_choice, 
		Modell->Environment.fang + 1 );

  sprintf(ctmp, "%.3f", Modell->Environment.fang_x);
  fl_set_input(rasterform->fang_input1, ctmp);

  sprintf(ctmp, "%.3f", Modell->Environment.fang_y);
  fl_set_input(rasterform->fang_input2, ctmp);

}



/*********************************************************************/
/* void quit(void)                                                   */
/*********************************************************************/ 
/*                                              
   Fkt beendet das Programm
   jh, 08.08.97

*/
/*********************************************************************/

void quit(void)
{
  long c;
  KeGlied* p;

  Schreibe_Querschnitte();
  Schreibe_Material();

  if(!Modell)
    exit(0);
  
  KeDurchlaufVorwaerts(p,KeModell) {

    Modell = p->x;

    if(Modell->unsaved_changes) {
      c = fl_show_choices("Einige nderungen wurden \n nicht gesichert !\n Wirklich Beenden ?", 3,
			  "Speichern und\nBeenden", "Beenden", "Abbruch", 1);
      if( c==1 )
	save();
      
      if( c==3 )
	return;
    }
  }  

  exit(0); 

}


/*********************************************************************/
/* void Progress(double value)                                       */
/*********************************************************************/ 
/*                                              
   Fkt steuert den progress-slider
   jh, 08.08.97

*/
/*********************************************************************/

void Progress(double value)
{
  fl_set_slider_value(form->progress_slider,value);  
}



/*********************************************************************/
/*  void not_implemented(void)                                       */
/*********************************************************************/ 
/* 
   den Nutzer auf nicht implementierte 
   Funktionen hinweisen 
   jh, 16.03.97
*/
/*********************************************************************/

void not_implemented(void)
{
  fl_show_alert("Funktion noch nicht implementiert !","","",1);
}



/*********************************************************************/
/*  void ScanString(char *s)                                  */
/*********************************************************************/ 
/* 
   Leerzeichen durch _ ersetzen  
   jh, 16.03.97
*/
/*********************************************************************/

void ScanString(char *s)
{ 
  do {
    if(*s == ' ')
      *s = '_';
  } while(*(s++) != '\0');
}


/*********************************************************************/
/*  void UnScanString(char *s)                                  */
/*********************************************************************/ 
/* 
   _ durch Leerzeichen ersetzen  
   jh, 13.02.98
*/
/*********************************************************************/

void UnScanString(char *s)
{ 
  do {
    if(*s == '_')
      *s = ' ';
  } while(*(s++) != '\0');
}



/***********************************************************/
/* void dienst_Prg_Status(long s)                          */
/***********************************************************/
/*
   Fkt setzt den Programm-Status
   prg_status -> globale Variable
   16.03.97
*/
/***********************************************************/

void dienst_Prg_Status(long s)
{
  prg_status = s;
  
  switch(s) {
  case 0 : /* Programm - Beginn */
    XUndefineCursor(display,win);
    break;
    
  case 1 : /* Standard - Modus */
    fl_set_button(control_form->zoom_button,0); 
    XUndefineCursor(display,win);
    break;
    
  case 2 :
  case 3 : /* Punkt whlen, Stab erzeugen */
    fl_set_button(control_form->zoom_button,0); 
    XDefineCursor(display,win,curs);
    break;
    
  case 4 : /* Zoom Modus */      
    XDefineCursor(display,win,curs2);
    break;
  }     
}



/*********************************************************************/
/* double* dienst_minmaxkoord_Nm(KeGlied* kette)                     */
/*********************************************************************/
/*
   Berechnen der grten und kleinsten Koordinaten 
   der Stbe in der bergebenen Kette
   wenn kein System definiert -> return NULL
   30.03.97
*/
/*********************************************************************/

double* dienst_minmaxkoord_Nm(KeGlied* kette)
{
  /* 
     [0] = minx,   [1] = maxx, 
     [2] = miny,   [3] = maxy    
  */

  double *minmax;    
  double xa,ya; 

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1,*tmp_punkt2;

  minmax = (double*) calloc (4,sizeof(double));

  if(!kette) {  /* kein System */
    free (minmax);
    return NULL;    
  }

  p = kette->nach;

  if(p == kette) { /* leeres System */
    free (minmax);
    return NULL;    
  }
  
  tmp_stab = p->x;   
  tmp_punkt1 = (*tmp_stab).pe_punkta;
  tmp_punkt2 = (*tmp_stab).pe_punktb;
  
  minmax[0] = (*tmp_punkt1).d_x;
  minmax[1] = (*tmp_punkt1).d_x;
  minmax[2] = (*tmp_punkt1).d_y;
  minmax[3] = (*tmp_punkt1).d_y;              
  
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;     
    tmp_punkt1 = (*tmp_stab).pe_punkta;
    tmp_punkt2 = (*tmp_stab).pe_punktb;
    
    xa = (*tmp_punkt1).d_x;
    ya = (*tmp_punkt1).d_y;
    
    if(xa>minmax[1]) minmax[1] = xa;
    if(xa<minmax[0]) minmax[0] = xa;
    if(ya>minmax[3]) minmax[3] = ya;
    if(ya<minmax[2]) minmax[2] = ya;
    
    xa = (*tmp_punkt2).d_x;
    ya = (*tmp_punkt2).d_y;
    
    if(xa>minmax[1]) minmax[1] = xa;
    if(xa<minmax[0]) minmax[0] = xa;
    if(ya>minmax[3]) minmax[3] = ya;
    if(ya<minmax[2]) minmax[2] = ya;	  
  }
  return minmax;
}



void initmat(double **a,double x1,double y1,double x2,double y2)
{  
  long i,j;
  double mat[3][3] = { {x1, x2, 1}, {y1, y2, 1}, {1,1,1} };
  double x3,y3;

  x3 = x1-x2;
  y3 = y1-y2;

  x1 = 0.5*(x1+x2);
  y1 = 0.5*(y1+y2);

  mat[0][2] = y3 + x1 ;
  mat[1][2] = - x3 + y1;
  
  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      a[i][j] = mat[i][j];
}


void InvMatrix(double **a,double **inv)
{
  double det = 0;
  long i;

  for(i=0;i<3;i++)
    det += ( ( a[0][i%3] * a[1][(i+1)%3] * a[2][(i+2)%3] ) -
	    ( a[2][i%3] * a[1][(i+1)%3] * a[0][(i+2)%3] ) );
  
  inv[0][0] = ( (a[1][1] * a[2][2]) - (a[2][1] * a[1][2]))/det;
  inv[1][0] = -( (a[1][0] * a[2][2]) - (a[2][0] * a[1][2]))/det;
  inv[2][0] = ( (a[1][0] * a[2][1]) - (a[2][0] * a[1][1]))/det;

  inv[0][1] = -( (a[0][1] * a[2][2]) - (a[2][1] * a[0][2]))/det;
  inv[1][1] = ( (a[0][0] * a[2][2]) - (a[2][0] * a[0][2]))/det;
  inv[2][1] = -( (a[0][0] * a[2][1]) - (a[2][0] * a[0][1]))/det;

  inv[0][2] = ( (a[0][1] * a[1][2]) - (a[1][1] * a[0][2]))/det;
  inv[1][2] = -( (a[0][0] * a[1][2]) - (a[1][0] * a[0][2]))/det;
  inv[2][2] = ( (a[0][0] * a[1][1]) - (a[1][0] * a[0][1]))/det;
}



/*********************************************************************/
/* long PruefePicked( ... )                                          */
/*********************************************************************/ 
/*                                              
   Fkt prft ob der Punkt (x,y) auf der Linie (x1,y1)-(x2,y2)
   liegt, wobei ein er den Abstand XS_EPS haben darf
   jh, 15.03.97

*/
/*********************************************************************/

long PruefePicked(double x1, double y1, double x2, double y2,
		  double x, double y)
{
  double **mat;
  double **invmat;
  double b1[3],b2[3];
  long j;

  mat    = AllocMatrix(3,3);
  invmat = AllocMatrix(3,3);

  b1[0] = x;
  b1[1] = y;
  b1[2] = 1.;

  initmat(mat, x1, y1, x2, y2);    
  
  InvMatrix(mat,invmat);     
  
  for(j=0;j<3;j++)
    b2[j] = b1[0] * invmat[j][0] +  b1[1] * invmat[j][1] + invmat[j][2];
  
  if(b2[0]>XS_KLICKED_EPS && b2[1]>XS_KLICKED_EPS)
    if( b2[2] < XS_KLICKED_EPS && b2[2] > -XS_KLICKED_EPS )  {
      free(mat);
      free(invmat);
      return 1;
    }

  free(mat);
  free(invmat);
  return 0;     
}



/*********************************************************************/
/* int Element_suchen(long nummer,Menge *M)                          */
/*********************************************************************/ 
/*                                              
   Fkt sucht die Nummer 'nummer' in der Menge M
   wenn vorhanden return = 1
   wenn nicht     return = 0
   jh, 02.04.97
*/
/*********************************************************************/

int Element_suchen(long nummer, Menge *M)
{    
  long i;
  long *nr;

  for(i=1;i<=M->n;i++)  {
    nr = M->feld[i];
    if( *nr == nummer)
      return 1;
  }
  
  return 0;
}



/*********************************************************************/
/* double maxM(TypStab_Nm* tmp_stab, double* maxMpos)                */
/*********************************************************************/
/*                                              
   Funktion berechnet das maximale Moment in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double maxM(TypStab_Nm* tmp_stab, double* maxMpos)
{
  double *pos=NULL;
  double maxM=-1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l; 
  double p;

  *maxMpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *maxMpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;   
   
    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Ma, (*tmp_intervall).d_Qa,
			  (*tmp_intervall).d_Mb, (*tmp_intervall).d_Qb,
			  (*tmp_intervall).d_laenge);   

    /* Intervall-Anfang/Ende prfen */   
    M = getM(tmp_stab, (*tmp_intervall).d_posA);
    if(M > maxM ) {
      maxM = M;
      *maxMpos = (*tmp_intervall).d_posA;
    }
    
    M = getM(tmp_stab, (*tmp_intervall).d_posB);
    if(M > maxM ) {
      maxM = M;
      *maxMpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1.-pos[0]) + (*tmp_intervall).d_posB * (1.+pos[0]));     
      M = getM(tmp_stab,p);    
      if(M > maxM ) {
	maxM = M;
	*maxMpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1.-pos[1]) + (*tmp_intervall).d_posB * (1.+pos[1]));           
      M = getM(tmp_stab,p);          
      if(M > maxM ) {
	maxM = M;
	*maxMpos = p;
      }   
    }

  }
  
  if(pos)
    free(pos);  

  return maxM;

}


/*********************************************************************/
/* double minM(TypStab_Nm* tmp_stab, double* maxMpos)                */
/*********************************************************************/
/*                                              
   Funktion berechnet das minimale Moment in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double minM(TypStab_Nm* tmp_stab, double* minMpos)
{
  double *pos=NULL;
  double minM=1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l; 
  double p;

  *minMpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *minMpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;   
   
    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Ma, (*tmp_intervall).d_Qa,
			  (*tmp_intervall).d_Mb, (*tmp_intervall).d_Qb,
			  (*tmp_intervall).d_laenge);   

    /* Intervall-Anfang/Ende prfen */   
    M = getM(tmp_stab, (*tmp_intervall).d_posA);
    if(M < minM ) {
      minM = M;
      *minMpos = (*tmp_intervall).d_posA;
    }
    
    M = getM(tmp_stab, (*tmp_intervall).d_posB);
    if(M < minM ) {
      minM = M;
      *minMpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = getM(tmp_stab,p);    
      if(M < minM ) {
	minM = M;
	*minMpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = getM(tmp_stab,p);          
      if(M < minM ) {
	minM = M;
	*minMpos = p;
      }   
    }
  }
  
  if(pos)
    free(pos);  

  return minM;

}



/*********************************************************************/
/* double maxQ(TypStab_Nm* tmp_stab, double* pos)                    */
/*********************************************************************/
/*                                              
   Funktion berechnet die max. Querkraft in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double maxQ(TypStab_Nm* tmp_stab, double* maxQpos)
{
  double *pos=NULL;
  double maxQ=-1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *maxQpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *maxQpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Qa, (*tmp_intervall).d_lastp_a,
			  (*tmp_intervall).d_Qb, (*tmp_intervall).d_lastp_b,
			  (*tmp_intervall).d_laenge);   

    /* Intervall-Anfang/Ende prfen */   
    M = getQ(tmp_stab, (*tmp_intervall).d_posA);
    if(M > maxQ ) {
      maxQ = M;
      *maxQpos = (*tmp_intervall).d_posA;
    }
    
    M = getQ(tmp_stab, (*tmp_intervall).d_posB);
    if(M > maxQ ) {
      maxQ = M;
      *maxQpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = getQ(tmp_stab,p);    
      if(M > maxQ ) {
	maxQ = M;
	*maxQpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = getQ(tmp_stab,p);          
      if(M > maxQ ) {
	maxQ = M;
	*maxQpos = p;
      }   
    }
  }
  
  if(pos)
    free(pos);  

  return maxQ;
}



/*********************************************************************/
/* double minQ(TypStab_Nm* tmp_stab, double* pos)                    */
/*********************************************************************/
/*                                              
   Funktion berechnet die minimale Querkraft in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double minQ(TypStab_Nm* tmp_stab, double* minQpos)
{
  double *pos=NULL;
  double minQ=1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *minQpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *minQpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Qa, (*tmp_intervall).d_lastp_a,
			  (*tmp_intervall).d_Qb, (*tmp_intervall).d_lastp_b,
			  (*tmp_intervall).d_laenge);   

    /* Intervall-Anfang/Ende prfen */   
    M = getQ(tmp_stab, (*tmp_intervall).d_posA);
    if(M < minQ ) {
      minQ = M;
      *minQpos = (*tmp_intervall).d_posA;
    }
    
    M = getQ(tmp_stab, (*tmp_intervall).d_posB);
    if(M < minQ ) {
      minQ = M;
      *minQpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = getQ(tmp_stab,p);    
      if(M < minQ ) {
	minQ = M;
	*minQpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = getQ(tmp_stab,p);          
      if(M < minQ ) {
	minQ = M;
	*minQpos = p;
      }   
    }
  }
  
  if(pos)
    free(pos);  

  return minQ;
}



/*********************************************************************/
/* double maxN(TypStab_Nm* tmp_stab, double* pos)                    */
/*********************************************************************/
/*                                              
   Funktion berechnet die max. Normalkraft in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double maxN(TypStab_Nm* tmp_stab, double* maxNpos)
{
  double *pos=NULL;
  double maxN=-1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *maxNpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *maxNpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Na, -(*tmp_intervall).d_lastn_a,
			  (*tmp_intervall).d_Nb, -(*tmp_intervall).d_lastn_b,
			  (*tmp_intervall).d_laenge);   
    
    /* Intervall-Anfang/Ende prfen */   
    M = getN(tmp_stab, (*tmp_intervall).d_posA);
    if(M > maxN ) {
      maxN = M;
      *maxNpos = (*tmp_intervall).d_posA;
    }
    
    M = getN(tmp_stab, (*tmp_intervall).d_posB);
    if(M > maxN ) {
      maxN = M;
      *maxNpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = getN(tmp_stab,p);    
      if(M > maxN ) {
	maxN = M;
	*maxNpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = getN(tmp_stab,p);          
      if(M > maxN ) {
	maxN = M;
	*maxNpos = p;
      }   
    }
  }
  
 if(pos)
    free(pos);  

 return maxN;
}



/*********************************************************************/
/* double minN(TypStab_Nm* tmp_stab, double* pos)                    */
/*********************************************************************/
/*                                              
   Funktion berechnet die minimale Normalkraft in einem Stab  
   maxPos ( 0 < z < 1 )
   jh, 20.04.97 
*/
/*********************************************************************/

double minN(TypStab_Nm* tmp_stab, double* minNpos)
{
  double *pos=NULL;
  double minN=1e10,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *minNpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *minNpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_Na, -(*tmp_intervall).d_lastn_a,
			  (*tmp_intervall).d_Nb, -(*tmp_intervall).d_lastn_b,
			  (*tmp_intervall).d_laenge);   
    
    /* Intervall-Anfang/Ende prfen */   
    M = getN(tmp_stab, (*tmp_intervall).d_posA);
    if(M < minN ) {
      minN = M;
      *minNpos = (*tmp_intervall).d_posA;
    }
    
    M = getN(tmp_stab, (*tmp_intervall).d_posB);
    if(M < minN ) {
      minN = M;
      *minNpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = getN(tmp_stab,p);    
      if(M < minN ) {
	minN = M;
	*minNpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = getN(tmp_stab,p);          
      if(M < minN ) {
	minN = M;
	*minNpos = p;
      }   
    }
  }
  
 if(pos)
    free(pos);  

 return minN;
}



/*********************************************************************/
/* double getM(TypStab_Nm* tmp_stab, double pos)                     */
/*********************************************************************/
/*                                              
   Funktion berechnet das Moment an der Stelle pos ( 0. -> 1. )
   jh, 20.04.97 
*/
/*********************************************************************/

double getM(TypStab_Nm* tmp_stab, double pos)
{ 
  double M=0;
  TypIntervall *tmp_intervall;
  KeGlied *p;
  double z;

  if(!(*tmp_stab).intervalle)
    return 0;   

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(p, (*tmp_stab).intervalle)  {
    tmp_intervall = p->x;
    
    /* liegt pos im Bereich des Intervalls ? */
    if(((*tmp_intervall).d_posA  <= pos) &&
       ((*tmp_intervall).d_posB  >= pos)) {

      /* berechne normierte Koordinate ( -1 < z < 1 ) bzgl. des Intervalls */      
      z = (pos - 0.5*((*tmp_intervall).d_posA + (*tmp_intervall).d_posB)) /
	(0.5*((*tmp_intervall).d_posB - (*tmp_intervall).d_posA));     

      /* interpoliere M */
      M = Hermite_dis((*tmp_intervall).d_Ma, (*tmp_intervall).d_Qa,
		      (*tmp_intervall).d_Mb, (*tmp_intervall).d_Qb,
		      (*tmp_intervall).d_laenge, z);
          
      return M;
    }    
  }

  return 0;
} 



/*********************************************************************/
/* double getN(TypStab_Nm* tmp_stab, double pos)                     */
/*********************************************************************/
/*                                              
   Funktion berechnet die Normalkraft an der Stelle pos ( 0. -> 1. )
   jh, 23.04.97 
*/
/*********************************************************************/

double getN(TypStab_Nm* tmp_stab, double pos)
{
  double N=0;
  TypIntervall *tmp_intervall;
  KeGlied *p;
  double z;
  
  if(!(*tmp_stab).intervalle)
    return 0;   

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(p, (*tmp_stab).intervalle)  {
    tmp_intervall = p->x;
    
    /* liegt pos im Bereich des Intervalls ? */
    if(((*tmp_intervall).d_posA  <= pos) &&
       ((*tmp_intervall).d_posB  >= pos)) {

      /* berechne normierte Koordinate ( -1 < z < 1 ) bzgl. des Intervalls */      
      z = (pos - 0.5*((*tmp_intervall).d_posA + (*tmp_intervall).d_posB)) /
	(0.5*((*tmp_intervall).d_posB - (*tmp_intervall).d_posA));          

      /* interpoliere N */
      N = Hermite_dis((*tmp_intervall).d_Na, -(*tmp_intervall).d_lastn_a,
		      (*tmp_intervall).d_Nb, -(*tmp_intervall).d_lastn_b,
		      (*tmp_intervall).d_laenge, z);           

      return N;
    }    
  } 

  return 0;
}



/*********************************************************************/
/* double getQ(TypStab_Nm* tmp_stab, double pos)                     */
/*********************************************************************/
/*                                              
   Funktion berechnet die Querkraft an der Stelle pos ( 0. -> 1. )
   jh, 23.04.97 
*/
/*********************************************************************/

double getQ(TypStab_Nm* tmp_stab, double pos)
{
  double Q=0;
  TypIntervall *tmp_intervall;
  KeGlied *p;
  double z;
  
  if(!(*tmp_stab).intervalle)
    return 0;
  
  
  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(p, (*tmp_stab).intervalle)  {
    tmp_intervall = p->x;
    
    /* liegt pos im Bereich des Intervalls ? */
    if(((*tmp_intervall).d_posA  <= pos) &&
       ((*tmp_intervall).d_posB  >= pos)) {

      /* berechne normierte Koordinate ( -1 < z < 1 ) bzgl. des Intervalls */      
      z = (pos - 0.5*((*tmp_intervall).d_posA + (*tmp_intervall).d_posB)) /
	(0.5*((*tmp_intervall).d_posB - (*tmp_intervall).d_posA));            

      /* interpoliere N */
      Q = Hermite_dis((*tmp_intervall).d_Qa, (*tmp_intervall).d_lastp_a,
		      (*tmp_intervall).d_Qb, (*tmp_intervall).d_lastp_b,
		      (*tmp_intervall).d_laenge, z);          

      return Q;
    }    
  }
 
  return 0;
}



/*********************************************************************/
/* double get_w(TypStab_Nm* tmp_stab, double pos)                     */
/*********************************************************************/
/*                                              
   Funktion berechnet die Verschiebung senkrecht zur Stabachse 
   an der Stelle pos ( 0. -> 1. )
   jh, 02.05.97 
*/
/*********************************************************************/

double get_w(TypStab_Nm* tmp_stab, double pos)
{ 
  double z;
  double dy;
  TypIntervall *tmp_intervall;
  KeGlied *p;
  double vxa,vya,vxb,vyb;
  double vs[6];
  double alpha1=0,alpha2=0;
  double alpha_stab; 
  long i;

  if(!(*tmp_stab).intervalle)
    return 0;   

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(p, (*tmp_stab).intervalle)  {
    tmp_intervall = p->x;
    
    /* liegt pos im Bereich des Intervalls ? */
    if(((*tmp_intervall).d_posA  <= pos) &&
       ((*tmp_intervall).d_posB  >= pos)) {

      /* berechne normierte Koordinate ( -1 < z < 1 ) bzgl. des Intervalls */      
      z = (pos - 0.5*((*tmp_intervall).d_posA + (*tmp_intervall).d_posB)) /
	(0.5*((*tmp_intervall).d_posB - (*tmp_intervall).d_posA));     
    
      /* Drehung des Stabes  */
      alpha_stab = (*tmp_stab).d_alpha;

      /* Drehung der Freiheitsgrade */
      alpha1 = (*tmp_intervall).d_alpha1;	     
      alpha2 = (*tmp_intervall).d_alpha2; 

      for(i=0;i<6;i++)	    
	vs[i] = (*tmp_intervall).d_vs[i];

      /* Verschiebungen im lokalen Koordinatensystem */
      vxa = (  cos(alpha_stab - alpha1) * vs[0] + sin(alpha_stab - alpha1) * vs[1]);
      vya = ( -sin(alpha_stab - alpha1) * vs[0] + cos(alpha_stab - alpha1) * vs[1]);
  	    
      vxb = (  cos(alpha_stab - alpha2) * vs[3] + sin(alpha_stab - alpha2) * vs[4]);
      vyb = ( -sin(alpha_stab - alpha2) * vs[3] + cos(alpha_stab - alpha2) * vs[4]);            
	
      /* Hermite - Interpolation w im glob. Koord.sys */
      dy = Hermite_dis(vya, vs[2], vyb, vs[5],
		       (*tmp_intervall).d_laenge,z);        

      return -dy;

    }    
  }

  return 0;
} 



/*********************************************************************/
/* double get_u(TypStab_Nm* tmp_stab, double pos)                    */
/*********************************************************************/
/*                                              
   Funktion berechnet die Verschiebung in Richtung Stabachse 
   an der Stelle pos ( 0. -> 1. )
   jh, 02.05.97 
*/
/*********************************************************************/

double get_u(TypStab_Nm* tmp_stab, double pos)
{ 
  double z;
  double dx;
  TypIntervall *tmp_intervall;
  KeGlied *p;
  double vxa,vya,vxb,vyb;
  double vs[6];
  double alpha1=0,alpha2=0;
  double alpha_stab; 
  long i;

  if(!(*tmp_stab).intervalle)
    return 0;   

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(p, (*tmp_stab).intervalle)  {
    tmp_intervall = p->x;
    
    /* liegt pos im Bereich des Intervalls ? */
    if(((*tmp_intervall).d_posA  <= pos) &&
       ((*tmp_intervall).d_posB  >= pos)) {

      /* berechne normierte Koordinate ( -1 < z < 1 ) bzgl. des Intervalls */      
      z = (pos - 0.5*((*tmp_intervall).d_posA + (*tmp_intervall).d_posB)) /
	(0.5*((*tmp_intervall).d_posB - (*tmp_intervall).d_posA));     
    
      /* Drehung des Stabes  */
      alpha_stab = (*tmp_stab).d_alpha;

      /* Drehung der Freiheitsgrade */
      alpha1 = (*tmp_intervall).d_alpha1;	     
      alpha2 = (*tmp_intervall).d_alpha2; 

      for(i=0;i<6;i++)	    
	vs[i] = (*tmp_intervall).d_vs[i];

      /* Verschiebungen im lokalen Koordinatensystem */
      vxa = (  cos(alpha_stab - alpha1) * vs[0] + sin(alpha_stab - alpha1) * vs[1]);
      vya = ( -sin(alpha_stab - alpha1) * vs[0] + cos(alpha_stab - alpha1) * vs[1]);
  	    
      vxb = (  cos(alpha_stab - alpha2) * vs[3] + sin(alpha_stab - alpha2) * vs[4]);
      vyb = ( -sin(alpha_stab - alpha2) * vs[3] + cos(alpha_stab - alpha2) * vs[4]);
           	
      /* lineare Interpolation der Verschiebung in Stabachse */
      dx = 0.5 * (vxa * (1-z) + vxb * (1+z));	     	    

      return dx;

    }    
  }

  return 0;
} 



/*********************************************************************/
/* double max_w(TypStab_Nm* tmp_stab, double* pos)                   */
/*********************************************************************/
/*                                              
   Funktion berechnet die max. Verschiebung in einem Stab 
   senkrecht zur Stabachse
   maxPos ( 0 < z < 1 )
   jh, 03.05.97 
*/
/*********************************************************************/

double max_w(TypStab_Nm* tmp_stab, double* max_wpos)
{
  double *pos=NULL;
  double max_w=-1e12,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *max_wpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *max_wpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_vs[1], (*tmp_intervall).d_vs[2],
			  (*tmp_intervall).d_vs[4], (*tmp_intervall).d_vs[5],
			  (*tmp_intervall).d_laenge);   
    
    /* Intervall-Anfang/Ende prfen */   
    M = get_w(tmp_stab, (*tmp_intervall).d_posA);
    if(M > max_w ) {
      max_w = M;
      *max_wpos = (*tmp_intervall).d_posA;
    }
    
    M = get_w(tmp_stab, (*tmp_intervall).d_posB);
    if(M > max_w ) {
      max_w = M;
      *max_wpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = get_w(tmp_stab,p);    
      if(M > max_w ) {
	max_w = M;
	*max_wpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = get_w(tmp_stab,p);          
      if(M > max_w ) {
	max_w = M;
	*max_wpos = p;
      }   
    }
  }
  
 if(pos)
   free(pos);  
  
 return max_w;
}



/*********************************************************************/
/* double min_w(TypStab_Nm* tmp_stab, double* pos)                   */
/*********************************************************************/
/*                                              
   Funktion berechnet die min. Verschiebung in einem Stab 
   senkrecht zur Stabachse
   maxPos ( 0 < z < 1 )
   jh, 03.05.97 
*/
/*********************************************************************/

double min_w(TypStab_Nm* tmp_stab, double* min_wpos)
{
  double *pos=NULL;
  double min_w=1e12,M;
  TypIntervall *tmp_intervall;
  KeGlied *l;
  double p;

  *min_wpos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *min_wpos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_vs[1], (*tmp_intervall).d_vs[2],
			  (*tmp_intervall).d_vs[4], (*tmp_intervall).d_vs[5],
			  (*tmp_intervall).d_laenge);   
    
    /* Intervall-Anfang/Ende prfen */   
    M = get_w(tmp_stab, (*tmp_intervall).d_posA);
    if(M < min_w ) {
      min_w = M;
      *min_wpos = (*tmp_intervall).d_posA;
    }
    
    M = get_w(tmp_stab, (*tmp_intervall).d_posB);
    if(M < min_w ) {
      min_w = M;
      *min_wpos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = get_w(tmp_stab,p);    
      if(M < min_w ) {
	min_w = M;
	*min_wpos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = get_w(tmp_stab,p);          
      if(M < min_w ) {
	min_w = M;
	*min_wpos = p;
      }   
    }
  }
  
 if(pos)
   free(pos);  
  
 return min_w;
}



/*********************************************************************/
/* double max_u(TypStab_Nm* tmp_stab, double* pos)                   */
/*********************************************************************/
/*                                              
   Funktion berechnet die max. Verschiebung in einem Stab 
   senkrecht zur Stabachse
   maxPos ( 0 < z < 1 )
   jh, 03.05.97 
*/
/*********************************************************************/

double max_u(TypStab_Nm* tmp_stab, double* max_upos)
{
  double *pos=NULL;
  double max_u=-1e12,M;
  TypIntervall *tmp_intervall;
  TypMaterial *mat;
  TypQuerschnitt *quer;
  double ea;
  KeGlied *l;
  double p;

  *max_upos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *max_upos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    mat = Suche_Material((*tmp_stab).l_matid);
    quer = Suche_Querschnitt((*tmp_stab).l_querid);

    ea = (*mat).d_E * (*quer).d_A;

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_vs[0], (*tmp_intervall).d_Na/ea,
			  (*tmp_intervall).d_vs[3], (*tmp_intervall).d_Nb/ea,
			  (*tmp_intervall).d_laenge);     
  
    /* Intervall-Anfang/Ende prfen */   
    M = get_u(tmp_stab, (*tmp_intervall).d_posA); 
    if(M > max_u ) {
      max_u = M;
      *max_upos = (*tmp_intervall).d_posA;
    }
    
    M = get_u(tmp_stab, (*tmp_intervall).d_posB);   
    if(M > max_u ) {
      max_u = M;
      *max_upos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = get_u(tmp_stab,p);    
      if(M > max_u ) {
	max_u = M;
	*max_upos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = get_u(tmp_stab,p);          
      if(M > max_u ) {
	max_u = M;
	*max_upos = p;
      }   
    }
  }
  
  if(pos)
    free(pos);  

  return max_u;
}



/*********************************************************************/
/* double min_u(TypStab_Nm* tmp_stab, double* pos)                   */
/*********************************************************************/
/*                                              
   Funktion berechnet die min. Verschiebung in einem Stab 
   senkrecht zur Stabachse
   maxPos ( 0 < z < 1 )
   jh, 03.05.97 
*/
/*********************************************************************/

double min_u(TypStab_Nm* tmp_stab, double* min_upos)
{
  double *pos=NULL;
  double min_u=1e12,M;
  TypIntervall *tmp_intervall;
  TypMaterial *mat;
  TypQuerschnitt *quer;
  double ea;
  KeGlied *l;
  double p;

  *min_upos = 0.;

  if(!(*tmp_stab).intervalle ) {
    *min_upos = -1;
    return 0;
  }

  /* Schleife ber alle Intervalle eines Stabes im Nm */
  KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
    tmp_intervall = l->x;      

    mat = Suche_Material((*tmp_stab).l_matid);
    quer = Suche_Querschnitt((*tmp_stab).l_querid);

    ea = (*mat).d_E * (*quer).d_A;

    /* bestimme Positionen der Extrema im Intervall */
    pos = Hermite_extrema((*tmp_intervall).d_vs[0], (*tmp_intervall).d_Na/ea,
			  (*tmp_intervall).d_vs[3], (*tmp_intervall).d_Nb/ea,
			  (*tmp_intervall).d_laenge);   
       
    /* Intervall-Anfang/Ende prfen */   
    M = get_u(tmp_stab, (*tmp_intervall).d_posA);
    if(M < min_u ) {
      min_u = M;
      *min_upos = (*tmp_intervall).d_posA;
    }
    
    M = get_u(tmp_stab, (*tmp_intervall).d_posB);
    if(M < min_u ) {
      min_u = M;
      *min_upos = (*tmp_intervall).d_posB;
    }

    /* keine Extrema */
    if(pos == NULL) 
      continue;
        
    /* liegt pos im Stab ? */
    if( (pos[0]>=-1.) &&  (pos[0]<=1.) ) {    
      /* hole M an der Stelle pos[0] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[0]) + (*tmp_intervall).d_posB * (1+pos[0]));
      M = get_u(tmp_stab,p);    
      if(M < min_u ) {
	min_u = M;
	*min_upos = p;
      }
    }
   
    if( (pos[1]>=-1.) &&  (pos[1]<=1.) ) {
      /* hole M an der Stelle pos[1] */
      p = 0.5 * ((*tmp_intervall).d_posA * (1-pos[1]) + (*tmp_intervall).d_posB * (1+pos[1]));
      M = get_u(tmp_stab,p);          
      if(M < min_u ) {
	min_u = M;
	*min_upos = p;
      }   
    }
  }
  
 if(pos)
   free(pos);  
  
 return min_u;
}



/*********************************************************************/
/* double maxMKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt das max Moment aller Stbe in der Kette
   return : maxM
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double maxMKette(KeGlied *kette, TypStab_Nm** stab, double* maxMpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double max_M=0,tmpM=0,pos=0;

  /* Startwert bestimmen */
  if(!kette)
    return 0;

  p = kette->nach; 
  tmp_stab = p->x;
  max_M = maxM(tmp_stab, &pos);
  *stab = tmp_stab;
  *maxMpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpM = maxM(tmp_stab, &pos);

    if(tmpM > max_M ) {
      max_M = tmpM,
      *stab = tmp_stab;
      *maxMpos = pos;
    }

  }

  return max_M;
    
}



/*********************************************************************/
/* double maxQKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt die max Querkraft aller Stbe in der Kette
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double maxQKette(KeGlied *kette, TypStab_Nm** stab, double* maxQpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double max_Q=0,tmpQ=0,pos=0;

  if(!kette)
    return 0;

  /* Startwert bestimmen */
  p = kette->nach; 
  tmp_stab = p->x;
  max_Q = maxQ(tmp_stab, &pos);
  *stab = tmp_stab;
  *maxQpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpQ = maxQ(tmp_stab, &pos);

    if(tmpQ > max_Q ) {
      max_Q = tmpQ,
      *stab = tmp_stab;
      *maxQpos = pos;
    }

  }

  return max_Q;
    
}



/*********************************************************************/
/* double maxNKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt die max Normalkraft aller Stbe in der Kette
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double maxNKette(KeGlied *kette, TypStab_Nm** stab, double* maxNpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double max_N=0,tmpN=0,pos=0;

  if(!kette)
    return 0;

  /* Startwert bestimmen */
  p = kette->nach; 
  tmp_stab = p->x;
  max_N = maxN(tmp_stab, &pos);
  *stab = tmp_stab;
  *maxNpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpN = maxN(tmp_stab, &pos);

    if(tmpN > max_N ) {
      max_N = tmpN,
      *stab = tmp_stab;
      *maxNpos = pos;
    }

  }

  return max_N;
    
}





/*********************************************************************/
/* double minMKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt das min Moment aller Stbe in der Kette
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double minMKette(KeGlied *kette, TypStab_Nm** stab, double* minMpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double min_M=0,tmpM=0,pos=0;

  if(!kette)
    return 0;

  /* Startwert bestimmen */
  p = kette->nach; 
  tmp_stab = p->x;
  min_M = minM(tmp_stab, &pos);
  *stab = tmp_stab;
  *minMpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpM = minM(tmp_stab, &pos);

    if(tmpM < min_M ) {
      min_M = tmpM,
      *stab = tmp_stab;
      *minMpos = pos;
    }

  }

  return min_M;
    
}



/*********************************************************************/
/* double minQKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt die min Querkraft aller Stbe in der Kette
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double minQKette(KeGlied *kette, TypStab_Nm** stab, double* minQpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double min_Q=0,tmpQ=0,pos=0;
  
  if(!kette)
    return 0;

  /* Startwert bestimmen */
  p = kette->nach; 
  tmp_stab = p->x;
  min_Q = minQ(tmp_stab, &pos);
  *stab = tmp_stab;
  *minQpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpQ = minQ(tmp_stab, &pos);

    if(tmpQ < min_Q ) {
      min_Q = tmpQ,
      *stab = tmp_stab;
      *minQpos = pos;
    }

  }

  return min_Q;
    
}



/*********************************************************************/
/* double minNKette( ... )                                           */
/*********************************************************************/
/*                                              
   Funktion bestimmt die min Normalkraft aller Stbe in der Kette
   pos ( 0. -> 1. )
   jh, 16.05.97 
*/
/*********************************************************************/

double minNKette(KeGlied *kette, TypStab_Nm** stab, double* minNpos)
{
  KeGlied *p;
  TypStab_Nm* tmp_stab;
  double min_N=0,tmpN=0,pos=0;

  if(!kette)
    return 0;

  /* Startwert bestimmen */
  p = kette->nach; 
  tmp_stab = p->x;

  min_N = minN(tmp_stab, &pos);

  *stab = tmp_stab;
  *minNpos = pos;

  /* Durchlauf ber die Kette */
  KeDurchlaufVorwaerts(p,kette) {
    tmp_stab = p->x;

    tmpN = minN(tmp_stab, &pos);

    if(tmpN < min_N ) {
      min_N = tmpN,
      *stab = tmp_stab;
      *minNpos = pos;
    }

  }

  return min_N;
    
}
