/*
  Datei     : dienst_environment.c
  erstellt  : 28.01.98
  gendert  : 01.02.98
  Autor     : jh
*/
 

#include "XStabDek.h"


/*********************************************************************/
/* void setFang( int mode )                                          */
/*********************************************************************/ 
/*                                              
   Fkt setzt den Fangmodus
   jh, 01.02.98
*/
/*********************************************************************/

void setFang( int mode )
{
  if( !Modell )
    return;

  if(mode < 0 || mode > 3 )
    return;

  Modell->Environment.fang = mode;

  fl_set_choice(rasterform->fang_choice, Modell->Environment.fang + 1 );
  fl_set_choice(drawcontrol_preferences_form->fang_choice, 
		Modell->Environment.fang + 1 );

}



/*********************************************************************/
/* void toggle_raster(void)                                          */
/*********************************************************************/ 
/*                                              
   Fkt schaltet das Raster ein bzw. aus
   jh, 18.03.97
*/
/*********************************************************************/

void toggle_raster(FL_OBJECT *obj, long arg)
{

  if( !Modell )
    return;

  /*  Raster ein/ausschalten  */

  if ( Modell->Environment.raster )
    Modell->Environment.raster = 0;
  else
    Modell->Environment.raster = 1;


  /*  Buttons setzen  */

  fl_set_button(rasterform->raster_checkbutton,  
		Modell->Environment.raster );
  fl_set_button(drawcontrol_preferences_form->rasterbutton , 
		Modell->Environment.raster );

  Zeichne();

}


/*********************************************************************/
/* void modifyKoord(double *x, double *y)                            */
/*********************************************************************/ 
/*                                              
   Fkt verndert die bergebenen Koordinaten in Abhngigkeit
   des Fangmodus
   wenn ein Punkt gefangen wird, wird dieser in ptrPunkt
   eingetragen
   jh, 18.03.97
*/
/*********************************************************************/

void modifyKoord(double *X, double *Y, TypPunkt** ptrPunkt)
{ 
  long l_tmp;
  double d_tmp, fang_x, fang_y, rest;

  double x,y;

  x = *X; y = *Y;  /*  bequemer als *x und *y  ;-) */


  switch ( Modell->Environment.fang ) {   


  case 0 :  /*  kein Fang  */
    
    ptrPunkt = NULL;
    return;
    break;


  case 1 :  /*  Koord.-Fang  */
   
    fang_x = Modell->Environment.fang_x;
    fang_y = Modell->Environment.fang_y; 
    
    l_tmp = (long) (x/fang_x);
    d_tmp = (double) l_tmp * fang_x;

    rest = x - d_tmp;
    if(fabs(rest) >= (fang_x/2))
      x = d_tmp + (fang_x*rest/fabs(rest));
    else
      x = d_tmp;     
        
    l_tmp = (long) (y/fang_y);
    d_tmp = (double) l_tmp * fang_y;
    rest = y - d_tmp;

    if(fabs(rest) >= (fang_y/2))
      y = d_tmp + (fang_y*rest/fabs(rest));
    else
      y = d_tmp;        
                 

    *ptrPunkt = NULL;
    *X = x; *Y = y;

    break;
 

  case 2 :  /*  Punkt-Fang  */

    *ptrPunkt = suchePunkt_Koord(x, y, 0.2 );

    if( *ptrPunkt != NULL ) {
      *X = (*ptrPunkt)->d_x;
      *Y = (*ptrPunkt)->d_y;
    }

    return;


  case 3 :  /*  Punkt-Fang mit Koord.-Fang  */

    *ptrPunkt = suchePunkt_Koord(x, y, 0.2 );

    if( *ptrPunkt == NULL ) {

      fang_x = Modell->Environment.fang_x;
      fang_y = Modell->Environment.fang_y; 
      
      l_tmp = (long) (x/fang_x);
      d_tmp = (double) l_tmp * fang_x;
      
      rest = x - d_tmp;
      if(fabs(rest) >= (fang_x/2))
	x = d_tmp + (fang_x*rest/fabs(rest));
      else
	x = d_tmp;     
      
      l_tmp = (long) (y/fang_y);
      d_tmp = (double) l_tmp * fang_y;
      rest = y - d_tmp;
      
      if(fabs(rest) >= (fang_y/2))
	y = d_tmp + (fang_y*rest/fabs(rest));
      else
	y = d_tmp; 

      *X = x; *Y = y;
      
    }
    else {
      *X = (*ptrPunkt)->d_x;
      *Y = (*ptrPunkt)->d_y;
    }

    return;


  }

  

}
