/*
  Datei     : locale.c
  erstellt  : 13.02.98
  gendert  : 
  Autor     : jh
*/

#include "XStabDek.h"

#define HASHSIZE 16384

#define DE 1
#define EN 2

#define DEFAULT_LANG 2


typedef struct {

  char *deutsch;
  char *english;

} TypLocale;



long hashmq(char* s);
void schreibe(KeGlied** kette,TypLocale* s,long pos);
TypLocale* erzeugeLocale(char* d, char* e);



/*********************************************************************/
/* char* locale(char *str)                                          */
/*********************************************************************/ 
/*                                              
   Fkt gibt den in deutsch bergebenden String
   in der eingestellten Sprache zurck
   jh, 13.02.98
*/
/*********************************************************************/

char* locale(char *str)
{
  static KeGlied** Kette = NULL;
  KeGlied *p;
  long pos;
  TypLocale *tmpLoc;
  FILE* d;
  char de[255], en[255], dummy[10];
  char filename[255];
  char tmp_dat[512];
  static long lang = 0; 


  /*  Sprache setzen  */

  if( lang == 0 ) {
   
    sprintf( tmp_dat, "%s", getenv("LANG") );

    lang = DE;

    /* 
       lang = DEFAULT_LANG;

       if( strcmp(tmp_dat, "DE_de") == 0)
      lang = DE;
      
      if( strcmp(tmp_dat, "EN_en") == 0)
      lang = EN;       
    */

  }

 
  if (lang == DE)
    return str;


  /*  Daten einlesen  */

  if( !Kette ) {

    Kette = (KeGlied**) calloc (HASHSIZE, sizeof(KeGlied*));
    
    sprintf(filename, "%s/verwaltung/locale.dat", c_install_pfad );
    d = fopen( filename ,"r");

    do {

      if( fgets(tmp_dat, 512, d) ) { 


	/*  Datenstze sind mit ':' gekennzeichnet  */

	if( tmp_dat[0] == ':' ) {
	
	  sscanf(tmp_dat, "%s %s %s", dummy, de, en);
	  
	  UnScanString(de);
	  UnScanString(en);      
	  
	  tmpLoc = erzeugeLocale(de, en);
	
	  pos = hashmq( (char*) tmpLoc->deutsch );
	  schreibe(Kette, tmpLoc, pos);

	}

      }     
      else
	break;
      
    } while (1);
         
  }



  /*  Daten suchen  */

  pos = hashmq(str);
  
  if(Kette[pos]) {

    KeDurchlaufVorwaerts(p, Kette[pos]) {
     
      tmpLoc = p->x;   	 
      
      if(strcmp(tmpLoc->deutsch, str) == 0) {

	/* printf("-- %s gefunden an Pos %ld Stelle %ld\n  ",find,pos,it); */

	switch (lang) {
	  
	case EN :
	  return tmpLoc->english;
	  break;

	default :
	  return str;
	  break;

	}

	break;

      }	 
    }
  }

  return str;
 
}



long hashmq(char* s)
{
  unsigned long summe=0;
  unsigned long i;

  for(i=0L;*(s++)!='\0';i++)    
    summe+=(*s)*(*s)*i;    
  
  (unsigned long) summe <<= 18L;
  (unsigned long) summe >>= 18L;

  return summe;
}



void schreibe(KeGlied** kette, TypLocale* s, long pos)
{
  if(!kette[pos])
    kette[pos] = KeKetteDefinieren();

  KeElementEintragen(s, Nach, kette[pos]);

  /* fprintf(stderr," schreibe [%s] [%s]\n", s->deutsch, s->english ); */

}



TypLocale* erzeugeLocale(char* d, char* e)
{
  TypLocale* this;

  this = (TypLocale*) calloc (1, sizeof(TypLocale));
  
  this->deutsch = (char*) calloc ( strlen(d)+1, sizeof(char));
  this->english = (char*) calloc ( strlen(e)+1, sizeof(char));

  sprintf(this->deutsch, "%s", d);
  sprintf(this->english, "%s", e);

  return this;

}
