/*
  Datei     : export.c
  erstellt  : 30.11.96
  geaendert : 07.12.96
  Autor     : jh, sm
*/
/*
  geaendert : 31.05.04, bha
  Bemerkung : void export(void)
                static --> static int sonst Compilerwarnung
  gendert  : 31.05.04, bha
  Bemerkung : void export_drucke_tmp(char *datname, char *printcommand)
                i und anz als unsigned deklariert da sonst Compilerwarnung
                strlen liefert anscheind unsigned zurueck
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "XStabDek.h"


int export_formatindex=-1;
char export_printcommand[100]="lpr";


/* Ausgabe-Formate */
TypExport formate[] =
{ 
  { (ok_fun) ps_ok, (options_fun) ps_options, "PostScript","*.ps"},
  { (ok_fun) tab_ok,(options_fun)  tab_options, "Tab Delimited","*.tab"},
  { (ok_fun) liste_ok, (options_fun) liste_options, "Liste aller Stbe","*.list"},
  {(ok_fun) NULL,(options_fun) NULL,""}
};



/*********************************************************************/
/* void export(void)                                                 */
/*********************************************************************/
/*                                              
   Ausgabe der Ergebnisse in verschiedenen Formaten
   jh, 04.04.97
*/
/*********************************************************************/

void export(void)
{ 
  long i; 
  static int flag=1;
  
  if(flag) {
    fl_clear_choice(export_form->export_choice);
    for(i=0; strcmp(formate[i].name,"");i++)    
      fl_addto_choice(export_form->export_choice,formate[i].name);
    export_formatindex=0;
    fl_set_input(export_form->export_druckerkommando,export_printcommand);  
    flag=0;
  }
  
  fl_show_form(export_form->export,
	       FL_PLACE_CENTER,FL_TRANSIENT,"Exportieren"); 
}



/*********************************************************************/
/* void export_drucke_tmp(char *datname, char *printcommand)         */
/*********************************************************************/
/*                                              
   die Funktion druckt die Datei 'datname' mit
   der Kommandozeile 'printcommand'
   jh, 04.05.97
*/
/*********************************************************************/

void export_drucke_tmp(char *datname, char *printcommand)
{
  pid_t pid;
  char printprg[100];
  char printcom[255];
  long unsigned i=0,anz=0;
  long j=0;
  char **arg;      
  
  Meldung("Drucke ...");   
    
  if(strlen(printcommand)<1) {
    fl_show_alert("","Geben Sie ein Druckkommando ein","",1);
    return;
  }
    
  sprintf(printcom,"%s",printcommand);   

  /* Druckprg bestimmen */
  sscanf(printcommand,"%s",printprg);
  
  if(strlen(printprg)<1)
    sprintf(printprg,"lpr");
 
  /* Parameter bestimmen */
  for(i=0;i<strlen(printcommand);i++)
    if(printcommand[i] == ' ') anz++;
    
  arg = (char**) calloc (anz+3,sizeof(char*)); 

  j=0;i=0;
  while(strlen(&printcommand[i])>0) {
    arg[j] = (char*) calloc (100,sizeof(char));   
    sscanf(&printcommand[i]," %s",arg[j]);   
    while(printcommand[i] == ' ') i++;
    i+=strlen(arg[j]);   
    j++;
  }

  /* temporre Datei in Parameter eintragen */
  arg[anz+1] = (char*) calloc (100,sizeof(char));
  sprintf(arg[anz+1],"%s",datname);

  /* letzten Parameter auf NULL setzen */
  arg[anz+2] = NULL;  

  /* neuen Proze starten */
  if( (pid = fork()) < 0 ) {
    fl_show_alert("","Druckproze konnte nicht gestartet werden !","",1);
  }
  else {
    if (pid==0) {
      if (execvp(printprg,arg) < 0) 
	fl_show_alert("","Fehler beim Drucken !","",1); 
    }
  }
     
  for(i=0;i<anz+2;i++)
    free(arg[i]);
  free(arg);

}







