/*
  Datei     : export_ps_zeichne.c
  erstellt  : 07.12.96
  geaendert : 31.07.97
  Autor     : jh, sm
*/



#include "XStabDek.h"

typedef struct
{
  double x,y;
}_Point;


typedef struct
{
  double x,y; /* Ecke links oben */
  double h,b; /* Hhe, Breite */
  double rand;
}TypBild;


TypBild bild[] = 
{
  {20, 159, 118, 170, 20} , 
  {20, 20 , 118, 170, 20} 
};


TypBild bildA4[] =
{
  { 20, 20, 170, 250, 30}
};


typedef struct
{
  double h, b;
  TypBild *bild;
} TypSeite;


KeGlied* Staebe; /* zu zeichnende Staebe */


void ps_header(TypBild bild, long arg);
void ps_dinA4(FILE *dat);
void ps_dinA5(FILE *dat);
void ps_BerechneMass(double , double ,double, double, TypMaszstab*, long, TypSeite);
void ps_ZeichneLager_Z(TypMaszstab mass, double x, double y);
void ps_ZeichneLager_XY(TypMaszstab mass, double x, double y, double alpha,long xy);
void ps_ZeichneLager(TypMaszstab mass);
void ps_Zeichne_Seitenzahl(long nr, TypBild);
void ps_Zeichne_Listen(void);

void ps_Zeichne(TypMaszstab ps_mass, long arg);

long ps_aktiv(long arg);


/* ps_zeichne_verscheibung */
extern void ps_ZeichneVerformung(TypMaszstab mass);


/* ps_zeichne_system.c */
extern void ps_ZeichneStabNummern(TypMaszstab mass);
extern void ps_ZeichneSystem(TypMaszstab,double);
extern void ps_ZeichneBezugsfaser(TypMaszstab mass);
extern void ps_zeichne_FG(TypMaszstab mass);


/* ps_zeichne_schnittkraft.c */
extern void ps_ZeichneMoment(TypMaszstab mass);
extern void ps_ZeichneQuerkraft(TypMaszstab mass);
extern void ps_ZeichneNormalkraft(TypMaszstab mass);




/*********************************************************************/
/* void ps_zeichne(FILE *dat)                                        */
/*********************************************************************/
/*                                              
   Funktion zeichnet das PostScript - File
   jh, 31.07.97
*/
/*********************************************************************/

void ps_zeichne(FILE *dat)
{
  /* ps_dinA5(dat); */
  ps_dinA4(dat);
}



/*********************************************************************/
/* void ps_dinA4(FILE *dat)                                          */
/*********************************************************************/
/*                                              
   Funktion zeichnet das PostScript - File auf DIN A4 Landscape
   jh, 31.07.97
*/
/*********************************************************************/

void ps_dinA4(FILE *dat)
{
  long i;
  double *minmax;
  TypMaszstab ps_mass;
  double min_x,min_y,max_x,max_y;
  char c_text[100];
  long seitenr;
  KeGlied* l;
  long hoch = 0;

  TypSeite seite = { 297,210, bildA4 };
 

  if( fl_get_button( ps_form->selected_button) ) {
    
    /* selektierte Stbe bestimmen */
    Staebe = getSelectedK();

  }
  else
    Staebe = Modell->KeStab_Nm;

  if( !Staebe )
    return;
    
  minmax = dienst_minmaxkoord_Nm(Staebe);
  
  min_x = minmax[0];   max_x = minmax[1];
  min_y = minmax[2];   max_y = minmax[3];

  if( fl_get_button( ps_form->hoch_button) ) {
    seite.bild[0].h = 250;
    seite.bild[0].b = 170;
    hoch = 1;
  }
  else {
    seite.bild[0].h = 170;
    seite.bild[0].b = 250;
    hoch = 0;
  }
    

  ps_open(dat);
  sprintf(c_text,"%%Pages: %ld\n",2L);
  ps_direct(c_text);

  seitenr = 0;

  for(i=0; i<5; i++) {

    if( ps_aktiv(i) ) {

      ps_begin_page();	
      {  
	seitenr++;

	/* Landscape */
	if(!hoch) {
	  ps_rotate(90); 
	  ps_translate(+210,0);
	}
	else {
	  ps_rotate(0); 
	  ps_translate(0,0);
	}

	
	/* Rahmen */
	ps_linewidth(0.1);          
	ps_rect(seite.bild[0].x, seite.bild[0].y, 
		seite.bild[0].b, seite.bild[0].h);   	
	
	/* berschrift */
	ps_header(seite.bild[0],i);
	
	ps_BerechneMass(max_x, min_x,
			max_y, min_y, &ps_mass, 
			0, seite);   
		
	/* Schnittkraft, Verschiebung zeichnen */	       
	ps_Zeichne(ps_mass,i);      	
    
	if( fl_get_button(ps_form->seitenzahl_button) ) {
	  ps_setgray(0);
	  ps_Zeichne_Seitenzahl(seitenr, seite.bild[0]);
	}
    
      }
      ps_end_page(); 

    }
  }


  /* Kette lschen */
  if( fl_get_button( ps_form->selected_button) ) {
    while(Staebe->nach != Staebe)
      {	  
	l = Staebe->nach;
	KeGliedAustragen(l);     
      }
  }

}



long ps_aktiv(long arg)
{
  switch (arg) {

  case 0 : /*System */    
    return fl_get_button(ps_form->system_button);
    break;

   case 1 : /* Moment */
     return fl_get_button(ps_form->moment_button);
     break;

   case 2 : /* Querkraft */
     return fl_get_button(ps_form->querkraft_button);
     break;

   case 3 : /* Normalkraft */
     return fl_get_button(ps_form->normalkraft_button);
     break;

   case 4 : /* Verformung */
     return fl_get_button(ps_form->verschiebung_button);
     break;
     
  default :    
    return 0;
    break;
    
  }  

  return 0;

}



void ps_Zeichne(TypMaszstab ps_mass, long arg)
{
   switch(arg) {

   case 0 : /*System */        
   
     ps_ZeichneLager(ps_mass);    
     if( fl_get_button( ps_form->fg_button) )
       ps_zeichne_FG(ps_mass);       
     ps_ZeichneStabNummern(ps_mass);
     ps_ZeichneSystem(ps_mass, 0);
     ps_setgray(0);  
     ps_ZeichneBezugsfaser(ps_mass); 

     break;

   case 1 : /* Moment */
        
     ps_ZeichneSystem(ps_mass, 0.6);
     ps_ZeichneBezugsfaser(ps_mass);   
     ps_setgray(0);      
     ps_linestyle(0);
     ps_ZeichneMoment(ps_mass);    
       
     break;

   case 2 : /* Querkraft */
       	    
     ps_ZeichneSystem(ps_mass,0.6);
     ps_ZeichneBezugsfaser(ps_mass);     
     ps_setgray(0);      
     ps_linestyle(0);
     ps_ZeichneQuerkraft(ps_mass);

     break;

   case 3 : /* Normalkraft */
      
     ps_ZeichneSystem(ps_mass, 0.6);
     ps_ZeichneBezugsfaser(ps_mass);      
     ps_setgray(0);
     ps_linestyle(0);
     ps_ZeichneNormalkraft(ps_mass);

     break;

   case 4 : /* Verformung */
        
     ps_ZeichneSystem(ps_mass, 0.6);
     ps_ZeichneBezugsfaser(ps_mass);
    
     ps_ZeichneVerformung(ps_mass);

     break;

   default :    
     break;

  }
}



void ps_header(TypBild bild, long arg)
{
  char c_text[300];

  ps_setgray(0);
  ps_text_font("Times-Roman",12);

  switch(arg) {
      
  case 0 : /* System */
    sprintf(c_text,"System : %s",Modell->System.c_datei);
    ps_drawtext(bild.x, bild.y + bild.h + 2, c_text);   
    break;

  case 1 : /* Moment */
    ps_drawtext(bild.x, bild.y + bild.h + 2,"Moment :");
    break;

  case 2 : /* Querkraft */
    ps_drawtext(bild.x, bild.y + bild.h + 2,"Querkraft :");
    break;

  case 3 : /* Normalkraft */
    ps_drawtext(bild.x, bild.y + bild.h + 2,"Normalkraft :");
    break;

  case 4 : /* Verformung */
    ps_drawtext(bild.x, bild.y + bild.h + 2,"Verformung :");
    break;

  default :
    ps_drawtext(bild.x, bild.y + bild.h + 2,"...");
    break;

  }
}


void ps_dinA5(FILE *dat)
{

#ifdef KKK

  double *minmax;
  TypMaszstab ps_mass;
  double min_x,min_y,max_x,max_y;

  TypSeite seite = { 297,210, bild };

  minmax = dienst_minmaxkoord_Nm();
  
  min_x = minmax[0];   max_x = minmax[1];
  min_y = minmax[2];   max_y = minmax[3];


  /* ... Seite 1  ... */

  ps_begin_page(dat);	
  {  
    ps_linewidth(0.1);
    ps_rect(seite.bild[0].x, seite.bild[0].y, 
	    seite.bild[0].b, seite.bild[0].h);

    ps_rect(seite.bild[1].x, seite.bild[1].y, 
	    seite.bild[1].b, seite.bild[1].h);
   
    ps_text_font("Times-Roman",12);

    ps_drawtext(seite.bild[0].x, seite.bild[0].y + seite.bild[0].h + 2,"System :");
    ps_drawtext(seite.bild[1].x, seite.bild[1].y + seite.bild[1].h + 2,"Momente :");


    /* Bild 0 */
    ps_BerechneMass(max_x, min_x,
		    max_y, min_y, &ps_mass, 0, seite);   

    /* System zeichnen */
    ps_ZeichneSystem(ps_mass);
    ps_ZeichneBezugsfaser(ps_mass);   

    /* Lager zeichnen */
    ps_linewidth(0.3);
    ps_linestyle(0);
    ps_setgray(0.5);
    ps_ZeichneLager(ps_mass);


    /* Bild 1 */
    ps_BerechneMass(max_x, min_x,
		    max_y, min_y, &ps_mass, 1, seite );   
    ps_setgray(0.6);
    ps_ZeichneSystem(ps_mass);
    ps_ZeichneBezugsfaser(ps_mass);

    ps_setgray(0);
    ps_ZeichneMoment(ps_mass);

    ps_Zeichne_Seitenzahl(1);
  }  
  ps_end_page();


  /* ... Seite 2  ... */

  ps_begin_page(dat);	
  {  
    ps_linewidth(0.1);
    ps_rect(seite.bild[0].x, seite.bild[0].y, 
	    seite.bild[0].b, seite.bild[0].h);

    ps_rect(seite.bild[1].x, seite.bild[1].y, 
	    seite.bild[1].b, seite.bild[1].h);
   
    ps_text_font("Times-Roman",12);

    ps_drawtext(seite.bild[0].x, seite.bild[0].y + seite.bild[0].h + 2,"Querkraft :");
    ps_drawtext(seite.bild[1].x, seite.bild[1].y + seite.bild[1].h + 2,"Normalkraft :");

    /* Bild 0 */

    ps_BerechneMass(max_x, min_x,
		    max_y, min_y, &ps_mass, 0, seite);
    ps_setgray(0.6);
    ps_ZeichneSystem(ps_mass);
    ps_ZeichneBezugsfaser(ps_mass);
    
    ps_setgray(0);    
    ps_ZeichneQuerkraft(ps_mass);

    /* Bild 1 */  
    
    ps_BerechneMass(max_x, min_x,
		    max_y, min_y, &ps_mass, 1,seite);
    ps_setgray(0.6);
    ps_ZeichneSystem(ps_mass);
    ps_ZeichneBezugsfaser(ps_mass);
    
    ps_setgray(0);    
    ps_ZeichneNormalkraft(ps_mass);
    
    ps_Zeichne_Seitenzahl(2);

  }  
  ps_end_page();


  /* ... Seite 3  ... */
  /*
     ps_begin_page(dat);	
     {   
     ps_Zeichne_Listen();
     }  
     ps_end_page();
  */


#endif

}


void ps_BerechneMass(double max_x, double min_x,
		     double max_y, double min_y,
		     TypMaszstab *mass, 
		     long bildnr, TypSeite seite)
{
  double sys_height,sys_width;
  double center;

  sys_height = fabs(max_y - min_y);
  sys_width  = fabs(max_x - min_x);

  (*mass).system = ((seite.bild[bildnr].b - 2 * seite.bild[bildnr].rand) / sys_width) <
    ((seite.bild[bildnr].h - 2 * seite.bild[bildnr].rand) / sys_height) ?  
      ((seite.bild[bildnr].b - 2 * seite.bild[bildnr].rand)/ sys_width) : 
	((seite.bild[bildnr].h - 2 * seite.bild[bildnr].rand) / sys_height);  

  center = (seite.bild[bildnr].h - sys_height * (*mass).system) / 2;
  (*mass).off_y = (seite.bild[bildnr].y + center) - (min_y * (*mass).system);    

  center = (seite.bild[bildnr].b - sys_width * (*mass).system) / 2;
  (*mass).off_x = (seite.bild[bildnr].x + center)  - (min_x * (*mass).system); 

}




void ps_ZeichneLager(TypMaszstab mass)
{
  long i;
  double x,y;
  double alpha;

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;


  if(!Staebe)
    return;

  /* Zeichen - Einstellungen */

  ps_linewidth(0.3);
  ps_linestyle(0);
  ps_setgray(0.5);


  KeDurchlaufVorwaerts(p,Staebe) {
    tmp_stab = p->x;     
    
    for(i=0;i<6;i++) {
      tmp_freigrad = (*tmp_stab).pe_frei[i];
      
      if(i<3)	    
	tmp_punkt = (*tmp_stab).pe_punkta;       	    
      else	    
	tmp_punkt = (*tmp_stab).pe_punktb;
      
      x = (*tmp_punkt).d_x;
      y = (*tmp_punkt).d_y;    
      
      /* nur zeichnen wenn primal */
      if( (*tmp_freigrad).l_status == CPmPrimal) {
	alpha =  (*tmp_freigrad).d_alpha;	    
	
	switch ( (*tmp_freigrad).l_art) {
	case 0 :
	  ps_ZeichneLager_XY(mass, x,y,alpha,XS_LAGER_X);
	  break;
	case 1 :
	  ps_ZeichneLager_XY(mass, x,y,alpha,XS_LAGER_Y);
	  break;
	case 2 :
	  ps_ZeichneLager_Z(mass, x,y);
	  break;
	}
      }
    }         
  }
}



void ps_ZeichneLager_XY(TypMaszstab mass, double x, double y, double alpha,long xy)
{
  double abstand1 = 2;
  double abstand2 = 6;
  double radius = 0.6;  /* Radius in mm */
  double s,c;

  if(xy == XS_LAGER_X)
    alpha -= PI/2;

  s = sin(alpha);
  c = cos(alpha);

  ps_arc(x * mass.system + mass.off_x - abstand1 * s,
	 y * mass.system + mass.off_y + abstand1 * c,
	 radius);	

  ps_arc(x * mass.system + mass.off_x - (abstand2 * s),
	 y * mass.system + mass.off_y + (abstand2 * c),
	 radius);
  
  ps_line(x * mass.system + mass.off_x - (abstand1 * s),
	  y * mass.system + mass.off_y + (abstand1 * c),
	  x * mass.system + mass.off_x - (abstand2 * s),
	  y * mass.system + mass.off_y + (abstand2 * c));
}



void ps_ZeichneLager_Z(TypMaszstab mass, double x, double y)
{  
  double abstand = 1.2;
  
  ps_rect((x * mass.system + mass.off_x - abstand ), 
	  (y * mass.system + mass.off_y - abstand ),
	  (2 * abstand),
	  (2 * abstand) );
}



void ps_Zeichne_Seitenzahl(long nr, TypBild bild)
{
  char c_text[50];
  double x;

  sprintf(c_text,"- %ld -",nr);

  ps_setgray(0);    
  ps_text_font("Times-Roman",12);

  x = bild.b / 2 + bild.x;
  ps_drawtext(x,12,c_text);
}



/***********************************************************/
/* void ps_Zeichne_Listen(void)                            */
/***********************************************************/ 
/*                                              
   Fkt gibt eine Liste aller Stbe in PS aus
   jh, 06.04.97
*/
/***********************************************************/

void ps_Zeichne_Listen(void)
{ 
  ps_drawtext(100,100,"STAEBE :\n\r  ------------------\n\r\n\r");
}

