/*
  Datei     : ps_zeichne_schnittkraft.c
  erstellt  : 02.08.97
  geaendert : 
  Autor     : jh
*/



#include "XStabDek.h"


extern KeGlied* Staebe;

typedef struct
{
  double x,y;
}_Point;


void ps_Zeichne_Schnittkraft(TypIntervall* tmp_inter,
			     long sk, TypMaszstab mass);
void ps_Zeichne_Beschriftung(TypStab_Nm* tmp_stab,
			     long sk, TypMaszstab mass);

void ps_ZeichneQuerkraft(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypStab_Nm *tmp_stab;
  TypIntervall *tmp_intervall;
  char *c_tmp;

  if(!Staebe)
    return;

  c_tmp = (char*) fl_get_input(ps_form->mass_q);
  mass.schnittkraft = atof(c_tmp);

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Staebe)  {

    tmp_stab = p->x;        

    if(!(*tmp_stab).intervalle)
      continue;   
     
    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
           
      ps_Zeichne_Schnittkraft(tmp_intervall, 1, mass);
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(ps_form->beschriftung_button)) 
      ps_Zeichne_Beschriftung(tmp_stab, 1, mass);
    
  }  
}



void ps_ZeichneNormalkraft(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypStab_Nm *tmp_stab;
  TypIntervall *tmp_intervall;
  char *c_tmp;

  if(!Staebe)
    return;
  
  c_tmp = (char*) fl_get_input(ps_form->mass_n);
  mass.schnittkraft = atof(c_tmp);

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Staebe)  {

    tmp_stab = p->x;        

    if(!(*tmp_stab).intervalle)
      continue;   
     
    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
      
      ps_Zeichne_Schnittkraft(tmp_intervall, 0, mass);
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(ps_form->beschriftung_button)) 
      ps_Zeichne_Beschriftung(tmp_stab, 0, mass);
    
  }  
}



void ps_ZeichneMoment(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypStab_Nm *tmp_stab;
  TypIntervall *tmp_intervall;
  char *c_tmp;

  if(!Staebe)
    return;

  /* Mastab holen */
  c_tmp = (char*) fl_get_input(ps_form->mass_m);
  mass.schnittkraft = atof(c_tmp);

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Staebe)  {

    tmp_stab = p->x;        

    if(!(*tmp_stab).intervalle)
      continue;   
     
    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
           
      ps_Zeichne_Schnittkraft(tmp_intervall, 2, mass);
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(ps_form->beschriftung_button)) 
      ps_Zeichne_Beschriftung(tmp_stab, 2, mass);
    
  }  
}


void ps_Zeichne_Schnittkraft(TypIntervall* tmp_inter,
			     long sk, TypMaszstab mass)
{
  long i;
  double z,step;
  double x0,y0,x1,y1;
  double xa,ya,xb,yb;
  double dx,dy;
  double *m;
 
  double s,c;
  long anz_points = 11; 
  double SKa,SKe,ska,ske;
  _Point *points;

  
  /* Speicher fr die Punkte */
  points = (_Point*) calloc ( anz_points , sizeof(_Point)); 
     
  /* geometrische Werte setzen */
  s = sin((*tmp_inter).d_alpha_stab);
  c = cos((*tmp_inter).d_alpha_stab);

  /* setze Sttzwerte und deren Ableitungen */
  switch(sk) {

  case 0 : /* N */      
      
    SKa = (*tmp_inter).d_Na;
    SKe = (*tmp_inter).d_Nb;
    ska = -(*tmp_inter).d_lastn_a;
    ske = -(*tmp_inter).d_lastn_b;
    break;

  case 1 : /* Q */
    
    SKa = (*tmp_inter).d_Qa;
    SKe = (*tmp_inter).d_Qb;
    ska = (*tmp_inter).d_lastp_a;
    ske = (*tmp_inter).d_lastp_b;
    break;

  case 2 : /* M */

    /* Moment in Statik-Richtung antragen
       -> positiv nach unten ! */
    SKa = -(*tmp_inter).d_Ma;
    SKe = -(*tmp_inter).d_Mb;
    ska = -(*tmp_inter).d_Qa;
    ske = -(*tmp_inter).d_Qb;
    break;

  default :
    fprintf(stderr,"falsche bergabeparameter !\n");
    return;
  }

  /* Geometrie setzen */
  xa = (*tmp_inter).d_xa;
  ya = (*tmp_inter).d_ya;

  xb = (*tmp_inter).d_xe;
  yb = (*tmp_inter).d_ye;      

  /* interpolieren */
  m = Hermite(SKa, ska, SKe, ske,
	      (*tmp_inter).d_laenge,
	      anz_points);
  
      
  /* Punkte berechnen */
  z = -1;
  step = (double) (2./((double) anz_points - 1.));

  for(i=0;i<anz_points;i++)  {
    
    /* Geometrie interpolieren */
    x0 = 0.5 * (xa * (1-z) + xb * (1+z));	
    y0 = 0.5 * (ya * (1-z) + yb * (1+z));		  	               	
       
    dx = m[i] * s * mass.schnittkraft;
    dy = m[i] * c * mass.schnittkraft;
    
    x1 = x0 - dx;
    y1 = y0 + dy;
        
    points[i].x = (double) (x1 * mass.system + mass.off_x);
    points[i].y = (double) (y1 * mass.system + mass.off_y);	 	  		  

    z +=step;
    
    ps_line((double) (x0 * mass.system + mass.off_x), 
	    (double) (y0 * mass.system + mass.off_y),
	    (double) points[i].x,
	    (double) points[i].y);
  }    

  for(i=0;i<anz_points-1;i++)
    ps_line(points[i].x, points[i].y, points[i+1].x, points[i+1].y);
  
  free(points);
  free(m); 
  
}



void ps_Zeichne_Beschriftung(TypStab_Nm* tmp_stab,
			     long sk, TypMaszstab mass)
{ 
  double maxS=0,pos=0;
  TypPunkt *pA,*pB;
  double x0,y0,x1,y1,dx,dy;
  char c_text[20];

  double abstand = 8; /* Abstand Schnittkraft - Beschriftung */
 
  if(!(*tmp_stab).intervalle)
    return;


  /* Zeichen - Einstellungen */

  ps_text_font("Times-Roman",8);


  /* Geometrie interpolieren */
  pA = (*tmp_stab).pe_punkta;
  pB = (*tmp_stab).pe_punktb;


  /* Pos 0. und 1. zeichnen */
  pos = 0.;
  while( pos <= 1. ) {
    
    switch(sk) {
    case 0 : /* N */   
      maxS = getN(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      break;
      
    case 1 : /* Q */ 
      maxS = getQ(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      break;
      
    case 2 : /* M */
      maxS = getM(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      maxS *= -1.;
      break;
    }
    
    x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
    y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
    
    dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
    dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
    
    x1 = x0 - dx;
    y1 = y0 + dy;	            	            
    
    ps_line(x1 * mass.system + mass.off_x,
	    y1 * mass.system + mass.off_y,
	    x1 * mass.system + mass.off_x + abstand,
	    y1 * mass.system + mass.off_y + abstand);
	     
    
    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand,
		c_text);     
    
    pos += 1.;
  }
  

  /* Maximum zeichnen */
  switch(sk) {
  case 0 : /* N */   
    maxS = maxN(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 1 : /* Q */ 
    maxS = maxQ(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 2 : /* M */
    maxS = maxM(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    maxS *= -1.;  /*Statik-Konvention ! */
    break;
  }
 
  x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
  y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
  
  dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
  dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
  
  x1 = x0 - dx;
  y1 = y0 + dy;	            	     

  ps_line(x1 * mass.system + mass.off_x,
	  y1 * mass.system + mass.off_y,
	  x1 * mass.system + mass.off_x + abstand,
	  y1 * mass.system + mass.off_y + abstand);
	     
    
  ps_drawtext(x1 * mass.system + mass.off_x + abstand,
	      y1 * mass.system + mass.off_y + abstand,
	      c_text);     
   

  /* Minimum beschriften */
  switch(sk) {
  case 0 : /* N */   
    maxS = minN(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 1 : /* Q */ 
    maxS = minQ(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 2 : /* M */
    maxS = minM(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    maxS *= -1.;  /*Statik-Konvention ! */
    break;
  }
 
  x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
  y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
  
  dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
  dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
  
  x1 = x0 - dx;
  y1 = y0 + dy;	            	     

  ps_line(x1 * mass.system + mass.off_x,
	  y1 * mass.system + mass.off_y,
	  x1 * mass.system + mass.off_x + abstand,
	  y1 * mass.system + mass.off_y + abstand);
  
  
  ps_drawtext(x1 * mass.system + mass.off_x + abstand,
	      y1 * mass.system + mass.off_y + abstand,
	      c_text);     
     
}

