/*
  Datei     : ps_zeichne_verschiebung.c
  erstellt  : 03.08.97
  geaendert : 
  Autor     : jh
*/


#include "XStabDek.h"


extern KeGlied* Staebe;


typedef struct
{
  double x,y;
}_Point;



void ps_Zeichne_Verschiebung_Stab(TypIntervall *tmp_intervall,
				  TypMaszstab mass);
void ps_Zeichne_Beschriftung_Verschiebung(TypStab_Nm* tmp_stab,
					  TypMaszstab mass);

void ps_ZeichneVerformung(TypMaszstab mass)
{
  KeGlied *intervalle;
  KeGlied *inter;
  TypIntervall *tmp_intervall;
  
  KeGlied *p;
  TypStab_Nm *tmp_stab;     

  if(!Staebe)
    return;

  ps_setgray(0);
  ps_linestyle(0); 

  KeDurchlaufVorwaerts(p,Staebe)  {
    tmp_stab = p->x;     
    intervalle = (*tmp_stab).intervalle;  
         
    if(!intervalle)
      continue;   

    /* Schleife ber alle Intervalle eines Stabes */
    KeDurchlaufVorwaerts(inter, intervalle)  { 
      tmp_intervall = inter->x;     
      ps_Zeichne_Verschiebung_Stab(tmp_intervall, mass);
    }
    
    if(fl_get_button(ps_form->beschriftung_button)) {    
      ps_Zeichne_Beschriftung_Verschiebung(tmp_stab, mass);
    }
    
  } 
  
}
  


/*********************************************************************/
/* void ps_Zeichne_Verschiebung_Stab(...)                            */
/*********************************************************************/ 
/*                                              
   Fkt zeichnet die Verschiebung eines Intervalles     
   jh, 01.08.97
*/
/*********************************************************************/

void ps_Zeichne_Verschiebung_Stab(TypIntervall *tmp_intervall,
				  TypMaszstab mass)
{ 
  long i;
  double z,step,x,y;
  double xa,ya,xb,yb;
  double dx,dy;
  double vxa,vya,vxb,vyb,vza,vzb;
  double vs[6];
  long anz_points = 5;
  double alpha1=0,alpha2=0;
  double alpha_stab; 
  double s,c;
  char *c_tmp;

  _Point *points;  

  points = (_Point*) calloc ( anz_points , sizeof(_Point));  


  ps_linewidth(0.7);


  /* Mastab holen */
  c_tmp = (char*) fl_get_input(ps_form->mass_verschieb);
  mass.vs = atof(c_tmp);
	  
  for(i=0;i<6;i++)	    
    vs[i] = (*tmp_intervall).d_vs[i];
  
  alpha_stab = (*tmp_intervall).d_alpha_stab;
  c = cos(alpha_stab);
  s = sin(alpha_stab);

  /* Drehung der Freiheitsgrade */
  alpha1 = (*tmp_intervall).d_alpha1;	     
  alpha2 = (*tmp_intervall).d_alpha2;	   
  
  /* Anfangs- und Endkoordinaten des Intervalles */
  xa = (*tmp_intervall).d_xa;   ya = (*tmp_intervall).d_ya;  
  xb = (*tmp_intervall).d_xe;   yb = (*tmp_intervall).d_ye;
    

  /* Verschiebungen im globalen Koordinatensystem */
  vxa = mass.vs * ( cos(alpha_stab - alpha1) * vs[0] + sin(alpha_stab - alpha1) * vs[1]);
  vya = mass.vs * ( -sin(alpha_stab - alpha1) * vs[0] + cos(alpha_stab - alpha1) * vs[1]);
  
  vxb = mass.vs * ( cos(alpha_stab - alpha2) * vs[3] + sin(alpha_stab - alpha2) * vs[4]);
  vyb = mass.vs * ( -sin(alpha_stab - alpha2) * vs[3] + cos(alpha_stab - alpha2) * vs[4]);
  
  vza = mass.vs * vs[2];
  vzb = mass.vs * vs[5];      
  
  step = (double) (2./((double) anz_points - 1.));
  
  z=-1.;
  
  for(i=0;i<anz_points;i++) {	

    /* lineare Interpolation der Verschiebung in Stabachse */
    dx = 0.5 * (vxa * (1.-z) + (vxb+(*tmp_intervall).d_laenge) * (1.+z));

    /* Hermite - Interpolation w,u im glob. Koord.sys */
    dy = Hermite_dis(vya, vza, vyb, vzb,
		     (*tmp_intervall).d_laenge,z);
    
    x = xa + (c * dx - s * dy);
    y = ya + (s * dx + c * dy );
    
    points[i].x = (double) (x * mass.system + mass.off_x);;
    points[i].y = (double) (y * mass.system + mass.off_y);;
    
    z+=step;
    
  }    
  
  for(i=0;i<anz_points-1;i++)
    ps_line(points[i].x, points[i].y, points[i+1].x, points[i+1].y);

  free(points);

}




/*********************************************************************/
/* void ps_Zeichne_Beschriftung_Verschiebung( ... )                  */
/*********************************************************************/
/*                                              
   Funktion beschriftet die Verschiebung 
   jh, 19.04.97 
*/
/*********************************************************************/

void ps_Zeichne_Beschriftung_Verschiebung(TypStab_Nm* tmp_stab,
					  TypMaszstab mass)
{ 
  double W,U,pos=0;
  TypPunkt *pA,*pB;
  double x0,y0,x1,y1,dx,dy;
  char c_text_u[20];
  char c_text_w[20];
  char *c_tmp;

  double abstand = 8;

  if(!(*tmp_stab).intervalle)
    return;

  
  ps_linewidth(0.2);
  ps_text_font("Times-Roman",8);


  /* Mastab holen */
  c_tmp = (char*) fl_get_input(ps_form->mass_verschieb);
  mass.vs = atof(c_tmp);

  /* Geometrie interpolieren */
  pA = (*tmp_stab).pe_punkta;
  pB = (*tmp_stab).pe_punktb;


  /* Pos 0. und 1. zeichnen */
  pos = 0.;
  while( pos <= 1. ) {                

    W = get_w(tmp_stab,pos);   
    U = get_u(tmp_stab,pos);
    sprintf(c_text_w,"w : %.4f",W);
    sprintf(c_text_u,"u : %.4f",U);  
      
    x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
    y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
    
    dx = (W * sin((*tmp_stab).d_alpha) + U * cos((*tmp_stab).d_alpha)) * mass.vs;
    dy = (U * sin((*tmp_stab).d_alpha) - W * cos((*tmp_stab).d_alpha)) * mass.vs;
    
    x1 = x0 + dx;
    y1 = y0 + dy;	            	            

    if(pos > 0 )
      abstand *= -1;
           
    ps_line(x1 * mass.system + mass.off_x,
	    y1 * mass.system + mass.off_y,
	    x1 * mass.system + mass.off_x + abstand,
	    y1 * mass.system + mass.off_y + abstand);
	     
    
    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand,
		c_text_w);

    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand + 3,
		c_text_u);     
    

    pos += 1.;
  }

  abstand = fabs(abstand);


  /* Maximum beschriften */
  
  W = max_w(tmp_stab,&pos); 

  if( pos > XS_LIMIT &&  pos < (1-XS_LIMIT)) {
    U = get_u(tmp_stab,pos);
    sprintf(c_text_w,"w : %.4f",W);
    sprintf(c_text_u,"u : %.4f",U);  
    
    x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
    y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
    
    dx = (W * sin((*tmp_stab).d_alpha) + U * cos((*tmp_stab).d_alpha)) * mass.vs;
    dy = (U * sin((*tmp_stab).d_alpha) - W * cos((*tmp_stab).d_alpha)) * mass.vs;
    
    x1 = x0 + dx;
    y1 = y0 + dy;	            	            

    ps_line(x1 * mass.system + mass.off_x,
	    y1 * mass.system + mass.off_y,
	    x1 * mass.system + mass.off_x + abstand,
	    y1 * mass.system + mass.off_y + abstand);
	     
    
    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand,
		c_text_w);

    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand + 3,
		c_text_u);     
   
  }
    
    
  /* Minimum beschriften */

  W = min_w(tmp_stab,&pos); 

  if( pos > XS_LIMIT &&  pos < (1-XS_LIMIT)) {
    U = get_u(tmp_stab,pos);
    sprintf(c_text_w,"w : %.4f",W);
    sprintf(c_text_u,"u : %.4f",U);  
    
    x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
    y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
    
    dx = (W * sin((*tmp_stab).d_alpha) + U * cos((*tmp_stab).d_alpha)) * mass.vs;
    dy = (U * sin((*tmp_stab).d_alpha) - W * cos((*tmp_stab).d_alpha)) * mass.vs;
    
    x1 = x0 + dx;
    y1 = y0 + dy;	            	            

    ps_line(x1 * mass.system + mass.off_x,
	    y1 * mass.system + mass.off_y,
	    x1 * mass.system + mass.off_x + abstand,
	    y1 * mass.system + mass.off_y + abstand);
    
    
    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand,
		c_text_w);

    ps_drawtext(x1 * mass.system + mass.off_x + abstand,
		y1 * mass.system + mass.off_y + abstand + 3,
		c_text_u);     
   
  }
  
}





