/*
  Datei     : initmain.c
  erstellt  : 15.03.97
  gendert  : 15.02.98
  Autor     : jh
*/
/*
  gendert  : 25.05.04, bha
  Bemerkung : mainscreen verkleinert (Absturz unter KDE)
  gendert  : 01.06.04, bha
  Bemerkung : TU-Logo mit Linux-Logo getauscht
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 

#include "XStabDek.h"
extern char *version;


void init_color(void);


void initmain_env(void)
{

  Modell = NULL;

  /* Rnder des Zeichenfensters */
  grafik_win_x = 10;   /* links */
  grafik_win_y = 105;  /* oben */
  grafik_win_xx = 10;  /* rechts */
  grafik_win_yy = 10;  /* unten */


  /* Pfade laden */
  set_path();


  /* Material einlesen */
  Lese_Material();


  /* Querschnitte einlesen */
  Lese_Querschnitte();    


  /* nur hier wird nicht die Methode benutzt !! , sonst SegFault */
  prg_status = 0;  

  fl_set_fselector_placement(FL_PLACE_CENTER); 

  /* Standardfarben initialisieren */
  init_color();
}




void initmain_info(void)
{
  char c_text[150];
  
  sprintf(c_text,"Version %s",version);
  fl_set_object_label(infoform->version,c_text);
  sprintf(c_text,"%s/xstab_logo.xpm",c_verwaltung_pfad);
  fl_set_pixmap_file(infoform->logo,c_text);
  sprintf(c_text,"%s/linux.xpm",c_verwaltung_pfad);
  fl_set_pixmap_file(infoform->xstab_logo,c_text);  
}



/*********************************************************************/
/* void init_color(void)                                             */
/*********************************************************************/ 
/*                                              
   Standardfarben initialisieren
   jh, 06.04.97
*/
/*********************************************************************/

void init_color(void)
{
  char c_text[256];

  sprintf(c_text,"%s/standard.col",c_verwaltung_pfad);

  /* Standardfarben lesen */
  if(!Lese_Color(c_text)) {	  
    /* wenn das nicht funktioniert hat */
    xs_color.fl_bg              = FL_BLACK;
    xs_color.fl_fg              = FL_WHITE;
    xs_color.fl_punkt           = FL_YELLOW;
    xs_color.fl_punkt_nr        = FL_YELLOW;
    xs_color.fl_stab            = FL_WHITE;
    xs_color.fl_stab_select     = FL_CYAN;
    xs_color.fl_stab_nr         = FL_RED;
    xs_color.fl_freigrad_dual   = FL_CYAN;
    xs_color.fl_freigrad_primal = FL_PALEGREEN;
    xs_color.fl_streckenlast    = FL_CYAN;
    xs_color.fl_punktlast       = FL_CYAN;  
    xs_color.fl_lager           = FL_PALEGREEN;
    xs_color.fl_normal          = FL_GREEN;
    xs_color.fl_quer            = FL_MAGENTA;
    xs_color.fl_moment          = FL_RED;
    xs_color.fl_achsen          = FL_MCOL;
    xs_color.fl_verschiebung    = FL_RED;
    xs_color.fl_feder           = FL_YELLOW;

    xs_color.bg              = fl_get_flcolor(xs_color.fl_bg);
    xs_color.fg              = fl_get_flcolor(xs_color.fl_fg);
    xs_color.punkt           = fl_get_flcolor(xs_color.fl_punkt);
    xs_color.punkt_nr        = fl_get_flcolor(xs_color.fl_punkt_nr);
    xs_color.stab            = fl_get_flcolor(xs_color.fl_stab);
    xs_color.stab_select     = fl_get_flcolor(xs_color.fl_stab_select);
    xs_color.stab_nr         = fl_get_flcolor(xs_color.fl_stab_nr);
    xs_color.freigrad_dual   = fl_get_flcolor(xs_color.fl_freigrad_dual);
    xs_color.freigrad_primal = fl_get_flcolor(xs_color.fl_freigrad_primal);
    xs_color.streckenlast    = fl_get_flcolor(xs_color.fl_streckenlast);
    xs_color.punktlast       = fl_get_flcolor(xs_color.fl_punktlast);
    xs_color.lager           = fl_get_flcolor(xs_color.fl_lager);
    xs_color.normal          = fl_get_flcolor(xs_color.fl_normal);
    xs_color.quer            = fl_get_flcolor(xs_color.fl_quer);
    xs_color.moment          = fl_get_flcolor(xs_color.fl_moment);
    xs_color.achsen          = fl_get_flcolor(xs_color.fl_achsen);
    xs_color.verschiebung    = fl_get_flcolor(xs_color.fl_verschiebung);
    xs_color.feder           = fl_get_flcolor(xs_color.fl_feder);

  }

}



/*********************************************************************/
/* void initmain_form(void)                                          */
/*********************************************************************/ 
/*                                              
   Funktion initialisiert und zeigt die main-form,
   in ihr sind Menleiste, Hauptzeichenfenster usw. 
   enthalten
   jh, 06.04.97                                 
*/
/*********************************************************************/

void initmain_form(void)
{
  char vers[30];
  double Width, Height;
  Display *tmpdisplay;           

  tmpdisplay = XOpenDisplay(NULL);

  sprintf(vers,"XStab %s",version);
 
  Width  = (long) XDisplayWidth(tmpdisplay, XDefaultScreen (tmpdisplay));
  Height = (long) XDisplayHeight(tmpdisplay, XDefaultScreen (tmpdisplay)); 

  //bha beginn
  // fl_set_form_size(form->mainform, Width-20, Height -40); 
  fl_set_form_size(form->mainform, Width-150, Height -250);  
  // bha ende
  fl_set_form_position(form->mainform,5,5);

  fl_show_form(form->mainform,FL_PLACE_POSITION,FL_FULLBORDER,vers); 

}



/*********************************************************************/
/* void initmain_buttons()                                           */
/*********************************************************************/ 
/*                                              
   Funktion initialisiert die Fenster, die mit den
   Buttons im Hauptfenster verknpft sind
   jh, 30.03.97                                 
*/
/*********************************************************************/

void initmain_buttons(void)
{
  fl_set_form_position(control_form->control,30,160); 
  fl_set_form_position(scale_form->scale,30,160); 

  /* Fenster System zeichnen, Lager, lasten ... */
  fl_set_form_position(drawcontrol_system_form->drawcontrol_system,30,160);
  fl_set_button(drawcontrol_system_form->system_button,1);
  fl_set_button(drawcontrol_system_form->lager_button,1);
  fl_set_button(drawcontrol_system_form->punktlasten_button,1);
  fl_set_button(drawcontrol_system_form->streckenlasten_button,1);
  fl_set_button(drawcontrol_system_form->punkte_button,1);

  /* Fenster Einstellungen, Ursprung, Bezugsfaser ... */
  fl_set_form_position(drawcontrol_preferences_form->drawcontrol_preferences,30,160);
  fl_set_button(drawcontrol_preferences_form->bezugsfaser_button,1);
  fl_set_button(drawcontrol_preferences_form->achsenbeschriftung_button,1);

}



/***********************************************************/
/*   void initmain_menu()                                  */
/***********************************************************/ 
/*                                              
   Funktion baut die Menzeile des 
   Hauptfensters auf   
   jh, 15.03.97                                 
*/
/***********************************************************/        

void initmain_menu(void)
{ 
  char* tmp;

  popup_datenbank = fl_newpup(rootwin);
  popup_system = fl_newpup(rootwin);                   
 

  /* ...  Ende  ... */ 

  fl_addto_menu(form->Beenden," Info");
  
  tmp = getText(" %s%%l", locale("Hilfe") );  
  fl_addto_menu(form->Beenden, tmp );

  tmp = getText(" %s", locale("Beenden") );   
  fl_addto_menu(form->Beenden, tmp );


  /* ...  Datenbank  ... */

  fl_setpup_bw(popup_datenbank,-2);
  fl_setpup_shadow(popup_datenbank,0);

  fl_set_menu_popup(form->Datenbank,popup_datenbank);

  tmp = getText(" %s%%l%%x4 ", locale("neues Projekt") );
  fl_addtopup(popup_datenbank, tmp);

  tmp = getText(" %s %%x1%%m", locale("System") );
  fl_addtopup(popup_datenbank, tmp, popup_system);

  tmp = getText(" %s %%x3", locale("Material") );
  fl_addtopup(popup_datenbank, tmp);

  tmp = getText(" %s %%x5", locale("Querschnitte") );
  fl_addtopup(popup_datenbank, tmp);


  /* ...  Datenbank -> System  ... */ 

  fl_setpup_bw(popup_system,-2);       

  tmp = getText(" %s%%x10%%l", locale("neues System") );
  fl_addtopup(popup_system, tmp);

  tmp = getText(" %s%%x11", locale("System ffnen"));
  fl_addtopup(popup_system, tmp);

  tmp = getText(" %s%%x12", locale("System sichern") );
  fl_addtopup(popup_system, tmp);

  tmp = getText(" %s%%x13%%l", locale("System sichern als ...") );
  fl_addtopup(popup_system, tmp);
  fl_addtopup(popup_system," System schlieen %x14");

  
  /* ...  Menue Berechnen  ... */

  fl_addto_menu(form->Berechne, locale("Theorie I. Ordnung") );
  fl_addto_menu(form->Berechne, locale("Theorie II. Ordnung") );


  /* ...  Menue Einstellungen  ... */

  fl_addto_menu(form->Einstellungen, locale("Raster / Fang") );
  fl_addto_menu(form->Einstellungen, locale("Stab erzeugen") );
 
  fl_addto_menu(form->Einstellungen, locale("Pfade") );
  fl_addto_menu(form->Einstellungen, locale("FG auch an biegesteifen Verbindungen") );
  fl_addto_menu(form->Einstellungen, locale("Prozessor") );
 
  fl_set_menu_item_mode(form->Einstellungen,4,FL_PUP_BOX);


  /* ...  Menue Ausgabe  ... */

  fl_addto_menu(form->Ausgabe," Bildschirm, alle Stbe");
  fl_addto_menu(form->Ausgabe," Bildschirm, markierte Stbe");
  fl_addto_menu(form->Ausgabe," Ausgabe");


  /* ...  Menue Tabellen  ... */

  
  fl_addto_menu(form->Tabellen, locale("Stbe"));
  fl_addto_menu(form->Tabellen, locale("Punkte")); 
 
}


void initmain_grafikenv(void)
{
  char *tmp;

  /* ...  Grafik Pop-Up  ... */ 

  popup = fl_newpup(win);
  popup2 = fl_newpup(win);
  popup3 = fl_newpup(win);

  fl_addtopup(popup3," 2 x %x20");
  fl_addtopup(popup3," 3 x %x21");
  fl_addtopup(popup3," 4 x %x22");

  tmp = getText("%s %%x30", locale("Quittieren") );
  fl_addtopup(popup2, tmp);

  tmp = getText("%s %%x31", locale("Abbruch") );
  fl_addtopup(popup2, tmp);

  tmp = getText("%s %%l", locale("STAB"));
  fl_addtopup(popup,tmp);

  fl_addtopup(popup,"Geometrie / Topologie");
  fl_addtopup(popup,"Material / Querschnitt");
  fl_addtopup(popup,"Schnittkrfte / Verschiebungen");  
  fl_addtopup(popup, locale("Freiheitsgrade") );
  fl_addtopup(popup, locale("Belastung") ); 
  fl_addtopup(popup, locale("Belastung kopieren") );
  fl_addtopup(popup," Stab teilen%m%l",popup3); 

  tmp = getText("%s %%m", locale("Lschen"));
  fl_addtopup(popup, tmp, popup2);

  fl_setpup_mode(popup,1,FL_PUP_GREY);  
}



/*********************************************************************/
/* void initmain_grafik(void)                                        */
/*********************************************************************/
/*                                              
   Grafikfenster initialisieren  
   jh, 13.05.97 
*/
/*********************************************************************/

void initmain_grafik(void)
{
  XSizeHints hint; 
  FL_Coord  main_w,main_h;

  rootwin =  fl_winget();
  fl_get_winsize(rootwin,&main_w,&main_h);
  
  display = fl_get_display();
  gc = XCreateGC(display,fl_state[fl_vmode].trailblazer,0,0);

  gc_select = XCreateGC(display,fl_state[fl_vmode].trailblazer,0,0);
  XSetFunction(display,gc_select, GXxor);
  XSetForeground(display,gc_select, fl_get_flcolor(FL_WHITE) );

  /* Cursor definieren */

  curs = XCreateFontCursor(display,XC_dotbox);
  curs2 = XCreateFontCursor(display,XC_circle);

  /* Fonts laden */

  font_large  = XLoadFont(display, "10x20");
  font_medium = XLoadFont(display, "9x15");
  font_small  = XLoadFont(display, "8x13");

  XSetFont(display,gc,font_medium);
  XSetFont(display,gc_select,font_medium);

  /* Hauptfenster initialisieren */ 
  hint.x = grafik_win_x;         
  hint.y = grafik_win_y;
  hint.width = main_w - hint.x - grafik_win_xx; 
  hint.height = main_h - hint.y - grafik_win_yy;
  hint.flags = PPosition | PSize;

  win = XCreateSimpleWindow(display,rootwin,
			    hint.x, hint.y, hint.width, hint.height,
			    2,              /* Randbreite */
			    COL_RAND,       /* Randfarbe */
			    xs_color.bg);   /* Hintergrund */

  /* XSelectInput(display,win,ButtonPressMask | KeyPressMask | ExposureMask); */
  XSelectInput(display,win, 
	       ButtonPressMask | 
	       ButtonMotionMask |
	       ButtonReleaseMask |
	       PointerMotionMask |
	       KeyPressMask); 

  XMapRaised(display,win);
  fl_set_event_callback(win_cb,0);
}

