/*
  Datei     : Lese.c
  erstellt  : 25.06.96
  gendert  : 13.01.97
  Autor     : jh
  Bemerkung :
*/
/*
  gendert  : 29.05.04, bha
  Bemerkung : funktion void Lese(char *filename) lese char so veraendert,
                dass nur XStab-Systembeschreibungsdateien versucht werden
                zu lesen. Zur Zeit werden nur Dateien gelesen, die mit V
                anfangen.
  gendert  : 31.05.04, bha
  Bemerkung : void Lese_Maszstab(char *pfad)
                i als unsigned deklariert da sonst Compilerwarnung
                strlen liefert anscheind unsigned zurueck
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "XStabDek.h"


extern char* version;


void readV0(FILE* d);
void readV1(FILE* d);


void Lese_Lastfall(FILE* d);
void Lese_Punktlasten(FILE *d);
void Lese_Streckenlasten(FILE *d);
void Lese_FG_Relationen(FILE* d);
void Lese_Staebe(FILE* d);
void Lese_Punkte(FILE* d);
void Lese_Freiheitsgrade(FILE *d);
void Lese_Lastfaelle(FILE* d);
void Lese_LFKombinationen(FILE* d);
void Lese_Maszstab(char *pfad);



/*********************************************************************/
/* void Lese(char *filename)                                         */
/*********************************************************************/ 
/*                                              
   Fkt liest ein System von Disk
   jh, 06.04.97
*/
/*********************************************************************/

void Lese(char *filename)
{
  FILE *d; 
  char *c_pfad; 
  char c_text[256];
  long vers;


  if(!filename) {
    c_pfad = (char*) fl_show_fselector("Datei Name",c_projekte_pfad,"*.sysdat","");
  }
  else {    
    c_pfad = filename;
  }

  if(c_pfad) {
    if(!(d = fopen(c_pfad,"r"))) {
      Meldung("Fehler beim Oeffnen der Datei !");
      return;
    }
  }
  else    
    return;


  // bha beginn
  // die beiden return ausdocumentieren, um alle Dateien zu laden

  // allgemeine Version des Fileformats bestimmen (ersten String der Datei lesen)
  fscanf(d,"%s",c_text);
  if( c_text[0] != 'V' ) {
    Meldung("Dies ist keine gltige XStab-Systembeschreibungsdatei.");
    printf("\nDatei nicht gelesen!!!\n");
    printf("Der erste String sollte ein V sein ist aber: %s\n",c_text);
    return;
  }
  printf("\nAllgemeine Version des Dateiformats: %s\n",c_text);

  // Version des Fileformats V bestimmen (Zahl hinter V aus der Datei lesen)
  fscanf(d,"%ld",&vers);  // l steht fuer long und d fuer int --> long int richtiger typ
  if( vers != 1 ) {
    Meldung("Dies ist keine gltige XStab-Systembeschreibungsdatei.");
    printf("\nDatei nicht gelesen!!!\n");
    printf("Es gibt nur V 1 diese Datei aber hat: V %ld\n",vers);
    return;
  }
  printf("Version des Dateiformats V: %ld\n",vers);
  // bha ende


  // neues Modell erzeugen und als aktuelles Modell setzen 
  Modell = erzeugeModell(); 

  // Mastab einlesen
  Lese_Maszstab(c_pfad);

  // ...  System einlesen  ...   
  sprintf(Modell->System.c_datei,"%s",c_pfad);

  if( c_text[0] != 'V' ) {
    //  version 0 
    Modell->System.l_id = atol(c_text);
    readV0(d);
  }
  else {
    switch ( vers ) {
    case 1 :  // version 1      
      readV1(d);
      break;
    }
  }
                         
  fclose(d);   

  Meldung("System geladen !"); 

  addToSystemChoice( Modell );
  
  dienst_Prg_Status(1);

  Modell->unsaved_changes = 0;

  setEnv();
  Zeichne(); 

}



/*********************************************************************/
/* void readV0(FILE* d)                                              */
/*********************************************************************/
/*                                              
   Fkt liest ein System von Disk im Fileformat 0
   jh, 22.08.97
*/
/*********************************************************************/

void readV0(FILE* d)
{

  fprintf(stderr,"read V0\n");
  
  /* Punkte einlesen */  
  Lese_Punkte(d);
  
  /* Freiheitsgrade einlesen */  
  Lese_Freiheitsgrade(d);

  /* ...  Staebe einlesen  ... */  
  Lese_Staebe(d);
  
  /* ...  FG Relationen einlesen  ... */  
  Lese_FG_Relationen(d);
  
  /* ...  Lastflle einlesen  ... */
  Lese_Lastfaelle(d);  
  Lese_Punktlasten(d);
  Lese_Streckenlasten(d);             

}



/*********************************************************************/
/* void readV1(FILE* d)                                              */
/*********************************************************************/
/*                                              
   Fkt liest ein System von Disk im Fileformat 1
   jh, 22.08.97
*/
/*********************************************************************/

void readV1(FILE* d)
{

  fprintf(stderr,"read V1\n");

  fscanf(d,"%ld",&(Modell->System.l_id));
  printf("SystemID: %ld\n",Modell->System.l_id);

  /* Punkte einlesen */  
  Lese_Punkte(d);
  
  /* Freiheitsgrade einlesen */  
  Lese_Freiheitsgrade(d);

  /* ...  Staebe einlesen  ... */  
  Lese_Staebe(d);
  
  /* ...  FG Relationen einlesen  ... */  
  Lese_FG_Relationen(d);
  
  /* ...  Lastflle einlesen  ... */
  Lese_Lastfaelle(d);  
  Lese_Punktlasten(d);
  Lese_Streckenlasten(d);

  Lese_LFKombinationen(d);

}



void Lese_Punkte(FILE* d)
{ 
  long anz,i;
  double _x,_y;
  long _nummer;
  TypPunkt    *tmp_punkt;
  
  fscanf(d," %ld",&anz); 
  
  for(i=0;i<anz;i++)  {                       
    fscanf(d," %ld %lf %lf", &_nummer, &_x, &_y);
    tmp_punkt = Erzeuge_Punkt_Nm(_x,_y, _nummer);    
  }
}


void Lese_Freiheitsgrade(FILE *d)
{  
  TypFreiGrad *tmp_freigrad; 
  char status; 
  long anz;
  long i;
  double dummy;
  char c_text[100];
 
  fscanf(d," %ld",&anz);  
  if(!Modell->KeFreiGrad_Nm)
    Modell->KeFreiGrad_Nm = KeKetteDefinieren();
  
  for(i=0;i<anz;i++)  {        
    tmp_freigrad = (TypFreiGrad*) calloc (1,sizeof(TypFreiGrad));
    
    (*tmp_freigrad).l_sysid = Modell->System.l_id;
    
    fscanf(d," %ld", &(*tmp_freigrad).l_nummer);
    fscanf(d," %c", &status);
    
    switch (status)  {
    case 'P' : 
      (*tmp_freigrad).l_status = CPmPrimal;
      fscanf(d," %lf",&(*tmp_freigrad).d_verschiebung);
      break;
      
    case 'D' :
      (*tmp_freigrad).l_status = CPmDual;
      fscanf(d," %lf",&dummy); 
      break;
      
    default :
      Meldung("Fehler beim Einlesen der Freiheitsgrade !\n");
      sprintf(c_text,"!! FG - Status = %c\n",status);
      Meldung(c_text);
      exit(1);
    }
    
    fscanf(d," %lf", &(*tmp_freigrad).d_alpha);
    fscanf(d," %ld", &(*tmp_freigrad).l_art);
    fscanf(d," %lf", &(*tmp_freigrad).d_feder);
    
    KeElementEintragen(tmp_freigrad,Nach,Modell->KeFreiGrad_Nm);
  }
}


void Lese_Staebe(FILE* d)
{ 
  TypStab_Nm     *tmp_stab;
  long l1,l2,l3;  
  long anz,i;

  fscanf(d," %ld",&anz);
 
  for(i=0; i<anz; i++)  {      

    tmp_stab = Erzeuge_Stab_Nm_Lese();
    
    fscanf(d," %ld", &(*tmp_stab).l_nummer);   
    
    /* Freiheitsgrade eintragen */
    
    fscanf(d," %ld %ld %ld",&l1,&l2,&l3);
    
    (*tmp_stab).pe_frei[0] = Suche_FreiGrad(l1, Modell->KeFreiGrad_Nm);
    (*tmp_stab).pe_frei[1] = Suche_FreiGrad(l2, Modell->KeFreiGrad_Nm);
    (*tmp_stab).pe_frei[2] = Suche_FreiGrad(l3, Modell->KeFreiGrad_Nm);        
    
    fscanf(d," %ld %ld %ld",&l1,&l2,&l3);
    
    (*tmp_stab).pe_frei[3] = Suche_FreiGrad(l1, Modell->KeFreiGrad_Nm);
    (*tmp_stab).pe_frei[4] = Suche_FreiGrad(l2, Modell->KeFreiGrad_Nm);
    (*tmp_stab).pe_frei[5] = Suche_FreiGrad(l3, Modell->KeFreiGrad_Nm);
    
    /* ...  Punktnummer eintragen  ... */
    
    fscanf(d," %ld %ld ",&l1,&l2);
    
    (*tmp_stab).pe_punkta = suchePunkt_Nr(l1, Modell->KePunkt_Nm);
    (*tmp_stab).pe_punktb = suchePunkt_Nr(l2, Modell->KePunkt_Nm);    
    
    SetzeGeometrie_Nm(tmp_stab);
    
    /* ...  Material  ... */
    
    fscanf(d," %ld",&(*tmp_stab).l_matid);   
    if(!Suche_Material((*tmp_stab).l_matid))   {
      Meldung("es wurden Stbe ohne Material geladen !");
    }

    /* ...  Querschnitt  ... */
    
    fscanf(d," %ld",&(*tmp_stab).l_querid);          
    if(!Suche_Querschnitt((*tmp_stab).l_querid))  {
      Meldung("es wurden Stbe ohne Querschnitt geladen !");
    }         
  }
}


void Lese_Lastfaelle(FILE* d)
{
  TypLastfall *tmp_last;
  long id,aktiv;
  double gewicht;
  char name[100];
  long anz,j;
  
 
  fscanf(d," %ld",&anz);
    
  for(j=0;j<anz;j++) {     
    fscanf(d,"%ld", &id);
    fscanf(d,"%lf", &gewicht);
    fscanf(d," %s", name);
    fscanf(d,"%ld", &aktiv);
    
    tmp_last = Erzeuge_Lastfall(0, name, id);       

    (*tmp_last).d_gewicht = gewicht;     
    (*tmp_last).l_aktiv = aktiv;
  }

  schreibeBrowserLastfall();
     
}



/*********************************************************************/
/* void Lese_LFKombinationen(FILE *d                                 */
/*********************************************************************/
/*                                              
   Fkt liest LF Kombinationen ein
   jh, 23.08.97
*/
/*********************************************************************/

void Lese_LFKombinationen(FILE *d)
{
  long anz,anzkomb,i,j;
  TypLastfallkombination* tmp_lfkomb;
  
  long id;
  char name[50];
  double gewicht;

  fscanf(d,"%ld",&anz);

  for(i=0;i<anz;i++) {   

    fscanf(d,"%ld",&id);

    tmp_lfkomb = erzeugeLFKombination(id);

    fscanf(d,"%s",name);
    sprintf(tmp_lfkomb->c_name,"%s",name);

    fscanf(d,"%ld",&anzkomb);

    for(j=0;j<anzkomb;j++) {

      fscanf(d,"%ld %lf",&id, &gewicht);
      LFKomb_addLF(tmp_lfkomb, id, gewicht);

    }

  }

  schreibeBrowserLastfallKombinationen();

}



void Lese_Punktlasten(FILE *d)
{
  long l_id;
  long l_lastfallid;
  double d_groesse;
  long anz;
  long l_koordsys_winkel, l_koordsys_last; 
  long l_stabnummer; 
  TypKnotenlast_Nm *tmp_punktlast; 
  double d_winkel;
  char c_name[100];
  long i; 
  double d_pos;
  long l_art;
  
  fscanf(d,"%ld",&anz);
  
  for(i=0;i<anz;i++) {                       
    fscanf(d,"%ld", &l_id);
    fscanf(d,"%ld", &l_lastfallid);
    fscanf(d," %s", c_name);
    fscanf(d,"%lf", &d_groesse);
    fscanf(d,"%ld", &l_stabnummer);
    fscanf(d,"%lf", &d_winkel);
    fscanf(d,"%ld", &l_koordsys_winkel);
    fscanf(d,"%ld", &l_koordsys_last);
    fscanf(d,"%lf", &d_pos);
    fscanf(d,"%ld", &l_art);
	  
    if(Suche_Stab_Nm(l_stabnummer))  {	  	      
      tmp_punktlast = Erzeuge_Punktlast_Nm(l_lastfallid , l_id);
	
      sprintf((*tmp_punktlast).c_name,"%s",c_name);	  	      
      (*tmp_punktlast).d_last = d_groesse;	     
      (*tmp_punktlast).l_stabnummer = l_stabnummer;	
      (*tmp_punktlast).d_alpha = d_winkel;
      (*tmp_punktlast).l_koordsys_winkel = l_koordsys_winkel;
      (*tmp_punktlast).l_koordsys_pos = l_koordsys_last;
      (*tmp_punktlast).d_pos = d_pos;
      (*tmp_punktlast).l_art = l_art;
	      	     
    }
    else {
      Meldung("(Lese Punktlast) Stab existiert nicht !");
    }
  }
}


void Lese_Streckenlasten(FILE *d)
{
  long l_lastfallid;
  long anz;  
  double d_lasta;
  double d_lastb;
  double d_alpha;
  long l_koordsys; 
  long l_stabnummer; 
 
  TypStreckenlast_Nm *tmp_streckenlast; 
 
  double anf,end;
  long l_id;
  char c_name[100]; 
  long i;
  
  fscanf(d,"%ld",&anz);
  
  for(i=0;i<anz;i++)  {	  
    fscanf(d," %s", c_name); 
    fscanf(d,"%ld", &l_id);
    fscanf(d,"%ld", &l_lastfallid);
    fscanf(d,"%lf", &d_lasta); 
    fscanf(d,"%lf", &d_lastb); 
    fscanf(d,"%lf", &d_alpha); 
    fscanf(d,"%ld", &l_koordsys); 
    fscanf(d,"%ld", &l_stabnummer); 
    fscanf(d,"%lf %lf", &anf, &end);
    
    if(Suche_Stab_Nm(l_stabnummer))  {
      tmp_streckenlast = Erzeuge_Streckenlast_Nm(l_lastfallid, l_id);
      
      sprintf((*tmp_streckenlast).c_name,"%s",c_name);	 
      (*tmp_streckenlast).l_lastfallid = l_lastfallid;
      (*tmp_streckenlast).d_lasta = d_lasta ;
      (*tmp_streckenlast).d_lastb = d_lastb;
      (*tmp_streckenlast).d_alpha = d_alpha;
      (*tmp_streckenlast).l_koordsys = l_koordsys; 
      (*tmp_streckenlast).l_stabnummer = l_stabnummer; 
      (*tmp_streckenlast).d_anf = anf;
      (*tmp_streckenlast).d_end = end;
	      	     
    }
    else  {
      Meldung("Stab existiert nicht !");
    }	 
  }
  
}


void Lese_FG_Relationen(FILE* d)
{
  TypFreiGrad *fg1,*fg2;
  long anz,i;
  long l1,l2;

  fscanf(d," %ld",&anz);
  

  for(i=0;i<anz;i++)  {
    fscanf(d,"%ld %ld",&l1,&l2);	  
    fg1 = Suche_FreiGrad(l1, Modell->KeFreiGrad_Nm);
    fg2 = Suche_FreiGrad(l2, Modell->KeFreiGrad_Nm);
    
    if(fg1 && fg2)	      
      Mng_PaarZufuegen(fg1, fg2, Modell->FG_Relation_Nm );
    else
      Meldung("Fehler bei FG Relation");
    
  }
}



/***********************************************************/ 
/* void Lese_Material()                                    */
/***********************************************************/ 
/*                                              
   Funktion liest die Materialien aus der Datei
   'material.dat'
   jh, 18.03.97
*/
/***********************************************************/

void Lese_Material(void)
{
  char pfad[200];
  FILE *d;
  TypMaterial *tmp_mat;
  long anz;
  long i;
  char c_tmp[255];

  sprintf(pfad, "%s/material.dat", c_matquer_pfad);

  if(!(d = fopen(pfad,"r"))) {
    sprintf(c_tmp,"Die Datei %s konnte nicht geffnet werden !",pfad);
    Meldung(c_tmp);
    Meldung("berprfen Sie die Pfadangaben in der Datei .xstab");
    return;
  }
  
  fscanf(d,"%ld",&standard_mat);
  fscanf(d,"%ld",&anz);

  for(i=0;i<anz;i++)  {
    tmp_mat = (TypMaterial*) calloc (1,sizeof(TypMaterial));
    
    fscanf(d,"%ld",&(*tmp_mat).l_id);
    fscanf(d," %s", (*tmp_mat).c_name);
    UnScanString( (*tmp_mat).c_name );
    fscanf(d,"%lf",&(*tmp_mat).d_E);
    fscanf(d,"%lf",&(*tmp_mat).d_mue);
    fscanf(d,"%lf",&(*tmp_mat).d_alpha);
    
    if(KeMaterial) {
      KeElementEintragen(tmp_mat,Nach,KeMaterial);
    }
    else {
      KeMaterial = KeKetteDefinieren();
      KeElementEintragen(tmp_mat,Nach,KeMaterial);
    }
  }
  
  fclose(d);
}



/***********************************************************/ 
/* void Lese_Querschnitte()                                */
/***********************************************************/ 
/*                                              
   Funktion liest die Querschnitte aus der Datei
   'querschnitte.dat'
   jh, 18.03.97
*/
/***********************************************************/

void Lese_Querschnitte(void)
{
  char pfad[200];
  FILE *d;
  TypQuerschnitt *tmp_quer;
  long anz;
  long i;
  char c_tmp[255];

  sprintf(pfad,"%s/querschnitte.dat",c_matquer_pfad);

  if(!(d = fopen(pfad,"r"))) {
    sprintf(c_tmp,"Die Datei %s konnte nicht geffnet werden !",pfad);
    Meldung(c_tmp);
    Meldung("berprfen Sie die Pfadangaben in der Datei .xstab");
    return;
  }
  
  fscanf(d,"%ld",&standard_quer);
  fscanf(d,"%ld",&anz);
  
  for(i=0;i<anz;i++) {
    tmp_quer = (TypQuerschnitt*) calloc (1,sizeof(TypQuerschnitt));

    fscanf(d,"%ld",&(*tmp_quer).l_id);
    fscanf(d," %s", (*tmp_quer).c_name);
    UnScanString( (*tmp_quer).c_name );

    fscanf(d,"%lf",&(*tmp_quer).d_A);
    fscanf(d,"%lf",&(*tmp_quer).d_Iz);
    fscanf(d,"%lf",&(*tmp_quer).d_maxy);      
      
    if(KeQuerschnitt) {
      KeElementEintragen(tmp_quer,Nach,KeQuerschnitt);
    }
    else {
      KeQuerschnitt = KeKetteDefinieren();
      KeElementEintragen(tmp_quer,Nach,KeQuerschnitt);
    }
  }
  
  fclose(d);

}



/*********************************************************************/
/* void Lese_Color(char *datei_name)                                 */
/*********************************************************************/ 
/*                                              
   Funktion liest Farbwerte ein
   jh, 07.04.97
*/
/*********************************************************************/

long Lese_Color(char *datei_name)
{
  FILE *d;
  char c_text[256];

  d = fopen(datei_name,"r");
  if(!d)  {
    sprintf(c_text,"Datei %s konnte nicht geffnet werden !",datei_name);
    Meldung(c_text);
    return 0;
  }

  fscanf(d,"%ld",&xs_color.fl_bg);                
  fscanf(d,"%ld",&xs_color.fl_fg);                
  fscanf(d,"%ld",&xs_color.fl_punkt);             
  fscanf(d,"%ld",&xs_color.fl_punkt_nr);          
  fscanf(d,"%ld",&xs_color.fl_stab);              
  fscanf(d,"%ld",&xs_color.fl_stab_select);       
  fscanf(d,"%ld",&xs_color.fl_stab_nr);           
  fscanf(d,"%ld",&xs_color.fl_freigrad_dual);     
  fscanf(d,"%ld",&xs_color.fl_freigrad_primal);   
  fscanf(d,"%ld",&xs_color.fl_streckenlast);      
  fscanf(d,"%ld",&xs_color.fl_punktlast);         
  fscanf(d,"%ld",&xs_color.fl_lager);             
  fscanf(d,"%ld",&xs_color.fl_normal);            
  fscanf(d,"%ld",&xs_color.fl_quer);              
  fscanf(d,"%ld",&xs_color.fl_moment);            
  fscanf(d,"%ld",&xs_color.fl_achsen);            
  fscanf(d,"%ld",&xs_color.fl_verschiebung);          
  fscanf(d,"%ld",&xs_color.fl_feder);  


  fclose(d);

  xs_color.bg              = fl_get_flcolor(xs_color.fl_bg);
  xs_color.fg              = fl_get_flcolor(xs_color.fl_fg);
  xs_color.punkt           = fl_get_flcolor(xs_color.fl_punkt);
  xs_color.punkt_nr        = fl_get_flcolor(xs_color.fl_punkt_nr);
  xs_color.stab            = fl_get_flcolor(xs_color.fl_stab);
  xs_color.stab_select     = fl_get_flcolor(xs_color.fl_stab_select);
  xs_color.stab_nr         = fl_get_flcolor(xs_color.fl_stab_nr);           
  xs_color.freigrad_dual   = fl_get_flcolor(xs_color.fl_freigrad_dual);     
  xs_color.freigrad_primal = fl_get_flcolor(xs_color.fl_freigrad_primal);   
  xs_color.streckenlast    = fl_get_flcolor(xs_color.fl_streckenlast);      
  xs_color.punktlast       = fl_get_flcolor(xs_color.fl_punktlast);         
  xs_color.lager           = fl_get_flcolor(xs_color.fl_lager);             
  xs_color.normal          = fl_get_flcolor(xs_color.fl_normal);            
  xs_color.quer            = fl_get_flcolor(xs_color.fl_quer);              
  xs_color.moment          = fl_get_flcolor(xs_color.fl_moment);            
  xs_color.achsen          = fl_get_flcolor(xs_color.fl_achsen);            
  xs_color.verschiebung    = fl_get_flcolor(xs_color.fl_verschiebung);      
  xs_color.feder           = fl_get_flcolor(xs_color.fl_feder);  
  
  return 1;

}



/*********************************************************************/
/* void Lese_Maszstab(char *pfad)                                    */
/*********************************************************************/ 
/*                                              
   Funktion liest die Mastbe eines Systems ein
   wenn die Datei nicht existiert, werden Standardwerte gesetzt
   jh, 28.04.97
*/
/*********************************************************************/

void Lese_Maszstab(char *pfad)
{
  char masspfad[255];
  char tmp[255];
  FILE *d;
  long unsigned i=0;

  /* Pfad ohne .sysdat bestimmen */
  for(i=0; i<strlen(pfad)-7; i++)
    tmp[i] = pfad[i];
  tmp[i] = '\0';

  sprintf(masspfad,"%s.massdat",tmp);

  d = fopen(masspfad,"r");
  
  if(!d) {
    sprintf(tmp,"Datei %s konnte nicht geladen werden ",masspfad);
    Meldung(tmp);
    /* Standardwerte setzen */  
    fl_set_positioner_xbounds(scale_form->posi,-0.2,1.2);
    fl_set_positioner_ybounds(scale_form->posi,-0.2,1.2);  

    fl_set_input(scale_form->input1,"50");   /* System         */
    fl_set_input(scale_form->input2,"20");   /* Verschiebung   */
    fl_set_input(scale_form->input3,"1");    /* Knotenlast     */
    fl_set_input(scale_form->input4,"1");    /* Elementlast    */
    fl_set_input(scale_form->input6,"1");    /* Schnittkraefte */
    fl_set_input(scale_form->hor_pos_input,"0");
    fl_set_input(scale_form->ver_pos_input,"0");

  }
  else {
    /* Werte einlesen */
    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->input1,tmp);
  
    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->input2,tmp);

    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->input3,tmp);

    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->input4,tmp);

    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->input6,tmp);

    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->hor_pos_input,tmp);

    fscanf(d,"%s",tmp);
    fl_set_input(scale_form->ver_pos_input,tmp);

    fclose(d);

  }   
}
