/*
  Datei     : Schreibe.c
  erstellt  : 07.07.96
  geaendert : 22.08.97
  Autor     : jh
*/
/*
  gendert  : 29.05.04, bha
  Bemerkung : einieg Leerzeilen beim Schreiben von *.sysdat eingefuegt,
                dass die *.sysdat uebersichtlicher ist und einfacher zu
                lesen ist.
  gendert  : 31.05.04, bha
  Bemerkung : void Schreibe_Maszstab(char *pfad)
                i als unsigned deklariert da sonst Compilerwarnung
                strlen liefert anscheind unsigned zurueck
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "XStabDek.h"


extern char* version;


void Schreibe_Maszstab(char *pfad);

void Schreibe_System(FILE* d);

void Schreibe_Lastfaelle(FILE *d);
void Schreibe_Punktlasten(FILE* d);
void Schreibe_Staebe(FILE* d);
void Schreibe_Streckenlasten(FILE* d);
void Schreibe_Punkte(FILE *d);
void Schreibe_FG_Relationen(FILE* d);
void Schreibe_Freiheitsgrade(FILE *d);
void Schreibe_LFKombinationen(FILE *d);


void save(void)
{
  char c_pfad[250];
  char *c_tmp;

  if(prg_status != 0) {	  	       
    if( strcmp(Modell->System.c_datei,"noname") == 0) {
      sprintf(c_pfad,"%s",c_projekte_pfad);   
      c_tmp = (char*) fl_show_fselector("Datei Name",c_pfad,"*.sysdat","");
      
      if(c_tmp)
	Schreibe(c_tmp);   
    }
    else
      Schreibe(Modell->System.c_datei);   	
  }
  else
    Meldung("System speichern nicht mglich !");
}


void save_as(void)
{ 
  char c_pfad[250];
  char *c_tmp;
  
 if(prg_status != 0) {
   sprintf(c_pfad,"%s",c_projekte_pfad);   
   c_tmp = (char*) fl_show_fselector("Datei Name",c_pfad,"*.sysdat","");
   
   if(c_tmp)
     Schreibe(c_tmp);   
 }
 else
   Meldung("System speichern nicht mglich !");
}


void Schreibe(char *pc_name)
{
  FILE *d;   
  char c_text[250];
  static char *ext=".sysdat";
  char datei[256];
  long length,i;

  sprintf(datei,"%s",pc_name);

  length = strlen(pc_name);
  for(i = length - 7; i < length; i++)
    if(ext[i-(length-7)] != pc_name[i]) {
      sprintf(datei,"%s.sysdat",pc_name);
      break;
    }

  d = fopen(datei,"w");
  
  if(!d) {
    Meldung("Fehler beim Schreiben !");
    return;
  }

  /* System schreiben */
  Schreibe_System(d);

  fclose(d);   

  sprintf(Modell->System.c_datei,"%s",datei); 
  sprintf(c_text,"%s geschrieben !",datei);
  Meldung(c_text);

  changeSystemChoice( Modell );
   
  /* Schreibe Mastab */
  Schreibe_Maszstab(datei);

  Modell->unsaved_changes = 0;

}


void Schreibe_System(FILE* d)
{ 
  /* Fileformat - Version schreiben */
  fprintf(d,"V 1\n");

  /* ...  System schreiben  ... */ 
  fprintf(d,"%ld\n", Modell->System.l_id); 
  fprintf(d,"\n\n\n\n");  

  /* Punkte schreiben */
  Schreibe_Punkte(d);

  /* Freiheitsgrade schreiben  */   
  Schreibe_Freiheitsgrade(d);
  
  /* Staebe schreiben */ 
  Schreibe_Staebe(d);

  /* FG Relationen */
  Schreibe_FG_Relationen(d);
   
  /* ...  Schreibe Lasten  ... */  
  Schreibe_Lastfaelle(d);

  Schreibe_Punktlasten(d);
  Schreibe_Streckenlasten(d);

  Schreibe_LFKombinationen(d);

}


void Schreibe_Punkte(FILE *d)
{
  long anz; 
  TypPunkt *tmp_punkt;
 
  KeGlied *p; 

  anz = 0;
  if(Modell->KePunkt_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm) {
      anz++;
    }
  
  fprintf(d," %ld\n",anz);
  fprintf(d,"\n");
  
  if(Modell->KePunkt_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm) {
      tmp_punkt = p->x;     
      fprintf(d," %ld",(*tmp_punkt).l_nummer);
      fprintf(d," %f %f\n",(*tmp_punkt).d_x,(*tmp_punkt).d_y);      
    }
  
  fprintf(d,"\n");
  fprintf(d,"\n");
  fprintf(d,"\n");
  fprintf(d,"\n");
  
}


void Schreibe_Freiheitsgrade(FILE *d)
{
  long anz; 
  TypFreiGrad *tmp_freigrad; 
  KeGlied *p; 


  anz = 0;
  if(Modell->KeFreiGrad_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeFreiGrad_Nm)
    {
      anz++;
    }

  fprintf(d," %ld\n",anz);
  fprintf(d,"\n");

  if(Modell->KeFreiGrad_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeFreiGrad_Nm) {
      tmp_freigrad = p->x;
      fprintf(d,"%ld",(*tmp_freigrad).l_nummer);     
      switch ((*tmp_freigrad).l_status)	{
      case CPmPrimal : 	
	fprintf(d," %s","P ");
	fprintf(d," %f",(*tmp_freigrad).d_verschiebung);
	break;
      case CPmDual :
	fprintf(d," %s","D ");
	fprintf(d," %f",0.);
	break;
      default :
	printf("Fehler beim Schreiben der Freiheitsgrade !\n");
	exit(1);
      }	  
      fprintf(d," %f\n",(*tmp_freigrad).d_alpha);  
      fprintf(d," %ld\n",(*tmp_freigrad).l_art);
      fprintf(d," %f\n",(*tmp_freigrad).d_feder);
    }
  
  fprintf(d,"\n");
  fprintf(d,"\n");
  fprintf(d,"\n");
  fprintf(d,"\n");
  fprintf(d,"\n");

}


void Schreibe_Staebe(FILE* d)
{
  long i,anz;
  TypPunkt *tmp_punkt;
  TypStab_Nm *tmp_stab;
  TypFreiGrad *tmp_freigrad; 
  KeGlied *p; 

  anz = 0;
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
      {
	anz++;
      }
  
  fprintf(d," %ld\n",anz);
  fprintf(d,"\n");          

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {      
      tmp_stab = p->x;
      fprintf(d," %ld\n", (*tmp_stab).l_nummer);

      /* Freiheitsgrade schreiben */
      for(i=0;i<6;i++)
	{
	  tmp_freigrad = (*tmp_stab).pe_frei[i];
	  fprintf(d," %ld",(*tmp_freigrad).l_nummer);
	}
      fprintf(d,"\n");
        
      /* Punktnummer schreiben */      
      tmp_punkt = (*tmp_stab).pe_punkta;
      fprintf(d," %ld ",(*tmp_punkt).l_nummer);
      tmp_punkt = (*tmp_stab).pe_punktb;
      fprintf(d," %ld\n",(*tmp_punkt).l_nummer);
	  
      /* Material, Querschnitt */
      fprintf(d," %ld\n",(*tmp_stab).l_matid);     
      fprintf(d," %ld\n",(*tmp_stab).l_querid);
    } 

  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          

}


void Schreibe_FG_Relationen(FILE* d)
{ 
  long i;
  TypFreiGrad *tmp_freigrad;
  Paar *paar;


  fprintf(d,"%d\n",Modell->FG_Relation_Nm->n);
  fprintf(d,"\n");          
  
  for(i=1;i<=Modell->FG_Relation_Nm->n;i++) {
    paar = Modell->FG_Relation_Nm->feld[i];
    tmp_freigrad = paar->a;
    fprintf(d,"%ld ",(*tmp_freigrad).l_nummer);
    
    tmp_freigrad = paar->b;
    fprintf(d," %ld \n",(*tmp_freigrad).l_nummer);	
  }
  
  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          
  fprintf(d,"\n");          

}



void Schreibe_Lastfaelle(FILE *d)
{
  long anz; 
  KeGlied *p; 
  TypLastfall* tmp_last; 
  Menge *M_aktiv;

  if(!Modell->KeLast) {
    fprintf(d," 0\n");
    return;
  }
 
  /* Menge definieren */
  M_aktiv = Mng_MengeDefinieren();
  
  /* Bestimmen d. aktiven Lastflle */
  HoleAktiveLastfaelle_Lastwahl(M_aktiv); 

  /* ...  Lastflle zhlen  ... */  
  anz = 0;  
  KeDurchlaufVorwaerts(p,Modell->KeLast)      
    anz++;      
  
  fprintf(d,"%ld\n",anz);
  fprintf(d,"\n");          
  
  KeDurchlaufVorwaerts(p,Modell->KeLast) {           	
    tmp_last = p->x;
    
    fprintf(d,"%ld\n",(*tmp_last).l_id);
    fprintf(d,"%f\n",(*tmp_last).d_gewicht);
    ScanString((*tmp_last).c_name);
    fprintf(d,"%s\n",(*tmp_last).c_name);
    
    /* Lastfall aktiv ? */
    if( Element_suchen((*tmp_last).l_id,M_aktiv) == 0 )
      fprintf(d,"-1\n");
    else
      fprintf(d,"1\n");
    
  }
  
  /* Menge der aktiven Lastflle lschen */  
  Mng_MengeUndElementeLoeschen(M_aktiv); 
  
  fprintf(d,"\n");        
  fprintf(d,"\n");        
  fprintf(d,"\n");        
  fprintf(d,"\n");        
  fprintf(d,"\n");        
}


void Schreibe_Punktlasten(FILE* d)
{
  long anz; 
  TypKnotenlast_Nm *tmp_punktlast;
  KeGlied *p; 
 
    
  anz=0;
  if(Modell->KePunktlast_Nm)
    KeDurchlaufVorwaerts(p, Modell->KePunktlast_Nm)      
      anz++;      
  
  fprintf(d,"%ld\n",anz);
  fprintf(d,"\n"); 
  
  if(Modell->KePunktlast_Nm)
    KeDurchlaufVorwaerts(p, Modell->KePunktlast_Nm) {
      tmp_punktlast = p->x;
      
      fprintf(d,"%ld\n", (*tmp_punktlast).l_id);
      fprintf(d,"%ld\n", (*tmp_punktlast).l_lastfallid);
      ScanString((*tmp_punktlast).c_name);
      fprintf(d,"%s\n",  (*tmp_punktlast).c_name); 	 
      fprintf(d,"%f\n",  (*tmp_punktlast).d_last); 	 
      fprintf(d,"%ld\n", (*tmp_punktlast).l_stabnummer);
      fprintf(d,"%f\n",  (*tmp_punktlast).d_alpha); 	 
      fprintf(d,"%ld\n", (*tmp_punktlast).l_koordsys_winkel);
      fprintf(d,"%ld\n", (*tmp_punktlast).l_koordsys_pos);
	  fprintf(d,"%f\n",  (*tmp_punktlast).d_pos);
      fprintf(d,"%ld\n", (*tmp_punktlast).l_art);
      fprintf(d,"\n");
      
    }  

    fprintf(d,"\n"); 
    fprintf(d,"\n"); 

}


void Schreibe_Streckenlasten(FILE* d)
{
  long anz; 
  TypStreckenlast_Nm *tmp_streckenlast;
  KeGlied *p; 

  anz=0;
  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm)      
      anz++;	        
  
  fprintf(d,"%ld\n",anz);
  fprintf(d,"\n"); 
  
  if(Modell->KeStreckenlast_Nm)
    KeDurchlaufVorwaerts(p, Modell->KeStreckenlast_Nm) {
      tmp_streckenlast = p->x;
      ScanString((*tmp_streckenlast).c_name);
      fprintf(d,"%s\n", (*tmp_streckenlast).c_name);
      fprintf(d,"%ld\n", (*tmp_streckenlast).l_id);
      fprintf(d,"%ld\n", (*tmp_streckenlast).l_lastfallid);
      fprintf(d,"%f\n", (*tmp_streckenlast).d_lasta); 
      fprintf(d,"%f\n", (*tmp_streckenlast).d_lastb); 
      fprintf(d,"%f\n", (*tmp_streckenlast).d_alpha);
      fprintf(d,"%ld\n", (*tmp_streckenlast).l_koordsys);
      fprintf(d,"%ld\n", (*tmp_streckenlast).l_stabnummer);
      fprintf(d,"%f %f\n", (*tmp_streckenlast).d_anf, (*tmp_streckenlast).d_end);		 
      fprintf(d,"\n"); 
    }

    fprintf(d,"\n"); 
    fprintf(d,"\n"); 
    fprintf(d,"\n"); 
    fprintf(d,"\n"); 

}



/*********************************************************************/
/* void Schreibe_LFKombinationen(FILE *d                             */
/*********************************************************************/
/*                                              
   Fkt schreibt LF Kombinationen 
   jh, 23.08.97
*/
/*********************************************************************/

void Schreibe_LFKombinationen(FILE *d)
{
  long anz=0,j;
  TypLastfallkombination* tmp_lfkomb;
  TypLFKomb *tmp_komb;
  KeGlied* p;

  Menge *M=NULL;

  anz = 0;
  if(Modell->KeLfKombination)
    KeDurchlaufVorwaerts(p,Modell->KeLfKombination)
    {
      anz++;
    }
    
  fprintf(d,"%ld\n\n",anz);

  if(Modell->KeLfKombination)
    KeDurchlaufVorwaerts(p,Modell->KeLfKombination) {
    
    tmp_lfkomb = p->x;

    fprintf(d,"%ld\n", tmp_lfkomb->l_id);   
   
    ScanString(tmp_lfkomb->c_name);
    fprintf(d,"%s\n",tmp_lfkomb->c_name);      

    M = tmp_lfkomb->LFKomb;

    fprintf(d,"%d\n",M->n);
    
    for(j=1;j<=M->n;j++) {

      tmp_komb = M->feld[j];

      fprintf(d,"%ld %f\n", tmp_komb->l_id, tmp_komb->d_gewicht);

    }

  }

}



/*****************************************************************/
void Schreibe_Material(void)
{
  KeGlied *p;
  char pfad[200];
  FILE *d;
  TypMaterial *tmp_mat;
  long anz;
 
  sprintf(pfad,"%s/material.dat",c_matquer_pfad);

  d = fopen(pfad,"w");

  anz=0;
  if(KeMaterial)
    KeDurchlaufVorwaerts(p,KeMaterial)    
      anz++;    

  fprintf(d,"%ld\n",standard_mat);
  fprintf(d,"%ld\n",anz);
  
  if(KeMaterial)
    KeDurchlaufVorwaerts(p,KeMaterial)  {
      tmp_mat = p->x;

      fprintf(d,"%ld\n",(*tmp_mat).l_id);
      ScanString((*tmp_mat).c_name);
      fprintf(d," %s\n",(*tmp_mat).c_name);
      fprintf(d,"%e\n",(*tmp_mat).d_E);
      fprintf(d,"%f\n",(*tmp_mat).d_mue);
      fprintf(d,"%f\n",(*tmp_mat).d_alpha);
    
    }
  fclose(d);
}


void Schreibe_Querschnitte(void)
{
  KeGlied *p;
  char pfad[200];
  char c_tmp[255];
  FILE *d;
  TypQuerschnitt *tmp_quer;
  long anz; 

  sprintf(pfad,"%s/querschnitte.dat",c_matquer_pfad);

  d = fopen(pfad,"w");

  if(!d) {
    sprintf(c_tmp,"Datei %s konnte nicht geschrieben werden",pfad);
    Meldung(c_tmp);
    return;
  }
    
  anz=0;
  if(KeQuerschnitt)
    KeDurchlaufVorwaerts(p,KeQuerschnitt)    
      anz++;

  fprintf(d,"%ld\n",standard_quer);
  fprintf(d,"%ld\n",anz);

  if(KeQuerschnitt)
    KeDurchlaufVorwaerts(p,KeQuerschnitt) {
      tmp_quer = p->x;

      fprintf(d,"%ld\n",(*tmp_quer).l_id);
      ScanString((*tmp_quer).c_name);
      fprintf(d," %s\n",(*tmp_quer).c_name);
      fprintf(d,"%e\n",(*tmp_quer).d_A);
      fprintf(d,"%e\n",(*tmp_quer).d_Iz);
      fprintf(d,"%f\n",(*tmp_quer).d_maxy);      
     
    }

  fclose(d);

}



/***********************************************************/ 
/* void Schreibe_Color(char *datei_name)                   */
/***********************************************************/ 
/*                                              
   Funktion schreibt Farbwerte 
   jh, 07.04.97
*/
/***********************************************************/

void Schreibe_Color(char *datei_name)
{
  FILE *d;
  char c_text[256];

  d = fopen(datei_name,"w");
  
  if(!d) {
    sprintf(c_text,"Datei %s konnte nicht geffnet werden !", datei_name);
    Meldung(c_text);
    return;
  }
  
  fprintf(d,"%ld\n",xs_color.fl_bg);                
  fprintf(d,"%ld\n",xs_color.fl_fg);                
  fprintf(d,"%ld\n",xs_color.fl_punkt);             
  fprintf(d,"%ld\n",xs_color.fl_punkt_nr);          
  fprintf(d,"%ld\n",xs_color.fl_stab);              
  fprintf(d,"%ld\n",xs_color.fl_stab_select);       
  fprintf(d,"%ld\n",xs_color.fl_stab_nr);           
  fprintf(d,"%ld\n",xs_color.fl_freigrad_dual);     
  fprintf(d,"%ld\n",xs_color.fl_freigrad_primal);   
  fprintf(d,"%ld\n",xs_color.fl_streckenlast);      
  fprintf(d,"%ld\n",xs_color.fl_punktlast);         
  fprintf(d,"%ld\n",xs_color.fl_lager);             
  fprintf(d,"%ld\n",xs_color.fl_normal);            
  fprintf(d,"%ld\n",xs_color.fl_quer);              
  fprintf(d,"%ld\n",xs_color.fl_moment);            
  fprintf(d,"%ld\n",xs_color.fl_achsen);            
  fprintf(d,"%ld\n",xs_color.fl_verschiebung);
  fprintf(d,"%ld\n",xs_color.fl_feder);

  fclose(d);     
  
  Meldung("Farben geschrieben.");
}



/*********************************************************************/
/* void Schreibe_Maszstab(char *pfad)                                */
/*********************************************************************/ 
/*                                              
   Funktion schreibt die Mastbe eines Systems 
   jh, 28.04.97
*/
/*********************************************************************/

void Schreibe_Maszstab(char *pfad)
{
  char masspfad[255];
  char *c_tmp,c_tmp2[255];
  FILE *d;
  long unsigned i=0;

  /* Pfad ohne .sysdat bestimmen */
  for(i=0; i<strlen(pfad)-7; i++)
    c_tmp2[i] = pfad[i];
  c_tmp2[i] = '\0';

  sprintf(masspfad,"%s.massdat",c_tmp2);

  if(!(d = fopen(masspfad,"w"))) {
    sprintf(c_tmp2,"Mastab konnte nicht geschrieben werden ! [%s]",masspfad);
    Meldung(c_tmp2);
    return;
  }


  /* Werte schreiben */
  c_tmp = (char*) fl_get_input(scale_form->input1); 
  fprintf(d,"%s\n",c_tmp);
 
  c_tmp = (char*) fl_get_input(scale_form->input2); 
  fprintf(d,"%s\n",c_tmp);
    
  c_tmp = (char*) fl_get_input(scale_form->input3); 
  fprintf(d,"%s\n",c_tmp);

  c_tmp = (char*) fl_get_input(scale_form->input4); 
  fprintf(d,"%s\n",c_tmp);
 
  c_tmp = (char*) fl_get_input(scale_form->input6); 
  fprintf(d,"%s\n",c_tmp);
    
  c_tmp = (char*) fl_get_input(scale_form->hor_pos_input); 
  fprintf(d,"%s\n",c_tmp);

  c_tmp = (char*) fl_get_input(scale_form->ver_pos_input); 
  fprintf(d,"%s\n",c_tmp);
   
  fclose(d);

}   

