/*
  Datei     : main.c
  erstellt  : 25.06.96
  geaendert : 22.08.97
  Autor     : jh
  Bemerkung :
*/
/*
  geaendert : 31.05.04, bha
  Bemerkung : - setlocale( LC_ALL, "C" ); --> geht aber nicht
                 setenv( "LANG", "C", 1 ) direkt nach int main()
                 ueberschreibt brutal die Umgebungsvariablen fuer die Programmausfuehrung 
                 (Komma-Punkt-Problem) 
              - void main(...) --> int main(...) 
                  und return(0) ans Ende von int main() sonst compiler warnung
*/
/*
  geaendert : 07.06.04, bha
  Bemerkung : - setlocale( LC_NUMERIC, "C" )
              - funktioniert mit aktuellster xform 1.0.90 aus Internet 
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#define XS_MAIN

  
#include "XStabDek.h"
#include <locale.h>    /* dort ist funktion setlocale definiert */


/* ...  ressourcen.c  ... */
extern void set_res(void);


/* ...  initmain.c  ... */
extern void initmain_grafik(void);
extern void initmain_grafikenv(void);
extern void initmain_env(void);
extern void initmain_buttons(void);
extern void initmain_form(void);
extern void initmain_menu(void);
extern void initmain_info(void);


char *version="1.3.1.";


int main(int argc,char *argv[])
{      

  fl_initialize(&argc,argv,version,0,0);  
  
  setlocale( LC_NUMERIC, "C" );


#ifdef _TOOLTIPS_
  tooltips_initialize(); 
#endif

  /* ...  Fenster erzeugen  ... */

  form                    = create_form_mainform();
  rasterform              = create_form_einstellung_raster();
  stabeditform            = create_form_stab_edit();
  freigradform            = create_form_freigrad();
  lastfallform            = create_form_lastfall(); 
  lastfalleditform        = create_form_lastedit();
  lastkopierenform        = create_form_copyLoad();
  infoform                = create_form_infoform();
  inputform               = create_form_inputform();
  staberzeugenform        = create_form_staberzeugen(); 
  warnungform             = create_form_warnung();
  schnittform             = create_form_schnittkraefte();
  querschnittform         = create_form_querschnittform();
  materialform            = create_form_materialform();
  materialeditform        = create_form_materialeditform();

  tab_punkte_form         = create_form_tab_punkte();
  tab_staebe_form         = create_form_tab_staebe();

  export_form             = create_form_export();
  ps_form                 = create_form_ps_opt_form();
  pfade_form              = create_form_pfade();

  prozessor_form          = create_form_prozessor();
  verschieben_form        = create_form_verschieben();
  punkterzeugen_form      = create_form_punkterzeugen();


  /* ...  Fenster - Buttons im Hauptfenster  ... */

  control_form                  = create_form_control();
  scale_form                    = create_form_scale();
  lastfallbrowserform           = create_form_lastfallwahl();
  drawcontrol_preferences_form  = create_form_drawcontrol_preferences();
  drawcontrol_system_form       = create_form_drawcontrol_system();
  color_form                    = create_form_color(); 

  
  /* ...  Umgebung initialisieren  ... */
 
  initmain_env(); 


  /* ...  Ressourcen setzen  ... */

  set_res();
  
  /* ...  Initialisierung  ... */
   
  initmain_form();  
  initmain_menu();
  initmain_info();
  initmain_grafik();
  initmain_grafikenv();

  initmain_buttons(); 

  if( argc > 1)
    Lese(argv[1]);

  /* ...  Steuerung an XForms bergeben  ... */

  fl_do_forms();

  return(0);
}

