/*
  Datei     : mat_cb.c
  erstellt  : 24.08.96
  geaendert : 11.06.97
  geaendert : 22.01.98 von as
  Autor     : jh
*/


#include "XStabDek.h"


void material_browser_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypMaterial *tmp_mat;
  char c_text[100];

  nummer = Hole_MaterialID();
  if(nummer == -1)
    return;

  tmp_mat = Suche_Material(nummer);

  if(tmp_mat) {
    sprintf(c_text,"%ld",(*tmp_mat).l_id);      
    fl_set_object_label(materialform->material_id_text,c_text);
    
    sprintf(c_text,"%.3e",(*tmp_mat).d_E);      
    fl_set_input(materialform->material_emodul_input,c_text);
    
    sprintf(c_text,"%.3f",(*tmp_mat).d_mue);      
    fl_set_input(materialform->material_mue_input,c_text);
    
    sprintf(c_text,"%.3f",(*tmp_mat).d_alpha);      
    fl_set_input(materialform->material_alpha_input,c_text);
    
    sprintf(c_text,"%s",(*tmp_mat).c_name);      
    fl_set_input(materialform->material_name_input,c_text);
  }
  else {        
    sprintf(c_text,"%s","###");      
    fl_set_object_label(materialform->material_id_text,c_text);          
    fl_set_input(materialform->material_emodul_input,c_text);         
    fl_set_input(materialform->material_mue_input,c_text);           
    fl_set_input(materialform->material_alpha_input,c_text);          
    fl_set_input(materialform->material_name_input,c_text);
    
  }
}


void material_uebernehmen_button_cb(FL_OBJECT *obj, long arg)
{
  char *c_tmp;
  char c_text[100];
  long nummer;
  long i;
  TypMaterial *tmp_mat;

  nummer = Hole_MaterialID();
  if(nummer == -1)
    return;

  tmp_mat = Suche_Material(nummer);
  
  if(tmp_mat) {

    c_tmp = (char*) fl_get_input( materialform->material_name_input );
    sprintf((*tmp_mat).c_name,"%s",c_tmp);
    
    c_tmp = (char*) fl_get_input(materialform->material_emodul_input);      
    (*tmp_mat).d_E = atof(c_tmp);    
    
    c_tmp = (char*) fl_get_input(materialform->material_mue_input);
    (*tmp_mat).d_mue = atof(c_tmp);
    
    c_tmp = (char*) fl_get_input(materialform->material_alpha_input);
    (*tmp_mat).d_alpha = atof(c_tmp);     
    
    sprintf(c_text,"%10ld  %s", (*tmp_mat).l_id, (*tmp_mat).c_name);
    
    for(i=1;i<= fl_get_browser_maxline(materialform->material_browser);i++) {
      if(fl_isselected_browser_line(materialform->material_browser,i)) {
	fl_replace_browser_line(materialform->material_browser,i,c_text);
	break;
      }
    }
  }
}

/* Material Erzeugen                                     */
/* Funktion liest Werte aus den Input-Feldern und        */
/* erstellt ein neues Material                           */
/* gendert von as am 22.01.98                           */
void material_erzeugen_button_cb(FL_OBJECT *obj, long arg)
{
  TypMaterial *tmp_mat;
  char *c_tmp;
  char c_text[100];

  tmp_mat = Erzeuge_Material();

  c_tmp = (char*) fl_get_input( materialform->material_name_input );
  sprintf((*tmp_mat).c_name,"%s",c_tmp);
    
  c_tmp = (char*) fl_get_input(materialform->material_emodul_input);      
  (*tmp_mat).d_E = atof(c_tmp);    
  
  c_tmp = (char*) fl_get_input(materialform->material_mue_input);
  (*tmp_mat).d_mue = atof(c_tmp);
  
  c_tmp = (char*) fl_get_input(materialform->material_alpha_input);
  (*tmp_mat).d_alpha = atof(c_tmp);     
  
  sprintf(c_text,"%10ld  %s",(*tmp_mat).l_id,(*tmp_mat).c_name);
  
  if(KeMaterial) {
    KeElementEintragen(tmp_mat,Nach,KeMaterial);
  }
  else {
    KeMaterial = KeKetteDefinieren();
    KeElementEintragen(tmp_mat,Nach,KeMaterial);
  }

  if(fl_get_browser_maxline(materialform->material_browser))
    fl_insert_browser_line(materialform->material_browser,1,c_text);
  else
    fl_add_browser_line(materialform->material_browser,c_text);   
  
}


void material_loeschen_button_cb(FL_OBJECT *obj, long arg)
{  
  TypMaterial *tmp_mat;
  long nummer;
  KeGlied *p;

  nummer = Hole_MaterialID();
    
  if(KeMaterial)
    KeDurchlaufVorwaerts(p,KeMaterial)  {
    tmp_mat = p->x;
    if((*tmp_mat).l_id == nummer) {
      KeGliedAustragen(p);
      free(tmp_mat);
      break;
    }
  }
    
    SetzeWerte_Material();
    
}


void material_ok_button_cb(FL_OBJECT *obj, long arg)
{
  fl_hide_form(materialform->materialform);
  Zeichne();
}


