/*
   Datei     : pfade.c
   erstellt  : 24.03.97
   geaendert : as am 07.02.98
   Autor     : jh
*/
/*
   geaendert : 29.05.04, bha
   Bemerkungen: in funktion void createPath(void)
                    - zwei zeilenumbrueche in strings entfernt
                    - Variable c_xstab hinzugefuegt sowie zugehoerig
                    - sprintf(...   und    fl_set_input(...    erstellt
*/
/*
   geaendert : 07.6.04, bha
   Bemerkungen: in funktion void createPath(void)
                    - tooltip ergaenzt            
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "XStabDek.h"
#include "guipfadeerzeugen.h"


void createPath(void);

FD_pfadeerzeugen * pfform;


/***********************************************************/ 
/* void set_path_form(void)                                */
/***********************************************************/ 
/*                                              
   Funktion schreibt die Pfade in der Form 'pfadeform'
   jh, 24.03.97
*/
/***********************************************************/

void set_path_form(void)
{ 
  fl_set_object_label(pfade_form->pfade_home_text,c_home);
  fl_set_input(pfade_form->pfade_xstab_input,c_install_pfad);    
  fl_set_input(pfade_form->pfade_matquer_input,c_matquer_pfad);  
  fl_set_input(pfade_form->pfade_projekte_input,c_projekte_pfad); 
  fl_set_input(pfade_form->pfade_tmp_input,c_tmp_pfad); 
  fl_set_input(pfade_form->pfade_htmlbrowser_input,c_hilfebrowser); 
  fl_set_input(pfade_form->pfade_psviewer_input,c_psviewer);
}



/***********************************************************/ 
/* void zeige_pfade(void)                                  */
/***********************************************************/ 
/*                                              
   Funktion zeigt die Form 'pfadeform'
   jh, 24.03.97
*/
/***********************************************************/

void zeige_pfade(void)
{
  fl_show_form(pfade_form->pfade,
	       FL_PLACE_CENTER,FL_TRANSIENT,"Pfade"); 
  /* Pfade in die Form schreiben */
  set_path_form(); 
}



/*********************************************************************/
/* void set_path(void)                                               */
/*********************************************************************/
/*                                              
   Funktion liest die Datei '.xstab', die in $HOME
   stehen mu und setzt die Pfade in der Form 'pfadeform'
   jh, 24.03.97
*/
/*********************************************************************/

void set_path(void)
{
  FILE* dat;
  char pfad[240];

  c_home = getenv("HOME");
  sprintf(pfad,"%s/.xstab", c_home);
  

  /*  die Datei '.xstab' mu im home-verzeichnis vorhanden sein  */

  if(!(dat = fopen(pfad,"r"))) {       

    /* no .xstab found -> create it ! */
    createPath();

  }
  

  fscanf(dat, "%s", c_install_pfad);
  sprintf(c_verwaltung_pfad, "%s/verwaltung", c_install_pfad);
  fscanf(dat, "%s", c_matquer_pfad);
  fscanf(dat, "%s", c_projekte_pfad);
  fscanf(dat, "%s", c_tmp_pfad);
  fscanf(dat, "%s", c_hilfebrowser);
  fscanf(dat, "%s", c_psviewer);

  fclose(dat);
 
}



/***********************************************************/ 
/* void save_path(void)                                    */
/***********************************************************/ 
/*                                              
   Funktion schreibt die Datei '.xstab' in $HOME'  
   Funktion erstellt die notwendigen Verzeichnisse
   jh, 24.03.97
   gendert am 05.02.98 von as
*/
/***********************************************************/

void save_path(void)
{
  FILE* dat;
  char pfad[240];
  char c_text[200];
  
  c_home = getenv("HOME");
  sprintf(pfad,"%s/.xstab",c_home);
  
  if(!(dat = fopen(pfad,"w"))) {
    sprintf(c_text,">> Fehler beim Schreiben von '.xstab' in '%s'!\n",c_home);
    Meldung(c_text);
  }
  
  fprintf(dat, "%s\n", c_install_pfad);
  fprintf(dat, "%s\n", c_matquer_pfad);
  fprintf(dat, "%s\n", c_projekte_pfad);
  fprintf(dat, "%s\n", c_tmp_pfad);
  fprintf(dat, "%s\n", c_hilfebrowser);
  fprintf(dat, "%s\n", c_psviewer);

  fclose(dat); 

  /* neue Verzeichnisse anlegen wenn noch nicht vorhanden */
  /* hinzugefgt von as am 06.02.98                       */
  createDirectory(c_matquer_pfad);
  createDirectory(c_projekte_pfad);
  createDirectory(c_tmp_pfad);
  
  Meldung("Pfade geschrieben und Verzeichnisse erstellt");  
}



/***********************************************************/ 
/* void pfade_uebernehmen(void)                            */
/***********************************************************/ 
/*                                              
   Funktion bernimmt die in der form 'pfade_form'
   angegebenen Pfade in die globalen char[]
   jh, 24.03.97
*/
/***********************************************************/

void pfade_uebernehmen(void)
{
  sprintf(c_install_pfad,"%s",fl_get_input(pfade_form->pfade_xstab_input));
  sprintf(c_matquer_pfad,"%s",fl_get_input(pfade_form->pfade_matquer_input));
  sprintf(c_projekte_pfad,"%s",fl_get_input(pfade_form->pfade_projekte_input)); 
  sprintf(c_tmp_pfad,"%s",fl_get_input(pfade_form->pfade_tmp_input)); 
  sprintf(c_hilfebrowser,"%s",fl_get_input(pfade_form->pfade_htmlbrowser_input)); 
  sprintf(c_psviewer,"%s",fl_get_input(pfade_form->pfade_psviewer_input));
}



/*********************************************************************/
/*  void createPath(void)                                            */
/*********************************************************************/ 
/*                                              
   die Datei .xstab wurde nicht gefunden, also mu die Datei
   angelegt werden
   jh, 14.10.97
   gendert am 07.02.98 von as
*/
/*********************************************************************/

void createPath(void)
{ 
  char c_xstab[50];
  char c_matquer[50];
  char c_projekte[50];
  char c_tmp[50];
  
  char* c_htmlBrowser = {"mozilla"};
  char* c_psViewer = {"gv"};
 

  /*  Fenster erzeugen, in diesem Fenster gibt der Benutzer
      die Pfade an, die in die datei '.xstab' bernommen 
      werden sollen  */

  pfform = (FD_pfadeerzeugen*) create_form_pfadeerzeugen();


#ifdef _TOOLTIPS_

  tooltips_addtip(pfform->pfade_xstab_input,
		  "In welchem Verzeichnis ist XStab installiert? (Dies ist u.a. fuer die richtige Anzeige der Icon wichtig.)");  
  tooltips_addtip(pfform->pfade_matquer_input,
		  "In welchem Verzeichnis stehen die Dateien\n material.dat und querschnitte.dat ?");
  tooltips_addtip(pfform->pfade_projekte_input,
		  "In welchem Verzeichnis werden Ihre Projekte gespeichert ?");
  tooltips_addtip(pfform->pfade_tmp_input,
		  "In diesem Verzeichnis legt XStab die temporren Dateien an, die zur Ausgabe gebraucht werden.");
  tooltips_addtip(pfform->pfade_htmlbrowser_input,
		  "Mit welchem Programm knnen HTML-Dateien betrachtet werden ?");
  tooltips_addtip(pfform->pfade_psviewer_input,
		  "Mit welchem Programm knnen PostScript-Dateien betrachtet werden ?");

#endif


  fl_set_object_label(pfform->pfade_home_text, c_home);
 
  sprintf(c_xstab, "%s/XStab", c_home);
  sprintf(c_matquer, "%s/XStab/verwaltung", c_home);
  sprintf(c_projekte, "%s/XStab/projekte", c_home);
  sprintf(c_tmp, "%s/XStab", c_home);

  fl_set_input(pfform->pfade_xstab_input, c_xstab);
  fl_set_input(pfform->pfade_matquer_input, c_matquer);
  fl_set_input(pfform->pfade_projekte_input, c_projekte);
  fl_set_input(pfform->pfade_tmp_input, c_tmp);
  fl_set_input(pfform->pfade_htmlbrowser_input, c_htmlBrowser);
  fl_set_input(pfform->pfade_psviewer_input, c_psViewer);


  fl_show_form(pfform->pfadeerzeugen,
	       FL_PLACE_CENTER,FL_TRANSIENT,"Pfade"); 


  /*  an dieser Stelle mu die Steuerung 
      an die xforms bergeben werden  */

  fl_do_forms();
 
}



/*********************************************************************/
/*  void createDirectoy(char* newDir)                                */
/*********************************************************************/
/*                                              
   Function creates directory if it does not exist already
   as, 06.02.98
*/
/*********************************************************************/

void createDirectory(char* newDir) 
{
  char c_dir[50];
  char c_text[200];
  int i;
  int i_length;

  i_length = strlen(newDir);

  if(i_length < 50)

    for(i=0;i<=i_length;i++) {
      c_dir[i] = newDir[i];

      if((c_dir[i] == '/') || (i == i_length)) {
	c_dir[i+1] = '\0';
	
	/* try to open directory */
	if(!opendir(c_dir)) {
	  errno=0;
	  
	  /* create directory */
	  mkdir(c_dir,0040777);

	  if(errno != 0) {
	    fprintf(stderr,"Versuch %s zu erstellen\n  ",c_dir);
	    perror("Fehlermeldung");
	    sprintf(c_text,">> Fehler beim Erstellen von '%s'!\n!",c_dir); 
	    Meldung(c_text); 
	    return;
	  }

	}

      }
    }

}

