/*
   Datei     : pfade_cb.c
   erstellt  : 24.03.97
   gendert  : 14.10.97
               08.02.98, jh
   Autor     : jh
*/


#include "XStabDek.h"
#include "guipfadeerzeugen.h"

extern FD_pfadeerzeugen *pfform;


/* ...  ressourcen.c  ... */
extern void set_res(void);


/* ...  initmain.c  ... */
extern void init_color(void);
extern void initmain_grafik(void);
extern void initmain_grafikenv(void);
extern void initmain_env(void);
extern void initmain_buttons(void);
extern void initmain_form(void);
extern void initmain_menu(void);
extern void initmain_info(void);



/***********************************************************/ 
/* void pfade_sichern_button_cb(FL_OBJECT *obj, long arg)  */
/***********************************************************/ 
/*                                              
   
   jh, 24.03.97
*/
/***********************************************************/

void pfade_sichern_button_cb(FL_OBJECT *obj, long arg)
{
  pfade_uebernehmen();
  save_path();
}



/***********************************************************/ 
/* void pfade_ok_button_cb(FL_OBJECT *obj, long arg)       */
/***********************************************************/ 
/*                                              
  
   jh, 25.03.97
*/
/***********************************************************/

void pfade_ok_button_cb(FL_OBJECT *obj, long arg)
{
  fl_hide_form(pfade_form->pfade);
  pfade_uebernehmen();
  Zeichne();
}



void pfadeerzeugen_abbrechen_button_cb(FL_OBJECT *obj, long arg)
{
  exit(0);
}



/*********************************************************************/
/* void pfadeerzeugen_ok_button_cb(FL_OBJECT *obj, long arg)         */
/*********************************************************************/
/*                                              
   cb - fkt
   die eingegebenen Pfade werden bernommen und das Programm
   wird gestartet
   jh, 08.02.98
*/
/*********************************************************************/

void pfadeerzeugen_ok_button_cb(FL_OBJECT *obj, long arg)
{
  char von[255]; 
  pid_t pid;

  sprintf(c_install_pfad,"%s", 
	  fl_get_input(pfform->pfade_xstab_input));

  sprintf(c_verwaltung_pfad, "%s/verwaltung", c_install_pfad);

  sprintf(c_matquer_pfad, "%s", 
	  fl_get_input(pfform->pfade_matquer_input));
  sprintf(c_projekte_pfad, "%s",
	  fl_get_input(pfform->pfade_projekte_input)); 
  sprintf(c_tmp_pfad, "%s",
	  fl_get_input(pfform->pfade_tmp_input)); 
  sprintf(c_hilfebrowser, "%s",
	  fl_get_input(pfform->pfade_htmlbrowser_input)); 
  sprintf(c_psviewer, "%s",
	  fl_get_input(pfform->pfade_psviewer_input));


  save_path();

  /*  systemweite Materialen und Querschnitte in das Verzeichnis
      des Benutzeres kopieren  */
  
  if(pid = fork()) {

    sprintf(von, "%s/material.dat", c_verwaltung_pfad);    
    execlp("cp","cp", von, c_matquer_pfad, 0);   

  }

  waitpid(pid, NULL, 0);

  if(pid = fork()) {

    sprintf(von, "%s/querschnitte.dat", c_verwaltung_pfad);
    execlp("cp","cp", von, c_matquer_pfad, 0);
    
  }

  waitpid(pid, NULL, 0);
  

  /*  Standardfarben kopieren  */

  if(pid = fork()) {
    
    sprintf(von, "%s/standard.col", c_verwaltung_pfad);    
    execlp("cp","cp", von, c_matquer_pfad, 0);
    
  }

  waitpid(pid, NULL, 0);

  /*  hier wird die Initialisierung fortgesetzt
      die durch die nicht vorhandene '.xstab' unterbrochen
      wurde  */


  /* Material einlesen */
  Lese_Material();
  
  
  /* Querschnitte einlesen */
  Lese_Querschnitte();    
  
  
  /* nur hier wird nicht die Methode benutzt !! , sonst SegFault */
  prg_status = 0;  

  fl_set_fselector_placement(FL_PLACE_CENTER); 

  /*  Standardfarben initialisieren  */

  init_color();


  /* ...  Ressourcen setzen  ... */

  set_res();
  
  /* ...  Initialisierung  ... */
  
  initmain_form();  
  initmain_menu();
  initmain_info();
  initmain_grafik();
  initmain_grafikenv();
  
  initmain_buttons(); 
 
  fl_hide_form(pfform->pfadeerzeugen);
  fl_free_form(pfform->pfadeerzeugen);

  free(pfform);

}
