/*
  Datei     : nachlauf.c
  erstellt  : 
  geaendert : 
  Autor     : jh,pl
*/
 

#include "XStabDek.h"


void Nachlauf(void)
{
  TypMaterial *mat;
  TypQuerschnitt *quer;
  TypStab_Km*  tmp_stab;                   
  KeGlied*  p;                       
 
  double alpha_stab=0,alpha1=0,alpha2=0;

  double    l;                         /* Laenge des Stabes .............*/
  double    E;                         /* E-Modul des Stabes ............*/
  double    A;                         /* Flaeche des Stabes ............*/
  double    I;                         /* Flaechentraegheitsmoment ......*/
  double    dpa,dpe;                   /* lin. Streckenlast senkr. Achse */
  double    dna,dne;                   /* lin. Streckenlast in Achsricht.*/
  int       j,k;                       /* Schleifen-Indizes .............*/
  double    elesteif[6][6];            /* Elementsteifigkeitsmatrix .....*/
  double    u[6];                      /* globaler Verschiebungs-Vektor .*/
  double    v[6];                      /* lokaler Verschiebungs-Vektor ..*/
  double    q[6];                      /* lokaler Last-Vektor ...........*/
  double    l2,l3,h[6];

  KeDurchlaufVorwaerts(p,Modell->KeStab_Km) {
    tmp_stab = p->x;          
    alpha_stab = (*tmp_stab).d_alpha;

    l     = tmp_stab->d_laenge;

    mat = Suche_Material( (*tmp_stab).l_matid );
    E     = (*mat).d_E;
    
    quer = Suche_Querschnitt( (*tmp_stab).l_querid );
    A     = (*quer).d_A;
    I     = (*quer).d_Iz;

    dna    = tmp_stab->d_lastn_a;
    dne    = tmp_stab->d_lastn_b;
    dpa    = tmp_stab->d_lastp_a;
    dpe    = tmp_stab->d_lastp_b;

    l2 = l*l;     
    l3 = l*l*l;

    /* hole globale Verschiebungen ...*/
    for( k=0; k<6; k++ ) {
      u[k] = tmp_stab->pe_frei[k]->d_verschiebung;
      if(k==0)
	alpha1 = tmp_stab->pe_frei[k]->d_alpha;
      if(k==3)
	alpha2 = tmp_stab->pe_frei[k]->d_alpha;
    }
    
    v[0] = ( cos(alpha_stab-alpha1) * u[0] + sin(alpha_stab-alpha1) * u[1]);
    v[1] = ( -sin(alpha_stab-alpha1) * u[0] + cos(alpha_stab-alpha1) * u[1]);
    
    v[3] = ( cos(alpha_stab-alpha2) * u[3] + sin(alpha_stab-alpha2) * u[4]);
    v[4] = ( -sin(alpha_stab-alpha2) * u[3] + cos(alpha_stab-alpha2) * u[4]);
    
    v[2] = u[2];
    v[5] = u[5];     


    q[0] = l* (   dna/3  +   dne/6  );
    q[1] = l* ( 7*dpa/20 + 3*dpe/20 );
    q[2] = l2* (   dpa/20 +   dpe/30 );
 
    q[3] = l* (   dna/6  +   dne/3  );
    q[4] = l* ( 3*dpa/20 + 7*dpe/20 );
    q[5] =-l2* (   dpa/30 +   dpe/20 );    


    /* setze Werte auf Null ..........*/
    for( j=0; j<6; j++ ) {
      for( k=0; k<6; k++ ) 
	elesteif[j][k] = 0.0;
      h[j]=0.0;
    }
    
    /*belege Elementsteifigkeitsmatrix*/

    elesteif[0][0] = E*A/l;
    elesteif[0][3] = -E*A/l;
    
    elesteif[1][1] = 12*E*I/l3;
    elesteif[1][2] = 6*E*I/l2;
    
    elesteif[1][4] = -12*E*I/l3;
    elesteif[1][5] = 6*E*I/l2;
    
    elesteif[2][1] = 6*E*I/l2;
    elesteif[2][2] = 4*E*I/l;
    
    elesteif[2][4] = -6*E*I/l2;
    elesteif[2][5] = 2*E*I/l;
    

    elesteif[3][0] = -E*A/l;
    elesteif[3][3] = E*A/l;

    elesteif[4][1] = -12*E*I/l3;
    elesteif[4][2] = -6*E*I/l2;

    elesteif[4][4] = 12*E*I/l3;
    elesteif[4][5] = -6*E*I/l2;

    elesteif[5][1] = 6*E*I/l2;
    elesteif[5][2] = 2*E*I/l;

    elesteif[5][4] = -6*E*I/l2;
    elesteif[5][5] = 4*E*I/l;

    /* Schnittkraefte = Elementsteifigkeitsmatrix * v - q  */
    /* h = EleSteif * v ..............*/

    for( j=0; j<6; j++ )             
      for( k=0; k<6; k++ ) 
	h[j] += elesteif[j][k] * v[k];
    
    for( k=0; k<6; k++ )  
      h[k] = h[k] - q[k];

    /* belege Schnittkraefte d. Stabes*/

    tmp_stab->d_Na = -h[0];            
    tmp_stab->d_Qa = h[1];
    tmp_stab->d_Ma = -h[2];

    tmp_stab->d_Nb = h[3];
    tmp_stab->d_Qb = -h[4];
    tmp_stab->d_Mb = h[5];
  }
}






