/*
  Datei     : matquercb.c
  erstellt  : 24.08.96
  geaendert : 25.08.96
  Autor     : jh
*/


#include "XStabDek.h"



void quer_browser_cb(FL_OBJECT *obj, long arg)
{
  long nummer;
  TypQuerschnitt *tmp_quer;
  char c_text[100];

  nummer = Hole_QuerschnittID();
  tmp_quer = Suche_Querschnitt(nummer);
  
  sprintf(c_text,"%ld",(*tmp_quer).l_id);      
  fl_set_object_label(querschnittform->quer_id_text,c_text);

  sprintf(c_text,"%.3e",(*tmp_quer).d_A);      
  fl_set_input(querschnittform->quer_A_input,c_text);

  sprintf(c_text,"%.3e",(*tmp_quer).d_Iz);      
  fl_set_input(querschnittform->quer_Iz_input,c_text);

  sprintf(c_text,"%.3f",(*tmp_quer).d_maxy);      
  fl_set_input(querschnittform->quer_maxy_input,c_text);

  sprintf(c_text,"%s",(*tmp_quer).c_name);      
  fl_set_input(querschnittform->quer_name_input,c_text);
}


void quer_erzeugen_button_cb(FL_OBJECT *obj, long arg)
{
  TypQuerschnitt *tmp_quer;
  char c_text[100];

  tmp_quer = Erzeuge_Querschnitt();

  sprintf((*tmp_quer).c_name,"neu");
  sprintf(c_text,"%10ld  %s",(*tmp_quer).l_id,(*tmp_quer).c_name);
  
  if(KeQuerschnitt)
    {
      KeElementEintragen(tmp_quer,Nach,KeQuerschnitt);
    }
  else
    {
      KeQuerschnitt = KeKetteDefinieren();
      KeElementEintragen(tmp_quer,Nach,KeQuerschnitt);
    }

  if(fl_get_browser_maxline(querschnittform->quer_browser))
    fl_insert_browser_line(querschnittform->quer_browser,1,c_text);  
  else
    fl_add_browser_line(querschnittform->quer_browser,c_text);  
}


void quer_loeschen_button_cb(FL_OBJECT *obj, long arg)
{
  TypQuerschnitt *tmp_quer;
  long nummer;
  KeGlied *p;

  nummer = Hole_QuerschnittID();

  if(nummer != -1)
    {
      if(KeQuerschnitt)
	KeDurchlaufVorwaerts(p,KeQuerschnitt)  
	{
	  tmp_quer = p->x;
	  if((*tmp_quer).l_id == nummer)
	    {
	      KeGliedAustragen(p);
	      free(tmp_quer);
	      break;
	    }
	}
      
      SetzeWerte_Querschnitt();
    }
}


void quer_ok_button_cb(FL_OBJECT *obj, long arg)
{
  fl_hide_form(querschnittform->querschnittform);
  Zeichne();
}


void quer_id_text_cb(FL_OBJECT *obj, long arg)
{}


void quer_input_cb(FL_OBJECT *obj, long arg)
{
  char *c_tmp;
  char c_text[100];
  long nummer;
  long i;
  TypQuerschnitt *tmp_quer;

  nummer = Hole_QuerschnittID();

  if(nummer != -1)
    {
      tmp_quer = Suche_Querschnitt(nummer);
      
      c_tmp = (char*) fl_get_input(obj);
      
      switch(arg)
	{
	case 1 :
	  sprintf((*tmp_quer).c_name,"%s",c_tmp);
	  break;
	  
	case 2 :
	  (*tmp_quer).d_A = atof(c_tmp);
	  break;
	  
	case 3 :      
	  (*tmp_quer).d_Iz = atof(c_tmp);
	  break;
	  
	case 4 :      
	  (*tmp_quer).d_maxy = atof(c_tmp);
	  break;
	}
      
      sprintf(c_text,"%10ld  %s", (*tmp_quer).l_id, (*tmp_quer).c_name);
      
      for(i=1;i<= fl_get_browser_maxline(querschnittform->quer_browser);i++)
	{
	  if(fl_isselected_browser_line(querschnittform->quer_browser,i))
	    {
	      fl_replace_browser_line(querschnittform->quer_browser,i,c_text);
	      break;
	    }
	}
    }
}


/*
  Standardwerte festlegen
*/
void standardmat_browser_cb(FL_OBJECT *obj, long arg)
{
  KeGlied *p;
  TypMaterial *tmp_mat;
  char c_text[100];
  
  standard_mat = Hole_Standard_MaterialID();

  if( standard_mat != -1)
    {
      if(KeMaterial)
	KeDurchlaufVorwaerts(p,KeMaterial)
	{	  
	  tmp_mat = p->x;           
	  
	  if((*tmp_mat).l_id == standard_mat)
	    {
	      sprintf(c_text,"%10ld  %s", (*tmp_mat).l_id, (*tmp_mat).c_name);
	      fl_set_object_label(staberzeugenform->standard_mat_text,c_text);  	    
	    }
	}      
    }
  else
    Meldung("kein Material gefunden !");
}


void standardquer_browser_cb(FL_OBJECT *obj, long arg)
{ 
  KeGlied *p;
  TypQuerschnitt *tmp_quer;
  char c_text[100];

  standard_quer = Hole_Standard_QuerschnittID();
  
  if( standard_quer != -1)
    {
      if(KeQuerschnitt)
	KeDurchlaufVorwaerts(p,KeQuerschnitt)
	{	  
	  tmp_quer = p->x;           
	  
	  if((*tmp_quer).l_id == standard_quer)
	    {
	      sprintf(c_text,"%10ld  %s", (*tmp_quer).l_id, (*tmp_quer).c_name);
	      fl_set_object_label(staberzeugenform->standard_quer_text,c_text);  	
	    }
	}      
    }
  else
    Meldung("keinen Querschnitt gefunden !");

}
