/*
  Datei     : tabelle.c
  erstellt  : 02.11.96
  gendert  : 02.04.97
  Autor     : jh
*/


#include "XStabDek.h"



/*********************************************************************/
/* void tabelle_staebe(void)                                         */
/*********************************************************************/ 
/*                                              
   Funktion zeigt Tabelle - Stbe            
   jh, 15.03.97
*/
/*********************************************************************/

void tabelle_staebe(void)
{
   
  tabelle_staebe_browserzeichnen();
  
  fl_show_form(tab_staebe_form->tab_staebe,
	       FL_PLACE_CENTER | FL_FREE_SIZE, FL_TRANSIENT,"Stbe"); 

}



/*********************************************************************/
/* void tabelle_staebe_browserzeichnen(void)                         */
/*********************************************************************/
/* 
   Funktion zeichnet die Stab-Tabelle
   jh, 20.07.97           
*/
/*********************************************************************/

void tabelle_staebe_browserzeichnen(void)
{
  TypStab_Nm *tmp_stab;
  TypPunkt *p1,*p2;
  char c_text[100];
  KeGlied *p;
  double pos;

  if(!Modell)
    return;

  if(!Modell->KeStab_Nm) 
    return;

  fl_freeze_form(tab_staebe_form->tab_staebe);
  fl_clear_browser(tab_staebe_form->tab_staebe_browser); 

  KeSchnellSortieren(Modell->KeStab_Nm, (Rel (*)(void*,void*)) Rel_Stab_Nm );
 
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;
    p1 = (*tmp_stab).pe_punkta;
    p2 = (*tmp_stab).pe_punktb;
    
    sprintf(c_text,"%3ld   (%5.2f/%5.2f)-(%5.2f/%5.2f) \t max M %8.3f  max Q %8.3f max N %8.3f", 
	    (*tmp_stab).l_nummer, (*p1).d_x, (*p1).d_y, (*p2).d_x, (*p2).d_y,
	    maxM(tmp_stab,&pos), maxQ(tmp_stab,&pos),  maxN(tmp_stab,&pos));
    
    fl_addto_browser(tab_staebe_form->tab_staebe_browser,c_text);
    
    if((*tmp_stab).l_selektiert == 1)
      fl_select_browser_line(tab_staebe_form->tab_staebe_browser,
			     fl_get_browser_maxline(tab_staebe_form->tab_staebe_browser));
    
  }
  
  fl_unfreeze_form(tab_staebe_form->tab_staebe);
  
}



/***********************************************************/
/* void tabelle_punkte(void)                               */
/***********************************************************/
/*                                              
   Funktion zeigt Tabelle - Punkte           
   jh, 15.03.97                                 
*/
/***********************************************************/

void tabelle_punkte(void)
{
  TypPunkt *tmp_punkt;
  char c_text[100];
  KeGlied *p;

  if(Modell) {

    fl_freeze_form(tab_punkte_form->tab_punkte);
    fl_clear_browser(tab_punkte_form->tab_punkte_browser);

    if(Modell->KePunkt_Nm) {
      KeSchnellSortieren(Modell->KePunkt_Nm, (Rel (*)(void*,void*)) Rel_Punkt );
      
      KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm) {	  
	tmp_punkt = p->x;
	
      sprintf(c_text,"%4ld   %10.4f   %10.4f ", 
	      (*tmp_punkt).l_nummer,
	      (*tmp_punkt).d_x, (*tmp_punkt).d_y );
      
      fl_addto_browser(tab_punkte_form->tab_punkte_browser,c_text);  
      }
    }
    fl_unfreeze_form(tab_punkte_form->tab_punkte);
  }

  fl_show_form(tab_punkte_form->tab_punkte,
	       FL_PLACE_CENTER,FL_TRANSIENT,"Punkte"); 
}

 
