/*
  Datei     : tabelle_cb.c
  erstellt  : 10.11.96
  gendert  : 08.08.97
  Autor     : jh
*/


#include "XStabDek.h"



/***********************************************************/
/* void tab_punkte_nummer_cb(FL_OBJECT *obj, long arg)     */
/***********************************************************/ 
/*                                              
   cb-Fkt wird aufgerufen wenn im Eingabefeld
   'nummer' eine Punktnummer angegeben wurde, der
   entsprechende Punkt wird gesucht, und die Koordinaten
   werden angezeigt
   jh, 21.03.97
*/
/***********************************************************/

void tab_punkte_nummer_cb(FL_OBJECT *obj, long arg)
{ 
  char *c_tmp;
  TypPunkt *tmp_punkt;
  char c_text[50];

  if(!Modell)
    return;

  c_tmp = (char*) fl_get_input(tab_punkte_form->tab_punkte_nummer);
  tmp_punkt = suchePunkt_Nr((long) atol(c_tmp), Modell->KePunkt_Nm);
  
  if(tmp_punkt)
    {
      sprintf(c_text,"%.4f",(*tmp_punkt).d_x);
      fl_set_input(tab_punkte_form->tab_punkte_x, c_text);
      
      sprintf(c_text,"%.4f",(*tmp_punkt).d_y);
      fl_set_input(tab_punkte_form->tab_punkte_y, c_text);
    }
  else
    {
      fl_set_input(tab_punkte_form->tab_punkte_x, "");
      fl_set_input(tab_punkte_form->tab_punkte_y, "");
    }
}



/***********************************************************/
/* void tab_punkte_x_cb(FL_OBJECT *obj, long arg)          */
/***********************************************************/ 
/*                                              
   cb-Fkt -> Eingabe der x_Koordinate
   jh, 21.03.97
*/
/***********************************************************/

void tab_punkte_x_cb(FL_OBJECT *obj, long arg)
{ 
  char *c_tmp;
  char punktnummer[4];
  long j;  
  TypPunkt *tmp_punkt;

  if(!Modell)
    return;

  c_tmp = (char*) fl_get_input(tab_punkte_form->tab_punkte_nummer);

  for(j=0;j<4;j++)
    punktnummer[j] = c_tmp[j];     
  
  tmp_punkt = suchePunkt_Nr((long) atol(punktnummer), Modell->KePunkt_Nm);

  if(tmp_punkt) {
    c_tmp = (char*) fl_get_input(tab_punkte_form->tab_punkte_x);  
    (*tmp_punkt).d_x = atof(c_tmp);
  }

  tabelle_punkte();

}


void tab_punkte_y_cb(FL_OBJECT *obj, long arg)
{
  char *c_tmp;
  char punktnummer[4];
  long j;  
  TypPunkt *tmp_punkt;

  if(!Modell)
    return;

  c_tmp = (char*) fl_get_input(tab_punkte_form->tab_punkte_nummer);

  for(j=0;j<4;j++)
    punktnummer[j] = c_tmp[j];     
  
  tmp_punkt = suchePunkt_Nr((long) atol(punktnummer), Modell->KePunkt_Nm);
  
  if(tmp_punkt) {
    c_tmp = (char*) fl_get_input(tab_punkte_form->tab_punkte_y);  
    (*tmp_punkt).d_y = atof(c_tmp);
  }

  tabelle_punkte();

}


void tab_punkte_ok_cb(FL_OBJECT *obj, long arg)
{ 
  fl_hide_form(tab_punkte_form->tab_punkte);
  Zeichne();
}


void tab_punkte_browser_cb(FL_OBJECT *obj, long arg)
{
  char *c_tmp;
  char punktnummer[4];
  long j;
  char c_text[50];
  TypPunkt *tmp_punkt;

  if(!Modell)
    return;

  c_tmp = (char*) fl_get_browser_line(tab_punkte_form->tab_punkte_browser,
				      fl_get_browser(obj));
  for(j=0;j<4;j++)
    punktnummer[j] = c_tmp[j];     
  
  tmp_punkt = suchePunkt_Nr((long) atol(punktnummer), Modell->KePunkt_Nm);

  sprintf(c_text,"%4ld",(*tmp_punkt).l_nummer);
  fl_set_input(tab_punkte_form->tab_punkte_nummer, c_text);

  sprintf(c_text,"%.4f",(*tmp_punkt).d_x);
  fl_set_input(tab_punkte_form->tab_punkte_x, c_text);

  sprintf(c_text,"%.4f",(*tmp_punkt).d_y);
  fl_set_input(tab_punkte_form->tab_punkte_y, c_text); 

}


void tab_staebe_schliessen_button_cb(FL_OBJECT *obj, long arg)
{
  fl_hide_form(tab_staebe_form->tab_staebe);
  Zeichne();
}



/*********************************************************************/
/* void tab_staebe_browser_cb(FL_OBJECT *obj, long arg)              */
/*********************************************************************/
/*                                              
   cb - Browser Tabelle Stebe
   angeklickte Stbe werden an- bzw. abgewhlt
   jh, 20.07.97           
*/
/*********************************************************************/

void tab_staebe_browser_cb(FL_OBJECT *obj, long arg)
{
  int line;
  char *c_tmp;
  long stabnummer;
  char c_stabnummer[3];
  TypStab_Nm* tmp_stab;
  long i;

  /* nummer der angeklickten Zeile */
  line = fl_get_browser(obj);
 
  if(!line)
    return;

  c_tmp = (char*) fl_get_browser_line(obj, fabs(line));

  /* Stabnummer ermitteln */
  for(i=0;i<3;i++)
    c_stabnummer[i] = c_tmp[i];

  stabnummer = atol(c_stabnummer);

  tmp_stab = Suche_Stab_Nm(stabnummer);

  if(!tmp_stab)
    return;

  if(line > 0)
    (*tmp_stab).l_selektiert = 1;
  else
    (*tmp_stab).l_selektiert = -1;
      
}



/*********************************************************************/
/* void tab_staebe_alleauswaehlen_cb(FL_OBJECT *obj, long arg)       */
/*********************************************************************/
/*                                              
   cb - alle Staebe werden selektiert
   jh, 20.07.97           
*/
/*********************************************************************/

void tab_staebe_alleauswaehlen_cb(FL_OBJECT *obj, long arg) 
{
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  long i;

  if(!Modell)
    return;

  /* alle Stbe selektieren */
  if(Modell->KeStab_Nm) {
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab = p->x;     
      (*tmp_stab).l_selektiert = 1;
    }  
  }

  /* Browser neu zeichnen */
  fl_freeze_form(tab_staebe_form->tab_staebe);
  {
    for(i=1; i<=fl_get_browser_maxline(tab_staebe_form->tab_staebe_browser); i++)
      fl_select_browser_line(tab_staebe_form->tab_staebe_browser,i);
  }
  fl_unfreeze_form(tab_staebe_form->tab_staebe);

}



/*********************************************************************/
/* void tab_staebe_alleabwaehlen_cb(FL_OBJECT *obj, long arg)        */
/*********************************************************************/
/*                                              
   cb - alle Staebe werden deselektiert
   jh, 20.07.97           
*/
/*********************************************************************/

void tab_staebe_alleabwaehlen_cb(FL_OBJECT *obj, long arg) 
{
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  long i;

  if(!Modell)
    return;

  /* alle Stbe selektieren */
  if(Modell->KeStab_Nm) {
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab = p->x;     
      (*tmp_stab).l_selektiert = -1;
    }  
  }

  /* Browser neu zeichnen */
  fl_freeze_form(tab_staebe_form->tab_staebe);
  {
    for(i=1; i<=fl_get_browser_maxline(tab_staebe_form->tab_staebe_browser); i++)
      fl_deselect_browser_line(tab_staebe_form->tab_staebe_browser,i);
  }
  fl_unfreeze_form(tab_staebe_form->tab_staebe);

}



/*********************************************************************/
/* void tab_staebe_invers_cb(FL_OBJECT *obj, long arg)               */
/*********************************************************************/
/*                                              
   cb - selektierte Staebe werden deselektiert,
   deselektierte Staebe werden selektiert
   jh, 20.07.97           
*/
/*********************************************************************/

void tab_staebe_invers_cb(FL_OBJECT *obj, long arg) 
{
  KeGlied *p;
  TypStab_Nm *tmp_stab;
   
  if(!Modell)
    return;

  if(!Modell->KeStab_Nm)
    return;

  /* Schleife ber alle Stbe  */
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;           
    (*tmp_stab).l_selektiert *= -1;
  }  
  
  /* Browser neu zeichnen */
  tabelle_staebe_browserzeichnen();  
  
}



/*********************************************************************/
/* void tab_staebe_extremum(FL_OBJECT *obj, long arg)                */
/*********************************************************************/
/*                                              
   Extrema bestimmen und darstellen
   jh, 08.08.97
*/
/*********************************************************************/

void tab_staebe_extremum(FL_OBJECT *obj, long arg) 
{
  KeGlied* staebe, *l;
  double M,Q,N;
  double pos;
  TypStab_Nm* tmp_stab;
  char c_text[200];

  if(!Modell)
    return;

  staebe = getSelectedK();

  if(!staebe) {
    fl_set_object_label(tab_staebe_form->tab_staebe_text_1,"");
    fl_set_object_label(tab_staebe_form->tab_staebe_text_2,"");
    fl_set_object_label(tab_staebe_form->tab_staebe_text_3,"");
    return;
  }

  /* max */
  if(arg == 1) {   

    M = maxMKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kNm         Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, M, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_1,c_text);

    Q = maxQKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kN          Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, Q, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_2,c_text);
    
    N = maxNKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kN          Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, N, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_3,c_text);

  }

  /* min */
  if(arg == 2) {

    M = minMKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kNm         Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, M, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_1,c_text);

    Q = minQKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kN          Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, Q, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_2,c_text);
    
    N = minNKette(staebe, &tmp_stab, &pos);
    sprintf(c_text,"Nr.: [ %ld ]       %.3f kN          Pos.: %.3f m ", 
	    (*tmp_stab).l_nummer, N, pos * (*tmp_stab).d_laenge);
    fl_set_object_label(tab_staebe_form->tab_staebe_text_3,c_text);

  }
  
  while(staebe->nach != staebe) {
    l = staebe->nach;
    KeGliedAustragen(l); 		  	             	
  }

}
