/*
  Datei     : FreiGrad_zeichne_Nm.c
  erstellt  : 02.04.97
  gendert  : 09.04.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"



/*********************************************************************/
/* void Zeichne_FG(void)                                             */
/*********************************************************************/ 
/*                                              
   Fkt zeichnet den Stab mit Freiheitsgraden im
   Fenster fg_win (Editieren von Freiheitsgraden)
   jh, 06.04.97                                 
*/
/*********************************************************************/

void Zeichne_FG(void)
{
  FL_Coord win_h,win_w;
  long i;
  TypStab_Nm *tmp_stab;
 
  tmp_stab = Suche_Stab_select_Nm(&i); 

  fl_get_winsize(fg_win, &win_w, &win_h);

  if(tmp_stab) {               
    XSetWindowBackground(display, fg_win, xs_color.bg);
    XClearWindow(display, fg_win);
    Zeichne_FG_Stab((long) win_w, (long) win_h, tmp_stab);
    
    if(fl_get_menu_item_mode(freigradform->fg_menu,1) == 6)
      Zeichne_FG_FgNummer((long) win_w, (long) win_h, tmp_stab);
    
    if(fl_get_menu_item_mode(freigradform->fg_menu,2) == 6)
      Zeichne_FG_Lager((long) win_w, (long) win_h, tmp_stab);
  }        
}



/*********************************************************************/
/* void Zeichne_FG_Stab( ... )                                       */
/*********************************************************************/ 
/*                                              
   Fkt zeichnet den Stab im
   Fenster fg_win (Editieren von Freiheitsgraden)
   jh, 06.04.97                                 
*/
/*********************************************************************/

void Zeichne_FG_Stab(long win_w, long win_h, TypStab_Nm *tmp_stab)
{
  double xa,ya,xb,yb;  
  TypPunkt *tmp_punkt1,*tmp_punkt2;
  double mass;
  double s,c,abstand = 4;
  double off_x,off_y;

  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;
 
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  XSetForeground(display,gc, xs_color.stab);  
  XSetBackground(display,gc, xs_color.bg);

  s =  (*tmp_stab).d_sin;
  c =  (*tmp_stab).d_cos;

  tmp_punkt1 = (*tmp_stab).pe_punkta;
  tmp_punkt2 = (*tmp_stab).pe_punktb;
  
  xa =  (*tmp_punkt1).d_x;
  ya =  (*tmp_punkt1).d_y;
  xb =  (*tmp_punkt2).d_x;
  yb =  (*tmp_punkt2).d_y;

  BerechneMass( &mass, &off_x, &off_y, win_w, win_h, tmp_stab);


  /* Stab zeichnen */
  XDrawLine(display,
	    fg_win,gc,
	    (long) (xa * mass + off_x ), 
	    (long) ( win_h - ya * mass + off_y),
	    (long) (xb * mass + off_x ), 
	    (long) ( win_h - yb * mass + off_y) );      


  /* Bezugsfaser zeichnen */
  line_style = LineOnOffDash;
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);
 
  XDrawLine ( display,
	      fg_win,gc,
	      (long) (xa * mass + off_x  + (abstand * s) ), 
	      (long) ( win_h - ya * mass + off_y + (abstand * c) ),
	      (long) (xb * mass + off_x  + (abstand * s) ),
	      (long) ( win_h - yb * mass + off_y + (abstand * c) )  );  

  
  /* Punkt A und B beschriften */
  XSetFont(display,gc,font_large);
  XSetForeground(display,gc, xs_color.punkt_nr);

  XDrawImageString(display,
		   fg_win,gc, 
		   (long) (xa * mass + off_x - 20),
		   (long) ( win_h - ya * mass + off_y + 20 ),
		   "A",1);

  XDrawImageString(display,
		   fg_win,gc, 
		   (long) (xb * mass + off_x + 10), 
		   (long) ( win_h - yb * mass + off_y - 10),
		   "B",1);      

  XSetFont(display,gc,font_medium);

  /* Punkt A und B zeichnen */
  {
    Typ_DsScale m;

    XSetForeground(display,gc,xs_color.punkt);

    /* Mastab setzen */
    m.system = mass;
    m.off_x = off_x; m.off_y = off_y;
    m.win = fg_win;
    m.display = display;
    m.gc = gc;         
    
    ds_punkt(xa,ya,m);	
    ds_punkt(xb,yb,m);
  }
}


void Zeichne_FG_FgNummer(long win_w, long win_h, TypStab_Nm *tmp_stab)
{
  long i;
  double xa,ya,xe,ye;
  double x1,x2,y1,y2;
  double alpha;
  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;
  double abstand;
  double ab=.35;   /*  Abstand vom Endpunkt */
  double laenge=40;
  char c_nummer[10];

  double off_x,off_y;
  double mass;

  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  BerechneMass( &mass, &off_x, &off_y, win_w, win_h, tmp_stab); 

  tmp_punkt = (*tmp_stab).pe_punkta;       
  xa = (*tmp_punkt).d_x;
  ya = (*tmp_punkt).d_y;    
  
  tmp_punkt = (*tmp_stab).pe_punktb;
  xe = (*tmp_punkt).d_x;
  ye = (*tmp_punkt).d_y;    
  
  abstand = ab;

  for(i=0;i<6;i++) {
    tmp_freigrad = (*tmp_stab).pe_frei[i];
      
    if(i>2)
      abstand = 1.8 - ab;
    
    alpha =  (*tmp_freigrad).d_alpha;
    
    x1 = 0.5 * (xa * (2 - abstand) + xe * abstand);
    y1 = 0.5 * (ya * (2 - abstand) + ye * abstand); 	     
    
    switch ( (*tmp_freigrad).l_art) {	      
    case 0 :
	      
      x1 = (x1 * mass + off_x );
      x2 = x1 + laenge * cos(alpha);
      
      y1 = (win_h - y1 * mass + off_y);
      y2 = y1 - laenge * sin(alpha);
      
      XSetForeground(display,gc, xs_color.freigrad_dual);
      ZeichnePfeil(x1,y1,x2,y2,fg_win);	    	    	     
      
      sprintf(c_nummer,"%ld",  (*tmp_freigrad).l_nummer );     
      
      if((*tmp_freigrad).l_status == CPmPrimal)
	XSetForeground(display,gc, xs_color.freigrad_primal);
      
      XDrawImageString(display, fg_win, gc,
		       (long) (x2 + 5),
		       (long) y2,
		       c_nummer,strlen(c_nummer));     
      break;
      
    case 1 :	    
      
      x1 = (x1 * mass + off_x );
      x2 = x1 - laenge * sin(alpha);
      
      y1 = (win_h - y1 * mass + off_y);
      y2 = y1 - laenge * cos(alpha);
      
      XSetForeground(display,gc, xs_color.freigrad_dual);
      
      ZeichnePfeil(x1,y1,x2,y2,fg_win);
      
      sprintf(c_nummer,"%ld", (*tmp_freigrad).l_nummer );     
      
      if((*tmp_freigrad).l_status == CPmPrimal)
	XSetForeground(display,gc, xs_color.freigrad_primal);
      
      XDrawImageString(display,fg_win,gc,
		       (long) x2,
		       (long) (y2 - 5),
		       c_nummer,strlen(c_nummer));     
      break;
      
    case 2 :	      	  
      
      XSetForeground(display,gc, xs_color.freigrad_dual);
      
      XDrawArc(display,fg_win,gc,
	       (long) ((x1 * mass + off_x) - (laenge-(laenge/5))),
	       (long) ((win_h - y1 * mass + off_y) - (laenge-(laenge/5))),
	       (long) (2 * ( laenge - (laenge / 5))),
	       (long) (2 * ( laenge - (laenge / 5))),
	       (long) (20*64),
	       (long) (50 * 64) );
      
      sprintf(c_nummer,"%ld",  (*tmp_freigrad).l_nummer );     
      
      if((*tmp_freigrad).l_status == CPmPrimal)
	XSetForeground(display,gc,fl_get_flcolor(FL_PALEGREEN));	   
      
      XDrawImageString(display, fg_win, gc,
		       (long) ( x1 * mass + off_x + laenge/1.3),
		       (long) (win_h - y1 * mass + off_y - laenge/1.3),
		       c_nummer,strlen(c_nummer));     
	  break;
      
    default :
      printf("Fehler bei FreiGrad - Art !\n");
    }    
  }    
}



/***********************************************************/
/* void Zeichne_FG_Lager( ... )                            */
/***********************************************************/ 
/*                                              
   Fkt zeichnet die Lagersysmbole im
   Fenster fg_win (Editieren von Freiheitsgraden)
   jh, 09.04.97                                 
*/

/***********************************************************/   

void Zeichne_FG_Lager(long win_w, long win_h, TypStab_Nm *tmp_stab)
{
  long i;
  double x,y;
  double alpha;

  TypMaszstab mass;

  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;

  XSetBackground(display,gc, xs_color.bg);

  BerechneMass( &mass.system, &mass.off_x, &mass.off_y, win_w, win_h, tmp_stab);
  mass.win_h = win_h;
  mass.win_w = win_w;
      
  for(i=0;i<6;i++)
    {
      tmp_freigrad = (*tmp_stab).pe_frei[i];
      
      if(i<3)	    
	tmp_punkt = (*tmp_stab).pe_punkta;       	    
      else	    
	tmp_punkt = (*tmp_stab).pe_punktb;
      
      x = (*tmp_punkt).d_x;
      y = (*tmp_punkt).d_y;    
      
      /* nur zeichnen wenn primal */
      if( (*tmp_freigrad).l_status == CPmPrimal) 
	{
	  alpha =  (*tmp_freigrad).d_alpha;
	  
	  if((*tmp_freigrad).d_verschiebung == 0)
	    XSetForeground(display,gc, xs_color.lager);
	  else
	    XSetForeground(display,gc,fl_get_flcolor(FL_RED));

	  /* benutze Zeichenfunktion des Hauptfensters */
	  switch ( (*tmp_freigrad).l_art)
	    {
	    case 0 :
	      Zeichne_Lager_XY(fg_win,mass, x,y,alpha,XS_LAGER_X);
	      break;
	    case 1 :
	      Zeichne_Lager_XY(fg_win,mass, x,y,alpha,XS_LAGER_Y);
	      break;
	    case 2 :	     
	      Zeichne_Lager_Z(fg_win,mass, x,y);
	      break;
	    }
	}
    }         
  
  XFlush(display);

}

