/*
  Datei     : Zeichne.c
  erstellt  : 03.07.96
  gendert  : 06.04.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"

void ZeichneBezugsfaser(TypMaszstab);
void ZeichneFreiGrad(TypMaszstab);
void ZeichneLagergroesse(TypMaszstab);
void ZeichnePunktNummern(TypMaszstab);
void ZeichnePunkte(TypMaszstab);
void ZeichneStabNummern(TypMaszstab);
void ZeichneSystem(TypMaszstab);




/* ...  zeichne_verschiebung.c  ... */

extern void Zeichne_Verschiebung(TypMaszstab);



/* ...  zeichne_schnittkraft.c  ... */

extern void ZeichneNormal(TypMaszstab);
extern void ZeichneQuer(TypMaszstab);
extern void ZeichneMoment(TypMaszstab);

extern void ZeichneRaster(TypMaszstab);
extern void ZeichneUrsprung(TypMaszstab);
extern void ZeichneKnotenlast(TypMaszstab);
extern void ZeichneStreckenlast(TypMaszstab);
extern void ZeichneSelektion(void);
extern void ZeichneLager(TypMaszstab);
extern void ZeichneAchsenbeschriftung(TypMaszstab mass);



/***********************************************************/
/*   void Zeichne(void)                                    */
/***********************************************************/ 
/*                                              
   Fkt zeichnet das System im Hauptfenster mit
   allen eingestellten Elementen
   jh, 15.03.97
*/
/***********************************************************/

void Zeichne(void)
{ 
  TypMaszstab mass;

  resize_window();

  if(!Modell)
    return;

  mass = Zeichne_HoleMaszstab();

  XClearWindow(display,win);
 
  if( Modell->Environment.raster )
    ZeichneRaster(mass);

  if( fl_get_button(drawcontrol_preferences_form->ursprung_button))
    ZeichneUrsprung(mass);

  if(fl_get_button(drawcontrol_preferences_form->achsenbeschriftung_button))
    ZeichneAchsenbeschriftung(mass);
 
  if(fl_get_button(drawcontrol_preferences_form->bezugsfaser_button))
    ZeichneBezugsfaser(mass);

  if(fl_get_button(drawcontrol_system_form->system_button))
    ZeichneSystem(mass);
 
  if(fl_get_button(drawcontrol_system_form->lager_button))
    ZeichneLager(mass);
  
  if(fl_get_button(drawcontrol_system_form->freiheitsgrade_button))
    ZeichneFreiGrad(mass);

  if(fl_get_button(drawcontrol_system_form->punktlasten_button))      
    ZeichneKnotenlast(mass);    

  if(fl_get_button(drawcontrol_system_form->streckenlasten_button))  
    ZeichneStreckenlast(mass);    

  if(fl_get_button(drawcontrol_system_form->verschiebung_button))
    Zeichne_Verschiebung(mass); 

  if(fl_get_button(drawcontrol_system_form->normalkraft_button))
    ZeichneNormal(mass);

  if(fl_get_button(drawcontrol_system_form->querkraft_button))
    ZeichneQuer(mass);

  if(fl_get_button(drawcontrol_system_form->moment_button))
    ZeichneMoment(mass);  
   
  if(fl_get_button(drawcontrol_system_form->punkte_button))
    ZeichnePunkte(mass);

  if(fl_get_button(drawcontrol_system_form->punktnummern_button))
    ZeichnePunktNummern(mass);

  if(fl_get_button(drawcontrol_system_form->stabnummern_button))
    ZeichneStabNummern(mass);

  if(fl_get_button(drawcontrol_system_form->lagergroessen_button))
    ZeichneLagergroesse(mass);
}



/***********************************************************/
/*  void ZeichneSystem(TypMaszstab mass)                   */
/***********************************************************/ 
/*                                              
   Fkt zeichnet die Stbe des Systems
   jh, 15.03.97

*/
/***********************************************************/

void ZeichneSystem(TypMaszstab mass)
{
  double xa,ya;  /* Anfangspunkt */
  double xb,yb;  /* Endpunkt     */

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1,*tmp_punkt2;

  /* Zeichnungseinstellungen */
  int line_style = LineSolid;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(!Modell->KeStab_Nm)
    return;

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;     
    tmp_punkt1 = (*tmp_stab).pe_punkta;
    tmp_punkt2 = (*tmp_stab).pe_punktb;
    xa = (*tmp_punkt1).d_x;
    ya = (*tmp_punkt1).d_y;
    xb = (*tmp_punkt2).d_x;
    yb = (*tmp_punkt2).d_y;
    
    if((*tmp_stab).l_selektiert == 1)
      {
	XSetLineAttributes(display,gc,line_width+2,line_style,cap_style,join_style);
	XSetForeground(display,gc,xs_color.stab_select);
      }
    else
      {
	XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);
	XSetForeground(display,gc,xs_color.stab);
      }
    
    XDrawLine(display,win,gc,
	      (long) (xa * mass.system + mass.off_x ), 
	      (long) (mass.win_h - ya * mass.system + mass.off_y),
	      (long) (xb * mass.system + mass.off_x ), 
	      (long) (mass.win_h - yb * mass.system + mass.off_y) );     
  }   
}



/***********************************************************/
/*  void ZeichnePunktNummern(TypMaszstab mass)             */
/***********************************************************/ 
/*                                              
   Fkt zeichnet die Punktnummern
   jh, 15.03.97

*/
/***********************************************************/

void ZeichnePunktNummern(TypMaszstab mass)
{
  double x,y;
  KeGlied *p;
  TypPunkt *tmp_punkt;
  char c_nummer[10];

  int line_style = LineSolid;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);
   
  XSetForeground(display,gc,xs_color.punkt_nr);
  XSetBackground(display,gc,xs_color.bg);

  if(Modell->KePunkt_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)
    {
      tmp_punkt = p->x;     
      
      sprintf(c_nummer,"%ld", (*tmp_punkt).l_nummer );
      
      x = (*tmp_punkt).d_x;
      y = (*tmp_punkt).d_y;     
            
      XDrawImageString(display,win,gc,
		       (long) (x * mass.system + mass.off_x + 10),
		       (long) (mass.win_h - y * mass.system + mass.off_y - 10),
		       c_nummer,strlen(c_nummer));     
    }    
}


void ZeichnePunkte(TypMaszstab mass)
{
  double x,y;
  KeGlied *p;
  TypPunkt *tmp_punkt; 
  Typ_DsScale m;
 
  setze_m(mass,&m);

  XSetForeground(display,gc,xs_color.punkt);       
  XSetBackground(display,gc,xs_color.bg);
  
  if(Modell->KePunkt_Nm)
    KeDurchlaufVorwaerts(p,Modell->KePunkt_Nm)
    {
      tmp_punkt = p->x;                
      
      x = (*tmp_punkt).d_x;
      y = (*tmp_punkt).d_y;         

      ds_punkt(x,y,m);		                 
    }    
}


void ZeichneStabNummern(TypMaszstab mass)
{
  double xa,ya;
  double xb,yb;

  KeGlied *p;
  TypPunkt *tmp_punkt1,*tmp_punkt2;
  TypStab_Nm *tmp_stab;
  char c_nummer[10];

  XSetForeground(display,gc, xs_color.stab_nr);
  XSetBackground(display,gc, xs_color.bg);

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;     
      
      sprintf(c_nummer,"%ld", (*tmp_stab).l_nummer );

      tmp_punkt1 = (*tmp_stab).pe_punkta;
      tmp_punkt2 = (*tmp_stab).pe_punktb;

      xa = (*tmp_punkt1).d_x;
      ya = (*tmp_punkt1).d_y;
      xb = (*tmp_punkt2).d_x;
      yb = (*tmp_punkt2).d_y;

      XDrawImageString(display,win,gc,
		       (long) ((0.5*(xa+xb)) * mass.system + mass.off_x + 10),
		       (long) (mass.win_h - (0.5*(ya+yb)) * mass.system + mass.off_y - 10),
		       c_nummer,strlen(c_nummer));     
    }    
}


void ZeichneBezugsfaser(TypMaszstab mass)
{
  double xa,ya;
  double xb,yb;
  double abstand=7;
  double s,c;

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1,*tmp_punkt2;

  int line_style = LineOnOffDash;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetForeground(display,gc,xs_color.stab);  
  XSetBackground(display,gc,xs_color.bg);

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)
    {
      tmp_stab = p->x;     
      tmp_punkt1 = (*tmp_stab).pe_punkta;
      tmp_punkt2 = (*tmp_stab).pe_punktb;

      xa = (*tmp_punkt1).d_x;
      ya = (*tmp_punkt1).d_y;
      xb = (*tmp_punkt2).d_x;
      yb = (*tmp_punkt2).d_y;    

      s =  (*tmp_stab).d_sin;
      c =  (*tmp_stab).d_cos;

      XDrawLine
	( display,win,gc,
	  (long) (xa * mass.system + mass.off_x  + (abstand * s) ), 
	  (long) ( mass.win_h - ya * mass.system + mass.off_y + (abstand * c) ),
	  (long) (xb * mass.system + mass.off_x  + (abstand * s) ),
	  (long) ( mass.win_h - yb * mass.system + mass.off_y + (abstand * c) ) 
	  );     
    }    
}




void ZeichneFreiGrad(TypMaszstab mass)
{
  long i,von,bis;
  double xa,ya,xe,ye;
  double x1,x2,y1,y2;
  double alpha;
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;
  double abstand;
  double ab=.3;   /*  Abstand vom Endpunkt */
  double laenge=40;
  char c_nummer[10];

  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetBackground(display,gc,xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  if(!Modell->KeStab_Nm)
    return;

  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;     
    
    tmp_punkt = (*tmp_stab).pe_punkta;       
    xa = (*tmp_punkt).d_x;
    ya = (*tmp_punkt).d_y;    
    
    tmp_punkt = (*tmp_stab).pe_punktb;
    xe = (*tmp_punkt).d_x;
    ye = (*tmp_punkt).d_y;    
    
    abstand = ab;
    
    
    /* Prfen, ob alle Freiheitsgrade gezeichnet werden mssen */
    Pruefe_Gelenke(&von, &bis, tmp_stab);
    
    /* Schleife ber die Freiheitsgrade eines Stabes */
    for(i=von; i<bis; i++) {
      tmp_freigrad = (*tmp_stab).pe_frei[i];
	
      if(i>2)
	abstand = 1.8 - ab;

      alpha =  (*tmp_freigrad).d_alpha;

      x1 = 0.5 * (xa * (2 - abstand) + xe * abstand);
      y1 = 0.5 * (ya * (2 - abstand) + ye * abstand); 	     

      switch ( (*tmp_freigrad).l_art) {	      
      case 0 :
	      
	x1 = (x1 * mass.system + mass.off_x );
	x2 = x1 + laenge * cos(alpha);
	      
	y1 = (mass.win_h - y1 * mass.system + mass.off_y);
	y2 = y1 - laenge * sin(alpha);

	XSetForeground(display,gc, xs_color.freigrad_dual);

	ZeichnePfeil(x1,y1,x2,y2,win);	    	    	     

	sprintf(c_nummer,"%ld",  (*tmp_freigrad).l_nummer );     
	      
	if((*tmp_freigrad).l_status == CPmPrimal)
	  XSetForeground(display,gc, xs_color.freigrad_primal);
	else {
	  if((*tmp_freigrad).d_feder != 0 )
	    XSetForeground(display,gc, xs_color.feder);
	}

	XDrawImageString(display,win,gc,
			 (long) (x2 + 5),
			 (long) y2,
			 c_nummer,strlen(c_nummer));     
	break;
	      
      case 1 :	    
	      
	x1 = (x1 * mass.system + mass.off_x );
	x2 = x1 - laenge * sin(alpha);
	      
	y1 = (mass.win_h - y1 * mass.system + mass.off_y);
	y2 = y1 - laenge * cos(alpha);

	XSetForeground(display,gc,xs_color.freigrad_dual);

	ZeichnePfeil(x1,y1,x2,y2,win);

	sprintf(c_nummer,"%ld", (*tmp_freigrad).l_nummer );     
	
	if((*tmp_freigrad).l_status == CPmPrimal)
	  XSetForeground(display,gc,xs_color.freigrad_primal);
	else {
	  if((*tmp_freigrad).d_feder != 0 )
	    XSetForeground(display,gc, xs_color.feder);
	}

	XDrawImageString(display,win,gc,
			 (long) x2,
			 (long) (y2 - 5),
			 c_nummer,strlen(c_nummer));     
	break;
	
      case 2 :	      	  
	
	XSetForeground(display,gc,xs_color.freigrad_dual);
	
	XDrawArc(display,win,gc,
		 (long) ((x1 * mass.system + mass.off_x) - (laenge-(laenge/5))),
		 (long) ((mass.win_h - y1 * mass.system + mass.off_y) - (laenge-(laenge/5))),
		 (long) (2 * ( laenge - (laenge / 5))),
		 (long) (2 * ( laenge - (laenge / 5))),
		 (long) (20*64),
		 (long) (50 * 64) );
	
	sprintf(c_nummer,"%ld",  (*tmp_freigrad).l_nummer );     
	
	if((*tmp_freigrad).l_status == CPmPrimal)
	  XSetForeground(display,gc,xs_color.freigrad_primal);
	else {
	  if((*tmp_freigrad).d_feder != 0 )
	    XSetForeground(display,gc, xs_color.feder);
	}

	XDrawImageString(display,win,gc,
			 (long) ( x1 * mass.system + mass.off_x + laenge/1.3),
			 (long) (mass.win_h - y1 * mass.system + mass.off_y - laenge/1.3),
			 c_nummer,strlen(c_nummer));     
	break;
	
      default :
	printf("Fehler bei FreiGrad - Art !\n");
      }
    }            
  }    
}
  

void ZeichneLagergroesse(TypMaszstab mass)
{
  long i;
  double xa,ya;
  double alpha,s,c;
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;
  char c_tmp[20];
  double l = 50;             /* Abstand */

  XSetBackground(display,gc,xs_color.bg); 
  XSetForeground(display,gc,xs_color.freigrad_primal);

  if(!Modell->KeStab_Nm)
    return;

  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
    tmp_stab = p->x;     
   
    for(i=0;i<6;i++) {
	  
      if(i<3)
	tmp_punkt = (*tmp_stab).pe_punkta;    
      else
	tmp_punkt = (*tmp_stab).pe_punktb;   
      
	  xa = (*tmp_punkt).d_x;
	  ya = (*tmp_punkt).d_y;    

	  tmp_freigrad = (*tmp_stab).pe_frei[i];
	  if( (*tmp_freigrad).l_status == CPmPrimal) 
	    {
	      alpha =  (*tmp_freigrad).d_alpha;

	      c = cos(alpha);
	      s = sin(alpha);

	      sprintf(c_tmp,"%.2f", (*tmp_freigrad).d_auflager);

	      switch ( (*tmp_freigrad).l_art)
		{
		case 0 :
		  XDrawImageString(display,win,gc,
				   (long) (xa * mass.system + mass.off_x + l * c),
				   (long) (mass.win_h - ya * mass.system + mass.off_y - l * s ),
				   c_tmp,strlen(c_tmp));     		  
		  break;
		case 1 :
		  XDrawImageString(display,win,gc,
				   (long) ( xa * mass.system + mass.off_x - l * s),
				   (long) (mass.win_h - (ya * mass.system) + mass.off_y - l * c ),
				   c_tmp,
				   strlen(c_tmp));    
		  break;
		case 2 :
		  XDrawImageString(display,win,gc,
				   (long) 
				   ( xa * mass.system + mass.off_x + (l-10) * cos(alpha+0.8)),
				   (long) 
				   (mass.win_h - ya * mass.system + mass.off_y - 
				    (l-10) * sin(alpha+0.8) ),
				   c_tmp,strlen(c_tmp));     
		  break;
		}
	    }
	}         
    }

  XFlush(display);

}



/***********************************************************/ 
/* void setze_m(TypMaszstab mass, Typ_DsScale *m)          */
/***********************************************************/ 
/*                                              
  Fuktion bertrgt den Mastab in die Struktur
  Typ_DsScale der Ds-Bibliothek
  jh, 18.03.97
*/
/***********************************************************/

void setze_m(TypMaszstab mass, Typ_DsScale *m)
{
  m->system = mass.system;
  m->off_x = mass.off_x;
  m->off_y = mass.off_y;
  m->win = win;
  m->display = display;
  m->gc = gc;
}
