/*
  Datei     : zeichne_dienst.c
  erstellt  : 03.04.97
  geaendert : 
  Autor     : jh
  Bemerkung : in dieser Datei stehen alle Dienstfkt, die zur
  grafischen Ausgabe bentigt werden
*/


#include "XStabDek.h"



/***********************************************************/ 
/* double Y_win_welt(double win_y)                         */
/***********************************************************/ 
/*                                              
   Transf. von win-koord nach welt-koord
   jh, 22.03.97
*/
/***********************************************************/

double Y_win_welt(Window win, long y)
{
  FL_Coord  win_w, win_h;
  TypMaszstab mass;

  mass = Zeichne_HoleMaszstab(); 
  fl_get_winsize(win, &win_w, &win_h);

  return (double) ( -1 * (y - mass.off_y - win_h)/mass.system ); 
}


double X_win_welt(Window win, long x)
{
  FL_Coord  win_w,win_h;  
  TypMaszstab mass;

  mass = Zeichne_HoleMaszstab(); 
  fl_get_winsize(win,&win_w,&win_h); 
  return (double) ( (x - mass.off_x) /mass.system );
}



/***********************************************************/ 
/* double Y_win_welt_m(double win_y)                      */
/***********************************************************/ 
/*                                              
   Transf. von win-koord nach welt-koord
   mit bergabe des Mastabes
   jh, 22.03.97
*/
/***********************************************************/

double Y_win_welt_m(Window win, long y, TypMaszstab mass)
{
  FL_Coord  win_w, win_h;  

  fl_get_winsize(win, &win_w, &win_h);
  return (double) ( -1 * (y - mass.off_y - win_h)/mass.system ); 
}


double X_win_welt_m(Window win, long x, TypMaszstab mass)
{
  FL_Coord  win_w,win_h;   

  fl_get_winsize(win,&win_w,&win_h); 
  return (double) ( (x - mass.off_x) /mass.system );
}



/***********************************************************/ 
/* double X_welt_win(double win_y)                         */
/***********************************************************/ 
/*                                              
   Transf. von welt-koord nach win-koord  
   jh, 22.03.97
*/
/***********************************************************/

long X_welt_win(Window win, double x)
{ 
  FL_Coord  win_w,win_h;
  TypMaszstab mass;

  mass = Zeichne_HoleMaszstab(); 
  fl_get_winsize(win,&win_w,&win_h); 

  return (long) (x * mass.system + mass.off_x);
}


long Y_welt_win(Window win, double y)
{ 
  FL_Coord  win_h,win_w;
  TypMaszstab mass;

  mass = Zeichne_HoleMaszstab();   
  fl_get_winsize(win,&win_w,&win_h); 

  return (long) (win_h - y * mass.system + mass.off_y);
}



/***********************************************************/ 
/* double X_welt_win_m(double win_y,TypMaszstab mass)      */
/***********************************************************/ 
/*                                              
   Transf. von welt-koord nach win-koord 
   mit bergabe des Mastabes
   jh, 22.03.97
*/
/***********************************************************/

long X_welt_win_m(Window win, double x,TypMaszstab mass)
{ 
  FL_Coord  win_w,win_h; 

  fl_get_winsize(win,&win_w,&win_h); 
  return (long) (x * mass.system + mass.off_x);
}


long Y_welt_win_m(Window win, double y,TypMaszstab mass)
{ 
  FL_Coord  win_h,win_w; 

  fl_get_winsize(win,&win_w,&win_h); 
  return (long) (win_h - y * mass.system + mass.off_y);
}



/***********************************************************/ 
/* void ZeichnePfeil(double x1,double y1, 
		  double x2, double y2, Window win)        */
/***********************************************************/ 
/*                                              
   Fkt zeichnet einen Pfeil in dem bergeben Fenster
   von x1,y1 nach x2,y2 (Spitze x2,y2)  
   jh,03.04.97
*/
/***********************************************************/

void ZeichnePfeil(double x1, double y1, 
		  double x2, double y2, Window win)
{
  double laenge;
  double alpha=0;
 
  laenge = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));

  if(x2 - x1) 
    {
      alpha = atan((y2-y1)/(x2-x1)); 
      if( (y2-y1)==0 && (x2<x1))
	alpha = -PI; 
    }  
  else 
    { 
      if(y1<y2) 
 	alpha = +PI/2; 
      if(y1>y2) 
 	alpha = -PI/2; 
    }   

  if( (x2-x1)<0 && (y2-y1)>0 ) 
    alpha += PI ;   

  if( (x2-x1)<0 && (y2-y1)<0 ) 
    alpha += PI ; 
  
  XDrawLine(display,win,gc,
	    (long) x1,
	    (long) y1,
	    (long) x2,
	    (long) y2);

  /* Spitze zeichnen */
  XDrawLine(display,win,gc,
	    (long) x2,
	    (long) y2,
	    (long) ( x2 - ( laenge/6 * cos(alpha-PI/6)) ),
	    (long) ( y2 - ( laenge/6 * sin(alpha-PI/6)) )  );
	    
  XDrawLine(display,win,gc,
	    (long) x2,
	    (long) y2,
	    (long) ( x2 - ( laenge/6 * sin(PI/3 - alpha)) ),
	    (long) ( y2 - ( laenge/6 * cos(PI/3 - alpha)) )  );	    

  XFlush(display);
}


TypMaszstab Zeichne_HoleMaszstab(void)
{
  TypMaszstab mass;
  char *c_tmp;
  double a,b;

  c_tmp = (char*) fl_get_input(scale_form->input1); 
  mass.system = atof(c_tmp);
  if(mass.system == 0)   {
    fl_set_input(scale_form->input1,"1"); 
    mass.system = 1;
  }
 
  c_tmp = (char*) fl_get_input(scale_form->input2); 
  mass.vs = atof(c_tmp);
    
  c_tmp = (char*) fl_get_input(scale_form->input3); 
  mass.kraft = (atof(c_tmp)/10);

  c_tmp = (char*) fl_get_input(scale_form->input4); 
  mass.streckenlast = (atof(c_tmp)/10);
 
  c_tmp = (char*) fl_get_input(scale_form->input6); 
  mass.schnittkraft = atof(c_tmp);
  mass.schnittkraft /= 100;
 
  fl_get_winsize(win, &mass.win_w, &mass.win_h);
  
  c_tmp = (char*) fl_get_input(scale_form->hor_pos_input); 
  a = atof(c_tmp);

  c_tmp = (char*) fl_get_input(scale_form->ver_pos_input); 
  b = atof(c_tmp);

  mass.off_x = fl_get_positioner_xvalue(scale_form->posi) * mass.win_w + (a * mass.system);
  mass.off_y = fl_get_positioner_yvalue(scale_form->posi) * -mass.win_h - (b * mass.system);

  return mass;
}


/***********************************************************/
/* void resize_window()                                    */
/***********************************************************/ 
/*                                              
   Fkt passt das Hauptfenster zur graf. Ausgabe an die
   Haupt-Form an
   jh, 03.04.97
*/
/***********************************************************/

void resize_window(void)
{
  FL_Coord w, h;
  long width, height;

  fl_get_winsize(rootwin, &w, &h);
   
  width  = w - grafik_win_x - grafik_win_xx;  
  height = h - grafik_win_y - grafik_win_yy;
  
  XSetWindowBackground( display, win, xs_color.bg );
  XMoveResizeWindow(display,win, 
		    grafik_win_x, grafik_win_y,
		    width, height);
}



/***********************************************************/
/* void ZeichneLager_Z( ... )                              */
/***********************************************************/ 
/*                                              
   Fkt zeichnet eine Drehfessel im Fenster win
   jh, 03.04.97
*/
/***********************************************************/

void Zeichne_Lager_Z(Window win,TypMaszstab mass, double x, double y)
{
  
  double abstand = 6;

  int line_style = LineSolid;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);
  
  XDrawRectangle
	( display,win,gc,
	  (long) (x * mass.system + mass.off_x  - abstand ), 
	  (long) (mass.win_h - y * mass.system + mass.off_y - abstand ),
	  (long) (2 * abstand),
	  (long) (2 * abstand) );     
}



/***********************************************************/
/* void Zeichne_Lager_XY( ... )                            */
/***********************************************************/ 
/*                                              
   Fkt zeichnet eine Wegfessel im Fenster win
   jh, 03.04.97
*/
/***********************************************************/

void Zeichne_Lager_XY(Window win,TypMaszstab mass, 
		     double x, double y, double alpha,long xy)
{
  double abstand1 = 10;
  double abstand2 = 30;
  double radius = 4;
  double s,c;

  int line_style = LineSolid;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(xy == XS_LAGER_X)
    alpha -= PI/2;

  s = sin(alpha);
  c = cos(alpha);

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  XDrawArc(display,win,gc,
	   (long) (x * mass.system + mass.off_x  - (abstand1 * s) - radius ), 
	   (long) (mass.win_h - y * mass.system + mass.off_y - (abstand1 * c) -radius ),
	   (long) (2*radius),
	   (long) (2*radius),
	   0,
	   360*64);

  XDrawArc(display,win,gc,
	   (long) (x * mass.system + mass.off_x  - (abstand2 * s) - radius ), 
	   (long) (mass.win_h - y * mass.system + mass.off_y - (abstand2 * c) -radius ),
	   (long) (2*radius),
	   (long) (2*radius),
	   0,
	   360*64);

  XDrawLine
	( display,win,gc,
	  (long) (x * mass.system + mass.off_x  - (abstand1 * s) ), 
	  (long) (mass.win_h - y * mass.system + mass.off_y - (abstand1 * c) ),
	  (long) (x * mass.system + mass.off_x  - (abstand2 * s) ),
	  (long) (mass.win_h - y * mass.system + mass.off_y - (abstand2 * c) ) 
	  );     
}



/***********************************************************/
/* void Zeichne_Feder_XY( ... )                            */
/***********************************************************/ 
/*                                              
   Fkt zeichnet eine Feder im Fenster win
   jh, 25.04.97
*/
/***********************************************************/

void Zeichne_Feder_XY(Window win,TypMaszstab mass, 
		      double x, double y, double alpha,long xy)
{
  double abstand1 = 10;
  double abstand2 = 40;
  double radius = 6;
  double s,c;

  int line_style = LineOnOffDash;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  if(xy == XS_LAGER_X)
    alpha -= PI/2;

  s = sin(alpha);
  c = cos(alpha);

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  XDrawArc(display,win,gc,
	   (long) (x * mass.system + mass.off_x  - (abstand1 * s) - radius ), 
	   (long) (mass.win_h - y * mass.system + mass.off_y - (abstand1 * c) -radius ),
	   (long) (2*radius),
	   (long) (2*radius),
	   0,
	   360*64);

  XDrawArc(display,win,gc,
	   (long) (x * mass.system + mass.off_x  - (abstand2 * s) - radius ), 
	   (long) (mass.win_h - y * mass.system + mass.off_y - (abstand2 * c) -radius ),
	   (long) (2*radius),
	   (long) (2*radius),
	   0,
	   360*64);

  XDrawLine(display,win,gc,
	    (long) (x * mass.system + mass.off_x  - (abstand1 * s) ), 
	    (long) (mass.win_h - y * mass.system + mass.off_y - (abstand1 * c) ),
	    (long) (x * mass.system + mass.off_x  - (abstand2 * s) ),
	    (long) (mass.win_h - y * mass.system + mass.off_y - (abstand2 * c) ) 
	    );     
}



/***********************************************************/
/* void ZeichneFeder_Z( ... )                              */
/***********************************************************/ 
/*                                              
   Fkt zeichnet eine Drehfeder im Fenster win
   jh, 25.04.97
*/
/***********************************************************/

void Zeichne_Feder_Z(Window win,TypMaszstab mass, double x, double y)
{
  
  double radius = 15;

  int line_style = LineOnOffDash;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);     

  XDrawArc(display,win,gc,
	   (long) (X_welt_win_m(win,x,mass) - radius),
	   (long) (Y_welt_win_m(win,y,mass) - radius),
	   (long) (2*radius),
	   (long) (2*radius),
	   0,
	   360*64);
}


			
/***********************************************************/ 
/* void Zeichne_KoordSys( ... )                           */
/***********************************************************/ 
/*                                              
   Funktion zeichnet Koordinatensystem global und lokal
   nach Statikkonvention (x,z) fr den Stab tmp_stab
   in einem bestimmten Fenster 
   jh, 03.05.97
*/
/***********************************************************/

void Zeichne_KoordSys(Window win,
		      TypStab_Nm *tmp_stab)
{ 
  double c,s;
  double x1,y1,x2,y2;
  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter; 
  FL_Coord win_h,win_w;

  XSetForeground(display,gc, xs_color.fg);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  fl_get_winsize(win, &win_w, &win_h);

  c = (*tmp_stab).d_cos;
  s = (*tmp_stab).d_sin;

  /* Koordsys global */
  ZeichnePfeil(20L, 20L, 20L, 90L, win); 
  ZeichnePfeil(20L, 20L, 90L, 20L, win);     

  XDrawImageString(display,win,gc, 100L, 20L,"X",1);
  XDrawImageString(display,win,gc, 20L, 110L,"Z",1);

  XDrawArc(display,win,gc, -20L, -20L, 80L, 80L, 
	   (long) (290*64), (long) (50*64) );
	 
  XDrawImageString(display,win,gc,25L, 35L, "phi",3);
  
  XDrawLine(display,win,gc,
	    (long) (20 + 40 * cos(0.349)),
	    (long) (20 + 40 * sin(0.349)),
	    (long) (20 + 35 * cos(0.524)),
	    (long) (20 + 35 * sin(0.524)));	  	

  XDrawLine(display,win,gc,
	    (long) (20 + 40 * cos(0.349)),
	    (long) (20 + 40 * sin(0.349)),
	    (long) (20 + 45 * cos(0.524)),
	    (long) (20 + 45 * sin(0.524)));


  /* Koordsys lokal */
  if( xs_color.fl_bg == FL_WHITE)
    XSetForeground(display,gc,fl_get_flcolor(FL_BLUE));
  else   
    XSetForeground(display,gc,fl_get_flcolor(FL_WHITE));

  x1 = -35;  y1 = 35;
  x2 = 35;   y2 = 35;

  ZeichnePfeil((long) (60 + (x1*c - y1*s)),
	       (long) (win_h - 60 - (x1*s + y1*c)),
	       (long) (60 + (x2*c - y2*s)),
	       (long) (win_h - 60 - (x2*s + y2*c)),
	       win); 

  x2 = 45;   y2 = 45;
  XDrawImageString(display,win,gc,
		   (long) (60 + (x2*c - y2*s)),
		   (long) (win_h - 60 - (x2*s + y2*c)), "X,u",3);

  x1 = -35;  y1 = 35;
  x2 = -35;  y2 = -35;
  
  ZeichnePfeil((long) (60 + (x1*c - y1*s)),
	       (long) (win_h - 60 - (x1*s + y1*c)),
	       (long) (60 + (x2*c - y2*s)),
	       (long) (win_h - 60 - (x2*s + y2*c)),
	       win);

  x2 = -45;   y2 = -45;
  XDrawImageString(display,win,gc,
		   (long) (60 + (x2*c - y2*s)),
		   (long) (win_h - 60 - (x2*s + y2*c)), "Z,w",3);
}

