/*
  Datei     : zeichne_lager.c
  erstellt  : 17.03.97
  gendert  : 25.06.97
  Autor     : jh
  Bemerkung :
*/


#include "XStabDek.h"



/*********************************************************************/
/* void ZeichneLager(TypMaszstab mass)                               */
/*********************************************************************/
/*                                              
   Fkt zeichnet die Lager im Hauptfenster
   jh, 25.04.97                                 
*/
/*********************************************************************/

void ZeichneLager(TypMaszstab mass)
{
  long i;
  double x,y;
  double alpha=0;
  
  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt;
  TypFreiGrad *tmp_freigrad;
  
  XSetBackground(display,gc,xs_color.bg);
  
  if(Modell->KeStab_Nm)
    KeDurchlaufVorwaerts(p,Modell->KeStab_Nm) {
      tmp_stab = p->x;     
      
      for(i=0;i<6;i++)	{
	tmp_freigrad = (*tmp_stab).pe_frei[i];

	if(i<3)	    
	  tmp_punkt = (*tmp_stab).pe_punkta;       	    
	else	    
	  tmp_punkt = (*tmp_stab).pe_punktb;

	x = (*tmp_punkt).d_x;
	y = (*tmp_punkt).d_y;    

	/* nur zeichnen wenn primal */
	if( (*tmp_freigrad).l_status == CPmPrimal) {
	  alpha =  (*tmp_freigrad).d_alpha;
	      
	  if((*tmp_freigrad).d_verschiebung == 0)
	    XSetForeground(display,gc, xs_color.lager);
	  else
	    XSetForeground(display,gc,fl_get_flcolor(FL_RED));

	  switch ( (*tmp_freigrad).l_art) {
	  case 0 :
	    Zeichne_Lager_XY(win,mass, x,y,alpha,XS_LAGER_X);
	    break;
	  case 1 :
	    Zeichne_Lager_XY(win,mass, x,y,alpha,XS_LAGER_Y);
	    break;
	  case 2 :
	    Zeichne_Lager_Z(win,mass, x,y);
	    break;	    
	  }

	  /* wenn primal und Feder, Feder entgegengesetzt zeichnen */
	  if( (*tmp_freigrad).d_feder != 0 ) {
	    switch ( (*tmp_freigrad).l_art) {
	    case 0 :
	      Zeichne_Feder_XY(win,mass, x,y,alpha-PI,XS_LAGER_X);
	      break;
	    case 1 :
	      Zeichne_Feder_XY(win,mass, x,y,alpha-PI,XS_LAGER_Y);
	      break;
	    case 2 :
	      Zeichne_Feder_Z(win,mass, x,y);
	      break;
	    }
	  }
	}
	else {  /* wenn dual, dann zeichnen wenn feder != 0 */
	  if((*tmp_freigrad).d_feder != 0) {
	    XSetForeground(display,gc, xs_color.feder);	   
	    
	    switch ( (*tmp_freigrad).l_art) {
	    case 0 :
	      Zeichne_Feder_XY(win,mass, x,y,alpha,XS_LAGER_X);
	      break;
	    case 1 :
	      Zeichne_Feder_XY(win,mass, x,y,alpha,XS_LAGER_Y);
	      break;
	    case 2 :
	      Zeichne_Feder_Z(win,mass, x,y);
	      break;
	      
	    }
	  }
	}
      }

    }
  
  XFlush(display);
  
}

