/*
  Datei     : Zeichne.c
  erstellt  : 03.07.96
  gendert  : 19.03.97
  Autor     : jh
*/


#include "XStabDek.h"



/***********************************************************/ 
/* void ZeichneKnotenlast(TypMaszstab mass)                */
/***********************************************************/ 
/*                                              
   Funktion zeichnet Punktlasten auf Stbe
   im Haupt-Fenster
   jh, 18.03.97
*/
/***********************************************************/

void ZeichneKnotenlast(TypMaszstab mass)
{ 
  long hilf;
  double x,y;
  double alpha,kraft;
  double ab;
  double mass_moment;  /* ... Mastab fr Knotenmomente  ... */
  Menge *M_aktiv;
  TypLastfall *tmp_lastfall;
  double gewicht;

  /* ... Linienstil ... */
  
  int line_style = LineSolid;
  int line_width;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  KeGlied *p;
  TypStab_Nm *tmp_stab;
  TypPunkt *tmp_punkt1,*tmp_punkt2;
  TypKnotenlast_Nm *tmp_pl;

  char c_tmp[100];


  XSetForeground(display,gc, xs_color.punktlast); 
 
  if(!Modell->KePunktlast_Nm)
    return;

  /* Mastab Moment skalieren */
  mass_moment = mass.kraft * 1.2;

  /* in M_aktiv stehen die IDs der aktiven Lastflle */
  M_aktiv = Mng_MengeDefinieren();
  HoleAktiveLastfaelle_Lastwahl(M_aktiv);

  /* Schleife ber alle Punktlasten */   
  KeDurchlaufVorwaerts(p,Modell->KePunktlast_Nm)  {      
    tmp_pl = p->x;
      
    /* nur zeichnen wenn Lastfall aktiv */
    if( Element_suchen((*tmp_pl).l_lastfallid, M_aktiv) )  {     
      /* Suche dazugehrigen Stab */      
      tmp_stab = Suche_Stab_Nm((*tmp_pl).l_stabnummer);
      
      tmp_punkt1 = (*tmp_stab).pe_punkta;
      tmp_punkt2 = (*tmp_stab).pe_punktb;
      
      /* Berechne Koordinaten */     	  
      x = (*tmp_punkt1).d_x * (1-(*tmp_pl).d_pos) 
	+ (*tmp_punkt2).d_x *    (*tmp_pl).d_pos;
      
      y = (*tmp_punkt1).d_y * (1-(*tmp_pl).d_pos) 
	+ (*tmp_punkt2).d_y *    (*tmp_pl).d_pos;
      
      kraft = (*tmp_pl).d_last;     
	     
      XSetLineAttributes(display,gc,line_width=4,line_style,cap_style,join_style);

      /* ...  Knotenmoment zeichnen  ... */	
      if((*tmp_pl).l_art == 2) {  
	if(mass.kraft * kraft < 0)
	  ab = 1.2;
	else
	  ab = -1.2;		     			
	
	/* Angriffspunkt zeichnen */
	XDrawArc(display,win,gc,
		 (long) ((x * mass.system + mass.off_x) - 2),
		 (long) ((mass.win_h - y * mass.system + mass.off_y) - 2),
		 (long) 4,
		 (long) 4,
		 0L,
		 23040L);
	      
	/* Pfeil zeichnen */
	XDrawArc(display,win,gc,
		 (long) ((x * mass.system + mass.off_x) - 30),
		 (long) ((mass.win_h - y * mass.system + mass.off_y) - 30),
		 (long) 60,
		 (long) 60,
		 0L,
		 (long) (kraft * mass_moment * 640) );
	
	XDrawLine(display,win,gc,
		  (long) ((x * mass.system + mass.off_x) + 
			  30 * cos(kraft * mass_moment*PI/18)),
		  (long) ((mass.win_h - y * mass.system + mass.off_y) - 
			  30 * sin(kraft * mass_moment * PI/18)),
		  (long) ((x * mass.system + mass.off_x) + 
			  25 * cos((kraft * mass_moment + ab) * PI/18)),
		  (long) ((mass.win_h - y * mass.system + mass.off_y) - 
			  25 * sin((kraft*mass_moment + ab)*PI/18)));
	
	XDrawLine(display,win,gc,
		  (long) ((x * mass.system + mass.off_x) + 
			  30 * cos(kraft * mass_moment * PI/18)),
		  (long) ((mass.win_h - y * mass.system + mass.off_y) - 
			  30 * sin(kraft * mass_moment * PI/18)),
		  (long) ((x * mass.system + mass.off_x) + 
			  35 * cos((kraft * mass_moment + ab)*PI/18)),
		  (long) ((mass.win_h - y * mass.system + mass.off_y) - 
			  35 * sin((kraft * mass_moment + ab)*PI/18))); 		  
      }      
      
      /* ...  Punktlast zeichnen  ... */	
      if( (*tmp_pl).l_art == 1) {
	if((*tmp_pl).l_koordsys_winkel == 2) /* global */
	  hilf = 0;
	else
	  hilf = 1;
	    
	alpha = (*tmp_pl).d_alpha + ((*tmp_stab).d_alpha * hilf);
	    
	ZeichnePfeil((long) ((x * mass.system + mass.off_x) - 
			     (kraft * mass.system * sin(alpha) * mass.kraft)), 
		     (long) ((mass.win_h - y * mass.system + mass.off_y) - 
			     (kraft * mass.system * cos(alpha) * mass.kraft)),
		     (long) (x * mass.system + mass.off_x) , 
		     (long) (mass.win_h - y * mass.system + mass.off_y),
		     win); 	     
      }

      /* Beschrfitung zeichnen */
      if(fl_get_button(drawcontrol_system_form->plbeschriftung_button)) {
	
	XSetLineAttributes(display,gc,line_width=1,line_style,cap_style,join_style);
	
	/* Gewichtung bestimmen */
	tmp_lastfall = Suche_Lastfall_id((*tmp_pl).l_lastfallid);
	if(!tmp_lastfall) {      
	  Meldung("Fehler : PL zeichnen kein Lastfall\n");      
	  return;
	}
	gewicht = (*tmp_lastfall).d_gewicht;
    
	XDrawLine(display,win,gc, 
		  X_welt_win_m(win,x,mass),
		  Y_welt_win_m(win,y,mass),
		  X_welt_win_m(win,x,mass) + 30,
		  Y_welt_win_m(win,y,mass) - 30);

	sprintf(c_tmp,"%.2fx%.2f",gewicht,kraft);
	XDrawImageString(display,win,gc,
			 X_welt_win_m(win,x,mass) + 30,
			 Y_welt_win_m(win,y,mass) - 30,
			 c_tmp,strlen(c_tmp));

      }

    }
  }
  
  Mng_MengeUndElementeLoeschen(M_aktiv); 
  
}

 
  
/*********************************************************************/
/* void ZeichneStreckenlast(TypMaszstab mass)                        */
/*********************************************************************/ 
/*                                              
   Funktion zeichnet Streckenlasten auf Stbe
   im Haupt-Fenster
   jh, 19.03.97
*/
/*********************************************************************/

void ZeichneStreckenlast(TypMaszstab mass)
{
  KeGlied *p=NULL;
  TypStab_Nm *tmp_stab=NULL;
  TypStreckenlast_Nm *tmp_sl=NULL;
  Menge *M_aktiv=NULL;
  TypLastfall *tmp_lastfall=NULL;
  double gewicht;
  long X1,Y1;
  long i,anz=10;
  long hilf;
  double xa,ya,xe,ye;
  double x1=0,y1=0,x2=0,y2=0;
  double z,z2;
  double step,step2;
  double La,Le,L;
  double s,c;
  double abstand,ab = 0; /* Abstand der Last vom Stab */

  double alpha; 

  TypPunkt *tmp_punkt1,*tmp_punkt2;
  
  int line_style = LineSolid;
  int line_width = 3;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  char c_tmp[100];

  if(!Modell->KeStreckenlast_Nm)
    return;

  XSetForeground(display,gc, xs_color.streckenlast);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  /* in M_aktiv stehen die IDs der aktiven Lastflle */
  M_aktiv = Mng_MengeDefinieren();
  HoleAktiveLastfaelle_Lastwahl(M_aktiv);
  
  /* Schleife ber alle Streckenlasten */  
  KeDurchlaufVorwaerts(p,Modell->KeStreckenlast_Nm) {	
    tmp_sl = p->x;
	
    /* nur zeichnen wenn Lastfall aktiv */
    if( Element_suchen((*tmp_sl).l_lastfallid, M_aktiv) ) {     
      /* Suche dazugehrigen Stab */      
      tmp_stab = Suche_Stab_Nm((*tmp_sl).l_stabnummer);
	    
      tmp_punkt1 = (*tmp_stab).pe_punkta;
      tmp_punkt2 = (*tmp_stab).pe_punktb;

      s =  (*tmp_stab).d_sin;  c =  (*tmp_stab).d_cos;            	   
	
      /* Koordinaten Stabanfang, Stabende */
      xa = (*tmp_punkt1).d_x;  ya = (*tmp_punkt1).d_y;
      xe = (*tmp_punkt2).d_x;  ye = (*tmp_punkt2).d_y;  

      /* Gre der Last an Punkt A,B */
      La = (*tmp_sl).d_lasta;  
      Le = (*tmp_sl).d_lastb;	         
	    
      if((*tmp_sl).l_koordsys == 2) /* global */
	hilf = 0;
      else
	hilf = 1;
	    
      alpha = (*tmp_sl).d_alpha + ((*tmp_stab).d_alpha * hilf);
	    
      step =  (double) (((*tmp_sl).d_end - (*tmp_sl).d_anf) / (anz-1));
      step2 = (double) (1. / (anz-1));
	    
      z = (*tmp_sl).d_anf;
      z2 = 0;
	    
      /* Pfeile zeichnen */
      for(i=0;i<anz;i++) {      
	x1 = xa*(1-z) + xe * z;
	y1 = ya*(1-z) + ye * z;
		
	/* Streckenlast mit Mastab skalieren */
	L = ( La*(1-z2) + Le * z2 ) * mass.streckenlast;
		
	x2 = x1 - L * sin(alpha);
	y2 = y1 + L * cos(alpha);
		
	if(L>0)
	  abstand = ab;
	else
	  abstand = -ab;
		
	ZeichnePfeil((long) (X_welt_win_m(win,x2,mass) - (abstand * s)),
		     (long) (Y_welt_win_m(win,y2,mass) - (abstand * c)),
		     (long) (X_welt_win_m(win,x1,mass) - (abstand * s)), 
		     (long) (Y_welt_win_m(win,y1,mass) - (abstand * c)),
		     win);			       
	z  += step;
	z2 += step2;
      }

      /* Verbindung Anfang - Ende zeichnen */
      {
	long x_a,y_a,x_e,y_e;

	/* Punkt A berechnen */
	z = (*tmp_sl).d_anf;	  
	    
	x1 = xa*(1-z) + xe * z;
	y1 = ya*(1-z) + ye * z;
	      
	/* Streckenlast mit Mastab skalieren */
	L = La * mass.streckenlast;
	      
	x1 = x1 - L * sin(alpha);
	y1 = y1 + L * cos(alpha);
	      
	if(L>0)
	  abstand = ab;
	else
	  abstand = -ab;
	      
	x_a = (long) (x1 * mass.system + mass.off_x - (abstand * s) );
	y_a = (long) (mass.win_h - y1 * mass.system + mass.off_y - (abstand *c));

	/* Punkt E berechnen */
	z  = (*tmp_sl).d_end;	     
	      
	x1 = xa*(1-z) + xe * z;
	y1 = ya*(1-z) + ye * z;
	      
	/* Streckenlast mit Mastab skalieren */
	L = Le * mass.streckenlast;
	      
	x1 = x1 - L * sin(alpha);
	y1 = y1 + L * cos(alpha);
	      
	if(L>0)
	  abstand = ab;
	else
	  abstand = -ab;
	      
	x_e = (long) (x2 * mass.system + mass.off_x - (abstand * s) );
	y_e = (long) (mass.win_h - y2 * mass.system + mass.off_y - (abstand *c));
	      
	XDrawLine(display,win,gc,
		  x_a,y_a,
		  x_e,y_e);	  
      }

      /* Beschriftung zeichnen */
      if(fl_get_button(drawcontrol_system_form->slbeschriftung_button)) {

	XSetLineAttributes(display,gc,line_width=1,line_style,cap_style,join_style);

	/* Gewichtung bestimmen */
	tmp_lastfall = Suche_Lastfall_id((*tmp_sl).l_lastfallid);
	if(!tmp_lastfall) {      
	  Meldung("Fehler : PL zeichnen kein Lastfall\n");      
	  return;
	}
	gewicht = (*tmp_lastfall).d_gewicht;
	
	z = (*tmp_sl).d_anf;
	x1 = xa*(1-z) + xe * z;
	y1 = ya*(1-z) + ye * z;

	X1 = X_welt_win_m(win,x1,mass);
	Y1 = Y_welt_win_m(win,y1,mass);

	XDrawLine(display,win,gc, 
		  X1, Y1,
		  X1 - 60L, Y1 - 30L);
	      
	sprintf(c_tmp,"%.2fx%.2f",gewicht,La);
	XDrawImageString(display,win,gc,
			 X1- 60L,
			 Y1- 30L,
			 c_tmp,strlen(c_tmp));

	z = (*tmp_sl).d_end;
	x1 = xa*(1-z) + xe * z;
	y1 = ya*(1-z) + ye * z;

	X1 = X_welt_win_m(win,x1,mass);
	Y1 = Y_welt_win_m(win,y1,mass);

	XDrawLine(display,win,gc, 
		  X1,Y1,
		  X1 + 30L,
		  Y1 - 30L);
	      
	sprintf(c_tmp,"%.2fx%.2f",gewicht,Le);
	XDrawImageString(display,win,gc,
			 X1 + 30L,
			 Y1 - 30L,
			 c_tmp,strlen(c_tmp));
	      
	XSetLineAttributes(display,gc,line_width=2,line_style,cap_style,join_style);
	      
      }
    }	
  }			
}
