/*
  Datei     : zeichne_schnittkraft.c
  erstellt  : 17.03.97
  gendert  : 18.04.97
  Autor     : jh
*/


#include "XStabDek.h"







/*********************************************************************/
/* void ZeichneMoment(TypMaszstab mass)                              */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Momentenlinie
   jh, 18.04.97 
*/
/*********************************************************************/

void ZeichneMoment(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypStab_Nm *tmp_stab;
  TypIntervall *tmp_intervall;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;

  XSetForeground(display,gc, xs_color.moment);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  if(!Modell->KeStab_Nm)
    return;

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {

    tmp_stab = p->x;        

    if(!(*tmp_stab).intervalle)
      continue;   
     
    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
           
      Zeichne_Schnittkraft(win,tmp_intervall, 2, mass);
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(drawcontrol_system_form->beschriftung_button)) 
      Zeichne_Beschriftung(win,tmp_stab, 2, mass);
  }  
  
}



/*********************************************************************/
/* void ZeichneNormal(TypMaszstab mass)                              */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Normalkraftlinie
   jh, 18.04.97 
*/
/*********************************************************************/

void ZeichneNormal(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypIntervall *tmp_intervall;
  TypStab_Nm *tmp_stab;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;
 

  XSetForeground(display,gc, xs_color.normal);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);


  if(!Modell->KeStab_Nm)
    return;

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {
    
    tmp_stab = p->x;     

    if(!(*tmp_stab).intervalle)
      continue;

    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
      
      Zeichne_Schnittkraft(win,tmp_intervall, 0, mass);      
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(drawcontrol_system_form->beschriftung_button)) 
      Zeichne_Beschriftung(win,tmp_stab, 0, mass);
  }    
}



/*********************************************************************/
/* void ZeichneQuer(TypMaszstab mass)                                */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Querkraftlinie
   jh, 18.04.97 
*/
/*********************************************************************/

void ZeichneQuer(TypMaszstab mass)
{
  KeGlied *p,*l;
  TypIntervall *tmp_intervall;
  TypStab_Nm *tmp_stab;

  int line_style = LineSolid;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter; 


  XSetForeground(display,gc, xs_color.quer);
  XSetBackground(display,gc, xs_color.bg);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  if(!Modell->KeStab_Nm)
    return;

  /* Schleife ber alle Stbe im Nutzermodell */
  KeDurchlaufVorwaerts(p,Modell->KeStab_Nm)  {
    
    tmp_stab = p->x;       
    
    if(!(*tmp_stab).intervalle)
      continue;

    /* Schleife ber alle Intervalle eines Stabes im Nm */
    KeDurchlaufVorwaerts(l, (*tmp_stab).intervalle)  {
      tmp_intervall = l->x;
      
      Zeichne_Schnittkraft(win,tmp_intervall, 1, mass);     
    }
    
    /* Beschriftung zeichnen */
    if(fl_get_button(drawcontrol_system_form->beschriftung_button)) 
      Zeichne_Beschriftung(win,tmp_stab, 1, mass);
  }     

}



/*********************************************************************/
/* void Zeichne_Schnittkraft( ... )                                  */
/*********************************************************************/
/*                                              
   Funktion zeichnet die Schnittkraft im
   Hauptfenster
   sk -> 2 - Moment
         1 - Querkraft
         0 - Normalkraft
   jh, 18.04.97 
*/
/*********************************************************************/

void Zeichne_Schnittkraft(Window win,
			  TypIntervall* tmp_inter,
			  long sk, TypMaszstab mass)
{
  long i;
  double z,step;
  double x0,y0,x1,y1;
  double xa,ya,xb,yb;
  double dx,dy;
  double *m;
 
  double s,c;
  long anz_points = 11; 
  double SKa,SKe,ska,ske;
  XPoint *points;      

  
  /* Speicher fr die Punkte */
  points = (XPoint*) calloc ( anz_points , sizeof(XPoint)); 
     
  /* geometrische Werte setzen */
  s = sin((*tmp_inter).d_alpha_stab);
  c = cos((*tmp_inter).d_alpha_stab);

  /* setze Sttzwerte und deren Ableitungen */
  switch(sk) {
  case 0 : /* N */      
      
    SKa = (*tmp_inter).d_Na;
    SKe = (*tmp_inter).d_Nb;
    ska = -(*tmp_inter).d_lastn_a;
    ske = -(*tmp_inter).d_lastn_b;
    break;

  case 1 : /* Q */
    
    SKa = (*tmp_inter).d_Qa;
    SKe = (*tmp_inter).d_Qb;
    ska = (*tmp_inter).d_lastp_a;
    ske = (*tmp_inter).d_lastp_b;
    break;

  case 2 : /* M */

    /* Moment in Statik-Richtung antragen
       -> positiv nach unten ! */
    SKa = -(*tmp_inter).d_Ma;
    SKe = -(*tmp_inter).d_Mb;
    ska = -(*tmp_inter).d_Qa;
    ske = -(*tmp_inter).d_Qb;
    break;

  default :
    fprintf(stderr,"falsche bergabeparameter !\n");
    return;
  }

  /* Geometrie setzen */
  xa = (*tmp_inter).d_xa;
  ya = (*tmp_inter).d_ya;

  xb = (*tmp_inter).d_xe;
  yb = (*tmp_inter).d_ye;      

  /* interpolieren */
  m = Hermite(SKa, ska, SKe, ske,
	      (*tmp_inter).d_laenge,
	      anz_points);
  
      
  /* Punkte berechnen */
  z = -1;
  step = (double) (2./((double) anz_points - 1.));

  for(i=0;i<anz_points;i++)  {
    
    /* Geometrie interpolieren */
    x0 = 0.5 * (xa * (1-z) + xb * (1+z));	
    y0 = 0.5 * (ya * (1-z) + yb * (1+z));		  	               	
       
    dx = m[i] * s * mass.schnittkraft;
    dy = m[i] * c * mass.schnittkraft;
    
    x1 = x0 - dx;
    y1 = y0 + dy;
        
    points[i].x = (long) X_welt_win_m(win,x1,mass);
    points[i].y = (long) Y_welt_win_m(win,y1,mass);	 	  		  

    z +=step;
    
    XDrawLine(display,win,gc, 
	      (long) X_welt_win_m(win,x0,mass), 
	      (long) Y_welt_win_m(win,y0,mass),
	      (long) points[i].x,
	      (long) points[i].y);
  }    
  
  XDrawLines(display, win, gc, points, anz_points, CoordModeOrigin);        
  
  free(points);
  free(m); 
  
}



/*********************************************************************/
/* void Zeichne_Beschriftung( ... )                                  */
/*********************************************************************/
/*                                              
   Funktion beschriftet die Beschriftung der Schnittkraft im
   Hauptfenster
   sk -> 2 - Moment
         1 - Querkraft
         0 - Normalkraft
   jh, 19.04.97 
*/
/*********************************************************************/

void Zeichne_Beschriftung(Window win,
			  TypStab_Nm* tmp_stab,
			  long sk, TypMaszstab mass)
{ 
  double maxS=0,pos=0;
  TypPunkt *pA,*pB;
  double x0,y0,x1,y1,dx,dy;
  char c_text[20];
 
  if(!(*tmp_stab).intervalle)
    return;

  /* Geometrie interpolieren */
  pA = (*tmp_stab).pe_punkta;
  pB = (*tmp_stab).pe_punktb;


  /* Pos 0. und 1. zeichnen */
  pos = 0.;
  while( pos <= 1. ) {
    
    switch(sk) {
    case 0 : /* N */   
      maxS = getN(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      break;
      
    case 1 : /* Q */ 
      maxS = getQ(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      break;
      
    case 2 : /* M */
      maxS = getM(tmp_stab,pos);
      sprintf(c_text,"%.2f",maxS);
      maxS *= -1.;
      break;
    }
    
    x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
    y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
    
    dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
    dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
    
    x1 = x0 - dx;
    y1 = y0 + dy;	            	            
    
    XDrawLine(display,win,gc, 
	      (long) X_welt_win_m(win,x1,mass),
	      (long) Y_welt_win_m(win,y1,mass),
	      (long) X_welt_win_m(win,x1,mass) + 30,
	      (long) Y_welt_win_m(win,y1,mass) - 30);
    
    XDrawImageString(display,win,gc,
		     (long) X_welt_win_m(win,x1,mass) + 30,
		     (long) Y_welt_win_m(win,y1,mass) - 30,
		     c_text,strlen(c_text));     

    pos += 1.;
  }
  

  /* Maximum zeichnen */
  switch(sk) {
  case 0 : /* N */   
    maxS = maxN(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 1 : /* Q */ 
    maxS = maxQ(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 2 : /* M */
    maxS = maxM(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    maxS *= -1.;  /*Statik-Konvention ! */
    break;
  }
 
  x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
  y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
  
  dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
  dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
  
  x1 = x0 - dx;
  y1 = y0 + dy;	            	     

  XDrawLine(display,win,gc, 
	    (long) X_welt_win_m(win,x1,mass),
	    (long) Y_welt_win_m(win,y1,mass),
	    (long) X_welt_win_m(win,x1,mass) + 30,
	    (long) Y_welt_win_m(win,y1,mass) - 30);
  
  XDrawImageString(display,win,gc,
		   (long) X_welt_win_m(win,x1,mass) + 30,
		   (long) Y_welt_win_m(win,y1,mass) - 30,
		   c_text,strlen(c_text));       

  /* Minimum beschriften */
  switch(sk) {
  case 0 : /* N */   
    maxS = minN(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 1 : /* Q */ 
    maxS = minQ(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    break;

  case 2 : /* M */
    maxS = minM(tmp_stab,&pos);
    sprintf(c_text,"%.2f",maxS);
    maxS *= -1.;  /*Statik-Konvention ! */
    break;
  }
 
  x0 = (*pA).d_x * (1-pos) + (*pB).d_x * pos;
  y0 = (*pA).d_y * (1-pos) + (*pB).d_y * pos;
  
  dx = maxS * sin((*tmp_stab).d_alpha) * mass.schnittkraft;
  dy = maxS * cos((*tmp_stab).d_alpha) * mass.schnittkraft;
  
  x1 = x0 - dx;
  y1 = y0 + dy;	            	     

  XDrawLine(display,win,gc, 
	    (long) X_welt_win_m(win,x1,mass),
	    (long) Y_welt_win_m(win,y1,mass),
	    (long) X_welt_win_m(win,x1,mass) + 30,
	    (long) Y_welt_win_m(win,y1,mass) - 30);
  
  XDrawImageString(display,win,gc,
		   (long) X_welt_win_m(win,x1,mass) + 30,
		   (long) Y_welt_win_m(win,y1,mass) - 30,
		   c_text,strlen(c_text));       
  
}

