/*
  Datei     : zeichne_umgebung.c
  erstellt  : 03.04.97
  gendert  : 
  Autor     : jh
  Bemerkung : alle Elemente der Umgebung -> Achsen, Ursprung usw.
*/


#include "XStabDek.h"


void ZeichneUrsprung(TypMaszstab mass)
{
  int line_style = LineSolid;
  int line_width = 2;
  int cap_style = CapButt;
  int join_style = JoinMiter; 

  XSetForeground(display,gc, xs_color.fg);
  XSetBackground(display,gc, xs_color.bg);

  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  ZeichnePfeil((long) (0 * mass.system + mass.off_x),
	       (long) (mass.win_h - 0 * mass.system + mass.off_y),
	       (long) (1 * mass.system + mass.off_x), 
	       (long) (mass.win_h - 0 * mass.system + mass.off_y),
	       win ) ;     

  ZeichnePfeil((long) (0 * mass.system + mass.off_x),
	       (long) (mass.win_h - 0 * mass.system + mass.off_y),
	       (long) (0 * mass.system + mass.off_x), 
	       (long) (mass.win_h - 1 * mass.system + mass.off_y),
	       win ) ;     

  XDrawImageString(display,win,gc,
		   (long) (1 * mass.system + mass.off_x + 10),
		   (long) (mass.win_h - 0 * mass.system + mass.off_y ),"X",1);

  XDrawImageString(display,win,gc,
		   (long) (0 * mass.system + mass.off_x ),
		   (long) (mass.win_h - 1 * mass.system + mass.off_y - 10),"Y",1);

  XDrawArc(display,win,gc,
	   (long) (-0.7 * mass.system + mass.off_x),
	   (long) (mass.win_h - 0.7 * mass.system + mass.off_y),
	   (long) (1.4 * mass.system),
	   (long) (1.4 * mass.system),
	   (long) (20*64),
	   (long) (50*64) );

  XDrawLine(display,win,gc,
	    (long) ((0.7*cos(1.222)) * mass.system + mass.off_x),
	    (long) (mass.win_h - (0.7*sin(1.222)) * mass.system + mass.off_y),
	    (long) ((0.6*cos(1)) * mass.system + mass.off_x),
	    (long) (mass.win_h - (0.6*sin(1)) * mass.system + mass.off_y));
  
  XDrawLine(display,win,gc,
	    (long) ((0.7*cos(1.222)) * mass.system + mass.off_x),
	    (long) (mass.win_h - (0.7*sin(1.222)) * mass.system + mass.off_y),
	    (long) ((0.78*cos(1)) * mass.system + mass.off_x),
	    (long) (mass.win_h - (0.78*sin(1)) * mass.system + mass.off_y));	  	
		    
  XDrawImageString(display,win,gc,
		   (long) (0.1 * mass.system + mass.off_x ),
		   (long) (mass.win_h - 0.1 * mass.system + mass.off_y),"Z",1);

}


void ZeichneRaster(TypMaszstab mass)
{
  double i;
  double stepx,stepy;

  int line_style = LineOnOffDash;
  int line_width = 0;
  int cap_style = CapButt;
  int join_style = JoinMiter;

 
  stepx = Modell->Environment.raster_x;   
  stepy = Modell->Environment.raster_x;

  XSetForeground(display,gc, xs_color.achsen);
  XSetLineAttributes(display,gc,line_width,line_style,cap_style,join_style);

  for(i=0;i<= ((mass.win_w-mass.off_x)/mass.system) ; i+=stepx)
    {
      XDrawLine(display,win,gc,
		(long) ( i * mass.system + mass.off_x ), (long) 0 ,
		(long) ( i * mass.system + mass.off_x ), (long) mass.win_h );     
    }  

  for(i=0; i>= -(mass.off_x/mass.system); i-=stepx)
    {
      XDrawLine(display,win,gc,
		(long) ( i * mass.system + mass.off_x ), (long) 0 ,
		(long) ( i * mass.system + mass.off_x ), (long) mass.win_h );     
    }  

  for(i=0; i<= ((mass.win_h+mass.off_y)/mass.system); i+=stepy)
    {       
      XDrawLine(display,win,gc,
		(long) 0, (long) ( mass.win_h - i * mass.system + mass.off_y ),
		(long) mass.win_w , (long) ( mass.win_h - i * mass.system + mass.off_y ));     
    }

  for(i=0; i>= (mass.off_y/mass.system); i-=stepy)
    {       
      XDrawLine(display,win,gc,
		(long) 0, (long) (mass.win_h - i * mass.system + mass.off_y ),
		(long) mass.win_w , (long) (mass.win_h - i * mass.system + mass.off_y ));     
    }


  /* ...  Achsen hervorheben  ... */
  
  if( fl_get_button(drawcontrol_preferences_form->achsen_button))
    {
      XSetForeground(display,gc, xs_color.fg);
      XSetLineAttributes(display,gc, line_width+2 ,line_style,cap_style,join_style);

      XDrawLine(display,win,gc,
		(long) ( 0 * mass.system + mass.off_x ), (long) 0 ,
		(long) ( 0 * mass.system + mass.off_x ), (long) mass.win_h );   

      XDrawLine(display,win,gc,
		(long) 0, (long) ( mass.win_h - 0 * mass.system + mass.off_y ),
		(long) mass.win_w , (long) ( mass.win_h - 0 * mass.system + mass.off_y ));     
    }

}


void ZeichneAchsenbeschriftung(TypMaszstab mass)
{
  double i;
  double stepx,stepy;
  char c_text[10];

  /* Hole Rasterweiten */ 
  stepx = Modell->Environment.raster_x;   
  stepy = Modell->Environment.raster_x;

  XSetFont(display,gc,font_small);

  XSetForeground(display,gc, xs_color.achsen); 
  XSetBackground(display,gc, xs_color.bg);

  for(i=0;i<= ((mass.win_w - mass.off_x)/mass.system) ; i+=stepx)
    {
      sprintf(c_text,"%.2f",i);

      XDrawImageString(display,win,gc,		      
		       (long) ( i * mass.system + mass.off_x ), 
		       (long) (mass.win_h - 50) ,
		       c_text,
		       strlen(c_text));     
    }  

  for(i=0; i>= -(mass.off_x/mass.system); i-=stepx)
    {
      sprintf(c_text,"%.2f",i);

      XDrawImageString(display,win,gc,		      
		       (long) ( i * mass.system + mass.off_x ), 
		       (long) (mass.win_h - 50 ),
		       c_text,
		       strlen(c_text));     
    }  

  for(i=0; i<= ((mass.win_h+mass.off_y)/mass.system); i+=stepy)
    {       
      sprintf(c_text,"%.2f",i);

      XDrawImageString(display,win,gc,		      
		       (long) (mass.win_w - 6*strlen(c_text) - 50) , 
		       (long) (mass.win_h - i * mass.system + mass.off_y ),
		       c_text,
		       strlen(c_text));     
    }
  
  
  for(i=0; i>= (mass.off_y/mass.system); i-=stepy)
    {       
      sprintf(c_text,"%.2f",i);
      
      XDrawImageString(display,win,gc,		      
		       (long) (mass.win_w - 6*strlen(c_text) - 50) , 
		       (long) (mass.win_h - i * mass.system + mass.off_y ),
		       c_text,
		       strlen(c_text));   
    }
  XSetFont(display,gc,font_medium);
}

